<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */






//This file handles updates which are key to how the updater works.
//They are the first to run


//Create the table to store the local revision numbers.

revision( 2885
, <<<_sql
	CREATE TABLE IF NOT EXISTS [[DB_NAME_PREFIX]]local_revision_numbers(
		module varchar(20) NOT NULL,
		revision_no int(10) unsigned NOT NULL,
		PRIMARY KEY (module)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

//In Tribiq 5.0.12 we changed how the updater works to include plugins.
//The path column needs to be added, and the module column should
//be renamed to patchfile
, <<<_sql
	ALTER TABLE [[DB_NAME_PREFIX]]local_revision_numbers
	DROP PRIMARY KEY
_sql

, <<<_sql
	ALTER TABLE [[DB_NAME_PREFIX]]local_revision_numbers
	ADD COLUMN path varchar(255) NOT NULL FIRST
_sql

, <<<_sql
	ALTER TABLE [[DB_NAME_PREFIX]]local_revision_numbers
	CHANGE COLUMN module patchfile varchar(64) NOT NULL
_sql

, <<<_sql
	ALTER TABLE [[DB_NAME_PREFIX]]local_revision_numbers
	ADD PRIMARY KEY (path, patchfile)
_sql

//Convert the format of existing entries
, <<<_sql
	UPDATE [[DB_NAME_PREFIX]]local_revision_numbers SET
		path = 'admin/db_updates/core',
		patchfile = 'local.inc.php'
	WHERE patchfile = 'general.inc.php';
_sql

, <<<_sql
	UPDATE [[DB_NAME_PREFIX]]local_revision_numbers SET
		path = 'admin/db_updates/modules/microsite'
	WHERE patchfile = 'microsite.inc.php';
_sql

, <<<_sql
	UPDATE [[DB_NAME_PREFIX]]local_revision_numbers SET
		path = 'admin/db_updates/modules/workflow'
	WHERE patchfile = 'workflow.inc.php';
_sql


//Moved plugins to their own revision numbers
);	revision( 2899
, <<<_sql
	UPDATE [[DB_NAME_PREFIX]]local_revision_numbers SET
		revision_no = 0
	WHERE path = 'plugins/calendar/db_updates'
	  AND patchfile = 'calendar.inc.php';
_sql

, <<<_sql
	UPDATE [[DB_NAME_PREFIX]]local_revision_numbers SET
		revision_no = 0
	WHERE path = 'plugins/picture_gallery/db_updates'
	  AND patchfile = 'picture_gallery.inc.php';
_sql


//Remove some junk revision numbers that may have entered the table
//during testing/changing the updater
);	revision( 2945
, <<<_sql
	DELETE FROM [[DB_NAME_PREFIX]]local_revision_numbers
	WHERE (path, patchfile) IN (
		('', 'admin_tabs.inc.php'),
		('', 'pro.inc.php'),
		('admin/db_updates/admin', 'perms.inc.php'),
		('admin/db_updates/admin', 'tabs.inc.php'),
		('plugins/howarewe_outlets/db_updates', 'admin_menu.inc.php')
	)
_sql


//Fix a problem where some revision numbers were incorrectly entered into 5.0.13a and 5.0.13b
);	revision( 3670
, <<<_sql
	UPDATE [[DB_NAME_PREFIX]]local_revision_numbers SET
	  revision_no = 3669
	WHERE revision_no = 3843
_sql

, <<<_sql
	UPDATE [[DB_NAME_PREFIX]]local_revision_numbers SET
	  revision_no = 3670
	WHERE revision_no = 4201
_sql
);

?>