<?php

define('NOT_ACCESSED_DIRECTLY', true);
define('THIS_FILE_IS_BEING_DIRECTLY_ACCESSED', false);
header('Content-Type: text/javascript; charset=UTF-8');

session_start();
require_once '../documentation_for_developers/helper_functions.inc.php';
require_once '../cmsincludes/stripslashes.inc.php';
require_once '../cmsincludes/cms.inc.php';
require_once 'cmsincludes/admin.inc.php';
require_once 'cmsincludes/welcome.inc.php';



if (request('quickValidate')) {
	
	$values = json_decode($_POST['values'], true);
	$rowClasses = json_decode($_POST['row_classes'], true);
	$snippets = array();
	
	quickValidateWelcomePage($values, $rowClasses, $snippets);
	
	echo json_encode(array('row_classes' => $rowClasses, 'snippets' => $snippets));
	exit;

} elseif (request('getLicense')) {
	$licenseDetails = getTribiqLicense('Tribiq Commercial License');
	echo $licenseDetails['text'];
	exit;
}





function tribiqAJAXParseXML3(&$tags, $parentKey = false) {
	$count = 0;
	if (is_array($tags)) {
		foreach ($tags as $key => &$value) {
			
			if (is_array($value)) {
				++$count;
				
				if (($parentKey == 'tabs' || $parentKey == 'fields') && !isset($value['ord'])) {
					$value['ord'] = $count;
				}
				
				tribiqAJAXParseXML3($value, $key);
			}
		}
	}
}





//Include every Plugin's XML files in dependency order
$tags = array();
//Include any xml files in the install directory
foreach (scandir($dir = CMS_ROOT. 'admin/welcome/') as $file) {
	if (substr($file, 0, 1) != '.' && substr($file, -4) == '.xml') {
		$xml = simplexml_load_file($dir. $file);
		tribiqAJAXParseXML($tags, $xml, 'welcome');
		unset($xml);
	}
}

//Tidy up a bit
$box = array();
$task = get('task');
$tags = $tags['welcome'];
tribiqAJAXParseXML2($tags);
tribiqAJAXParseXML3($tags);


if (post('_format') || post('_validate')) {
	$box = json_decode($_POST['_box'], true);
}
$getRequest = json_decode($_GET['get'], true);


//Check to see if the CMS is installed
$freshInstall = false;
$installStatus = 0;
$installed =
	checkConfigFileExists('global')
 && (@include_once CMS_ROOT. 'siteconfigs/global.php')
 && ($installStatus = 1)
 && @mysql_connect(DBHOST_GLOBAL, DBUSER_GLOBAL, DBPASS_GLOBAL)
 && @mysql_select_db(DBNAME_GLOBAL)
 && ($result = @mysql_query("SHOW TABLES LIKE '". DB_NAME_PREFIX_GLOBAL. "site_registry'"))
 && ($installStatus = 2)
 && (@mysql_num_rows($result))
 && ($installStatus = 3);

//Run the installer if the CMS is not installed
if (!$installed) {
	if (arrayKey($box, 'path') != 'install') {
		$box = array('path' => 'install');
	}
	checkBoxDefinition($box, $tags['install']);
	
	$installed = installerAJAX($tags, $box, $task, $installStatus, $freshInstall);
}


if ($installed) {
	//If the CMS is installed, run the CMS properly now.
	define('SHOW_SQL_ERRORS_TO_VISITORS', true);
	
	//Include siteconfigs/global.php if the installer has not already done so
	if (!defined('DBNAME_GLOBAL')) {
		require CMS_ROOT. 'siteconfigs/global.php';
	}
	
	connectGlobalDB();
	doUrlRedirect(false, true);
	connectLocalDB();
	
	//Log the Admin in automatically if they've just done a fresh install
	if ($freshInstall) {
		setAdminSession(1, 'local');
		$loggedIn = true;
	
	//Otherwise, check that they are trying to log from to the correct domain
	} elseif (httpOrhttps(). $_SERVER['HTTP_HOST'] != getGlobalURL(true)) {
		//Direct them to the admin domain if not
		$box['_location'] = getGlobalURL(true). SUBDIRECTORY. 'admin/adminlogin.php?'. http_build_query($getRequest);
		$loggedIn = false;
	
	//Otherwise, check if the Admin has been logged in, and show the log in section if not
	} elseif (!$loggedIn = checkPriv(false, true)) {
		if (arrayKey($box, 'path') != 'login') {
			$box = array('path' => 'login');
		}
		checkBoxDefinition($box, $tags['login']);
		
		//If the Admin is asking to log out, but has already logged out, just redirect them
		if ($task == 'logout') {
			$box['_location'] = redirectAdmin($getRequest);
		
		//Otherwise show the login screen
		} else {
			$loggedIn = loginAJAX($tags, $box, $getRequest);
		}
	}
	
	if ($loggedIn) {
		if ($task == 'logout') {
			//Log the current admin out
			unsetAdminSession();
			$box['_location'] = redirectAdmin($getRequest);
		
		} else {
			//Check if database updates are needed
			$dbUpToDate = !checkIfDBUpdatesAreNeeded($andDoUpdates = false);
			
			if (!$dbUpToDate) {
				if (arrayKey($box, 'path') != 'update') {
					$box = array('path' => 'update');
				}
				checkBoxDefinition($box, $tags['update']);
				
				$dbUpToDate = updateAJAX($tags, $box, $task);
			}
			
			if ($dbUpToDate) {
				//Check if a password change is needed/requested
				$dontNeedToChangePassword = !session('password_needs_changing') && $task != 'change_password';
				
				if (!$dontNeedToChangePassword) {
					if (arrayKey($box, 'path') != 'change_password') {
						$box = array('path' => 'change_password');
					}
					checkBoxDefinition($box, $tags['change_password']);
					
					$dontNeedToChangePassword = changePasswordAJAX($tags, $box, $task);
				}
				
				
				if ($dontNeedToChangePassword) {
					//Allow the Admin to pass the welcome page at this point
					$_SESSION['admin_logged_in'] = true;
					$_SESSION['hide_empty_slots'] = 1;
					$_SESSION['page_preview_mode'] = 1;
					$_SESSION['page_edit_mode'] = 0;
					$_SESSION['page_slot_mode'] = 0;
					
					if ($task == 'reload_sk' || $task == 'password_changed' || $task == 'site_reset') {
						//Don't show the diagnostics page if someone is performing the site reset, reload_sk or change password tasks
						$doneWithDiagnostics = true;
					} else {
						//Otherwise show the diagnostics page if there are errors to display
						if (arrayKey($box, 'path') != 'diagnostics') {
							$box = array('path' => 'diagnostics');
						}
						checkBoxDefinition($box, $tags['diagnostics']);
						
						$doneWithDiagnostics = diagnosticsAJAX($tags, $box);
					}
					
					if ($doneWithDiagnostics) {
						if (arrayKey($box, 'path') != 'congratulations') {
							$box = array('path' => 'congratulations');
						}
						
						checkBoxDefinition($box, $tags['congratulations']);
						
						if ($task == 'install') {
							//If the CMS was just installed, show the congrats screen
							congratulationsAJAX($tags, $box);
						
						} else {
							//Otherwise redirect the Admin away from this page
							$box['_location'] = redirectAdmin($getRequest);
						}
					}
				}
			}
		}
	}
}


$box['_task'] = $task;
echo json_encode($box);