<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */


if (isset($_GET['action']) && $_GET['action']=="publish") {
	if (checkPriv("_PRIV_PUBLISH_ITEM") && allowPublish ($cID, $cType, $cVersion, $_SESSION["admin_username"], 'dashboard-tooltip')) {
		publishContent ($cID, $cType, $cVersion);
		header("location: ". indexDotPHP(true). "?cID=" . $cID . "&cType=" . $cType . "&cVersion=" . $cVersion);
		exit;
	}
} elseif (isset($_GET['action']) && $_GET['action']=="delete") {
	if (checkPriv("_PRIV_DELETE_DRAFT") && allowDelete ($cID, $cType, $cVersion, $_SESSION["admin_username"])) {
		
		$menuitem = getMenuItemFromContent($cID, $cType);
	
		if ($prev_version = deleteContent ($cID, $cType)) {
			header("location: ". indexDotPHP(true). "?cID=" . $cID . "&cType=" . $cType . "&cVersion=" . $prev_version);
			exit;
		} else {
			if ($menuitem) {
				$mID = $menuitem[0];
				header("location: ". indexDotPHP(true). "?mID=" . $mID );
				exit;
			} else {
				header("location: ". indexDotPHP(true). "?cID=home");
				exit;
			}		
		}
	}
} elseif (isset($_POST['action']) && $_POST['action']=="delete_menu_item") {
	if (checkPriv("_PRIV_DELETE_MENU_ITEM")) {
		
		deleteMenuItem_recursive($_POST['mID']);
		
		if (function_exists("getMenuStructureArray")) {
			$menu_array = getMenuStructureArray(0,0,"","");
			createMenuCache($menu_array);
		}
	}
} elseif (isset($_GET['action']) && $_GET['action']=="trash") {
	if (checkPriv("_PRIV_TRASH_CONTENT") && allowTrash ($cID, $cType, $cVersion, $_SESSION["admin_username"])) {
		trashContent ($cID, $cType, $cVersion);
		header("location: ". indexDotPHP(true). "?cID=home");
		exit;
	}
} elseif (isset($_GET['action']) && $_GET['action']=="hide") {
	if (checkPriv("_PRIV_HIDE_CONTENT") && allowHide ($cID, $cType, $cVersion, $_SESSION["admin_username"])) {
		hideContent ($cID, $cType, $cVersion);
	}
} elseif (isset($_GET['action']) && $_GET['action']=="set_equivalent") {
	$lang = $_GET['lang'];
	$search = $_GET['search'];
	$viewTab = $_GET['cType'];
	header("Location: admin/content_equivalence.php?lang=" . $lang . "&view_tab=" . $cType . "&search=" . $search );
	exit;
} elseif (isset($_GET['action']) && $_GET['action']=="manage_equivalent") {
	$lang = $_GET['lang'];
	$equivId = $_GET['equiv_id'];
	header("Location: admin/content_equivalence_manage.php?lang=" . $lang . "&type=" . $cType . "&id=" . $cID . "&equiv_id=" . $equivId );
	exit;
} elseif (isset($_GET['action']) && $_GET['action']=="add_equivalent") {
	$lang = $_GET['lang'];
	$equivId = $_GET['equiv_id'];
	$start = $_GET['start'];
	header("Location: admin/content_equivalence_set.php?lang=" . $lang . "&type=" . $cType . "&id=" . $equivId . '&start=' . $start );
	exit;
} elseif (isset($_GET['action']) && $_GET['action']=="create_task" && checkModuleReady('workflow.inc.php')) {
	header("Location: admin/task_create.php?cID=" . $cID . "&cType=" . $cType . "&cVersion=" . $cVersion );
	exit;
} elseif (isset($_GET['action']) && $_GET['action']=="add_diagnostic_page") {
	addDiagnosticPage($cID,$cType,getPublishedVersion($cID,$cType));
	header("location: " . SUBDIRECTORY . indexDotPHP(). "?cID=" . $cID . "&cType=" . $cType . "&cVersion=" . $cVersion);
	exit;
} elseif (isset($_GET['action']) && $_GET['action']=="remove_diagnostic_page") {
	removeDiagnosticPage($cID,$cType,getPublishedVersion($cID,$cType));
	header("location: " . SUBDIRECTORY . indexDotPHP(). "?cID=" . $cID . "&cType=" . $cType . "&cVersion=" . $cVersion);
	exit;
} elseif (isset($_GET['action']) && $_GET['action']=="rollback") {
	if (checkPriv("_PRIV_CREATE_REVISION_DRAFT") 
		&& getLatestVersionStatus($cID,$cType)!="private_draft"
		&& getContentStatus($cID,$cType,$cVersion)!="published") {
		createPrivateDraft($cID,$cVersion,getLatestVersion($cID,$cType));
		header("location: " . SUBDIRECTORY . indexDotPHP(). "?cID=" . $cID . "&cType=" . $cType . "&cVersion=" . getLatestVersion($cID,$cType));
		exit;		
	}
}

?>