<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;

//Have an optional parameter that lets us check by email and not username
if ($checkViaEmail) {
	$whereStatement = "email = '". mysql_real_escape_string($adminUsernameOrEmail). "'";
} else {
	$whereStatement = "username = BINARY '". mysql_real_escape_string($adminUsernameOrEmail). "'";
}

//Checking passwords?
if ($password === false) {
	//If not, keep $passwordStatement empty
	$passwordStatement = '';
} else {
	//Otherwise, check the user's password.
	//We need to check if we are using SHA one-way encryption on a password. Any users who
	//have not changed their password or logged in since we implemented this will have their
	//passwords stored as a plain-text.
	//For plain texts, use (BINARY) string comparision for now, until we can fix them below.
	//For encrypted passwords, we need to encrypt the attempted password and compare it against
	//the encrypted password in the database.
	if (checkNewPasswordColumnsExist()) {
		$passwordStatement = "
			IF (password_salt IS NULL, 
				password = BINARY '". mysql_real_escape_string($password). "',
				password = SHA(CONCAT(password_salt, '". mysql_real_escape_string($password). "'))
			) AS password_correct,
			password_salt IS NULL AS password_salt_is_null,";
	} else {
		//Work around for un-patched databases without the columns
		$passwordStatement = "
			password = BINARY '". mysql_real_escape_string($password). "' AS password_correct,
			0 AS password_salt_is_null,";
	}
}

//Check for super admins first
connectGlobalDB();
$sql = "SELECT
			id,
			email,
			status,
			username,
			use_language_id,
			'global' AS `type`,
			". $passwordStatement. "
			CONCAT(first_name, ' ', last_name) AS full_name
		FROM ". DB_NAME_PREFIX_GLOBAL ."superadmins
		WHERE ". $whereStatement. "
		AND status = 'active'";

$result = my_mysql_query($sql);
connectLocalDB();

//Is there a superadmin with that name?
if($details = mysql_fetch_array($result)) {
	
	//Handle the case mentioned above, where we have a user with their password stored
	//as plain text, by setting their password.
	if ($password !== false && $details['password_correct'] && $details['password_salt_is_null']) {
		setPasswordAdmin($details['id'], $details['type'], $password);
	}
	unset($details['password_salt_is_null']);
	
	//Do their passwords match?
	//Return true or false appropriately
	if ($details['password_correct'] && $details['status'] == 'active') {
		return true;
	} else {
		return false;
	}
}

//If we didn't find a superadmin with that name, check for local admins
$sql = "SELECT
			id,
			email,
			status,
			username,
			use_language_id,
			'local' AS `type`,
			". $passwordStatement. "
			CONCAT(first_name, ' ', last_name) AS full_name
		FROM ". DB_NAME_PREFIX ."admins
		WHERE ". $whereStatement;

$result = my_mysql_query($sql);

//Is there an admin with that name?
if($details = mysql_fetch_array($result)) {
	
	//Handle the case mentioned above, where we have a user with their password stored
	//as plain text, by setting their password.
	if ($password !== false && $details['password_correct'] && $details['password_salt_is_null']) {
		setPasswordAdmin($details['id'], $details['type'], $password);
	}
	unset($details['password_salt_is_null']);
	
	//Do their passwords match?
	//Return true or false appropriately
	if ($details['password_correct'] && $details['status'] == 'active') {
		return true;
	} else {
		return false;
	}
}

//If we found no-one with that name, return 0.
	//I want the "user not found" and "password not correct" states to be different,
	//yet still both evaulate to false
return 0;
?>