<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv('_PRIV_VIEW_SLOT')) exit;

//The buttons need to look different depending on whether there is a plugin in the slot or not
$full = $this->instanceId? 'Full' : 'Empty';
$fullAndPhrases = $this->instanceId && $this->pluginClassNameForPhrases? 'Full' : 'Empty';
$fullAndParent = $this->instanceId && ($parent = getInstanceParent($this->instanceId))? 'Full' : 'Empty';
$fullAndNotParent = $this->instanceId && !$parent? 'Full' : 'Empty';

//Get the Template id from index.php, as well as the cID to check if this is an error page
global $use_template_id, $cID;

//Write two buttons to the page; one for managing the slot contents and one for editing the
//settings of the plugin in the slot. CSS is used so that the edit settings button is invisible
//when the slot is empty
//The slot controls should not be shown on the error pages
if (is_numeric($cID)) {
	echo '
		<div id="', $this->containerId, '-control_box" class="tribiq_slotAdminControlBox">';
	
	if (checkPriv('_PRIV_MANAGE_ITEM_SLOT') || checkPriv('_PRIV_MANAGE_TEMPLATE_SLOT')) {
		
		echo '
			<a
				href="#"
				class="tribiq_slotAddContents', $full, '"
				id="', $this->containerId, '-add_contents"
				title="', getPhrase('Add Plugin|Add a Plugin into the Slot &quot;[[slot_name]]&quot;', array('slot_name' => str_replace('_', ' ', $this->slotName))), '"
				onclick="return tribiqA.', checkPriv('_PRIV_MANAGE_ITEM_SLOT')? 'pickNewPlugin' : 'managePluginSlot', '(this, \'', $this->slotName, '\');"
			></a>';
	}
	
	if (checkPriv('_PRIV_MANAGE_PLUGIN_THEME')) {
		echo '
			<a
				href="#"
				class="tribiq_changeTheme', $full, '"
				id="', $this->containerId, '-theme"
				title="', getPhrase('Change the appearance of this Plugin|Click to change the Theme for the Plugin Instance for this Slot.'), '"
				onclick="return tribiqA.pluginSlotChangeTheme(this, event, \'', $this->slotName, '\');"
			></a>';
		
		global $skin;
		cms_core::$pluginPossibleThemes .= '
				tribiqA.slotPossibleThemes["'. $this->slotName. '"] =
					'. json_encode(listPluginThemeCSS($this->pluginName, $this->pluginClassName, $this->framework, $this->frameworkPluginClassName, $skin['id'])). ';';
	}
	
	if (checkPriv('_PRIV_VIEW_VLP')) {
		echo '
			<a
				href="#"
				class="tribiq_phrases', $fullAndPhrases, '"
				id="', $this->containerId, '-phrases"
				title="', getPhrase('View/Manage Phrases|Click to view or manage Phrases for this Plugin.'), '"
				onclick="return tribiqA.pluginPhrases(this, \'', $this->slotName, '\');"
			></a>';
	}
	
	if (checkPriv('_PRIV_VIEW_PLUGIN_INSTANCE')) {
		echo '
			<a
				href="#"
				class="tribiq_editSettings', $full, '"
				id="', $this->containerId, '-edit"
				title="', getPhrase('Settings for the Plugin Instance: | &quot;[[instance_name]]&quot;<br/>Click to access its Settings.', array('instance_name' => htmlspecialchars($this->instanceName))), '"
				onclick="return tribiqA.pluginSlotEditSettings(this, \'', $this->slotName, '\');"
			></a>';
	}
	
	echo '
			<a
				href="#"
				class="tribiq_slotContents', $fullAndNotParent, '"
				id="', $this->containerId, '-contents"
				title="', getPhrase(
							'[[slot_name]]|Plugin: [[plugin_name]]<br/>Instance: [[instance_name]]<br/>Scope: [[level]]<br/>Click to change the scope of this Plugin Instance, to remove it or to replace it.',
							array(
								'level' => $this->cmsPluginApiLinkGetSlotLevel(),
								'slot_name' => str_replace('_', ' ', $this->slotName),
								'plugin_name' => htmlspecialchars(getPluginDisplayName($this->pluginId)),
								'instance_name' => htmlspecialchars($this->instanceName))), '"
				onclick="return tribiqA.managePluginSlot(this, \'', $this->slotName, '\');"
			></a>';
	
	if (checkPriv('_PRIV_MANAGE_PLUGIN_INSTANCE')) {
		echo '
			<a
				href="#"
				class="tribiq_rollout', $fullAndParent, '"
				id="', $this->containerId, '-rollout"
				title="', getPhrase('Apply new settings...'), '"
				onclick="return tribiqA.pluginSlotRollout(this, \'', $this->slotName, '\');"
			></a>
			<a
				href="#"
				class="tribiq_rollback', $fullAndParent, '"
				id="', $this->containerId, '-rollback"
				title="', getPhrase('Abandon new settings'), '"
				onclick="return tribiqA.pluginSlotRollback(this, \'', $this->slotName, '\');"
			></a>';
	}
	
	echo '
		</div>';
}

return false;
?>