<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || arrayKey($_SESSION, 'admin_logged_into_site') != SUBDIRECTORY. SITENAME) exit;

if ($formInputs['cID']) {
	$item_meta = getItemMeta($formInputs['cID'],$formInputs['cVersion']);
	$title = $item_meta['title'];
	$language_id = $item_meta['language_id'];
	$status = $item_meta['status'];
	$description = $item_meta['description'];
	$keywords = $item_meta['keywords'];
	
	if (checkModuleReady("microsites-cms.inc.php")) {
		$microsite_id = getMicrositeIdFromContent($formInputs['cID'], $formInputs['cType'], $formInputs['cVersion']);
	}
}

if ($showPubDate = shouldCTypeShowPubDate($formInputs['cType'])) {
	if ($formInputs['cID']) {
		$publication_date = getPublicationDate($formInputs['cID'],$formInputs['cVersion']);
	} else {
		//Make sure that there is a default publication date set
		$row = mysql_fetch_row(my_mysql_query("SELECT CURRENT_DATE()"));
		$publication_date = $row[0];
	}
}

if ($editMode && isset($formInputs['title'])) {
	$title = $formInputs['title'];
	$language_id = $formInputs['language_id'];
	$description = $formInputs['description'];
	$keywords = $formInputs['keywords'];
	$publication_date = $formInputs['publication_date'];
} elseif (!$formInputs['cID']) {
	$language_id = $formInputs['suggestedLanguageId'];
}

if (!$status) {
	$status = "private_draft";
}

if ($editMode) {
	
	$formhtml = getPhrase("Use this screen to edit Meta Data for this Content Item. A meaningful Title, Description and Keywords may help with search engine optimization. On HTML Content Items, you can define a textual Alias to identify this content.");

	$formhtml .= "<form name=\"setmetadata\" action=\"?width=". $formInputs['width'] . "&height=" . $formInputs['height'] . "&KeepThis=true&TB_iframe=true&modal=true\" id=\"setmetadata\" method=\"post\" class=\"thickbox\" onsubmit=\"formHandler(); return false;\">
					<input type=\"hidden\" id=\"formMode\" name=\"formMode\" value=\"edit\" />
					\n";
	
	$formhtml .= "<table class=\"thickbox_table\" id=\"content_form\" border=\"0\">	
						<tr id=\"errorDisplayRow\" style=\"display:none;\">
							<td>&nbsp;</td>
							<td><div id=\"errorDisplay\" style=\"display:none;\">" . $errordisplay . "</div></td>
						</tr>			
							</td>
						</tr>\n";
	
	if (!$formInputs['cID'] && ($formInputs['cType']=="document" || $formInputs['cType']=="picture" || $formInputs['cType']=="audio" || $formInputs['cType']=="video")) {
		if ($formInputs['filename_as_title']) {
			$filename_as_title_checked = " checked=\"checked\"";
		} else {
			$filename_as_title_checked = "";
		}
		
		$formhtml .= "<tr>
						<td class=\"title\"><label for=\"filename_as_title\">" . getPhrase('_FILENAME_AS_TITLE:') . "</label></td>
						<td>
							<input type=\"checkbox\" name=\"filename_as_title\" id=\"filename_as_title\"" . $filename_as_title_checked . " />
							<div class=\"icon_field\"></div>
						</td>
					</tr>\n";			
	}	
					
						
	$formhtml .= "<tr";
					
	if ($error['title']) {
		$formhtml .= " class=\"inputerror\"";
	}
					
	$formhtml .= "					>
							<td class=\"title\"><label for=\"title\">" . getPhrase('Browser Title:') . "</label></td>
							<td ". mandatory($title). ">
								<input class=\"form_field\" name=\"title\" id=\"title\" required=\"true\" cssErrorClass=\"input_text_error\" value=\"" . htmlspecialchars($title) . "\" />
								<div class=\"icon_field\"></div>
								<br/><br/><i>". getPhrase('Create a keyword-rich Title for good SEO.'). "</i>
							</td>
						</tr>\n";

	if (checkModuleReady("microsites-cms.inc.php")) {
		if ($microsites = getMicrosites()) {
			if(!$formInputs['cID']) {
				$formhtml .= "		<tr>
										<td class=\"title\"><label for=\"microsite_id\">" . getPhrase('_MICROSITE:') . "</label></td>
										<td>
											<select class=\"form_field\" name=\"microsite_id\" id=\"microsite_id\">
												<option value=\"\">" . getPhrase("_NONE_SPECIFIED") . "</option>\n";
				
				if ($microsites) {
					foreach ($microsites as $microsite) {
						if ($microsite['id']==$formInputs['microsite_id']) {
							$selected = " selected=\"selected\"";
						} else {
							$selected = "";
						}
					
						$formhtml .= "<option value=\"" . $microsite['id'] . "\"" . $selected . ">" . $microsite['name'] . "</option>\n";
					}
				}
	
				$formhtml .= "				</select>
											<div class=\"icon_field\"></div>
										</td>
									</tr>\n";
			} else {
				if ($microsite = getMicrosite($microsite_id)) {
					$microsite_name = $microsite['name'];
				} else {
					$microsite_name = getPhrase("_NOT_SET");
				}
				
				$formhtml .= "		<tr>
										<td class=\"title\"><label for=\"microsite_id\">" . getPhrase('_MICROSITE:') . "</label></td>
										<td>" . $microsite_name . "</td>
									</tr>\n";
			}
		}
	}
	
	$formhtml .= "		<tr>
							<td class=\"title\"><label for=\"language\">" . getPhrase('_LANGUAGE:') . "</label></td>
							<td>";
	
	if ($formInputs['cID'] || $formInputs['suggestedLanguageId']) {
		$lang = ifNull($language_id, $formInputs['suggestedLanguageId']);
		$formhtml .= "
								" . htmlspecialchars(getLanguageName($lang)) . "
								<input type=\"hidden\" name=\"language_id\" value=\"" . htmlspecialchars($lang) . "\"/>";
	} else {
		$formhtml .= "
								<select class=\"form_field\" name=\"language_id\" id=\"language_id\">";
									
		$arrLanguages = getLanguages();
		
		foreach ($arrLanguages as $language) {
			if ($language['id']==$language_id) {
				$selected = "selected=\"selected\"";
			} else {
				$selected = "";		
			}
			
			$formhtml .= "										<option value=\"" . $language['id'] . "\" " . $selected . " style=\"background-image: url(../admin/images/flags/" .  $language['flag'] . ".gif); background-position:right; background-repeat:no-repeat\">" . $language['language_local_name'] . "\n";
		}
				
		$formhtml .= "									</select>
								<div class=\"icon_field\"></div>";
	}
	
	$formhtml .= "
							</td>
						</tr>
						<tr>
							<td class=\"title\">" . getPhrase('_STATUS:') . "</td>
							<td>" . $status . "</td>
						</tr>
						<tr>
							<td class=\"title\">&nbsp;</td>
							<td><a href=\"#\" onclick=\"tribiqTab.propagateName(); return false;\">Click to Auto fill Description and Keywords</a></td>
						</tr>
						<tr>
							<td class=\"title\"><label for=\"description\">" . getPhrase('Description Meta Tag:') . "</label></td>
							<td>
								<textarea class=\"form_field\" name=\"description\" id=\"description\" cols=\"34\" rows=\"4\">" . htmlspecialchars($description) . "</textarea>
								<div class=\"icon_field\"></div>
							</td>
						</tr>
						<tr>
							<td class=\"title\"><label for=\"keywords\">" . getPhrase('Keywords Meta Tag:') . "</label></td>
							<td>
								<textarea class=\"form_field\" name=\"keywords\" id=\"keywords\" cols=\"34\" rows=\"4\">" . htmlspecialchars($keywords) . "</textarea>
								<div class=\"icon_field\"></div>
							</td>
						</tr>";
	
	if ($showPubDate) {
		$formhtml .= "
						<tr>
							<td class=\"title\" ><label for=\"publication_date\">" . getPhrase('_PUBLICATION_DATE:') . "</label></td>
							<td >
								<input class=\"form_field\" style=\"width: 10em; margin-right: 0.5em;\" name=\"publication_date\" id=\"publication_date\" value=\"" . htmlspecialchars($publication_date) . "\" readonly=\"readonly\" />
								<input type=\"button\" value=\"". getPhrase('Clear'). "\" onclick=\"get('publication_date').value='';\"/>
							</td>
						</tr>";
	}
	
	if ($showEditButton) {
		$formhtml .= "
						<tr>
							<td>&nbsp;</td>
							<td class=\"left\">
								<input type=\"submit\" id=\"submit\" class=\"submit\" value=\"" . getPhrase("_CANCEL") . "\" onclick=\"cancelEdit();\" />
							</td>
						</tr>";
	}
	
	$formhtml .= "
					</table>
				</form>";
			
} else {

	$formhtml = getPhrase("				
Use this screen to edit Meta Data for this Content Item. A meaningful Title, Description and Keywords may help with search engine optimization. On HTML Content Items, you can define a textual Alias to identify this content.");

	$formhtml .= "<form name=\"setmetadata\" action=\"?width=". $formInputs['width'] . "&height=" . $formInputs['height'] . "&KeepThis=true&TB_iframe=true&modal=true\" id=\"editmetadata\" method=\"post\" class=\"thickbox\" onsubmit=\"formHandler(this);return false;\">
					<input type=\"hidden\" id=\"formMode\" name=\"formMode\" value=\"view\" />
					<table class=\"thickbox_table\" id=\"content_form\" border=\"0\">
						<tr>
							<td class=\"title\">" . getPhrase('Browser Title:') . "</td>
							<td>
								" . htmlspecialchars($title) . "
								<br/><i>". getPhrase('Create a keyword-rich Title for good SEO.'). "</i>
							</td>
						</tr>";
						
	if (checkModuleReady("microsites-cms.inc.php")) {
		if ($microsites = getMicrosites()) {
			if ($microsite = getMicrosite($microsite_id)) {
				$microsite_name = $microsite['name'];
			} else {
				$microsite_name = getPhrase("_NOT_SET");
			}
			
			$formhtml .= "		<tr>
									<td class=\"title\"><label for=\"microsite_id\">" . getPhrase('_MICROSITE:') . "</label></td>
									<td>" . $microsite_name . "</td>
								</tr>\n";
		}
	}
	
	$formhtml .= "		<tr>
							<td class=\"title\">" . getPhrase('_LANGUAGE:') . "</td>
							<td>" . htmlspecialchars(getLanguageName($language_id)) . "</td>
						</tr>
						<tr>
							<td class=\"title\">" . getPhrase('_STATUS:') . "</td>
							<td>" . $status . "</td>
						</tr>
						<tr>
							<td class=\"title\">" . getPhrase('Description Meta Tag:') . "</td>
							<td>" . htmlspecialchars($description) . "</td>
						</tr>
						<tr>
							<td class=\"title\">" . getPhrase('Keywords Meta Tag:') . "</td>
							<td>" . htmlspecialchars($keywords) . "</td>
						</tr>";
	
	if ($showPubDate) {
		$formhtml .= "
						<tr>
							<td class=\"title\" >" . getPhrase('_PUBLICATION_DATE:') . "</td>
							<td >" . htmlspecialchars(formatDateNicely($publication_date, 'vis_date_format_long')) . "</td>
						</tr>";
	}
	
	if ($showEditButton && (($formInputs['cVersion']==getLatestVersion($formInputs['cID'],$formInputs['cType'])) || getLatestVersionStatus($formInputs['cID'],$formInputs['cType'])!="private_draft")) {
		$formhtml .= "		<tr>
								<td>&nbsp;</td>
								<td class=\"left\">
									<input type=\"submit\" id=\"submit\" name=\"submit\" class=\"submit\" value=\"" . getPhrase("_EDIT") . "\" />
								</td>
							</tr>\n";
	}
	
	$formhtml .= "
					</table>
				</form>";
}

return array($formhtml,$msg,$type_msg);
?>