<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || arrayKey($_SESSION, 'admin_logged_into_site') != SUBDIRECTORY. SITENAME) exit;

$error = array();

if ($_FILES[$filename]) {
	if (is_uploaded_file($_FILES[$filename]['tmp_name'])) {
		if ($_FILES[$filename]['size'] > $maxSize) {
			$error['document'] = getPhrase('_FILE_UPLOAD_ERROR_SIZE', array('size' => $maxSize));
		}		
		
		if ($movie) {
			$ext = explode('.', $_FILES[$filename]['name']);
			if (($c = count($ext)) > 1 && $ext[$c-1] == 'mov') {
				$image = array('mime' => 'video/quicktime');
			} elseif ($c > 1 && $ext[$c-1] == 'swf') {
				$image = array('mime' => 'application/x-shockwave-flash');
			} elseif ($c > 1 && $ext[$c-1] == 'wmv') {
				$image = array('mime' => 'audio/x-ms-wmv');
			} else {
				$error['document'] = getPhrase('_INVALID_MOVIE_TYPE');
			}
		} else {
			if (strtolower(substr($_FILES[$filename]['name'], -4)) == '.ico') {
				$image = array(0, 0, '', '', 'mime' => 'image/vnd.microsoft.icon');
			} else {
				$image = getimagesize($_FILES[$filename]['tmp_name']);
			}
			
			$validTypes = array('image/jpeg','image/gif','image/png','image/jpg','image/pjpeg');
			if ($type == 'favicon') {
				$validTypes[] = 'image/vnd.microsoft.icon';
			}
			
			if (!in_array($image['mime'], $validTypes)) {
				$error['document'] = getPhrase('_INVALID_IMAGE_TYPE');
			}
		}
	} else {
		if ($movie) {
			switch ($_FILES[$filename]['error']) {
				case 1:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_SIZE', array( 'size' => $maxSize ) );
					break;
				case 2:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_SIZE', array( 'size' => $maxSize ) );
					break;
				case 3:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_PARTIAL_UPLOAD', array( 'size' => $maxSize ) );
					break;
				default:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_EMPTY', array( 'size' => $maxSize ) );
			}
		} else {
			switch ($_FILES[$filename]['error']) {
				case 1:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_SIZE', array( 'size' => $maxSize ) );
					break;
				case 2:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_SIZE', array( 'size' => $maxSize ) );
					break;
				case 3:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_PARTIAL_UPLOAD', array( 'size' => $maxSize ) );
					break;
				default:
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_EMPTY', array( 'size' => $maxSize ) );
			}		
		}
	}

	if (!count($error)) {
		
		$size = $_FILES[$filename]['size'];
		$imageData = file_get_contents($_FILES[$filename]['tmp_name']);
		
		$sticky = 0;
		$image['width'] = $image[0];
		$image['height'] = $image[1];
		$image['mime_type'] = $image['mime'];
		$image['filename'] = $_FILES[$filename]['name'];
		

		if ($type == 'user') {
			$sql = '
			REPLACE INTO ' . DB_NAME_PREFIX . 'user_images
			SET user_id = ' . (int) $id . ',
				`usage` = "fullsize",';
			
			$sticky = !checkRowExists('user_images', array('user_id' => $id, 'sticky_flag' => 1));
			
		} elseif ($type == 'group') {
			$sql = '
			REPLACE INTO ' . DB_NAME_PREFIX . 'group_images
			SET group_id = ' . (int) $id . ',
				`usage` = "fullsize",';
			
			$sticky = !checkRowExists('group_images', array('group_id' => $id, 'sticky_flag' => 1));
			
		} elseif ($type == 'favicon') {
			$sql = '
			REPLACE INTO ' . DB_NAME_PREFIX . 'favicons
			SET `usage` = "'. ($image['mime_type'] == 'image/vnd.microsoft.icon'? 'favicon' : 'mobile'). '",';
			
		} elseif ($type == 'storekeeper_populate') {
		
			$sql = '
			REPLACE INTO ' . DB_NAME_PREFIX . ($movie? 'movies' : 'images'). '
			SET content_item_id = ' . (int) $cID . ',
				content_item_version = ' . (int) $cVersion . ',
				content_item_type = \'' . mysql_real_escape_string($cType) . '\',
				created_datetime = NOW(),';
			
			$image['content_item_id'] = $cID;
			$image['content_item_type'] = $cType;
			$image['content_item_version'] = $cVersion;
			
			if ($cID) {
				$sticky = !checkRowExists(
							$movie? 'movies' : 'images',
							array(
								'content_item_id' => $cID,
								'content_item_type' => $cType,
								'content_item_version' => $cVersion,
								'sticky_flag' => 1));
			}
		}
		
		$sql .= '
				filename = "' . mysql_real_escape_string($image['filename']) . '",
				mime_type = "' . mysql_real_escape_string($image['mime_type']) . '",
				width = ' . (int) $image['width'] . ',
				height = ' . (int) $image['height'] . ',
				size = '.  (int) $size. ',
				data = "' . mysql_real_escape_string($imageData) . '",
				checksum = "' . ($checksum = md5($imageData)) . '"';
		
		if ($type != 'favicon') {
			$sql .= ',
				sticky_flag = '. (int) $sticky;
		}
		
		if ($type == 'storekeeper_populate') {
			$sql .= ',
				checksum_inc_name = "' . ($checksum = md5($image['filename']. $checksum)) . '"';
		}
		
		if (!$movie && $type != 'favicon') {
			$sql .= ',';
			require CMS_ROOT. 'tb/ajax/includes/storekeeper_image_populator.php';
		}

		$result = my_mysql_query($sql);
		return $checksum;
	} else {
		return $error;
	}
} else {
	return array(getPhrase("_ERR_FILE_SIZE_GREATER_THAN_SERVER_LIMIT"));
}
?>