<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || arrayKey($_SESSION, 'admin_logged_into_site') != SUBDIRECTORY. SITENAME) exit;

//Keep some results on what happens
$numberOf = array('upload_error' => false, 'wrong_language' => false, 'added' => 0, 'updated' => 0, 'protected' => 0);

//Assume that phrases are core, unless we see a Plugin's name
$pluginClass = '';
$columns = false;
$justHadAnEmptyLine = true;
$knownColumnHeader = array('Target Language ID' => 1, 'Phrase Code' => 1, 'Translation' => 1, 'Plugin' => 1);

//Open the file
require_once CMS_ROOT. 'libraries/mit/parsecsv/parsecsv.lib.php';
$pCSV = new parseCSV();
ini_set('auto_detect_line_endings', true);
$f = fopen($file, "r");

//Loop through each row
//Note: Replaced a call to fgetcsv() with a call to parsecsv when reading CSV files, as it has far less compatability issues
while ($row = fgets($f)) {
	$row = $pCSV->parse_string("0,1,2,3,4,5\n". $row. "\n");
	$row = arrayKey($row, 0);
	$rowCount = count($row);
	
	//Ignore empty lines, though remember that we've had them
	if (!$row || $rowCount == 0 || $row[0] === '' || $row[0] === null) {
		$justHadAnEmptyLine = true;
		continue;
	
	
	//Look out for column headers if we've not had them already...
	//...or if we've just had an empty line and we see what looks like a column header
	} elseif ((
			!$columns || $justHadAnEmptyLine
		) && (
			$knownColumnHeader[arrayKey($row, 0)] ||
			$knownColumnHeader[arrayKey($row, 1)] ||
			$knownColumnHeader[arrayKey($row, 2)]
	)	) {
		
		//Little hack so that the import does not fail if someone overtypes the "Translation" column
		if (arrayKey($row, 0) == 'Phrase Code' && arrayKey($row, 1) == 'Reference Text' && arrayKey($row, 2)) {
			$row[2] = 'Translation';
		} elseif (arrayKey($row, 0) == 'Phrase Code' && arrayKey($row, 1)) {
			$row[1] = 'Translation';
		} elseif (arrayKey($row, 0) && arrayKey($row, 1) == 'Phrase Code') {
			$row[0] = 'Translation';
		}
		
		$columns = array_flip($row);
	
	
	//Check if this row has information on a phrase
	} elseif (isset($columns['Phrase Code']) && isset($columns['Translation'])) {
			//Report an error if we've not found the language id yet
			if ($scanning === true || $languageId === false) {
				$numberOf['upload_error'] = true;
				fclose($f);
				return $numberOf;
			
			} elseif ($scanning === 'full scan')  {
				++$numberOf['added'];
			
			//Add the phrase (unless it is for a Plugin that we don't have)
			} elseif ($pluginClass !== false) {
				importVisitorPhrase($languageId, $pluginClass, $row[$columns['Phrase Code']], $row[$columns['Translation']], $adding, $numberOf);
			}
	
	//Handle setup-information (allow this to be on the same line if needed)
	} else {
		//Look out for the language_id in the file before we have the data
		//The language id of this pack should be in the row immediately after
		if (isset($columns['Target Language ID'])) {
			
			//Read and note down the language_id
			$packLanguageId = $row[$columns['Target Language ID']];
					
			//If we were just looking for the language id, return it
			if ($scanning) {
				$languageId = $packLanguageId;
				if ($scanning !== 'full scan') {
					fclose($f);
					return;
				}
			
			//Are we adding a new VLP? Use the language id from the language pack if so
			} elseif ($adding && !$languageId) {
				$languageId = $packLanguageId;
			
			//Are we updating an existing VLP? Check the language id from the pack matches this language id
			} elseif($packLanguageId != $languageId && !$forceLanguageIdOverride) {
				$numberOf['wrong_language'] = true;
				fclose($f);
				return $numberOf;
			}
		}
		
		//Look out for phrases associated with a Plugin
		if (isset($columns['Plugin'])) {
			if (!$row[$columns['Plugin']]) {
				$pluginClass = '';
			
			//Check: do we have this Plugin..?
			} elseif ($scanning === 'full scan' || getPluginIdByClassName($row[$columns['Plugin']])) {
				$pluginClass = $row[$columns['Plugin']];
			} else {
				$pluginClass = false;
			}
		}
	}
}
fclose($f);

return $numberOf;
?>