<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || arrayKey($_SESSION, 'admin_logged_into_site') != SUBDIRECTORY. SITENAME) exit;

if (($valid = validateAddLanguage($details, $tab)) && ($valid['valid'])) {
	
	//Get the first HTML Template from the database
	$templates = getAllExistingTemplates('html', 0, -1, 1, false);
	
	//Fetch the defaut values for templates
	$default_ids = mysql_fetch_assoc(my_mysql_query("
		SELECT default_template_id
		FROM " . DB_NAME_PREFIX . "contenttypes
		WHERE content_type_id = 'html'
	"));
	
	//The home page is mandatory; search page and extranet pages are optional
	$pages_to_add = array();
	if ($tab == 1) {
		$pages_to_add['home_page_alias'] = 'homepage_id';
		
		if ($details['create_search_page']) {
			$pages_to_add['search_page_alias'] = 'search_page_id';
		}
	
	} elseif ($tab == 2) {
		if ($details['create_extranet_login_page']) {
			$pages_to_add['extranet_login_page_alias'] = 'extranet_login_page_id';
		}
		
		if ($details['create_extranet_registration_page']) {
			$pages_to_add['extranet_registration_page_alias'] = 'extranet_registration_page_id';
		}
		
		if ($details['create_extranet_password_reminder_page']) {
			$pages_to_add['extranet_password_reminder_page_alias'] = 'extranet_password_reminder_page_id';
		}
		
		if ($details['create_extranet_change_password_page']) {
			$pages_to_add['extranet_change_password_page_alias'] = 'extranet_change_password_page_id';
		}
		
		if ($details['create_extranet_logout_page']) {
			$pages_to_add['extranet_logout_page_alias'] = 'extranet_logout_page_id';
		}
	}
	
	
	//Work out how many menu items have already been created
	if ($tab == 1) {
		$i = 0;
	} else {
		$i = $details['sp_alias']? 2 : 1;
	}
	
	//Create the content items needed
	foreach ($pages_to_add as $aliasColumn => $langColumn) {
		$alias = $details[$aliasColumn];
	
		//Fetch the previously used content id, and get the next one. Or use 1, if there was none.
		if ($contentId = getLatestContentID('html')) {
			++$contentId;
		} else {
			$contentId = 1;
		}

		//Add home/search/login pages to the menu
		if ($tab == 1 || $aliasColumn == 'extranet_login_page_alias') {
			++$i;
			foreach (array('Main' => 'primary', 'Footer' => 'secondary') as $menuSection => $redundancy) {
				my_mysql_query("
					INSERT INTO ". DB_NAME_PREFIX. "menuitems (
						section_id,
						redundancy,
						name,
						target_loc, content_id, content_type,
						html_content_alias,
						language_id,
						accesskey, mode, ext_url, ordinal, active,
						hide_private_item
					)
					VALUES (
						'". mysql_real_escape_string($menuSection). "',
						'". mysql_real_escape_string($redundancy). "',
						'". mysql_real_escape_string($alias). "',
						'int', ". $contentId. ", 'html',
						'". mysql_real_escape_string($alias). "',
						'". mysql_real_escape_string($details['lang']). "',
						'', '', '', ". (int) $i. ", 0,
						". ($aliasColumn == 'extranet_login_page_alias'? 2 : 0). "
					)"
				);
			}
		}
		
		$pageContents = '<h1>'. htmlspecialchars($alias). '</h1>';
		
		if (substr($details['lang'], 0, 2) == 'en') {
			if ($aliasColumn == 'home_page_alias') {
				$pageContents = getPhrase(
<<<_text
<h1>Welcome to your new Tribiq CMS site!</h1>
<p>Congratulations, you have just installed your new Tribiq site.</p>
<p>You can edit this page as you wish by clicking on the "edit" icon just above this text.</p>
<p>Don't forget! You will need to Publish this Content Item by clicking on the "Publish" button in the Admin Toolbar above this page.</p>
<p>Get support, Plugins, Templates, Skins and much more at <a target="_blank" href="http://tribiq.com">http://tribiq.com</a>.</p>
<p>We hope you enjoy using Tribiq CMS.</p>
_text
					);
			} elseif ($aliasColumn == 'extranet_login_page_alias') {
				$pageContents = getPhrase(
<<<_text
<h1>Extranet Page</h1>
<p>This page is your default Extranet Login Page. Visitors who are not logged in will be directed here if they attempt to access a Content Item that requires registration.</p>
<p>Before you can use this page, you need to place an Instance of the Extranet Login Plugin on this page.</p>
_text
					);
			} elseif ($aliasColumn == 'extranet_registration_page_alias') {
				$pageContents = getPhrase(
<<<_text
<h1>Extranet Page</h1>
<p>This page is your default Extranet Registration Page. Visitors who attempt to Register with your site will be directed here.</p>
<p>Before you can use this page, you need to:</p>
<ol><li>Place an Instance of the Extranet Registration Plugin on this page.</li>
<li>Select an appropriate Email Template in the Extranet Registration Plugin's settings.</li></ol>
_text
					);
			} elseif ($aliasColumn == 'extranet_password_reminder_page_alias') {
				$pageContents = getPhrase(
<<<_text
<h1>Extranet Page</h1>
<p>This page is your default Extranet Password Reminder Page. Visitors who ask for a reminder of their password will be directed here.</p>
<p>Before you can use this page, you need to:</p>
<ol><li>Place an Instance of the Extranet Password Reminder Plugin on this page.</li>
<li>Select an appropriate Email Template in the Extranet Password Reminder Plugin's settings.</li></ol>
_text
					);
			} elseif ($aliasColumn == 'extranet_change_password_page_alias') {
				$pageContents = getPhrase(
<<<_text
<h1>Extranet Page</h1>
<p>This page is your default Extranet Change Password Page. Visitors who with to change their password will be directed here.</p>
<p>Before you can use this page, you need to place an Instance of the Extranet Change Password Plugin on this page.</p>
_text
					);
			} elseif ($aliasColumn == 'extranet_logout_page_alias') {
				$pageContents = getPhrase(
<<<_text
<h1>Extranet Page</h1>
<p>This page is your default Extranet Logout Page. Visitors will be directed here when they click on a &quot;logout&quot; link.</p>
<p>Before you can use this page, you need to place an Instance of the Extranet Logout Plugin on this page.</p>
_text
					);
			} elseif ($aliasColumn == 'search_page_alias') {
				$pageContents = getPhrase(
<<<_text
<h1>Search Page</h1>
<p>This page is your default Search Page.</p>
<p>If you put a Search Entry Box Plugin on your site, Visitors will be directed here if they launch a search.</p>
<p>Before you can use this page, you need to:</p>
<ol><li>Place an Instance of the Search Results Plugin on this page.</li>
<li>Place an Instance of the Search Entry Box Plugin on elsewhere on your site.</li></ol>
_text
					);
			}
		}
		
		//Create a content entry for this page
		my_mysql_query("
			INSERT INTO ".DB_NAME_PREFIX."content_html (
				id,
				title,
				language_id,
				created_datetime, 
				owner_id, owner_authtype, 
				creating_author_id, creating_author_authtype,
				last_author_id, last_author_authtype,
				template_id,
				alias,
				content_bodymain,
				spare_varchar1, spare_varchar2, new_menu_text,
				status
			)
			VALUES (
				 " . (int) $contentId . ",
				'" . mysql_real_escape_string($alias) . "',
				'" . mysql_real_escape_string($details['lang']) . "',
					 NOW(),
				 " . (int) $_SESSION["admin_userid"] . ", '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
				 " . (int) $_SESSION["admin_userid"] . ", '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
				 " . (int) $_SESSION["admin_userid"] . ", '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
				 " . (int) $templates[0]['template_id'] . ",
				'" . mysql_real_escape_string($alias) . "',
				'" . mysql_real_escape_string($pageContents) . "',
				 '', '', '',
				 'private_draft'
			)"
		);
		
		$details[str_replace('_alias', '_id', $aliasColumn)] = $contentId;
		
		if (inc('tribiq_avls')) {
			if ($equivCID = getRow('languages', $langColumn, array(), true)) {
				tribiq_avls::recordEquivalenceOfDuplicatedLanguage('html', $equivCID, $contentId);
			}
		}


	}
	
	if ($tab == 1) {
		//Add language to languages table
		my_mysql_query("
			INSERT INTO ".DB_NAME_PREFIX."languages (
				id,
				homepage_id,
				search_page_id,
				language_local_name,
				flag_file_name
			)
			VALUES (
				'" . mysql_real_escape_string($details['lang']) . "',
				". (int) arrayKey($details, 'home_page_id'). ",
				". (int) arrayKey($details, 'search_page_id'). ",
				'" . mysql_real_escape_string(getVLPPhrase('__LANGUAGE_LOCAL_NAME__', '', $details['lang'])) . "',
		replace('" . mysql_real_escape_string(getVLPPhrase('__LANGUAGE_FLAG_FILENAME__', '', $details['lang'])) . "', '.gif', '')
			)"
		);	
		
		$numRowsResult = my_mysql_query("SELECT count(*) FROM " . DB_NAME_PREFIX . "languages");
		$numLanguages = mysql_fetch_array($numRowsResult);
		$numLanguages = $numLanguages[0];
		
		
		//Set this homepage as the default homepage if none is set
		if ($numLanguages==1) {
			$sql = "
				UPDATE ".DB_NAME_PREFIX."site_settings SET
					value = ". (int) arrayKey($details, 'home_page_id'). "
				WHERE name = 'default_homepage_id'";
		} else {
			$sql = "
				UPDATE ".DB_NAME_PREFIX."site_settings SET
					value = ". (int) arrayKey($details, 'home_page_id'). "
				WHERE name = 'default_homepage_id'
				  AND value IS NULL";
		}
		my_mysql_query($sql);
	
	} elseif ($tab == 2) {
		//Update the languages table
		my_mysql_query("
			UPDATE ".DB_NAME_PREFIX."languages SET
				extranet_login_page_id = ". (int) arrayKey($details, 'extranet_login_page_id'). ",
				extranet_registration_page_id = ". (int) arrayKey($details, 'extranet_registration_page_id'). ",
				extranet_password_reminder_page_id = ". (int) arrayKey($details, 'extranet_password_reminder_page_id'). ",
				extranet_change_password_page_id = ". (int) arrayKey($details, 'extranet_change_password_page_id'). ",
				extranet_logout_page_id = ". (int) arrayKey($details, 'extranet_logout_page_id'). "
			WHERE id = '". mysql_real_escape_string($details['lang']). "'"
		);
	}
	
}

return false;
?>