<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;

if ($authtype == "local") {
	$prefix = DB_NAME_PREFIX;
	$table = 'admins';
} else {
	$prefix = DB_NAME_PREFIX_GLOBAL;
	$table = 'superadmins';
	connectGlobalDB();
}

//Build up an insert/update statement using the values we have for the fields
$sql = "";
foreach(getFields($prefix, $table) as $field => $details) {
	if ($field != 'password' && isset($newAdmin[$field])) {
		addFieldToSQL($sql, $prefix. $table, $field, $newAdmin, $admin_id, $details);
	}
}

//Handle passwords using a special logic
if ($newAdmin['password']) {
	//The update Password tab only has the password on it.
	//In this case the $sql query will be empty and needs starting
	if (!$sql) {
		$sql .= "UPDATE ". $prefix. $table. " SET";
	} else {
		$sql .= ",";
	}
	
	if (checkNewPasswordColumnsExist()) {
		//Generate a random salt for this password. If someone gets hold of the encrypted value of
		//the password in the database, having a salt on it helps to stop dictonary attacks.
		$salt = randomString(8);
		
		$sql .= "
			password_salt = '". $salt. "',
			password_needs_changing = 0,
			password = SHA('". mysql_real_escape_string($salt. $newAdmin['password']). "')";
	} else {
		//If the password_salt and password_needs_changing columns are not in the database, revert
		//back to old functionality
		$sql .= "
			password = '". mysql_real_escape_string($newAdmin['password']). "'";
	}
	
	unset($newAdmin['password']);
}

if(!$admin_id) {
	$sql .=",
			status = 'active',
			created_date = '".mysql_real_escape_string(date("Y-m-d H:i:s"))."'";
} else {
	$sql .= "
		WHERE id = ". (int) $admin_id;
}

$result = my_mysql_query($sql);

//For new admins, grab their insert id
if (!$admin_id) {
	$admin_id = mysql_insert_id();
}

connectLocalDB();

//Convert the old permissions columns to the new roles system
foreach (array(
	'_ROLE_MANAGER' => 'perm_manage',
	'_ROLE_SYSADMIN' => 'perm_sysadmin',
	'_ROLE_PUBLISHER' => 'perm_publish',
	'_ROLE_AUTHOR' => 'perm_publish',
	'_ROLE_MENU_EDITOR' => 'perm_editmenu',
	'_ROLE_FORUM_ADMIN' => 'perm_manageforum',
	'_ROLE_EXTRANET_USER_MANAGER' => 'perm_edit_users',
	'_ROLE_EXTRANET_GROUP_MANAGER' => 'perm_edit_groups'
) as $role => $column) {
	if (isset($newAdmin[$column])) {
		setAdminRole($admin_id, $authtype, $role, $newAdmin[$column], $nonDestructive);
	}
}

if ($_SESSION['admin_userid'] == $admin_id && $_SESSION['admin_authtype'] == $authtype) {
	setAdminSession($admin_id, $authtype);
}

return false;
?>