<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */



function checkItemExists ($cIDorAlias = 0, $cType = 'html') {
	
	if ($cType != 'html' || is_numeric($cIDorAlias)) {
		// We only currently allow HTML pages to use aliases
		// This route if ID is numeric
		$sql = "SELECT id
				FROM ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($cType). "
				WHERE id = ". (int) $cIDorAlias;
	} else {
		// For HTML items, this route if ID is an alias (textual, previously called pseudonym)
		$sql = "SELECT id
				FROM ".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . "
				WHERE alias = '" . mysql_real_escape_string($cIDorAlias) . "'";
	}
	$result = my_mysql_query ($sql);
	if ($row = mysql_fetch_array ($result)) {
		return $row["id"];
	} else {
		return false;
	}
}

function createPrivateDraft($cID, $cVersion, $latest_version, $cType = false, $checkPrivs = false) {
	return require 'cmsincludes/admin/createPrivateDraft.fun.php';
}




function duplicateContent($cID, $cVersion, $newAlias = '', $cType = false) {
	return require 'cmsincludes/admin/duplicateContent.fun.php';
}






function setItemMeta($cID, $cVersion, $title, $language_id, $description = '', $keywords = '', $publication_date = false) {
	return require 'cmsincludes/admin/setItemMeta.fun.php';
}

function getItemAdvancedFields ($cID, $cVersion) {
	
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;

	$sql = "SELECT spare_varchar1,
				spare_varchar2
			FROM " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . "
			WHERE id = " . (int) $cID . "
				AND version = " . (int) $cVersion;

	$result = my_mysql_query($sql);
	
	if (mysql_num_rows($result)>0) {
		$row = mysql_fetch_array($result);
		return $row;
	} else {
		return false;
	}
}

function showContentIconMedium () {
	return "
				<img style=\"vertical-align:middle;margin:0px 2px\" src=\"contenttypes/images/icon_news_med.gif\" border=\"0\">";

}

function updateWithSampleText ($cID,$cType,$cVersion,$content_area="content_bodymain") {
	$sql = "UPDATE " . DB_NAME_PREFIX . "content_" . $cType . "
			SET " . $content_area . " = '<h1>Sample Text</h1>\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Curabitur eros augue, suscipit et, tempus nec, consequat sed, erat. Proin est. Proin dapibus. In facilisis sagittis libero. Vivamus nec enim. Cras magna. Donec eu eros. Vestibulum purus dui, viverra nec, sagittis at, laoreet at, augue. Integer mi ante, dictum id, posuere ac, malesuada non, nisi. Sed pulvinar elementum nisi. Nullam lacus erat, cursus sed, rutrum sit amet, interdum vel, quam.</p>'
			WHERE id = " . (int) $cID . "
				AND version = " . (int) $cVersion;
	
	$result = my_mysql_query($sql);
}

function displaySetPermissionsForm ($formInputs, $showEditButton, $editMode) {
	return require 'cmsincludes/admin/displaySetPermissionsForm.fun.php';
}

function validatePermissions ($data) {
	
	if (!$data['selected_items']&&$data['perm_type']=="selected_groups") {
		$error[] = getPhrase("_MSG_PERMS_NO_GROUPS_SELECTED");
	}
	
	if ($error) {
		return Array("valid" => false,"errArray" => $error);
	} else {
		return Array("valid" => true,"errArray" => "");
	}
}

function savePermissions ($formInputs) {
	if ($formInputs['perm_type']=="public") {
		setPublic($formInputs['cID'], $formInputs['cType'], $formInputs['cVersion']);
		$formInputs['log_user_access'] = false;
	}

	if ($formInputs['perm_type']=="all_extranet") {
		setPrivate($formInputs['cID'], $formInputs['cType'], $formInputs['cVersion']);
	}
	
	if ($formInputs['selected_items']&&$formInputs['perm_type']=="selected_groups") {	
		setPrivateByGroupAndUser($formInputs['cID'], $formInputs['cType'], $formInputs['cVersion'],explode(",",$formInputs['selected_items']));
	}
	
	if (inc('tribiq_cms_core_probusiness')) {
		tribiq_cms_core_probusiness::saveLogUserAccessCheckbox($formInputs['cID'], $formInputs['cType'], $formInputs['cVersion'], $formInputs['log_user_access']);
	}
}

function shouldCTypeShowPubDate($cType) {
	$sql = "SELECT show_pub_date
			FROM " . DB_NAME_PREFIX . "contenttypes
			WHERE content_type_id = '" . mysql_real_escape_string($cType) . "'";

	$result = my_mysql_query($sql);
	$row = mysql_fetch_assoc($result);
	return (bool) $row['show_pub_date'];
}

function displaySetMetaDataForm($formInputs, $showEditButton, $editMode) {
	return require 'cmsincludes/admin/displaySetMetaDataForm.fun.php';
}

function validateMetaData ($data) {
	if (!$data['cID'] && ($data['cType']=="document" || $data['cType']=="picture" || $data['cType']=="audio" || $data['cType']=="video")) {
		if (!$data['filename_as_title'] && !$data['title']) {
			$error[] = getPhrase('_MSG_NO_TITLE');
		}
	} else {
		if (!$data['title']) {
			$error[] = getPhrase('You must enter a title for your Content Item.');
		}
	}
	
	if ($error) {
		return Array("valid" => false,"errArray" => $error);
	} else {
		return Array("valid" => true,"errArray" => "");
	}
}

function saveMetaData($formInputs) {
	return require 'cmsincludes/admin/saveMetaData.fun.php';
}

function displaySetTemplateForm($formInputs, $showEditButton) {
	return require 'cmsincludes/admin/displaySetTemplateForm.fun.php';
}

function validateItemTemplate ($data) {
	if (!$data['template_id']) {
		$error[] = getPhrase("_MSG_NO_TEMPLATE_SELECTED");
	}
	
	if ($error) {
		return Array("valid" => false,"errArray" => $error);
	} else {
		return Array("valid" => true,"errArray" => "");
	}
}

function saveItemTemplate($formInputs) {

	updateItemTemplate($formInputs['cID'], $formInputs['cType'], $formInputs['cVersion'], $formInputs['template_id'], $formInputs['skin_id']);
	
	$content_item = array("cID" => $formInputs['cID'],"cVersion" => $formInputs['cVersion']);
	
	return $content_item;
}

function displayCreateOptionsForm ($formInputs) {
	return require 'cmsincludes/admin/displayCreateOptionsForm.fun.php';
}

function validateCreateOptions ($data) {
	if ($error) {
		return Array("valid" => false,"errArray" => $error);
	} else {
		return Array("valid" => true,"errArray" => "");
	}
}

function saveCreateOptions ($formInputs) {
	if ($formInputs['include_lorem']=="on") {
		updateWithSampleText($formInputs['cID'], $formInputs['cType'], $formInputs['cVersion']);
	}

	$content_item = array("cID" => $formInputs['cID'],"cVersion" => $formInputs['cVersion']);
	
	return $content_item;
}


function getPublicationDate ($cID, $cVersion) {
	$sql = "SELECT DATE(publication_date)
			FROM " . DB_NAME_PREFIX . "content_" . mysql_real_escape_string($GLOBALS['cType']) . "
			WHERE id = " . (int) $cID . "
				AND version = " . (int) $cVersion;
	
	$result = my_mysql_query($sql);
	
	if (mysql_num_rows($result)>0) {
		$row = mysql_fetch_array($result);
		
		return $row[0];
	} else {
		return false;
	}
}


function tidyFilename($filename) {
	$filename = strtolower($filename);
	$filename = preg_replace("/[^a-z0-9-_\.]/","-",$filename);
	return $filename;
}



function createRandomDir($length, $path) {
	if ($length < 1) $length = 10;
	srand ((double)microtime()*1000000);
	for ($r=1; $r<=$length; $r++) {
		$randomDir .= chr (rand (97, 122));
		$randomDir .= rand (1, 150);
	}
	$randomDir_path = "$path/$randomDir";
	mkdir ($randomDir_path, 0755);
	if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {

	} else {
		chmod ($randomDir_path, 0777);
	}
	$file  = "deny from all\n";
	$file .= "allow from ".$_SERVER["REMOTE_ADDR"]."\n";
	$file .= "RemoveType .php";
	touch ("$path/$randomDir/.htaccess");
	$myfile = fopen("$path/$randomDir/.htaccess","w");
	$fp = fwrite($myfile, $file);
	fclose($myfile);
	return $randomDir;
}

function cleanDownloads() {
	require_once 'cmsincludes/visitor/cleanDownloads.fun.php';
}

function buildDownloads($cID, $cVersion, $constraints, $upscaleImagesIfNeeded) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	cleanDownloads();
	# folder creation
	# pass a string length and the document path to the function which creates a randomly generated folder name
	
	$links = array();
	foreach ($constraints as $constraint) {
		$randomDir = createRandomDir('15', CMS_ROOT. 'tmp_downloads');
		
		if ($constraint['height'] && $constraint['width']) {
			$dimensions = $constraint;
		} else {
			$dimensions = false;
		}
		
		if ($filename = createCTypeFile ($cID, $cVersion, $randomDir, $dimensions, $newDimensions, $upscaleImagesIfNeeded)) {
			$links[$newDimensions['width']. 'x'. $newDimensions['height']] =
				array(
					'Download_Link' => "tmp_downloads/" . $randomDir . "/" . $filename,
					'Download_Width' => $newDimensions['width'],
					'Download_Height' => $newDimensions['height']);
		}
	}

	return $links;
}



?>