<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require 'cache.inc.php';
$ETag = 'tribiq-image-'. $_SERVER["HTTP_HOST"]. '-';

if (array_key_exists('c', $_GET)) {
	
	$ETag .= '-c-'. preg_replace('/[^\w-]/', '', $_GET['c']);
	useCache($ETag);
	useGZIP();
	
	require 'visitorheader.inc.php';
	
	$sql = "
		WHERE checksum_inc_name = '" . mysql_real_escape_string($_GET['c']) . "'";

} elseif (array_key_exists('id', $_GET)) {
	
	session_start();
	require 'visitorheader.inc.php';
	if (!checkPriv()) {
		exit;
	}
	
	$ETag .= '-id-'. (int) $_GET['id'];
	useCache($ETag);
	useGZIP();
	
	$sql = "
		WHERE content_item_id = " . (int) $_GET['id'] . "
		  AND content_item_type = 'picture'
		  AND content_item_version = " . (int) getLatestVersion($_GET['id'], 'picture') . "
		ORDER BY sticky_flag = 1 DESC
		LIMIT 1";

} else {
	
	if (!empty($_GET['cID'])) {
		$ETag .= '-cID-'. ($cID = (int) $_GET['cID']);
	}
	
	if (!empty($_GET['cType'])) {
		$ETag .= '-cType-'. ($cType = preg_replace('/[^\w-]/', '', $_GET['cType']));
	}
	
	if (!empty($_GET['cVersion'])) {
		$ETag .= '-cVersion-'. ($cVersion = (int) $_GET['cVersion']);
	}
	
	if (!empty($_GET['mode'])) {
		$ETag .= '-mode-'. ($mode = preg_replace('/[^\w-]/', '', $_GET['mode']));
	}
	
	$ETag .= '-filename-'. (preg_replace('/[^\w-]/', '', $_GET['filename']));
	useCache($ETag);
	useGZIP();
	
	require 'visitorheader.inc.php';
	
	
	if ( empty($cID) ) {
		if( !empty($_SERVER["HTTP_REFERER"]) && $_SERVER["HTTP_REFERER"] ){
			$url = $_SERVER["HTTP_REFERER"];
			$url_parts = parse_url($url); //first of all parse the URL into parts
			parse_str($url_parts['query'],$output); //then automagically *create* variables from the arguments
			//this *should* get us $id plus possibly get $entityType and / or $version
			
			if ($siteConfig['mod_rewrite_enabled']) {
				if (strpos($_SERVER["HTTP_REFERER"],$siteConfig['mod_rewrite_suffix'])) {
					$cID = substr($_SERVER["HTTP_REFERER"],strrpos($_SERVER["HTTP_REFERER"],"/")+1,(strrpos($_SERVER["HTTP_REFERER"],$siteConfig['mod_rewrite_suffix'])-strrpos($_SERVER["HTTP_REFERER"],"/"))-1);
				} else {
					$cID = $output['cID'];
					$cType = $output['cType'];
					$cVersion = $output['cVersion'];			
				}
			} else {
				$cID = $output['cID'];
				$cType = $output['cType'];
				$cVersion = $output['cVersion'];
			}
		}
	} 
	
	if (!$cType || !checkContentTypeExists($cType)) {
		$cType = "html";
	}
	
	if (!is_numeric($cID)) {
		includeContentType('html');
		$cID = getIDfromAlias($cID);
	}
	
	if (!$cVersion) {
		$cVersion = getShowableVersion($cID, $cType, $cVersion, $_SESSION["admin_username"], $_SESSION["extranetUserID"],false,false,true);
	}
	
	
	$sql = "
		WHERE content_item_id = " . (int) $cID . "
		  AND content_item_type = '" . mysql_real_escape_string($cType) . "'
		  AND content_item_version = " . (int) $cVersion . "
		  AND filename = '" . mysql_real_escape_string($_GET['filename']) . "'";
}


if ($mode == "thumb") {
	$sql = "
		SELECT thumbnail_data as data,
			mime_type,
			created_datetime,
			UNIX_TIMESTAMP(created_datetime) AS unix_date
		FROM " . DB_NAME_PREFIX . "images".
		$sql;
} else {
	$sql = "
		SELECT data, 
			mime_type,
			created_datetime,
			UNIX_TIMESTAMP(created_datetime) AS unix_date
		FROM " . DB_NAME_PREFIX . "images"
		. $sql;
}

if (($result = my_mysql_query($sql)) && ($row = mysql_fetch_assoc($result))) {
	header('Content-Type: ' . $row['mime_type']);
	echo $row['data'];
} else {
	header('Content-Type: image/gif');
	echo file_get_contents(CMS_ROOT. 'admin/images/icons/icon_delete.gif');
}