<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

if (!function_exists('connectGlobalDB')) {
	function connectGlobalDB() {
		if (getCurrentDatabase() === DBHOST_GLOBAL) {
			return;
		}
		
		if (!$dbSelected = connectToDatabase(DBHOST_GLOBAL, DBNAME_GLOBAL, DBUSER_GLOBAL, DBPASS_GLOBAL)) {
			/* Database connection error */
			echo "Sorry, there was a database error. Could not connect to global database using:<ul>
				<li>DBHOST_GLOBAL = ". DBHOST_GLOBAL ."</li>
				<li>DBNAME_GLOBAL = ". DBNAME_GLOBAL ."</li>
				<li>DBUSER_GLOBAL = ". DBUSER_GLOBAL ."</li>
			</ul>";
			exit;
		}
		
		mysql_select_db(DBNAME_GLOBAL, $dbSelected);
		if (!defined('DATABASE_CONNECTION_MADE')) {
			define('DATABASE_CONNECTION_MADE', true);
		}
	}
}

if (!function_exists('connectLocalDB')) {
	function connectLocalDB() {
		connectGlobalDB();
	}
}

if (!function_exists('connectToDatabase')) {
	function connectToDatabase($dbhost='localhost', $dbname, $dbuser, $dbpass) {
		if ( $link_id = @mysql_connect ($dbhost, $dbuser, $dbpass) ) {
			// from http://drupal.org/node/40515		
			if (!mysql_query('SET NAMES "UTF8"')) { echo "Database error: ".mysql_errno().", ".mysql_error(); }
			if (!mysql_query("SET collation_connection='utf8_general_ci'")) { echo "Database error: ".mysql_errno().", ".mysql_error(); }
			if (!mysql_query("SET collation_server='utf8_general_ci'")) { echo "Database error: ".mysql_errno().", ".mysql_error(); }
			if (!mysql_query("SET character_set_client='utf8'")) { echo "Database error: ".mysql_errno().", ".mysql_error(); }
			if (!mysql_query("SET character_set_connection='utf8'")) { echo "Database error: ".mysql_errno().", ".mysql_error(); }
			if (!mysql_query("SET character_set_results='utf8'")) { echo "Database error: ".mysql_errno().", ".mysql_error(); }
			if (!mysql_query("SET character_set_server='utf8'")) { echo "Database error: ".mysql_errno().", ".mysql_error(); }
			return $link_id;
		} else {
			reportDatabaseError("Database connection failure", mysql_errno(), mysql_error());
			return false;
		}
	}
}

if (!function_exists('defineSite')) {
	function defineSite($host, $url) {
		define('SITENAME', 'mytribiqsite');
		
		//Get the information from the global site_registry table
		if ($adminURL = getRow('site_registry', 'goto_admin_url', array('sitename' => SITENAME), $notZero = false, DB_NAME_PREFIX_GLOBAL)) {
			define('DEFAULT_URL', $adminURL);
		} else {
			define('DEFAULT_URL', $host);
		}
	}
}

if (!function_exists('doUrlRedirect')) {
	function doUrlRedirect($host = false, $welcomePage = false) {
		/*
		 * Do the basic processing of the requested URL
		 * You may request one of many domain names which are registered through the global
		 * site_registry table; if the domain is found in here then we set the SITENAME accordingly,
		 * and the DEFAULT_URL for the site (which is always used for administration, even though
		 * there are other URLs from the guest perspective.
		 * You may also request the site using a URL held in the alias_urls table, in which case
		 * this will cause a refresh of the browser to DEFAULT_URL/?id=some_defined_alias.
		 */
		
		if (!$host) {
			$host = $_SERVER['HTTP_HOST'];
		}
		
		$hostWOPort = false;
		if (($pos = strpos($host, ':')) !== false) {
			$hostWOPort = substr($host, 0, $pos);
		}
		
		if (defined('DEBUG_USE_STRICT_MODE') && DEBUG_USE_STRICT_MODE) {
			my_mysql_query("SET @@SESSION.sql_mode = 'STRICT_ALL_TABLES'");
		}
	
		
		
		//Attempt to get a sitename from the public_urls global table.
		//Preferably one that matches the URL being accessed
		$sql = "
			SELECT
				sitename,
				public_url AS host,
				public_url = '". mysql_real_escape_string($host). "'";
		
		if ($hostWOPort) {
			$sql .= " OR public_url = '". mysql_real_escape_string($hostWOPort). "'";
		}
		
		$sql .= " AS correct_url
			FROM ". DB_NAME_PREFIX_GLOBAL. "public_urls
			ORDER BY public_url = '". mysql_real_escape_string($host). "' DESC";
		
		if ($hostWOPort) {
			$sql .= ",
			public_url = '". mysql_real_escape_string($hostWOPort). "' DESC";
		}
		
		$sql .= "
			LIMIT 1";
		
		//Attempt to run the SQL query
		$result = @mysql_query($sql);
		if (!$result) {
			//If there was a bug (e.g. the table was missing) attempt to redirect to the installer, then exit
			if ($host === arrayKey($_SERVER, 'HTTP_HOST') && $welcomePage === false) {
			  ?>
				<html>
				  <head>
					<title>Welcome to Tribiq CMS</title>
				  </head>
				  <body>
					<script type="text/javascript">
					<!--
						document.location.href = '<?php echo httpOrHttps(). $_SERVER["HTTP_HOST"]. SUBDIRECTORY; ?>admin/welcome.php';
					-->
					</script>
					<h1>Welcome to Tribiq CMS</h1>
					<p>A new Tribiq-powered website is coming soon at this location.</p>
					<p style="font-size: 70%">If you own this site and wish to continue with the installation please enable JavaScript to continue.</p>
				  </body>
				</html>
			  <?php
			}
			exit;
		}
		
		$url = mysql_fetch_assoc($result);
		
		//If we didn't get a perfect match, check the global spare_urls table
		//in case the is a redirect set up
		if (!$url['correct_url']) {
			$sql = "
				SELECT
					sr.sitename,
					sr.goto_admin_url,
					su.content_id,
					su.content_type,
					su.requested_url AS host,
					1 AS correct_url
				FROM ". DB_NAME_PREFIX_GLOBAL. "spare_urls AS su
				INNER JOIN ". DB_NAME_PREFIX_GLOBAL. "site_registry AS sr
				   ON su.sitename = sr.sitename
				WHERE su.requested_url = '". mysql_real_escape_string($host). "'";
		
			if ($hostWOPort) {
				$sql .= "
				   OR su.requested_url = '". mysql_real_escape_string($hostWOPort). "'";
			}
		
			if (($result = @mysql_query($sql)) && ($redirect = mysql_fetch_assoc($result))) {
				$url = $redirect;
			}
		}
		
		if (issetArrayKey($url, 'correct_url')) {
			$host = $url['host'];
		}
		
		defineSite($host, $url);
		
		
		//Check if the siteconfig file exists
		if (!file_exists(CMS_ROOT. "siteconfigs/". SITENAME. ".php")) {
			echo "
				<h1>CMS Configuration Error</h1>
				<p>
					Tribiq CMS could not load settings for the site &quot;", SITENAME, "&quot;.
				</p><p>
					Please ensure the configuration file exists for this domain:
				</p><p>
					<pre>
						", CMS_ROOT, "siteconfigs/", SITENAME, ".php
					</pre>
				</p>";
			exit;
		}
		require CMS_ROOT. "siteconfigs/". SITENAME. ".php";
		
		//See if request uses an 'alias_url' in which case redirect to the relevant id
		if (issetArrayKey($url, 'content_id') && $url['goto_admin_url'] != $host) {
			connectLocalDB();
			header ('location:'. linkToItem($url['content_id'], $url['content_type'], false, true, '', true, false, false, $url['goto_admin_url']));
			exit;
		}
		
		if (!$welcomePage) {
			define('CMS_BACKUP_DIR', getRow('global_settings', 'value', array('name' => 'backup_dir'), false, DB_NAME_PREFIX_GLOBAL));
			define('CMS_DOCSTORE_DIR', getRow('global_settings', 'value', array('name' => 'docstore_dir'), false, DB_NAME_PREFIX_GLOBAL));
			define('CMS_DROPBOX_DIR', getRow('global_settings', 'value', array('name' => 'dropbox_dir'), false, DB_NAME_PREFIX_GLOBAL));
		}
	}
}

if (!function_exists('getCurrentDatabase')) {
	function getCurrentDatabase() {
		if (!defined('DATABASE_CONNECTION_MADE')) {
			return false;
		}
		
		$sql = "SELECT DATABASE()";
		$result = my_mysql_query($sql);
		$row = mysql_fetch_row($result);
		return $row[0];
	}
}

if (!function_exists('getGlobalURL')) {
	function getGlobalURL($includeProtocol = false) {
		connectGlobalDB();
			$url = getRow('site_registry', array('goto_admin_url', 'admin_use_ssl'), array('sitename' => SITENAME), $notZero = false, DB_NAME_PREFIX_GLOBAL);
		connectLocalDB();
		
		if ($includeProtocol) {
			return ($url['admin_use_ssl'] == 'force'? 'https://' : 'http://'). $url['goto_admin_url'];
		} else {
			return $url['goto_admin_url'];
		}
	}
}

if (!function_exists('my_mysql_query')) {
	function my_mysql_query($sql="") {
		if ($result = mysql_query ($sql)) {
			return $result;
		} else {
			if ($_GET['mode']=="diagpage" && $_GET['diagcode']==DIAGNOSTIC_CODE) {
				ob_end_clean();
				echo "[[FAILURE]]";
				logDiagnosticCheck($_GET['cID'],$_GET['cType'],getPublishedVersion($_GET['cID'],$_GET['cType']),0);
				exit;
			}
			
			
			if (defined('RUNNING_FROM_COMMAND_LINE')) {
				echo "Database query error\n\n". mysql_errno(). "\n\n". mysql_error(). "\n\n". $sql. "\n\n";
				exit;
			}
			
			if (DEBUG_SEND_EMAIL === true) {
				reportDatabaseError("Database query error", mysql_errno(), mysql_error(), $sql, print_r(debug_backtrace(), true));
			}
			
			if (SHOW_SQL_ERRORS_TO_VISITORS !== true) {
				echo 'A database error has occured on this section of the site. Please contact a site Administrator.';
				exit;
			}
			
			echo "<div id=\"error_information\">
	Database query error: ".mysql_errno().", ".mysql_error().",\n$sql\n\n
	Trace-back information:\n";
			
			print_r(debug_backtrace());
			
			echo '
				<!-- Dont show this bit in the source -->
				<br /><br />
				<a href="#" onClick="
					this.innerHTML = \'\';
					document.body.innerHTML = 
						\'<textarea style=&quot;height: 95%; min-height: 600px; width:95%; min-width: 800px;&quot;>\' +
							document.getElementById(\'error_information\').innerHTML.substring(0,
								document.getElementById(\'error_information\').innerHTML.indexOf(
									\'<!-- Dont show this bit in the source -->\'
								)
							) + 
						\'<\' + \'/\' + \'textarea>\';
					return false;
				">
					<b>Click here to see this error message in a textarea</b>
				</a>
			</div>';
			
			exit;
		}
	}
}

if (!function_exists('reportDatabaseError')) {
	function reportDatabaseError($errtext="", $errno="", $error="", $sql="", $backtrace = "") {
		$subject = "MySQL Error at ".$_SERVER['HTTP_HOST'];
		
		$message = $_SERVER['REMOTE_ADDR']. " accessing ". $_SERVER['REQUEST_URI']. "\n\n". $errtext. "\n\n". $errno. "\n\n". $error. "\n\n". $sql. "\n\n". $backtrace. "\n\n";
		
		// Additional headers
		$headers = "From: ". EMAIL_ADDRESS_GLOBAL_SUPPORT . "\r\n";
		
		// Mail it
		mail(EMAIL_ADDRESS_GLOBAL_SUPPORT, $subject, $message, $headers);
	}
}


?>