<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;

# Delete Temporary directories and Contents that are older than x Minutes.
/* Windows Delete */
if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
	/* findtest with Level 1 recursive */
	function rmdir_rf($dirname) {
		if ($dirHandle = opendir($dirname)) {
			chdir($dirname);
			while ($file = readdir($dirHandle)) {
				if ($file == '.' || $file == '..') continue;
				if (is_dir($file)) rmdir_rf($file);
				else unlink($file);
			}
			chdir('..');
		closedir($dirHandle);
			rmdir($dirname);
			chdir('..');
		}
	}
	function permission($filename) {
		$perms = fileperms($filename);
		if     (($perms & 0xC000) == 0xC000) { $info = 's'; }
		elseif (($perms & 0xA000) == 0xA000) { $info = 'l'; }
		elseif (($perms & 0x8000) == 0x8000) { $info = '-'; }
		elseif (($perms & 0x6000) == 0x6000) { $info = 'b'; }
		elseif (($perms & 0x4000) == 0x4000) { $info = 'd'; }
		elseif (($perms & 0x2000) == 0x2000) { $info = 'c'; }
		elseif (($perms & 0x1000) == 0x1000) { $info = 'p'; }
		else                                 { $info = 'u'; }

		// ????????
		$info .= (($perms & 0x0100) ? 'r' : '-');
		$info .= (($perms & 0x0080) ? 'w' : '-');
		$info .= (($perms & 0x0040) ? (($perms & 0x0800) ? 's' : 'x' ) : (($perms & 0x0800) ? 'S' : '-'));

		// ??????
		$info .= (($perms & 0x0020) ? 'r' : '-');
		$info .= (($perms & 0x0010) ? 'w' : '-');
		$info .= (($perms & 0x0008) ? (($perms & 0x0400) ? 's' : 'x' ) : (($perms & 0x0400) ? 'S' : '-'));

		// ???
		$info .= (($perms & 0x0004) ? 'r' : '-');
		$info .= (($perms & 0x0002) ? 'w' : '-');
		$info .= (($perms & 0x0001) ? (($perms & 0x0200) ? 't' : 'x' ) : (($perms & 0x0200) ? 'T' : '-'));

		return $info;
	}

	function dir_list($dir) {
		if ($dir[strlen($dir)-1] != '/') $dir .= '/';

		if (!is_dir($dir)) return array();

		$dir_handle  = opendir($dir);
		$dir_objects = array();
		while ($object = readdir($dir_handle))
			if (!in_array($object, array('.','..')))
			{
				$filename    = $dir . $object;
				$file_object = array(
										'name' => $object,
										'size' => filesize($filename),
										'perm' => permission($filename),
										'type' => filetype($filename),
										'time' => date("d F Y H:i:s", filemtime($filename))
									);
				$dir_objects[] = $file_object;
			}

		return $dir_objects;
	}

	function checkEntities($dir_array,$age) {
		$entity_total = count($dir_array);
		$entity_age_ok = false;
		$oldtime = strtotime($age);
		$entity_age_limit = $age;
		$verified_NOTOK_count = 0;

		$entitiesOK = false;
		for ($entity = 0; $entity < $entity_total; $entity++) {
			$entityTime = strtotime($dir_array[$entity]['time']);
			if ($entityTime <= $oldtime) {
				$entity_age_ok = true;
			} else {
				$entity_age_ok = false;
				$verified_NOTOK_count++;
			}

		}
		
		if ($verified_NOTOK_count) return false; else return true;
	}

	/* You can Change these two variables */
	$age_limit = "-15 minutes";
	$path = CMS_ROOT . "tmp_downloads";


	/* Root folder cache */
	$root_dir_check_array = dir_list($path);
	$root_entity_total = count($root_dir_check_array);

	/* Old timestamp */
	$oldtime = strtotime($age_limit);

	/* Go through the root directory */

	for ($entity = 0; $entity < $root_entity_total; $entity++) {

		/* If directory check it */
		$entityPermString = $root_dir_check_array[$entity]['perm'];
		if (preg_match('#d#i',$entityPermString)) {
			$sub_path_str = $path."/".$root_dir_check_array[$entity]['name'];
			$subdir_array = dir_list($sub_path_str);

			$dir_ok = checkEntities($subdir_array,$age_limit);
			if ($dir_ok) rmdir_rf($sub_path_str); // delete folder it is ok
		} else {
			$entityTime = strtotime($root_dir_check_array[$entity]['time']);
			if ($entityTime <= $oldtime) {
				unlink($path."/".$root_dir_check_array[$entity]['name']);
			} else {
				/* Don't delete yet */
			}

		}

	}
		
} else {


/* Linux - we can do this via shell. */

	$command = "find tmp_downloads/ -type d -mmin +1 -mindepth 1 -exec rm -r {} \;";
	
	shell_exec($command);
	
}

?>