<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;

//Attempt to get the value of this field
$value = '';
//Check the POST
if ($type != 'submit' && $type != 'checkbox' && $type != 'radio' && isset($this->postVariables[arrayKey($attributes, 'name')])) {
	$value = $this->postVariables[arrayKey($attributes, 'name')];

//Check the GET
} elseif ($type != 'submit' && $type != 'checkbox' && $type != 'radio' && isset($this->getVariables[arrayKey($attributes, 'name')])) {
	$value = $this->getVariables[arrayKey($attributes, 'name')];

//Check for a value from a LOV
} elseif ($i && $type != 'toggle') {
	$value = $saveVal;

//Check for a value set as an attribute
} elseif (isset($attributes['value']) && ($type == 'button' || $type == 'submit' || !isset($this->postVariables[arrayKey($attributes, 'name')]))) {
	$value = ($type == 'checkbox' || $type == 'toggle')? $attributes['value'] : $this->phrase($attributes['value']);

//Check for a value in the merge fields
} elseif (isset($mergeFieldsRow[arrayKey($attributes, 'name')])) {
	$value = $mergeFieldsRow[arrayKey($attributes, 'name')];

//Ensure checkboxes always have a value
} elseif ($type == 'checkbox') {
	$value = 1;
}


//If the type wasn't set, just look up the value and do nothing else
if ($type === false) {
	return;
}


//There's no need to re-upload a file that's already been uploaded
if ($type == 'file') {
	if ($value && substr($value, 0, 14) == 'tmp_downloads/' && file_exists(CMS_ROOT. $value)) {
		echo htmlspecialchars(substr(basename($value), 0, -7));
		echo '
			<input type="hidden" name="', htmlspecialchars(arrayKey($attributes, 'name')), '" value="', htmlspecialchars($value), '">'; 
		return;
	} else {
		$value = null;
	}
}

//LOVs only: Add the $rowNum to the name and id as needed to avoid clashes
if ($i) {
	if ($type == 'checkbox' || $type == 'toggle') {
		$attributes['name'] = arrayKey($attributes, 'name'). '__'. $i;
	}
	if (isset($attributes['id'])) {
		$attributes['id'] = $attributes['id']. '__'. $i;
	}
}

//Checkboxes/Radiogroups only: If the form has already been submitted, overwrite the "checked" attribute depending on whether the checkbox/radiogroup was chosen
if ($type == 'checkbox' && isset($_POST['cID'])) {
	if (isset($this->postVariables[arrayKey($attributes, 'name')])) {
		$attributes['checked'] = 'checked';
	} else {
		unset($attributes['checked']);
	}

} elseif ($type == 'radio' && isset($_POST['cID'])) {
	if (isset($this->postVariables[arrayKey($attributes, 'name')]) && $this->postVariables[arrayKey($attributes, 'name')] == $saveVal) {
		$attributes['checked'] = 'checked';
	} else {
		unset($attributes['checked']);
	}

} elseif ($type == 'date' && !arrayKey($attributes, 'name')) {
	$type = 'text';

} elseif ($type == 'date' && !$readonly) {
	
	$attributes['id'] = ifNull(arrayKey($attributes, 'id'), $attributes['name']);
	
	$values = explode('-', $value, 3);
	if (!(int) arrayKey($values, 0) || !(int) arrayKey($values, 1) || !(int) arrayKey($values, 2)) {
		if ($value === 'TODAY') {
			$value = date('Y-m-d');
			$values = explode('-', $value, 3);
		} else {
			$value = '';
			$values = array('', '', '');
		}
	}
	
	$j = 0;
	foreach (array(31 => 1, 12 => 1, (int) date('Y') + 10 => (int) date('Y') - 10) as $to => $from) {
		$v = (int) $values[3 - ++$j];
		echo '
			<select class="jquery_datepicker" name="', htmlspecialchars($attributes['name']), '__', $j, '" id="', htmlspecialchars($attributes['id']), '__', $j, '">
				<option></option>';
		
		for ($k = $from; $k <= $to; ++$k) {
			echo '
				<option', $v == $k? ' selected="selected"' : '', '>', str_pad($k, 2, '0', STR_PAD_LEFT), '</option>';
		}
		
		echo '
			</select>';
	}
	
	$attributes['class'] = 'jquery_datepicker '. arrayKey($attributes, 'class');
	$attributes['onkeyup'] = 'tribiq.dateFieldKeyUp(this, event); '. arrayKey($attributes, 'onkeyup');
}


if (!$readonly) {
					
	//Most attributes that are part of the HTML spec we'll pass on directly
	$allowedAtt = array(
		'id' => true,
		'name' => true,
		'size' => true,
		'type' => true,
		'maxlength' => true,
		'accesskey' => true,
		'checked' => true,
		'class' => true,
		'cols' => true,
		'dir' => true,
		'rows' => true,
		'style' => true,
		'tabindex' => true,
		'title', true.
		'onblur' => true,
		'onchange' => true,
		'onclick' => true,
		'ondblclick' => true,
		'onfocus' => true,
		'onmousedown' => true,
		'onmousemove' => true,
		'onmouseout' => true,
		'onmouseover' => true,
		'onmouseup' => true,
		'onkeydown' => true,
		'onkeypress' => true,
		'onkeyup' => true,
		'onselect' => true);
	
	
	//Open the field's tag
	if ($type == 'date') {
		echo '<input type="hidden" name="', htmlspecialchars($attributes['name']), '" id="', htmlspecialchars($attributes['id']), '__0" value="', htmlspecialchars($value), '"/>
			<input type="text" readonly="readonly" id="', htmlspecialchars($attributes['id']), '"';
		
		unset($allowedAtt['name']);
		unset($allowedAtt['type']);
	
	} elseif ($type == 'select') {
		echo '<select';
	
	} elseif ($type == 'textarea') {
		echo '<textarea';
	
	} elseif ($type == 'toggle') {
		if ($i) {
			//Toggles need their value/class name set differently depending on whether they are open, to try and mirror radiogroups as close as is possible
			echo '<input type="submit" value="';
			$attributes['class'] = arrayKey($attributes, 'class'). ' toggle';
			
			if ($value == $saveVal) {
				echo '&bull;';
				$attributes['class'] .= ' toggle_selected';
			} else echo o;
			
			echo '"';
			
		} else {
			echo '<input type="hidden"';
		}
		unset($allowedAtt['type']);
	
	} else {
		echo '<input';
	}
	
	foreach ($attributes as $att => $attVal) {
		if ($allowedAtt[$att]) {
			echo ' ', $att, '="', htmlspecialchars($attVal), '"';
		}
	}
	
	//Add the value (which happens slightly differently for select lists and textareas, and has already been done for toggles)
	if ($type == 'date' || $type == 'select') {
		echo '>';
	
	} elseif ($type == 'textarea') {
		echo '>', htmlspecialchars($value), '</textarea>';
	
	} elseif ($type != 'toggle' || !$i) {
		echo ' value="', htmlspecialchars($value), '"/>';
	}
}


$showLabel = false;
$addHiddenField = $readonly;

//LOVs need labels displaying for each value.
//In read only mode, these should only be displayed if they are selected
if ($i) {
	switch ($type) {
		case 'checkbox':
		case 'radio':
			$showLabel = !$readonly || engToBooleanArray($attributes, 'checked');
			break;
		case 'select':
			$showLabel = $readonly && $saveVal == $value;
			break;
		case 'toggle':
			$showLabel = !$readonly || $saveVal == $value;
			$addHiddenField = false;
			break;
	}

//In read-only mode, most fields need their value displaying.
} elseif ($readonly) {
	switch ($type) {
		case 'checkbox':
			$showLabel = engToBooleanArray($attributes, 'checked');
			break;
		case 'date':
		case 'file':
		case 'hidden':
		case 'password':
		case 'submit':
		case 'text':
		case 'textarea':
			$showLabel = true;
			break;
	}
}
		
if ($showLabel) {
	//Display the field's value
	echo '
		<label', issetArrayKey($attributes, 'id')? ' for="'. htmlspecialchars(arrayKey($attributes, 'id')). '"' : '', '>';
	
	if ($type == 'password') {
		echo preg_replace('/./', '*', $value);
	} elseif ($type == 'textarea') {
		echo nl2br(htmlspecialchars($value));
	} elseif ($type == 'date' && $value && !preg_replace('/\d\d\d\d-\d\d-\d\d/', '', $value)) {
		echo htmlspecialchars(formatDateNicely($value, '_MEDIUM'));
	} else {
		echo htmlspecialchars(ifNull($dispVal, $saveVal, $value));
	}
	echo '</label>';
}

if ($addHiddenField) {
	echo '
		<input type="hidden" name="', htmlspecialchars(arrayKey($attributes, 'name')), '" value="', htmlspecialchars($value), '">';
}


return;
?>