/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */


//Create an encapsulated object for the Admin Floating Box functions
window.tribiqAFB = function() {};
tribiqAFB.sizing = false;

tribiqAFB.documentScrollTop = false;


//Open an admin floating box
tribiqAFB.open = function(pluginClassName, fbName, pk) {
	
	var overlayColor, overlayOpacity;
	if (typeof tribiqSK == 'undefined' || tribiqSK.selectMode === false) {
		overlayColor = 'black';
		overlayOpacity = 50;
	} else {
		overlayColor = 'white';
		overlayOpacity = 35;
	}
	
	//Record the current scroll location of the page behind the box
	if (tribiqAFB.documentScrollTop === false) {
		tribiqAFB.documentScrollTop = $(tribiq.browserIsSafari()? 'body' : 'html').scrollTop();
	}
	
	//Open the box...
	tribiq.AFBOpen = true;
	tribiq.oldAFBOpen = true;
	tribiqAFB.changed = false;
	tribiqA.openBox(false, '', 'AdminFloatingBox', false, 944, 50, 2, true, overlayOpacity, overlayColor);
	//...but hide the box itself, so only the overlay shows
	get('tribiq_fbAdminFloatingBox').style.display = 'none';
	
	//If any Admin Boxes are open, set a warning message for if an admin tries to leave the page 
	window.onbeforeunload = tribiqA.onbeforeunload;
	
	
	tribiqAFB.className = pluginClassName? pluginClassName : 'core';
	
	//Do our inputs look like the old tb_show inputs?
	//Do some filtering for backwards compatability purposes if so
	if (!pk && tribiqAFB.className == 'core') {
		var pos1 = fbName.indexOf('tb/');
		
		if (pos1 != -1) {
			
			while((newpos1 = fbName.indexOf('tb/', pos1 + 3)) != -1) {
				pos1 = newpos1;
			}
			
			var pos2 = fbName.indexOf('.php', pos1 + 3);
			
			if (pos2 != -1) {
				pk = fbName;
				fbName = fbName.substr(pos1 + 3, pos2 - pos1 - 3);
			}
		}
	}
	
	if (tribiqAFB.className == 'core') {
		tribiqAFB.fbFileName = fbName;
	} else {
		tribiqAFB.fbName = fbName;
	}
	
	if (!pk) {
		pk = new Array();
	}
	
	
	//Have two overrideable functions, in case any tabs want advanced logic for their Save Button
	tribiqTab.setSaveButtonState = function(tab) {
		tribiqAFB.determineSaveButtonState();
	}

	tribiqTab.setSaveArea = function(html) {
		get('tribiq_fbButtons').innerHTML = html;
	}

	tribiqTab.preSave = function() {
		return true;
	}

	tribiqTab.postSave = function() {}
	
	
	tribiqAFB.data = new Array();
	
	tribiqAFB.confirm_path = false;
	tribiqAFB.debug = false;
	tribiqAFB.dontCloseJustYet = false;
	tribiqAFB.maxHeight = false;
	tribiqAFB.parent_js_path = false;
	tribiqAFB.tab = false;
	
	$.get(tribiqAFB.getURL('init', false, pk),
		function(data) {
			
			try {
				data = JSON.parse(data);
			} catch (e) {
				tribiqAFB.close();
				tribiqA.showMessage(data, 'error');
				return;
			}
			
			for (i in data) {
				tribiqAFB[i] = data[i];
			}
			
			//Generate the HTML for the tabs
			tribiqAFB.firstTab = false;
			var html = '';
			
			for (tab in tribiqAFB.tabs) {
				//Generate the HTML for the tab
				html +=
					  '<div id="afb_tab_' + tab + '"><div>'
						+ '<a href="#" onclick="tribiqAFB.clickTab(this, \'' + tab + '\'); return false;">'
							+ htmlspecialchars(tribiqAFB.tabs[tab].tab_label)
						+ '</a>'
					+ '</div></div>';
				
				//Ensure the first tab will be selected first
				if (!tribiqAFB.firstTab) {
					tribiqAFB.firstTab = tab;
				}
				
				//Check for the "loaded by default" option, and create an empty data array if it is true
				if (tribiqAFB.tabs[tab].loaded_by_default) {
					tribiqAFB.newData(tab);
				}
				
				//Set a max height for this tab, if one was given
				if (tribiqAFB.tabs[tab].max_height && tribiqAFB.maxHeight === false) {
					tribiqAFB.maxHeight = tribiqAFB.tabs[tab].max_height;
				}
			}
			
			if (tribiqAFB.debug) {
				alert(tribiqAFB.debug);
			}
			
			//Don't do anything if there were no tabs!
			if (html == '') {
				tribiqAFB.close();
				return;
			}
			
			//Line inserted for backwards compatability purposes with JS written for the old tab system
			primaryKey = tribiqAFB.pk;
			
			//Add any JavaScript libraries that cover the whole thickbox (core ability only)
			if (tribiqAFB.parent_js_path) {
				tribiqAFB.addScript(tribiqAFB.parent_js_path, 'tb_parent_prog.js');
			}
			
			//Set the HTML for the floating boxes tabs and title
			get('tribiq_jqmTabs').innerHTML = html;
			tribiqAB.setTitle(tribiqAFB.title);
			get('tribiq_fbAdminInner').innerHTML = '';
			tribiqTab.setSaveArea(tribiqAFB.getSaveButtonHTML('Save'));
			
			//Set the floating box to the max height for the user's screen
			tribiqAFB.size();
			
			//Show the box
			get('tribiq_fbAdminFloatingBox').style.display = 'block';
			
			//Simulate a click on the first tab to open it by default
			tribiqAFB.openTab(tribiqAFB.firstTab);
		},
	'text');
}

tribiqAFB.getSaveButtonHTML = function(saveButtonText) {
	return '<input id="tribiqAFB_save" class="submit_disabled" type="button" value="' + saveButtonText + '"/>';
}

//Automatically set the box to the correct height for the users screen, or the maximum height requested, whichever is smaller
tribiqAFB.size = function() {
	if (tribiqAFB.sizing) {
		clearTimeout(tribiqAFB.sizing);
	}
	
	if (get('tribiq_fbMain')) {
		get('tribiq_fbMain').style.top = '24px';
		get('tribiq_fbButtons').style.paddingBottom = '31px';
		get('tribiq_jqmTabs').style.display = tribiq.browserIsIE()? '' : 'inherit';
	}
	
	if (get('tribiq_fbAdminInner')) {
		var height = Math.floor($(window).height() * 0.96 - (tribiq.browserIsIE()? 210 : tribiq.browserIsSafari()? 202 : 205));
		
		if (tribiqAFB.maxHeight && height > tribiqAFB.maxHeight) {
			height = tribiqAFB.maxHeight;
		}
		
		if ((height = 1*height) > 0) {
			get('tribiq_fbAdminInner').style.height = height + 'px';
		}
	}
	
	//Keep the page below at the top of the page, to prevent a bug with TinyMCE
	if (tribiq.AFBOpen && tribiqAFB.documentScrollTop !== false) {
		$(tribiq.browserIsSafari()? 'body' : 'html').scrollTop(0);
	}
	
	tribiqAFB.sizing = tribiq.setTimeout('tribiqAFB.size()', 250);
}



//Get a URL needed for an AJAX request
tribiqAFB.getURL = function(mode, tab, pk) {
	var url = URLBasePath;
	
	//Check to see if this a request for a floating box/tab in the core, or in a Plugin
	if ((mode == 'init' && tribiqAFB.className != 'core')
	 || (mode != 'init' && tribiqAFB.tabs[tab].plugin_id)) {
		
		//Requests for Plugin Floating boxes all go through plugins.php
		url += 'plugins.php'
			+ '?tbName=' + encodeURIComponent(tribiqAFB.fbName)
			+ '&pluginClassName=' + encodeURIComponent(tribiqAFB.className);
		
		
		if (mode == 'init') {
			url += '&method_call=showAdminFloatingBox'
				+ '&afb=1';
		} else {
			url += '&method_call=' + mode + 'AdminFloatingBoxTab'
				+ '&adminFloatingBoxTabId=' + tab;
		}
		
		//Tell the tab which of the inputs are primary keys
		url += '&primaryKeyParams=';
		var comma = '';
		for (key in tribiqAFB.pk) {
			url += comma + key;
			comma = ',';
		}
		
	
	} else {
		//Requests for Core Floating boxes all go through various files in the tb directory
		//Which file depends on if this is the floating box or one of its tabs
		if (mode == 'init') {
			url += 'tb/' + tribiqAFB.fbFileName + '.php'
				+ '?afb=1';
		} else {
			url += 'tb/ajax/' + tab + '.php'
				+ '?' + mode + '=true';
		}
	}
	
	if (mode == 'init') {
		url += tribiq.urlRequest(pk);
	} else {
		url += tribiq.urlRequest(tribiqAFB.pk)
			+ tribiq.urlRequest(tribiqAFB.data[tab]);
	}
	
	return url;
}


//Handle the user clicking on a tab
tribiqAFB.clickTab = function(el, tab) {
	
	if (el) {
		el.blur();
	}
	
	//Record the information that the user has just entered
	tribiqAFB.setData();
	
	//Check if it is valid, and don't let the user tab-out if it is not
	if (tribiqAFB.validate(tribiqAFB.tab) !== false) {
		tribiqAFB.changeTab(tab);
	}
}

//Change to a different tab
tribiqAFB.changeTab = function(tab) {
	if (get('afb_tab_' + tab).className == 'current') {
		return;
	}
	
	tribiqAFB.openTab(tab);
}

//Load in a tab
tribiqAFB.openTab = function(tab) {
	//Switch to that tab, if it's not already chosen
	if (tribiqAFB.tab) {
		get('afb_tab_' + tribiqAFB.tab).className = '';
	}
	get('afb_tab_' + tab).className = 'current';
	
	//Fetch the HTML for the tab
	var url = tribiqAFB.getURL('show', tab);
	var data = tribiq.nonAsyncAJAX(url, true);
	
	//The data should be returned in plain html.
	//However some of the old thickboxes use JSON, so we need to watch out for this if we can
	if (data.substr(0, 1) == '{') {
		try {
			data = (JSON.parse(data)).formHTML;
		} catch (e) {
		}
	}
	
	//Close TinyMCE if it is open
	if (typeof tinyMCE != 'undefined') {
		if (tinyMCE.activeEditor) {
			tinyMCE.activeEditor.remove();
		}
	}
	
	tribiqAFB.radioLastChanged = false;
	tribiqAFB.radioChanging = false;
	
	get('tribiq_fbAdminInner').innerHTML = data;
	tribiqAFB.addTabSupportFiles(tab);
	
	tribiqAFB.tab = tab;
	tribiqTab.setSaveButtonState();
	tribiqA.setUpMandatoryFieldEvents(get('tribiq_fbAdminInner'));
	tribiq.addJQueryElements('#tribiq_fbAdminInner ');
}

tribiqAFB.refreshTab = function() {
	tribiqAFB.openTab(tribiqAFB.tab);
}

tribiqAFB.saveAndRefreshTab = function() {
	tribiqAFB.setData();
	tribiqAFB.refreshTab();
}

//Create an entry for a tab in the data array
tribiqAFB.newData = function(tab) {
	if (!tribiqAFB.data[tab]) {
		tribiqAFB.data[tab] = new Array();
		tribiqAFB.data[tab].formMode = 'edit';
	}
}

//Begin edit mode
tribiqAFB.edit = function() {
	tribiqAFB.newData(tribiqAFB.tab);
	tribiqAFB.openTab(tribiqAFB.tab);
}

//Cancel edit mode
tribiqAFB.cancel = function() {
	delete tribiqAFB.data[tribiqAFB.tab];
	tribiqAFB.openTab(tribiqAFB.tab);
}

//Check if a tab is in edit mode
tribiqAFB.editingTab = function(tab) {
	return (tribiqAFB.data[tab] && tribiqAFB.data[tab].formMode == 'edit')
		|| (tribiqAFB.tab == tab && get('formMode') && get('formMode').value == 'edit');
}

//Check if a tab is in edit mode, and enable/disable the save button appropriately
tribiqAFB.determineSaveButtonState = function(exclusionList) {
	
	if (!exclusionList) {
		exclusionList = new Array();
	}
	
	for (tab in tribiqAFB.tabs) {
		if (!exclusionList[tab] && tribiqAFB.editingTab(tab)) {
			tribiqAFB.enableOrDisableSaveButton(true);
			return true;
		}
	}
	
	tribiqAFB.enableOrDisableSaveButton(false);
	return false;
}

tribiqAFB.inEditMode = false;
tribiqAFB.enableOrDisableSaveButton = function(enable) {
	tribiqAFB.inEditMode = enable;
	get('tribiqAFB_save').className = enable? 'submit' : 'submit_disabled';
	get('tribiqAFB_save').onclick = enable? tribiqAFB.saveTabs : function() {};
}

//Load in any JS or CSS files needed for a tab
tribiqAFB.addTabSupportFiles = function(tab) {
	
	//Load in any CSS for a tab, if there is any
	if (tribiqAFB.tabs[tab].tab_css_path) {
		var newStyleSheet = document.createElement('link');
		
		newStyleSheet.type = 'text/css';
		newStyleSheet.rel = 'stylesheet';
		newStyleSheet.href = URLBasePath + tribiqAFB.tabs[tab].tab_css_path;
		
		document.getElementsByTagName('head')[0].appendChild(newStyleSheet);
	}
	
	//Load in any javascript for a tab, if there is any
	if (tribiqAFB.tabs[tab].tab_js_path) {
		tribiqAFB.addScript(tribiqAFB.tabs[tab].tab_js_path, 'tb_tab_prog_' + tab + '.js');
	}
}

//Add a JavaScript library to the page
tribiqAFB.addScript = function(path, id) {
	var bSaf = (navigator.userAgent.indexOf('Safari') != -1);
	var bOpera = (navigator.userAgent.indexOf('Opera') != -1);
	var bMoz = (navigator.appName == 'Netscape');	
	var script = document.createElement("script");
	
	script.id = id;
	script.type = "text/javascript";
	
	if (path.indexOf('://') == -1) {
		path = URLBasePath + path + '?v=' + encodeURIComponent(window.tribiqCSSJSVersionNumber);
	}

	var code = tribiq.nonAsyncAJAX(path);
	
	if (tribiq.browserIsIE()) {
		script.text = code;
	} else {
		script.innerHTML = code;
	}
	
	document.getElementsByTagName("head")[0].appendChild(script);
	
	if (tribiq.browserIsSafari()) {
		eval(code);
	}
}

//Validate the data for a tab
tribiqAFB.validate = function(tab) {
	
	//If we've never been to a tab, or it's in view mode, don't try and validate it
	if (!tribiqAFB.editingTab(tab)) {
		return null;
	}
	
	//Run the AJAX validation routine
	var url = tribiqAFB.getURL('validate', tab);
	
	var data = tribiq.nonAsyncAJAX(url, true, true);
	
	//Stop here if no errors were reported
	if (!data.errArray || !data.errArray.length) {
		return true;
	}
	
	//Otherwise display the errors to the user.
	var html = '';
	for (i in data.errArray) {
		html += (html? '<br/>' : '') + data.errArray[i];
	}
	
	tribiqAFB.changeTab(tab);
	tribiqAFB.showError(html);
	
	return false;
}

tribiqAFB.showError = function(html) {
	
	if (get("errorDisplayRow")) {
		get("errorDisplayRow").style.display = '';
	}
	
	if (get("errorDisplay")) {
		get("errorDisplay").style.display = '';
		get("errorDisplay").innerHTML = html;
	} else {
		tribiqA.showMessage(html, 'error');
	}
	
	get("tribiq_fbAdminInner").scrollTop = 0;
}

//Read the values of the fields for the current tab into the data array
tribiqAFB.setData = function() {
	if (get('formMode') && get('formMode').value == 'edit') {
		tribiqAFB.data[tribiqAFB.tab] = tribiqAFB.createArrayFromFormElement(get('tribiq_fbAdminInner'));
	} else {
		delete tribiqAFB.data[tribiqAFB.tab];
	}
}

//Attempt to save a tab
tribiqAFB.saveTab = function(tab) {
	
	//Check that the tab is actually being saved before we attempt to save it
	if (!tribiqAFB.editingTab(tab)) {
		return null;
	}
	
	//Run the AJAX saving routine
	var url = tribiqAFB.getURL('save', tab);
	

	//Using a try...catch here just in case we have a tab that no-one has set a save function for
	var saveReturnValues;
	var error = false;
	try {
		saveReturnValues = tribiq.nonAsyncAJAX(url, true);
		
		if (saveReturnValues && saveReturnValues.length > 2) {
			if (saveReturnValues.substr(0, 1) != '{' && saveReturnValues.substr(0, 1) != '[') {
				error = true;
			} else {
				saveReturnValues = JSON.parse(saveReturnValues);
				
				if (saveReturnValues) {
					for (key in saveReturnValues) {
						tribiqAFB.pk[key] = saveReturnValues[key];
					}
				}
			}
		}
	} catch (e) {
		error = true;
	}
	
	if (error) {
		alert('The ' + tribiqAFB.tabs[tab].tab_label + ' section encountered an error. The changes you have made in that section may not have been saved.\nThe following error message was returned:\n\n' + saveReturnValues);
	}
}

//Attempt to save all of the tabs
tribiqAFB.saveTabs = function() {
	
	//Save the data for the current screen, if needed
	tribiqAFB.setData();
	
	if (tribiqAFB.confirm_path) {
		var url = URLBasePath + tribiqAFB.confirm_path + '?confirm=1' + tribiq.urlRequest(tribiqAFB.pk);
		var data = tribiq.nonAsyncAJAX(url, true, true);
		if (data.action == 'cancel') {
			return;
		} else if (data.action == 'confirm') {
			tribiqA.floatingBox(data.html, data.buttons, data.warning);
			return;
		}
	}
	
	tribiqAFB.saveTabsSkippingConfirm();
}

tribiqAFB.saveTabsSkippingConfirm = function() {
	
	var tabsToSave = new Array();
	
	if (tribiqTab.preSave()) {
	
		//Run the validation funciton for every tab
		for (tab in tribiqAFB.tabs) {
			var status = tribiqAFB.validate(tab);
			
			//If a tab is not valid, stop on that tab and show the errors
			if (status === false) {
				return;
			
			//If a tab is valid, add it to the save list
			} else if (status === true) {
				tabsToSave[tab] = true;
			
			//Otherwise if a tab was not being edited, do nothing
			}
		}
		
		//Save each tab
		for (tab in tabsToSave) {
			tribiqAFB.saveTab(tab);
		}
		
		tribiqTab.postSave();
		
		//Close the floating box
		tribiqAFB.refreshParentAndClose();
	}
}

tribiqAFB.refreshParentAndClose = function() {
	
	if (tribiqAFB.dontCloseJustYet) {
		return;
	}
	
	tribiq.oldAFBOpen = false;
	tribiqAFB.inEditMode = false;
	
	//Attempt to work out what to do next.
	if ((typeof tribiqSK != 'undefined')) {
		//Reload the storekeeper if this window is a storekeeper window (new storekeeper)
		var id = false;
		
		if (tribiqAFB.pk.storekeeperIdColumn) {
			id = tribiqAFB.pk[tribiqAFB.pk.storekeeperIdColumn];
		} else {
			for (i in tribiqAFB.pk) {
				id = tribiqAFB.pk[i];
				break;
			}
		}
		
		tribiqSK.refreshToShowItem(id);
		tribiqAFB.close();
		return;
		
	} else if (tribiqAFB.pk.slotName != undefined) {
		//Refresh the slot if this was one of the slot settings thickboxes
		tribiq.refreshPluginSlot(tribiqAFB.pk.slotName, 1*tribiqAFB.pk.instanceId, tribiqAFB.createGetRequestFromPrimaryKeyForSlotReload());
	
	//Otherwise build up a URL from the primary key, if it looks valid
	} else if (tribiqAFB.pk.mID) {
		//Going to a menu id
		tribiq.goToURL(URLBasePath + tribiq.indexDotPHP + '?mID=' + tribiqAFB.pk.mID);
	} else if (tribiqAFB.pk.cID) {
		//Go to a specific content item
		tribiq.goToURL(tribiq.linkToItem(tribiqAFB.pk.cID, tribiqAFB.pk.cType));
	}
	
	tribiqAFB.close();
}

tribiqAFB.close = function() {
	//Close TinyMCE if it is open
	if (typeof tinyMCE != 'undefined') {
		if (tinyMCE.activeEditor) {
			tinyMCE.activeEditor.remove();
		}
	}
	
	if (tribiqAB.sizing) {
		clearTimeout(tribiqAB.sizing);
	}
	if (tribiqAFB.sizing) {
		clearTimeout(tribiqAFB.sizing);
	}
	
	if (tribiq.AFBOpen) {
		tribiqA.closeFloatingBox();
		$('#tribiq_fbAdminFloatingBox').jqmHide();
	}
	if (get('tribiq_fbAdminFloatingBox').style.display == 'block') {
		get('tribiq_fbAdminFloatingBox').style.display = 'none';
	}
	tribiq.AFBOpen = false;
	tribiq.oldAFBOpen = false;
	tribiqAFB.inEditMode = false;
	
	//Really odd workaround for a really odd CSS glitch in IE6
	if (tribiq.browserIsIE6()) {
		$('body').addClass('ie6workaround');
	}
	
	//Return the page to it's original scroll position, before the box was opened
	if (tribiqAFB.documentScrollTop !== false) {
		$(tribiq.browserIsSafari()? 'body' : 'html').scrollTop(tribiqAFB.documentScrollTop);
		tribiqAFB.documentScrollTop = false;
	}
	
	return false;
}


//Handle checkboxes that show/hide rows when checked
tribiqAFB.checkboxChange = function(el) {
	var sel = '#tribiq_fbAdminFloatingBox .requires_' + el.name;
	if (tribiq.browserIsIE6()) {
		if (el.checked) {
			$(sel).each(function(i, e) {e.style.display = ''});
		} else {
			$(sel).each(function(i, e) {e.style.display = 'none'});
		}
	} else {
		if (el.checked) {
			$(sel).show('blind', {}, 500);
		} else {
			$(sel).hide('blind', {}, 500);
		}
	}
	
	$(sel + ' input').each(function(i, e) { if (e.type == 'checkbox' && e.checked) { e.checked = false; $(e).click(); e.checked = false; } });
}

//Handle radiogroups that show/hide rows when checked
tribiqAFB.radioLastChanged = false;
tribiqAFB.radioChanging = false;
tribiqAFB.radioChange = function(el, isSelectList) {
	if (el.checked || isSelectList) {
		
		if (!isSelectList) {
			if (tribiqAFB.radioLastChanged !== false && tribiqAFB.radioLastChanged == el.id) {
				return;
			}
			tribiqAFB.radioLastChanged = el.id;
		}
		
		var sel = '#tribiq_fbAdminFloatingBox .requires_' + el.name;
		var selNot = '#tribiq_fbAdminFloatingBox .requires_' + el.name + '__' + el.value;
		
		if (tribiq.browserIsIE6()) {
			$(sel).not(selNot).each(function(i, e) {e.style.display = 'none'});
			$(selNot).each(function(i, e) {e.style.display = ''});
		} else {
			//Check if the previous animation has finished playing
			//If it has, we can add :visible and :hidden to the selectors to stop showing/hidding fields that are already visible/hidden
			var vis = '', hid = '';
			if (tribiqAFB.radioChanging) {
				clearTimeout(tribiqAFB.radioChanging);
			} else {
				vis = ':visible';
				hid = ':hidden';
			}
			
			$(sel + vis).not(selNot).hide('blind', {}, 500);
			$(selNot + hid).show('blind', {}, 500);
			
			tribiqAFB.radioChanging = tribiq.setTimeout('tribiqAFB.radioChanging = false;', 510);
		}
		
		$(selNot + ' input').each(function(i, e) { if (e.type == 'checkbox' && e.checked) { e.checked = false; $(e).click(); e.checked = false; } });
		$(sel + ' input').each(function(i, e) { if (e.type == 'checkbox' && e.checked) { e.checked = false; $(e).click(); e.checked = false; } });
	}
}


	






//A couple of the less generic closing functions, for handling admin floating boxes that have opened from
//slot controls or the storekeeper
tribiqAFB.createGetRequestFromPrimaryKeyForSlotReload = function() {
	var getRequestString = "";
	
	for (i in tribiqAFB.pk) {
		if (i != 'cID' && i != 'cType' && i != 'cVersion' && i != 'slotName' && i != 'instanceId') {
			getRequestString += "&" + i + "=" + encodeURIComponent(tribiqAFB.pk[i]);
		}
	}
	
	return getRequestString;
}




//Functions for TinyMCE

tribiqAFB.SK = function(field_name, url, type, win) {
	
	tribiqAFB.win = win;
	tribiqAFB.field_name = field_name;
	
	if (type == 'file') {
		tribiqA.SK('tribiqAFB', 'setLinkURL', false,
						'tribiq__content',
						'tribiq__content/content',
						'tribiq__content',
						'tribiq__content/content',
						false, undefined, undefined, undefined, true);
	
	} else if (type == 'image') {
		tribiqA.SK('tribiqAFB', 'setImageURL', false,
						'tribiq__content/media/images',
						'tribiq__content/media/images',
						'tribiq__content',
						false,
						false, undefined, undefined, undefined, true);
	
	} else if (type == 'media') {
		tribiqA.SK('tribiqAFB', 'setFlashURL', false,
						'tribiq__content/media/movies',
						'tribiq__content/media/movies',
						'tribiq__content',
						false,
						false, undefined, undefined, undefined, true);
	}
}

tribiqAFB.setEditorField = function(value, fieldName) {
	if (!fieldName) {
		fieldName = tribiqAFB.field_name;
	}
	
	tribiqAFB.win.document.forms[0].elements[fieldName].value = value;
	
	if (tribiqAFB.win.document.forms[0].elements[fieldName].onchange) {
		tribiqAFB.win.document.forms[0].elements[fieldName].onchange();
	}
}

tribiqAFB.setLinkURL = function(path, key, row) {
	//Get the URL via an AJAX program
	var URL = URLBasePath + tribiq.pluginClassAJAX('tribiq_cms_core', key, true);
	
	tribiqAFB.setEditorField(URL);
}

tribiqAFB.setImageURL = function(path, key, row) {
	var imageURL = URLBasePath + "cmsincludes/image.php?c=" + key.id;
	
	tribiqAFB.setEditorField(imageURL);
}

tribiqAFB.setFlashURL = function(path, key, row) {
	var flashURL = URLBasePath + "cmsincludes/movie.php?c=" + key.id;
	
	tribiqAFB.setEditorField(flashURL);
}





//Code for submiting forms via AJAX

tribiqAFB.createArrayFromFormElement = function(parentElement) {
	var inputs = parentElement.getElementsByTagName("input");
	var textareas = parentElement.getElementsByTagName("textarea");
	var selectboxes = parentElement.getElementsByTagName("select");
	var arrFormElementValues = new Object();
	
	if (inputs != undefined) {
		for (var i = 0;i < inputs.length;i++) {
			if (!inputs[i].disabled) {
				var inputName = false;
				
				if (inputs[i].name) {
					inputName = inputs[i].name;
					
				} else if (inputs[i].id) {
					inputName = inputs[i].id;
				}
					
				if (inputName) {
					
					if (inputs[i].type == "radio") {
						if (inputs[i].checked) {
							arrFormElementValues[inputName] = inputs[i].value;
						}
						
					} else if (inputs[i].type == "checkbox") {
						if (inputs[i].checked) {
							arrFormElementValues[inputName] = inputs[i].value;
						} else {
							arrFormElementValues[inputName] = "";
						}
						
					} else {
						arrFormElementValues[inputName] = inputs[i].value;
					}
				}
			}
		}
	}

	if (textareas != undefined) {
		for (var i = 0;i < textareas.length;i++) {
			if (!textareas[i].disabled) {
				if (textareas[i].className == "tinymce" || textareas[i].className == "tinymce_with_images") {
					arrFormElementValues[textareas[i].name] = $('#' + textareas[i].id).html();
				
				} else if (textareas[i].name) {
					arrFormElementValues[textareas[i].name] = textareas[i].value;
				
				} else if (textareas[i].id) {
					arrFormElementValues[textareas[i].id] = textareas[i].value;
				}
			}
		}
	}

	if (selectboxes != undefined) {
		for (var i = 0;i < selectboxes.length;i++) {
			if (!selectboxes[i].disabled) {
				var value = '';
				if (selectboxes[i].multiple) {
					for (var j = 0; j < selectboxes[i].options.length; j++) {
						if (value != '') {
							value += ',';
						}
						value += '' + selectboxes[i].options[j].value;
					}
				} else {
					value = selectboxes[i].options[selectboxes[i].selectedIndex].value;
				}
				
				if (selectboxes[i].name) {
					arrFormElementValues[selectboxes[i].name] = value;
				
				} else if (selectboxes[i].id) {
					arrFormElementValues[selectboxes[i].id] = value;
				}
			}
		}
	}

	return arrFormElementValues;	
}












//Function for checking mandatory fields
//Currently, it checks if a value has been entered and/or chosen for text fields, text areas or select lists.
//Can also check if checkboxes have been checked, or if one of a set of radio-groups have been chosen.

//It needs two pointers to work:
	//one pointer to the mandatory field, which must be set up in the manField variable in advance
	//and one pointer to the table cell containing the field, which it takes as input
tribiqA.manField = false;
tribiqA.specialFilledLogicNotMeet = false;

tribiqA.mandatoryField = function(tableContainer) {
	
	tribiqAFB.changed = true;
	
	if (tribiqA.manField) {
		var filled = false;
		
		if (tribiqA.specialFilledLogicNotMeet) {
			filled = false;
			
		} else if (tribiqA.manField.type && tribiqA.manField.type == 'radio') {
			inputs = tableContainer.getElementsByTagName("input");
			
			if (inputs!=undefined) {
				for (var i=0;i<inputs.length;i++) {
					if (inputs[i].type == 'radio' && inputs[i].name == tribiqA.manField.name && inputs[i].checked) {
						filled = true;
					}
				}
			}
			
		} else if (tribiqA.manField.type && tribiqA.manField.type == 'checkbox') {
			filled = tribiqA.manField.checked;
			
		} else {
			filled = tribiqA.manField.value !== '';
		}
		
		if (filled && tableContainer.className == 'mandatory') {
			tableContainer.className = 'mandatory_correct';
		
		} else if (!filled && tableContainer.className == 'mandatory_correct') {
			tableContainer.className = 'mandatory';
		}
	}
	
	tribiqA.manField = false;
	tribiqA.specialFilledLogicNotMeet = false;
}

//Special logic for checking password fields and their reconfirmation
tribiqA.mandatoryPasswordFields = function(el) {
	//Check if the required fields are on the page
	if (get('password') && get('password_reconfirm') && get('password_cell') && get('password_reconfirm_cell')) {
		//Check the password field normally
		tribiqA.manField = get('password');
		get('password_cell').onclick();
		
		//Only let the reconfirmed password be marked as correct if it matches the password
		tribiqA.specialFilledLogicNotMeet = get('password').value !== get('password_reconfirm').value;
		tribiqA.manField = get('password_reconfirm');
		get('password_reconfirm_cell').onclick();
	
	} else {
		//Fall back to the normal logic if the required fields are not on the page
		tribiqA.manField = el;
	}
}


//Skim a form for Mandatory fields, and add in the logic and events for them as needed
//However if there is already an onKeyUp or onClick event set on a field it will not overwrite it;
//you need to add them in manually in that case

//Also contains a workaround for IE which doesn't have focus CSS: onFocus and onBlur events
//are added to fake the ability
tribiqA.setUpMandatoryFieldEvents = function(formElement) {
	
	if (get('errorDisplay') && get('errorDisplay').innerHTML == '') {
		get('errorDisplay').style.display = 'none';
	}

	var cells = formElement.getElementsByTagName("td");

	if (cells != undefined) {
		for (var c=0; c < cells.length; c++) {
			if (cells[c].className == 'mandatory' || cells[c].className == 'mandatory_correct') {
				cells[c].onkeyup = new Function("tribiqA.mandatoryField(this);");
				cells[c].onclick = new Function("tribiqA.mandatoryField(this);");
				
				
				var inputs = cells[c].getElementsByTagName("input");
				var textareas = cells[c].getElementsByTagName("textarea");
				var selectboxes = cells[c].getElementsByTagName("select");

				if (inputs != undefined) {
					for (var i=0; i < inputs.length; i++) {
						if (inputs[i].type == 'radio' || inputs[i].type == 'checkbox') {
							if(!inputs[i].onclick) inputs[i].onclick = new Function("tribiqA.manField = this;");
						
						} else if (inputs[i].className == 'form_field') {
							if(!inputs[i].onkeyup) inputs[i].onkeyup = new Function("tribiqA.manField = this;");
							
							if (tribiq.browserIsIE()) {
								inputs[i].onfocus = new Function("this.className = 'form_field_focused';");
								inputs[i].onblur = new Function("this.className = 'form_field';");
							}
						}
					}
				}
			
				if (textareas != undefined) {
					for (var i=0; i < textareas.length; i++) {
						if (textareas[i].className == 'form_field') {
							if(!textareas[i].onkeyup) textareas[i].onkeyup = new Function("tribiqA.manField = this;");
							
							if (tribiq.browserIsIE()) {
								textareas[i].onfocus = new Function("this.className = 'form_field_focused'");
								textareas[i].onblur = new Function("this.className = 'form_field'");
							}
						}
					}
				}
			
				if (selectboxes != undefined) {
					for (var i=0; i < selectboxes.length; i++) {
						if (selectboxes[i].className == 'form_field') {
							if(!selectboxes[i].onclick) selectboxes[i].onclick = new Function("tribiqA.manField = this;");
							if(!selectboxes[i].onkeyup) selectboxes[i].onkeyup = new Function("tribiqA.manField = this;");
							
							if (tribiq.browserIsIE()) {
								selectboxes[i].onfocus = new Function("this.className = 'form_field_focused'");
								selectboxes[i].onblur = new Function("this.className = 'form_field'");
							}
						}
					}
				}
			} else {
				cells[c].onkeyup = new Function("if (tribiqAFB.inEditMode) tribiqAFB.changed = true;");
				cells[c].onclick = new Function("if (tribiqAFB.inEditMode) tribiqAFB.changed = true;");
			}
		}
	}
}









//These functions are here for backwards compatability purposes with the old thickbox functions
function formHandler() {
	if (tribiqAFB.justCanceled) {
		tribiqAFB.cancel();
	} else {
		tribiqAFB.edit();
	}
	tribiqAFB.justCanceled = false;
}

function cancelEdit() {
	tribiqAFB.justCanceled = true;
}

function genericTableSortClick(dataset_name,column,sort) {
	get('dataset_name').value = dataset_name;
	get('gsf').value = column;
	get('gsfo').value = sort;
	
	if (get('formMode')) {
		get('formMode').value = 'edit';
	}
	
	tribiqAFB.setData();
	tribiqAFB.openTab(tribiqAFB.tab);
	return false;
}

function genericTablePageClick(dataset_name,page) {
	get('dataset_name').value = dataset_name;
	get('page').value = page;
	
	if (get('formMode')) {
		get('formMode').value = 'edit';
	}	
	
	tribiqAFB.setData();
	tribiqAFB.openTab(tribiqAFB.tab);
	return false;
}

//dummy function for backwards compatability purposes, can remove when all js libraries are switched over
function tabInitialiseAfterLoad() {
	
}

//for backwards compatability purposes with JS written for the old tab system
var primaryKey = new Array();
var storekeeperItemKey = false;


//Replacement for the SelectBox library
tribiqAFB.moveOptions = function(from, to) {
	if ((from = get(from)) && (to = get(to))) {
		$(from).copyOptions(to);
		$(from).removeOption(/./, true);
		$(from).sortOptions();
		$(to).sortOptions();
	}
}