/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */


window['tribiqAT'] = function() {};

tribiqAT.permanentMsg = null;

tribiqAT.toolbarButtonClick = function(buttonId,element) {
	var url = URLBasePath + "cmsincludes/admintoolbar_button_handler.php";
	var data = "button_id=" + buttonId;
	
	if (tribiq.cID!=undefined) {
		data += "&cID=" + tribiq.cID;
	}
	
	if (tribiq.cType!=undefined) {
		data += "&cType=" + tribiq.cType;
	}
	
	if (tribiq.cVersion!=undefined) {
		data += "&cVersion=" + tribiq.cVersion;
	}
	
	if (tribiq.mID!=undefined) {
		data += "&mID=" + tribiq.mID;
	}
	
	if (tribiq.checkSlotsBeingEdited()) {
		data += "&editing=1";
	}

	$.ajax({
			url: url,
			type: 'POST',
			data: data,
			success: function (data) {
				if (data['open_thickbox']) {
					tribiqAFB.open('', data['url']);
				}

				if (data['open_admin_floating_box']) {
					tribiqAFB.open(data['pluginClassName'], data['fbName'], data['pk']);
				}

				if (data['open_floating_box']) {
					eval(decodeURI(data['floating_box_data']));
				}

				if (data['reload_page']) {
					if (data['destination']) {
						var params = "?";
						
						for (i in data['destination']) {
							params += i + "=" + data['destination'][i] + "&";
						}
					
						params = params.substr(0,params.length-1);
					
						window.location = URLBasePath + params;
					} else {
						window.location.reload();
					}
				}

				if (data['function_to_run']) {
					if (data['parameters']) {
						var parameters = eval("(" + data['parameters'] + ")");
					}
					
					var fun = data['function_to_run'].split('.');
					
					if (fun[1]) {
						window[fun[0]][fun[1]](element,parameters);
					} else {
						window[data['function_to_run']](element,parameters);
					}
				}
				
				if (data['open_storekeeper_select']) {
					tribiqA.SK(
						data.callbackObject, data.callbackFunction, data.enableMultipleSelect,
						data.path, data.targetPath, data.minPath, data.maxPath, data.disallowIdenticalMinPath,
						data.chooseButtonActiveClass, data.choosePhrase, data.chooseMultiplePhrase);
				}
		
				return false;
			},
			dataType: "json",
			async: false
	});
	
	return false;
}

tribiqAT.addMenuItemAction = function(path, key, keyId) {
	var message = tribiq.nonAsyncAJAX(
					URLBasePath + 'plugins.php?__pluginClassName__=tribiq_cms_core&method_call=storekeeperAJAX' +
						'&__path__=tribiq__content/content' +
						'&add_to_menu=1' +
						'&id=' + 1*tribiq.cID +
						'&refiner__content_type=' + encodeURIComponent(tribiq.cType) +
						'&id2=' + 1*key.id,
					true, false);
	
	if (message) {
		tribiqA.floatingBox(message, true, 'error');
	} else {
		tribiq.goToURL(tribiq.linkToItem(tribiq.cID, tribiq.cType));
	}
}

tribiqAT.deleteMenuItemAction = function() {
	var url = URLBasePath + 'plugins.php?__pluginClassName__=tribiq_cms_core&__path__=tribiq__menu/menu_items&method_call=storekeeperAJAX';

	$.post(url,{'delete': 1, id: tribiq.mID},function (data) {
			window.location = URLBasePath + tribiq.indexDotPHP + "?cID=" + tribiq.cID + "&cType=" + tribiq.cType + "&cVersion=" + tribiq.cVersion;
		}, 'text');
}

tribiqAT.trashContentAction = function() {
	var url = URLBasePath + 'plugins.php?__pluginClassName__=tribiq_cms_core&__path__=tribiq__content/content&method_call=storekeeperAJAX';

	$.post(url,{trash: 1, id: tribiq.cID, refiner__content_type:tribiq.cType},function (data) {
			window.location = URLBasePath + tribiq.indexDotPHP + "?cID=" + tribiq.cID + "&cType=" + tribiq.cType + "&cVersion=" + tribiq.cVersion;
		}, 'text');
}

tribiqAT.hideContentAction = function() {
	var url = URLBasePath + 'plugins.php?__pluginClassName__=tribiq_cms_core&__path__=tribiq__content/content&method_call=storekeeperAJAX';

	$.post(url,{hide: 1, id: tribiq.cID, refiner__content_type:tribiq.cType},function (data) {
			window.location = URLBasePath + tribiq.indexDotPHP + "?cID=" + tribiq.cID + "&cType=" + tribiq.cType + "&cVersion=" + tribiq.cVersion;
		}, 'text');
}

tribiqAT.createDraftAction = function() {
	var url = URLBasePath + 'plugins.php?__pluginClassName__=tribiq_cms_core&__path__=tribiq__content/content&method_call=storekeeperAJAX';

	$.post(url,{createDraft: 1, id: tribiq.cID, refiner__content_type:tribiq.cType},function (data) {
			window.location = URLBasePath + tribiq.indexDotPHP + "?cID=" + tribiq.cID + "&cType=" + tribiq.cType + "&cVersion=" + (tribiq.cVersion+1);
		}, 'text');
}

tribiqAT.deleteContentAction = function() {
	var url = URLBasePath + 'plugins.php?__pluginClassName__=tribiq_cms_core&__path__=tribiq__content/content&method_call=storekeeperAJAX&frontend=1';

	$.post(url,{'delete': 1, id: tribiq.cID, refiner__content_type:tribiq.cType},function (data) {
			if (data['version']) {
				window.location = URLBasePath + tribiq.indexDotPHP + "?cID=" + tribiq.cID + "&cType=" + tribiq.cType + "&cVersion=" + data['version'];
			} else if (data['content_id']) {
				window.location = URLBasePath + tribiq.indexDotPHP + "?cID=" + data['content_id'] + "&cType=" + data['content_type'];
			} else if (data['alias']) {
				window.location = URLBasePath + tribiq.indexDotPHP + "?cID=" + data['alias'];
			} else {
				window.location = URLBasePath;
			}
		}, 'json');
}

tribiqAT.selectTab = function(selectedTabElement,tabName) {
	$("#tribiq_middlesection_content > .tribiq_tab_on").css({display: "none"});
	$("#" + tabName).css({display: "block"});
	$("#tribiq_tabs > .tribiq_tab_on").removeClass("tribiq_tab_on");
	$(selectedTabElement).addClass("tribiq_tab_on");
}

tribiqAT.showPermanentMessage = function(msg,supressSlide) {
	tribiqAT.permanentMsg = msg;

	$("#tribiq_message_content").text(msg);
	$("#tribiq_message_content").show();
	
	if (!supressSlide) {
		$("#tribiq_message_content").effect("slide",{direction: "right"},1250);
	}
}

tribiqAT.showTemporaryMessage = function(msg) {
	$("#tribiq_message_content").hide("slide",{direction: "down"},"fast",function() {
		$("#tribiq_message_content").text(msg);
		$("#tribiq_message_content").effect("slide",{direction: "right"},1250,function() {
			var t = tribiq.setTimeout("tribiqAT.resetToPermanentMessage()",4000);
		});
	});
}

tribiqAT.resetToPermanentMessage = function() {
	$("#tribiq_message_content").hide("slide",{direction: "down"},"fast",function() {
		tribiqAT.showPermanentMessage(tribiqAT.permanentMsg);
	});
}



tribiqAT.toggleShowHideSlots = function(element, parameters) {
	$('.tribiq_slotWithNoContents').css('display', parameters.hideEmpty? 'none' : '');
	$('.tribiq_slotAdminControlBox').css('display', parameters.hideEmpty? 'none' : '');
	$(element).toggleClass("tribiq_show_slots");
}

tribiqAT.changePageMode = function(element, parameters) {
	if (parameters.pageMode=="edit") {
		tribiqA.pageMode = 'edit';
		$('body').removeClass('tribiq_pagePreviewMode');
		$('body').removeClass('tribiq_pageEditMode');
		$('body').removeClass('tribiq_pageSlotMode');
		$('body').addClass('tribiq_pageEditMode');
	} else if (parameters.pageMode=="slot") {
		tribiqA.pageMode = 'slot';
		$('body').removeClass('tribiq_pagePreviewMode');
		$('body').removeClass('tribiq_pageEditMode');
		$('body').removeClass('tribiq_pageSlotMode');
		$('body').addClass('tribiq_pageSlotMode');
	} else {
		tribiqA.pageMode = 'preview';
		$('body').removeClass('tribiq_pagePreviewMode');
		$('body').removeClass('tribiq_pageEditMode');
		$('body').removeClass('tribiq_pageSlotMode');
		$('body').addClass('tribiq_pagePreviewMode');
	}

	tribiqAT.toggleRadioStyleButtons(element,parameters);
}

tribiqAT.toggleRadioStyleButtons = function(element, parameters) {
	if (parameters.pageMode=="preview") {
		$('.' + parameters.radioClass).removeClass("tribiq_page_preview_mode_on");
		$('.' + parameters.radioClass).removeClass("tribiq_page_edit_mode_on");
		$('.' + parameters.radioClass).removeClass("tribiq_page_slot_mode_on");
		$(element).addClass("tribiq_page_preview_mode_on");
	} else if (parameters.pageMode=="edit") {
		$('.' + parameters.radioClass).removeClass("tribiq_page_preview_mode_on");
		$('.' + parameters.radioClass).removeClass("tribiq_page_edit_mode_on");
		$('.' + parameters.radioClass).removeClass("tribiq_page_slot_mode_on");
		$(element).addClass("tribiq_page_edit_mode_on");
	} else if (parameters.pageMode=="slot") {
		$('.' + parameters.radioClass).removeClass("tribiq_page_preview_mode_on");
		$('.' + parameters.radioClass).removeClass("tribiq_page_edit_mode_on");
		$('.' + parameters.radioClass).removeClass("tribiq_page_slot_mode_on");
		$(element).addClass("tribiq_page_slot_mode_on");
	}
}

tribiqAT.openStorekeeper = function (element, parameters) {
	window.open(parameters.url);
}

/*

	$(".tribiq_slotWithContents").mouseenter(function () {
								mouseEnterCounter++;
								
								if (mouseEnterCounter==1) {
									previousPosition = $(this).css("position");
									$(this).css("position","relative");
									previousZIndex = $(this).css("z-index");
									$(this).css("z-index",500);
									$("#modal-overlay").show();
								} else {
									mouseEnterCounter--;
								}
							});
							
	$(".tribiq_slotWithContents").mouseleave(function () {
								mouseEnterCounter--;
								$(this).css("position",previousPosition);
								$(this).css("z-index",previousZIndex);
								//alert($(this).attr("id") + ": " + $(this).css("z-index"));
								$("#modal-overlay").hide();
							});

*/