<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

header('Content-Type: text/css; charset=UTF-8');

require '../cmsincludes/cache.inc.php';
useCache('tribiq-inc-css-'. CSS_JS_VERSION);
useGZIP($_GET['gz']);


function incCCS($file) {
	if (file_exists($file. '.min.css')) {
		require $file. '.min.css';
	} elseif (file_exists($file. '.css')) {
		require $file. '.css';
	}
	
	echo "\n/**/\n";
}


//Include all of the standard CSS libraries for the CMS
incCCS('libraries/mit/jquery/css/jquery-ui');
incCCS('libraries/mit/jquery/css/fancybox');
incCCS('libraries/mit/jquery/css/tiptip');
incCCS('libraries/lgpl/punymce/emoticons');

//Include a list of fixes for IE6
if (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 6') !== false) {
	incCCS('libraries/mit/jquery/css/fancybox_ie6');
	
	echo '
		body { behavior: url(libraries/lgpl/csshover/csshover.htc); }
		
		#tiptip_content {
			width: 200px;
		}
		
		#tiptip_arrow, #tiptip_arrow_inner {
			overflow: hidden;
		}';
}

//Include a list of fixes for IE
if (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false) {
	echo '
		#tiptip_content {
			filter: alpha(opacity=90);
		}
		
		#tiptip_arrow {
			filter: alpha(opacity=35);
		}';
}

//Hide/show different fields for date pickers, depending on whether JavaScript is enabled
//Default calendar icon for datepickers
echo '
	body.js select.jquery_datepicker {
		display: none;
	}
	
	body.no_js input.jquery_datepicker {
		display: none;
	}
	
	input.jquery_datepicker {
		background-image: url("../admin/images/icons/calendar_small.gif");
		background-repeat: no-repeat;
		background-position: 98% 50%;
	}';

//Bugfix for jQueryUI Datepicker (all browsers)
echo '
	#ui-datepicker-div {
		display: none;
	}';