<?php {
/** License info will be placed here by Build */


/**
 * This file is provided with the intention of documenting a few Core functions and features.
 * 
 * It's far from complete, so you may need to read cmsincludes/cms.inc.php or cmsincludes/admin.inc.php if you can't find a function you need.
 */


//Add an extranet user into a group, or out of a group
//	function addUserToGroup($userId, $groupId, $remove = false) {}

//	function checkLogin($name, $password, $format = 'email') {}

/**
 * Check for permission to see a content item
 */
//	function checkPerm($cID, $cType, $cVersion = false) {}

/**
 * Check for an admin priv
 */
//	function checkPriv($action = false) {}

/**
 * Check is a user is in a certain extranet group
 */
//	function checkUserInGroup($groupId, $userId = 'session') {}

//	function connectGlobalDB() {}

//	function connectLocalDB() {}

//	function createPassword() {}

/**
 * Format a date for display
 */
//	function formatDateNicely($date, $format_type = false, $lang = false, $time_format = '', $rss = false) {}

/**
 * Format a datetime for display
 */
//	function formatDateTimeNicely($date, $format_type = false, $lang = false, $rss = false) {}

/**
 * Format a filesize for display
 */
//	function formatFilesizeNicely($size, $precision = 0) {}

/**
 * Format a file type for display
 */
//	function formatFileTypeNicely($type) {}

/**
 * Get an item's title
 */
//	function getItemTitle($cID, $cType, $cVersion = false) {}

/**
 * Check what Language an Item is in
 */
//	function getContentLang($cID, $cType, $cVersion = false) {}

/**
 * Get an item's description
 */
//	function getItemDescription($cID, $cType, $cVersion) {}

/**
 * Get an Admin Phrase
 */
//	function getPhrase($code, $replace = array()) {}

/**
 * Gets an array of the ids of the groups that an user belongs to. 
 */

//	function getUserGroups( $userId ) {}

/**
 * Gets a string containing the names of the groups that an user belongs to. 
 */

//	function getUserGroupsNames( $userId ) {}

//	function inc($pluginClass) {}

function itemStickyImage($cID, $cType, $cVersion = false) {
	return cms_core::getContentStickyImage($cID, $cType, $cVersion);
}

function langEquivalentItem(&$cID, &$cType) {
	if (inc('tribiq_avls')) {
		tribiq_avls::equivalentItem($cID, $cType);
	}
}

//	function logUserIn($userId, $user = false) {}

//Attempt to automatically log a User in if the cookie is set on the User's Machine
function logUserInAutomatically() {
	if (!issetArrayKey($_SESSION, 'extranetUserID')
	 && issetArrayKey($_COOKIE, 'LOG_ME_IN_COOKIE')
	 && ($idAndMD5 = explode('_', $_COOKIE['LOG_ME_IN_COOKIE'], 2))
	 && (count($idAndMD5) == 2)
	 && ($user = getUserDetails($idAndMD5[0]))
	 && ($idAndMD5[1] === md5(SITENAME. $user['id']. $user['username']. $user['email']. $user['password']))) {
		logUserIn($user['id'], $user);
	}
}

function logUserOut() {
	unset($_SESSION['extranetUserID']);
	unset($_SESSION['extranetUserID_pending']);
	unset($_SESSION['extranetUser_firstname']);
	unset($_SESSION['extranetUserIsAnEmployee']);
	unset($_SESSION['extranetUserSteps']);
	$_SESSION['FORGET_EXTRANET_LOG_ME_IN_COOKIE'] = true;
}


//	function outputImage($data,$width,$height,$mimeType) {}
//	function outputStorekeeperImage($data,$width,$height,$mimeType) {}

//	function phrase($code, $replace = array()) {}

//	function sendSignal($signalName, $signalParams) {}

/**
 * Get the value of a site setting from the Core
 */
//	function setting($name) {}

/** 
 * Automatically generate SQL to search through a content-types table, for example for a content list
 * A bit of a techy function so we've included the full code here, so you can see exactly what it does
 */
function sqlToSearchContentTable($cType, $hidePrivateItems = true, $onlyShow = false, $specificId = false) {
	$sql = "";
	
	if ($onlyShow == 'public') {
		$sql .= "
		  AND c.private = 0";
	} elseif ($onlyShow == 'private') {
		$sql .= "
		  AND c.private = 1";
	}
	
	$specificIdSQL = '';
	if ($specificId) {
		$specificIdSQL = "AND c.id = ". (int) $specificId;
	}
	
	//refiner by whether the current viewer can see each item
	if (checkPriv()) {
		//Show Admins everything, even including private drafts
		//However if there is a private draft, we must not also show the published version
		$sql .= "
		  AND c.status IN ('published', 'private_draft')
		  AND (c.id, c.status) NOT IN (
			SELECT id, 'published'
			FROM ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($cType). "
			WHERE status = 'private_draft'
		  )";
	
	} elseif (!$hidePrivateItems) {
		//If show_private_items is enabled, show all items
		$sql .= "
		  AND c.status = 'published'";
		
	} elseif (!$_SESSION['extranetUserID'] && $onlyShow == 'private') {
		//Private items can only be seen by logged in users...
		return "
		  AND 1=2";
		  
	} elseif (!$_SESSION['extranetUserID'] || $onlyShow == 'public') {
		//If the visitor is not logged in, only show public items
		$sql .= "
		  AND c.status = 'published'
		  AND c.private = 0";
	
	} else {
		//If the visitor is logged in, check which items they can see
		$sql .= "
		  AND c.status = 'published'
		  AND (c.private = 0
			OR (c.id, c.version) NOT IN (
				SELECT content_id, content_version
				FROM ". DB_NAME_PREFIX. "user_content_link
				WHERE content_type = '". mysql_real_escape_string($cType). "'
				  ". $specificIdSQL. "
			  UNION
				SELECT content_id, content_version
				FROM ". DB_NAME_PREFIX. "group_content_link AS c
				WHERE content_type = '". mysql_real_escape_string($cType). "'
				  ". $specificIdSQL. "
			)
			OR (c.id, c.version) IN (
				SELECT content_id, content_version
				FROM ". DB_NAME_PREFIX. "user_content_link
				WHERE user_id = ". (int) $_SESSION['extranetUserID']. "
				  AND content_type = '". mysql_real_escape_string($cType). "'
				  ". $specificIdSQL. "
			  UNION
				SELECT content_id, content_version
				FROM ". DB_NAME_PREFIX. "group_user_link AS u
				INNER JOIN ". DB_NAME_PREFIX. "group_content_link AS c
				   ON c.group_id = u.group_id
				WHERE u.user_id = ". (int) $_SESSION['extranetUserID']. "
				  AND content_type = '". mysql_real_escape_string($cType). "'
				  ". $specificIdSQL. "
			)
		  )";
	}
	
	return $sql;
}

function userEmail($userId = 'session') {
	if ($userId === 'session') {
		$userId = session('extranetUserID');
	}
	
	if ($userId) {
		return getEmail($userId);
	} else {
		return false;
	}
}

function userScreenName($userId = 'session') {
	if ($userId === 'session') {
		$userId = session('extranetUserID');
	}
	
	if ($userId) {
		return getUserScreenName($userId);
	} else {
		return false;
	}
}

function userUsername($userId = 'session') {
	if ($userId === 'session') {
		$userId = session('extranetUserID');
	}
	
	if ($userId) {
		return getUsername($userId);
	} else {
		return false;
	}
}


} ?>