<?php {
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */


/**
 * This file collects some helper functions, in both PHP and JavaScript.
 * 
 * Using them is completely optional, but they are intended to be for your assistance
 */


function addAmp($request) {
	if ($request != '' && substr($request, 0, 1) != '&') {
		return '&'. $request;
	} else {
		return $request;
	}
}

function arrayKey(&$array, $key, $key2 = false, $key3 = false, $key4 = false, $key5 = false, $key6 = false, $key7 = false, $key8 = false, $key9 = false) {
	
	if (is_array($array) && isset($array[$key])) {
		if ($key2 === false) {
			return $array[$key];
		} else {
			return arrayKey($array[$key], $key2, $key3, $key4, $key5, $key6, $key7, $key8, $key9);
		}
	} else {
		return false;
	}
}

//	function checkRowExists($table, $ids, $prefix = DB_NAME_PREFIX) {}

function curl($URL) {
	if (!$hCURL = @curl_init()) {
		return false;
	}

	$sReturn = '';
	$sReferer = httpHost();
	
	curl_setopt($hCURL, CURLOPT_FAILONERROR, 1); 
	curl_setopt($hCURL, CURLOPT_HEADER, 0);
	curl_setopt($hCURL, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($hCURL, CURLOPT_TIMEOUT, 30);
	curl_setopt($hCURL, CURLOPT_VERBOSE, 0);
	curl_setopt($hCURL, CURLOPT_FOLLOWLOCATION, 0);
	curl_setopt($hCURL, CURLOPT_POST, 0);
	curl_setopt($hCURL, CURLOPT_URL, $URL);
	curl_setopt($hCURL, CURLOPT_REFERER, $sReferer);
	
	$result = curl_exec($hCURL);
	
	curl_close($hCURL);
	return $result;
}

//Reverses encodeItemIdForStorekeeper()
function decodeItemIdForStorekeeper($id) {
	if (substr($id, 0, 1) == '~') {
		return rawurldecode(str_replace('~', '%', substr($id, 1)));
	} else {
		return $id;
	}
}

function deleteRow($table, $ids, $prefix = DB_NAME_PREFIX, $multiple = true) {
	return checkRowExists($table, $ids, $prefix, false, false, $multiple, true);
}

function displayHTMLAsPlainText(&$text, $excerptLength = 200, $stripTitles = false, $highlightTerm = false, $excerptCutOffPhrase = '...') {
	if ($stripTitles) {
		$text = preg_replace('@<h\d>.*?</h\d>@is', '', $text);
	}
	
	$text = strip_tags($text);
	
	if (strlen($text) > (int) $excerptLength) {
		$text = mb_substr($text, 0, (int) $excerptLength,'UTF-8');
		
		$text = preg_replace("/[\S]+$/","",$text);
		$text = preg_replace("/[\s\t\n\r,]+$/","",$text);
			
		if (!preg_match("/[\.]$/",$text)) {
			$text .= $excerptCutOffPhrase;
		}
	} else {
		$text = preg_replace("/[\s\t\n\r,]+$/","",$text);
	}
	
	if ($highlightTerm !== false) {
		$text = str_ireplace($highlightTerm, '<strong>'. $highlightTerm. '</strong>', $text);
	}
}

//Given a string, this function makes it safe to use in the URL after a hash (i.e. a safe id for Storekeeper)
function encodeItemIdForStorekeeper($id) {
	return '~'. str_replace('%', '~', rawurlencode($id));
}

function engToBoolean($text) {
	return $text && strtolower($text) != 'no' && strtolower($text) != 'false'? 1:0;
}

function engToBooleanArray(&$array, $key, $key2 = false, $key3 = false, $key4 = false, $key5 = false, $key6 = false, $key7 = false, $key8 = false, $key9 = false) {
	
	if (is_array($array) && isset($array[$key])) {
		if ($key2 === false) {
			return engToBoolean($array[$key]);
		} else {
			return engToBooleanArray($array[$key], $key2, $key3, $key4, $key5, $key6, $key7, $key8, $key9);
		}
	} else {
		return false;
	}
}

function get($name) {
	return isset($_GET[$name])? $_GET[$name] : false;
}

function getRow($table, $cols, $ids, $notZero = false, $prefix = DB_NAME_PREFIX) {
	return checkRowExists($table, $ids, $prefix, $cols, $notZero);
}

function getRows($table, $cols, $ids, $orderBy = array(), $notZero = false, $prefix = DB_NAME_PREFIX) {
	return checkRowExists($table, $ids, $prefix, $cols, $notZero, true, false, $orderBy);
}

//Encode a random name to something suitable for a HTML ID by replacing anything
//non-alphanumeric with an underscore
function HTMLId($text) {
	return preg_replace('/[^a-zA-Z0-9]/', '_', $text);
}

//(JavaScript only)
//	function htmlspecialchars(text) {}

//Attempt to check whether we are in http or https, and return a value appropriately
function httpOrhttps() {
	if (substr(arrayKey($_SERVER, 'SCRIPT_URI'), 0, 5) == 'https') {
		return 'https://';
	} else {
		return 'http://';
	}
}

function httpHost() {
	return ifNull(arrayKey($_SERVER, 'HTTP_HOST'), DEFAULT_URL);
}

function indexDotPHP($noBasePath = false) {
	if (defined('DIRECTORY_INDEX_FILENAME')) {
		$indexFile = DIRECTORY_INDEX_FILENAME;
	} else {
		$indexFile = 'index.php';
	}
	
	if ($indexFile) {
		return $indexFile;
	} elseif ($noBasePath) {
		return SUBDIRECTORY;
	} else {
		return '';
	}
}

function insertRow($table, $values, $prefix = DB_NAME_PREFIX) {
	return setRow($table, $values, array(), $prefix);
}

function issetArrayKey(&$array, $key, $key2 = false, $key3 = false, $key4 = false, $key5 = false, $key6 = false, $key7 = false, $key8 = false, $key9 = false) {
	
	if (is_array($array) && isset($array[$key])) {
		if ($key2 === false) {
			return (bool) $array[$key];
		} else {
			return issetArrayKey($array[$key], $key2, $key3, $key4, $key5, $key6, $key7, $key8, $key9);
		}
	} else {
		return false;
	}
}

//A short function that makes code a little bit nicer to read if used
function ifNull($a, $b, $c = null) {
	return $a? $a : ($b? $b : $c);
}

function jsOnClickEscape($text) {
	return str_replace("\n", "\\n", str_replace('\'', '\\\'', htmlspecialchars($text)));
}

//	function my_mysql_query($sql) {}

//Get a value from an array of merge fields, where you're not sure of the index name but have a few ideas about what it might be called
function pullFromArray(&$var, &$array, $key1, $key2 = '', $key3 = '') {
	
	if (!is_array($array)) {
		return;
	}
	
	$keys = func_get_args();
	array_splice($keys, 0, 2);
	
	foreach ($keys as &$key) {
		if ($key = preg_replace('/[^a-zA-Z]/', '', strtolower($key))) {
			foreach ($array as $akey => &$value) {
				$akey = preg_replace('/[^a-zA-Z]/', '', strtolower($akey));
				if ($akey == $key) {
					$var = $value;
					return;
				}
			}
		}
	}
}

function post($name) {
	return isset($_POST[$name])? $_POST[$name] : false;
}

function request($name) {
	return isset($_REQUEST[$name])? $_REQUEST[$name] : false;
}


	
/**
* Plugin Developers can use the email() method to send an email
*/
function sendEmail($subject, $body, $addressTo, $nameTo = false, $addressFrom = false, $nameFrom = false, $attachments = array(), $attachmentFilenameMappings = array()) {
	
	if ($nameTo === false) {
		$nameTo = $addressTo;
	}
	if ($addressFrom === false) {
		$nameFrom = getSiteConfig('email_name_from');
		$addressFrom = getSiteConfig('email_address_from');
	} elseif ($nameFrom === false) {
		$nameFrom = $addressFrom;
	}
	
	require_once CMS_ROOT. 'libraries/lgpl/PHPMailer/class.phpmailer.php';
	
	$mail = new PHPMailer();
	$mail->IsHTML(true);
	$mail->Sender = $addressFrom;
	$mail->From = $addressFrom;
	$mail->FromName = $nameFrom;
	$mail->AddReplyTo($mail->From, $mail->FromName);
	$mail->Subject = $subject;
	$mail->Body = $body;
	$mail->CharSet = 'UTF-8';
	$mail->AltBody = html_entity_decode(strip_tags($body), ENT_COMPAT, 'UTF-8');
	$mail->AddAddress($addressTo, $nameTo);
	$mail->AddCustomHeader("Precedence: bulk");
	

	foreach ($attachments as $fieldName => $fileToAttach) {
		if (file_exists($fileToAttach)){
			if (issetArrayKey($attachmentFilenameMappings, $fieldName)) {
				$mail->AddAttachment($fileToAttach, $attachmentFilenameMappings[$fieldName]);	
			} else {
				$mail->AddAttachment($fileToAttach);	
			}
		}
	}
	
	return $mail->Send();
}

function session($name) {
	return isset($_SESSION[$name])? $_SESSION[$name] : false;
}

//	function setRow($table, $values, $ids, $prefix = DB_NAME_PREFIX) {}


	
/**
* The SimpleXML() method converts a string into XML, using PHP's SimpleXMLElement
*/
function SimpleXMLString(&$string) {
	//Check if the input is false before processing it, so this function can safely be chained
	if (!$string) {
		return false;
	}
	
	try {
		$xml = @new SimpleXMLElement($string);
		return $xml;
	} catch (Exception $e) {
		return false;
	}
}

//Get an attribute from a SimpleXML object
function SimpleXMLAttribute(&$SimpleXML, $name) {
	
	if ($attributes = $SimpleXML->attributes()) {
		return $attributes['name'];
	}
	return null;
}

function SimpleXMLCURL($url, &$xml, &$error) {
	$error = false;
	
	if (!function_exists('curl_init') || !($hCURL = @curl_init())) {
		$error = getPhrase("Couldn't initialize a cURL handle. You should contact your administrator to ensure cURL is installed and running on your server.");
		return false;
	}
	
	curl_setopt( $hCURL, CURLOPT_FAILONERROR, 1 ); 
	curl_setopt( $hCURL, CURLOPT_HEADER, 0 );
	curl_setopt( $hCURL, CURLOPT_RETURNTRANSFER, 1 );
	curl_setopt( $hCURL, CURLOPT_TIMEOUT, 30 );
	curl_setopt( $hCURL, CURLOPT_VERBOSE, 0 );
	curl_setopt( $hCURL, CURLOPT_FOLLOWLOCATION, 0 );
	curl_setopt( $hCURL, CURLOPT_POST, 0 );
	curl_setopt( $hCURL, CURLOPT_URL, $url );
	curl_setopt( $hCURL, CURLOPT_REFERER, httpHost());
	curl_setopt( $hCURL, CURLOPT_COOKIE, 'PHPSESSID=' . $_COOKIE['PHPSESSID'] . '; path=/');

	session_write_close();
	
	$xml = curl_exec( $hCURL );
	curl_close($hCURL);
	
	if ($xml === false) {
		$error = getPhrase("Could not connect to ". $url);
		return false;
		
	} elseif (!$xml) {
		$error = getPhrase("Empty response from ". $url);
		return false;
		
	} else {
		try {
			$xml = @new SimpleXMLElement($xml);
		} catch (Exception $e) {
			$xml = false;
		}
		
		if (!$xml) {
			$error = getPhrase("Invalid XML response from ". $url);
			return false;
		}
	}
	
	return true;
}

function sqlArraySort(&$phpArray){
	
	if (is_array($phpArray) && !empty($phpArray)) {
		$sql = "show collation like 'utf8_unicode_ci'";
		$result = my_mysql_query($sql);
		$collate = mysql_fetch_row($result);
		
		$first = true;
		$arraysOfArrays = array();
		$sql = "
			SELECT *
			FROM (";
		
		foreach ($phpArray as $key => $value) {
			$sql .= "\n". ($first? "" : " UNION "). " SELECT ";
			
			if ($arraysOfArrays[$key] = is_array($value)) {
				$value = json_encode($value);
			}
			
			if (is_numeric($key)) {
				$sql .= (int) $key;
			} else {
				$sql .= "'". mysql_real_escape_string($key). "'";
			}
			
			$sql .= ", _utf8'". mysql_real_escape_string($value). "'";
			
			if ($collate) {
				$sql .= "COLLATE utf8_unicode_ci";
			}
			
			$first = false;
		}
		
		$sql .= ") countries
			ORDER BY 2";
		
		$phpArray = array();
		$result = my_mysql_query($sql);
		while ($row = mysql_fetch_row($result)) {
			if ($arraysOfArrays[$row[0]]) {
				$phpArray[$row[0]] = json_decode($row[1], true);
			} else {
				$phpArray[$row[0]] = $row[1];
			}
		}
	}
}

function updateRow($table, $values, $ids, $prefix = DB_NAME_PREFIX) {
	return setRow($table, $values, $ids, $prefix, false);
}

function urlRequest($arr) {
	if (!$arr) {
		return '';
	} elseif (!is_array($arr)) {
		return addAmp($arr);
	}
	
	$request = '';
	foreach ($arr as $name => &$value) {
		$request .= '&'. rawurlencode($name). '=';
		
		if ($value !== false && $value !== null) {
			$request .= rawurlencode($value);
		}
	}
	
	return $request;
}

//Attempt to check if an email address looks valid
function validateEmailAddress($email) {
	return preg_match('#^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,7})$#i', $email);
}

//Validate a screen name
function validateScreenName($screenName) {
	//Attempt to validate allowing UTF-8 characters through
	$invalid = @preg_match('/[^\p{L} \d\-\_]/u', $screenName);
	
	//Fall back to traditional pattern matching if that fails
	if ($invalid !== 0 && $invalid !== 1) {
		$invalid = preg_match('/[^\w \d\-\_]/u', $screenName);
	}
	
	return !$invalid;
}


function XMLEscape($text) {
	return str_ireplace(array("'", '&nbsp;'), array('&apos;', ' '), htmlspecialchars($text));
}

//	function windowsServer() {}


} ?>