<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */


//This Plugin displays an image or a flash movie; it is intended to be used at the top of a page to display a Masthead
class tribiq_animation extends plugin_base_class {
	
	var $mergeFields = array();
	var $subSections = array();
	
	function allowPluginToBeShownOnErrorPage() {
		return true;
	}
	
	//The init method is called by the CMS lets Plugin Developers run code before the Plugin and the page it is on are displayed.
	//In visitor mode, the Plugin is only displayed if this method returns true.
	function init() {
		if ($this->getMediaIdTypeAndURLFromSetting( $mediaId, $mediaType, $mediaURL, 'masthead_flash' )  && ( $mediaType == 'movie') ) {
			$this->mergeFields['Flash_Source'] = $mediaURL;
			$this->mergeFields['Flash_Id'] = $this->containerId. '_movie';
			return true;
			
		} else {
			return false;
		}
		
	}
	
	
	//The showSlot method is called by the CMS, and displays the Plugin on the page
	function showSlot() {
		//Check if we have a flash movie
		if ($this->mergeFields['Flash_Source']) {
			//Use the Theme Section for flash movies and set the flash vars
			$this->subSections['Flash_Masthead'] = true;
			$this->mergeFields['Flash_Height'] =  $this->setting( 'height' );
			$this->mergeFields['Flash_Width'] =  $this->setting( 'width' );
			$this->mergeFields['Flash_Version'] =  $this->setting( 'version' ) ;

			//Display the plugin
			$this->framework('Outer', $this->mergeFields, $this->subSections );
		}
	}
}
?>
