<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

if (!SimpleXMLCURL('http://tribiq.com/stores.xml', $xml, $error)) {
	$panel['no_items_message'] = $error;

} else {
	if ($xml->feeds) {
		$panel['items'] = array();
		
		foreach ($xml->feeds->children() as $item) {
			if ($phase == 1) {
				$panel['items'][$item->getName()] = array('name' => (string) $item->name, 'image' => (string) $item->image);
			} else {
				if ($item->getName() == $refinerId) {
					if (!SimpleXMLCURL($item->url, $xml2, $error)) {
						$panel['no_items_message'] = $error;
					
					} elseif ($xml2->channel) {
						$panel['title'] = ifNull((string) $xml2->channel->title, (string) $item->name);
						$panel['banner'] = ifNull((string) $xml2->channel->banner, (string) $item->banner);
						
						$i=0;
						if ($xml2->channel->item) {
							foreach ($xml2->channel->item as $item2) {
								$panel['items'][++$i] = array(
									'title' => '#'. $i. ' '. (string) $item2->title,
									'url' => (string) $item2->link,
									'pubDate' => (string) $item2->pubDate,
									'tooltip' => (string) $item2->description);
							}
						}
					}
				}
			}
		}
	}
}

return false;
?>