<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

switch ($path) {
	case 'tribiq__overview':
		
		$this->CURLNewsFetch($panel, 1);
		
		break;

	
	case 'tribiq__overview/feed':
		
		$this->CURLNewsFetch($panel, 2, $refinerId);
		
		break;

	
	case 'tribiq__menu':
		foreach ($panel['items'] as $id => &$item) {
			if (file_exists(CMS_ROOT. 'admin/images/store_keeper/main_icons/general_'. $id. '.gif')) {
				$item['image'] = 'admin/images/store_keeper/main_icons/general_'. $id. '.gif';
			}
		}
		
		break;

	
	case 'tribiq__menu/sections':
		$panel['title'] = getPhrase('[[lang]] Menu Sections', array('lang' => getLanguageName($this->get('refiner__language'))));
		
		foreach ($panel['items'] as $id => &$item) {
			$item['traits'] = array('empty' => !checkRowExists('menuitems', array('section_id' => $id)));
		}
		
		break;

	
	case 'tribiq__menu/menu_items':
		$mrg = array('lang' => getLanguageName($this->get('refiner__language')), 'section' => $this->get('refiner__section'));
		
		if (!checkPriv('_PRIV_SHUFFLE_MENU_ITEM') || $selectMode) {
			unset($panel['item']['tooltip']);
		}
		
		if ($this->get('refiner__children')) {
			$parentMenuItem = getMenuItemFromMenuID($this->get('refiner__children'));
			$mrg['parent'] = $parentMenuItem['name'];
			$mrg['n'] = getMenuItemLevel($this->get('refiner__children'), $ancestor, $ancestorButOne) + 1;
			
			$panel['title'] = getPhrase('Children of "[[parent]]" in "[[section]]" Section in [[lang]] Menu Items (Level [[n]])', $mrg);
			$panel['no_items_message'] = getPhrase('The "[[parent]]" Menu Item has no children.', $mrg);
			
			if (issetArrayKey($panel, 'item_buttons', 'change_parent')) {
				$panel['item_buttons']['change_parent']['combine_items']['path'] =
					getMenuItemStorekeeperDeepLink($this->get('refiner__children'));
			}
		
		} else {
			$panel['title'] = getPhrase('[[lang]] Menu Items in "[[section]]" Section (Level 1)', $mrg);
			$panel['no_items_message'] = getPhrase('There are no Menu Items in the "[[section]]" section.', $mrg);
			
			$panel['item_buttons']['edit']['priv'] = '_PRIV_EDIT_TOP_LEVEL_MENU_ITEM';
			$panel['item_buttons']['delete']['priv'] = '_PRIV_DELETE_TOP_LEVEL_MENU_ITEM';
			$panel['collection_buttons']['create']['priv'] = '_PRIV_ADD_TOP_LEVEL_MENU_ITEM';
			$panel['collection_buttons']['quick_create']['priv'] = '_PRIV_ADD_TOP_LEVEL_MENU_ITEM';
			
			if (issetArrayKey($panel, 'item_buttons', 'change_parent')) {
				$panel['item_buttons']['change_parent']['combine_items']['path'] =
					'tribiq__menu/item//'. $this->get('refiner__language'). '//item//'. $this->get('refiner__section');
				unset($panel['item_buttons']['move_to_top_level']);
			}
		}
		
		foreach ($panel['items'] as $id => &$item) {
			$item['css_class'] = 
				$item['internal_target']? (
					$item['parent_id']? (
						$item['children']?
							'linked_child_menuitem_with_children'
						:	'linked_child_menuitem_without_children'
					) : (
						$item['children']?
							'linked_toplevel_menuitem_with_children'
						:	'linked_toplevel_menuitem_without_children'
					)
				) : (
					$item['parent_id']? (
						$item['children']?
							'unlinked_child_menuitem_with_children'
						:	'unlinked_child_menuitem_without_children'
					) : (
						$item['children']?
							'unlinked_toplevel_menuitem_with_children'
						:	'unlinked_toplevel_menuitem_without_children'
					)
				);
			
			if ($item['children']) {
				$item['traits'] = array('has_children' => true);
			} else {
				$item['traits'] = array('childless' => true);
			}
			
			if ($this->get('_get_item_links')) {
				$item['deep_link'] = getMenuItemStorekeeperDeepLink($id);
			}
		}
		
		break;

	
	case 'tribiq__content':
		foreach ($panel['items'] as $id => &$item) {
			$item['css_class'] = 'content_type_'. $item['content_type_id'];
		}
		
		if (isset($this->getVariables['refiner__trash'])) {
			$panel['collection_buttons'] = array();
			$panel['item_buttons'] = array();
			$panel['title'] = getPhrase('Content Types (Trashed Content Items)');
			unset($panel['trash']);
		
		} elseif ($this->get('refiner__category')) {
			$panel['title'] = getPhrase('Content Types (Category "[[category]]")', array(
				'category' => getCategoryName($this->get('refiner__category'))));
			unset($panel['trash']);
			
		} elseif ($this->get('refiner__plugin')) {
			$panel['title'] = getPhrase('Content Types (Plugin "[[plugin]]")', array(
				'plugin' => getPluginDisplayName($this->get('refiner__plugin'))));
			unset($panel['trash']);
			
		} elseif ($this->get('refiner__plugin_instance')) {
			$panel['title'] = getPhrase('Content Types (Plugin Instance "[[plugin]]")', array(
				'plugin' => getPluginInstanceName($this->get('refiner__plugin_instance'))));
			unset($panel['trash']);
			
		} elseif ($this->get('refiner__template_instance')) {
		
			$templateDetails = getTemplateDetails($this->get('refiner__template_instance'));
			if (issetArrayKey($templateDetails,'name') && issetArrayKey($templateDetails,'filename')){
				$panel['title'] = getPhrase('Content Types for the Template [[name]] of the Template File "[[filename]]"', array(
					'name' => arrayKey($templateDetails,'name'),
					'filename' => arrayKey($templateDetails,'filename')));
			}
		} else {
			$panel['trash']['empty'] = true;
			foreach (getContentTypes() as $contentType) {
				$sql = "
					SELECT 1
					FROM ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($contentType['content_type_id']). " AS c
					INNER JOIN (
						SELECT id, MAX(version) as version 
						FROM ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($contentType['content_type_id']). "
						GROUP BY id
					) AS sub
					   ON c.id = sub.id
					  AND c.version = sub.version
					WHERE status = 'archived'
					LIMIT 1";
				
				$result = my_mysql_query($sql);
				if (mysql_fetch_row($result)) {
					$panel['trash']['empty'] = false;
					break;
				}
			}
		}
		
		break;

	
	case 'tribiq__content/languages':
		if (isset($this->getVariables['refiner__trash'])) {
			$panel['collection_buttons'] = array();
			$panel['item_buttons'] = array();
			$panel['title'] = getPhrase('Trashed Content of the type "[[ctype]]"', array(
				'ctype' => getContentTypeName($this->get('refiner__content_type'))));
			$panel['no_items_message'] = getPhrase('There are no Trashed Content of the type "[[ctype]]"', array(
				'ctype' => getContentTypeName($this->get('refiner__content_type'))));
		
		} elseif ($this->get('refiner__category')) {
			$panel['title'] = getPhrase('Content of the type "[[ctype]]" in the Category "[[category]]"', array(
				'category' => getCategoryName($this->get('refiner__category')),
				'ctype' => getContentTypeName($this->get('refiner__content_type'))));
			$panel['no_items_message'] = getPhrase('There is no Content of the type "[[ctype]]" in the Category "[[category]]"', array(
				'category' => getCategoryName($this->get('refiner__category')),
				'ctype' => getContentTypeName($this->get('refiner__content_type'))));
		
		} elseif ($this->get('refiner__plugin')) {
			$panel['title'] = getPhrase('Content of the type "[[ctype]]" containing the Plugin "[[plugin]]"', array(
				'plugin' => getPluginDisplayName($this->get('refiner__plugin')),
				'ctype' => getContentTypeName($this->get('refiner__content_type'))));
			$panel['no_items_message'] = getPhrase('There is no Content of the type "[[ctype]]" containing the Plugin "[[plugin]]"', array(
				'plugin' => getPluginDisplayName($this->get('refiner__plugin')),
				'ctype' => getContentTypeName($this->get('refiner__content_type'))));
		
		} elseif ($this->get('refiner__plugin_instance')) {
			$panel['title'] = getPhrase('Content of the type "[[ctype]]" containing the Plugin Instance "[[plugin]]"', array(
				'plugin' => getPluginInstanceName($this->get('refiner__plugin_instance')),
				'ctype' => getContentTypeName($this->get('refiner__content_type'))));
			$panel['no_items_message'] = getPhrase('There is no Content of the type "[[ctype]]" containing the Plugin Instance "[[plugin]]"', array(
				'plugin' => getPluginInstanceName($this->get('refiner__plugin_instance')),
				'ctype' => getContentTypeName($this->get('refiner__content_type'))));
		
		}  elseif ($this->get('refiner__template_instance')) {
			$templateDetails = getTemplateDetails($this->get('refiner__template_instance'));
			if (issetArrayKey($templateDetails,'name') && issetArrayKey($templateDetails,'filename')){
				$panel['title'] = getPhrase('Content of the type "[[ctype]]" for the Template "[[name]]" of the Template File "[[filename]]"', array(
					'name' => arrayKey($templateDetails,'name'),
					'filename' => arrayKey($templateDetails,'filename'),
					'ctype' => getContentTypeName($this->get('refiner__content_type'))));
				$panel['no_items_message'] = getPhrase('There is no Content of the type "[[ctype]]" for the Template "[[name]]" of the Template File "[[filename]]"', array(
					'name' => arrayKey($templateDetails,'name'),
					'filename' => arrayKey($templateDetails,'filename'),
					'ctype' => getContentTypeName($this->get('refiner__content_type'))));
			}
		} else {
			$panel['title'] = getPhrase('Content of the type "[[ctype]]"', array(
				'ctype' => getContentTypeName($this->get('refiner__content_type'))));
		}
		
		foreach ($panel['items'] as $id => &$item) {
			if (file_exists(CMS_ROOT. 'admin/images/store_keeper/main_icons/general_'. $id. '.gif')) {
				$item['image'] = 'admin/images/store_keeper/main_icons/general_'. $id. '.gif';
			}
		}
		
		if (!count($panel['items'])) {
			unset($panel['collection_buttons']['create']);
		}
		
		break;

	
	case 'tribiq__content/content':
		
		$cTypeName = getContentTypeName($this->get('refiner__content_type'));
		$langName = $this->get('refiner__language')? getLanguageName($this->get('refiner__language')) : '';
		
		$panel['item_buttons']['add_to_menu']['combine_items']['path'] .= '/item//'. $this->get('refiner__language'). '//';
		
		if (isset($this->getVariables['refiner__trash'])) {
			$panel['collection_buttons'] = array();
			$panel['item_buttons'] = array('settings' => $panel['item_buttons']['settings'], 'view' => $panel['item_buttons']['view'], 'duplicate' => $panel['item_buttons']['duplicate']);
			$panel['title'] = getPhrase('Trashed Content of the type "[[ctype]]" in the Language "[[lang]]"', array(
				'ctype' => $cTypeName,
				'lang' => $langName));
		
		} elseif ($this->get('refiner__category')) {
			$panel['title'] = getPhrase('"[[ctype]]" / "[[lang]]" Content in the Category "[[category]]"', array(
				'category' => getCategoryName($this->get('refiner__category')),
				'ctype' => $cTypeName,
				'lang' => $langName));
		
		} elseif ($this->get('refiner__plugin')) {
			$panel['title'] = getPhrase('"[[ctype]]" / "[[lang]]" Content containing the Plugin "[[plugin]]"', array(
				'plugin' => getPluginDisplayName($this->get('refiner__plugin')),
				'ctype' => $cTypeName,
				'lang' => $langName));
			$panel['no_items_message'] = getPhrase('There are no "[[ctype]]" / "[[lang]]" Content Items containing the Plugin "[[plugin]]".', array(
				'plugin' => getPluginDisplayName($this->get('refiner__plugin')),
				'ctype' => $cTypeName,
				'lang' => $langName));
		
		} elseif ($this->get('refiner__plugin_instance')) {
			$panel['title'] = getPhrase('"[[ctype]]" / "[[lang]]" Content containing the Plugin Instance "[[plugin]]"', array(
				'plugin' => getPluginInstanceName($this->get('refiner__plugin_instance')),
				'ctype' => $cTypeName,
				'lang' => $langName));
			$panel['no_items_message'] = getPhrase('There are no "[[ctype]]" / "[[lang]]" Content Items containing the Plugin Instance "[[plugin]]".', array(
				'plugin' => getPluginInstanceName($this->get('refiner__plugin_instance')),
				'ctype' => $cTypeName,
				'lang' => $langName));
		
		} elseif ($this->get('refiner__template_instance')) {
			$templateDetails = getTemplateDetails($this->get('refiner__template_instance'));
			if (issetArrayKey($templateDetails,'name') && issetArrayKey($templateDetails,'filename')){
				$panel['title'] = getPhrase('Content of the type "[[ctype]]" / "[[lang]]" for the Template "[[name]]" of the Template File "[[filename]]"', array(
					'name' => arrayKey($templateDetails,'name'),
					'filename' => arrayKey($templateDetails,'filename'),
					'ctype' => $cTypeName,
					'lang' => $langName));
				$panel['no_items_message'] = getPhrase('There is no Content of the type "[[ctype]]" / "[[lang]]" for the Template "[[name]]" of the Template File "[[filename]]"', array(
					'name' => arrayKey($templateDetails,'name'),
					'filename' => arrayKey($templateDetails,'filename'),
					'ctype' => $cTypeName,
					'lang' => $langName));
			}
		} elseif ($this->get('refiner__language')) {
			$panel['title'] = getPhrase('Content of the type "[[ctype]]" in the Language "[[lang]]"', array(
				'ctype' => $cTypeName,
				'lang' => $langName));
		}
		
		$panel['collection_buttons']['create_multiple']['tooltip'] =
			getPhrase('Create multiple Content Items of type "[[ctype]]"', array(
				'ctype' => $cTypeName));
		
		if ($this->get('refiner__content_type') != 'picture') {
			unset($panel['item_buttons']['view_image']);
			
			if ($this->get('refiner__content_type') != 'document') {
				unset($panel['item_buttons']['download']);
				
				if ($this->get('refiner__content_type') != 'audio'
				 && $this->get('refiner__content_type') != 'video') {
					unset($panel['collection_buttons']['create_multiple']);
				}
			}
		}
		
		$content_tag_zerofill = getSiteConfig('content_tag_zerofill');
		
		foreach ($panel['items'] as $id => &$item) {
			$item['description'] = formatNicely($item['description'], 20);
			$item['keywords'] = formatNicely($item['keywords'], 20);
			
			if ($this->get('refiner__content_type') == 'html' && $item['alias']) {
				$item['tag'] = formatTag($item['tag'], $this->get('refiner__content_type'), $item['alias'], false, $content_tag_zerofill);
			} else {
				$item['tag'] = formatTag($item['tag'], $this->get('refiner__content_type'), $item['title'], false, $content_tag_zerofill);
			}
			
			$item['css_class'] = getItemIconClass($id, $this->get('refiner__content_type'), $item['version'], $item['status']);
			
			$item['traits'] = array();
			if ($item['status'] == 'private_draft') {
				$item['traits']['draft'] = true;
				if ($item['version'] > 1 || !checkIfAliasIsSystemAlias($id, $this->get('refiner__content_type'))) {
					$item['traits']['deletable'] = true;
				}
			}
			if ($item['status'] == 'published') {
				$item['traits']['published'] = true;
			}
			if ($item['status'] == 'hidden') {
				$item['traits']['hidden'] = true;
			}
			if ($item['status'] == 'published' || $item['status'] == 'hidden') {
				if (!checkIfAliasIsSystemAlias($id, $this->get('refiner__content_type'))) {
					$item['traits']['trashable'] = true;
				}
			}
			
			if ($item['menu']) {
				$item['traits']['linked'] = true;
			} else {
				$item['traits']['unlinked'] = true;
			}
			
			$item['frontend_link'] = indexDotPHP(). '?cID='. $id. '&cType='. $this->get('refiner__content_type');
			if ($this->get('_get_item_links')) {
				$item['name'] = $item['tag'];
				$item['deep_link'] = 'tribiq__content/item//'. $this->get('refiner__content_type'). '//item//'. $item['language_id']. '//'. $id;
			}
		}
		
		break;
	
	
	case 'tribiq__content/categories':
		$langs = getLanguages();
		foreach($langs as $lang) {
			if ($lang['id'] != $langId) {
				$panel['columns']['lang_'. $lang['id']] = array('title' => $lang['id']);
			}
		}
		
		$categoryItemCount = array();
		foreach (getContentTypes() as $contentType) {
			$sql = "
				SELECT cil.category_id, COUNT(DISTINCT c.id) AS c
				FROM ". DB_NAME_PREFIX. "category_item_link AS cil
				INNER JOIN ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($contentType['content_type_id']). " AS c
				   ON c.id = cil.item_id
				  AND c.version = cil.version
				  AND c.status IN ('published', 'private_draft')
				INNER JOIN (
					SELECT id, MAX(version) as version
					FROM ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($contentType['content_type_id']). " AS c
					GROUP BY id
				) AS sub
				   ON c.id = sub.id
				  AND c.version = sub.version
				WHERE cil.content_type = '". mysql_real_escape_string($contentType['content_type_id']). "'
				GROUP BY cil.category_id";
			
			$result = my_mysql_query($sql);
			while ($row = mysql_fetch_assoc($result)) {
				$categoryItemCount[$row['category_id']] = $row['c'] + (int) arrayKey($categoryItemCount, $row['category_id']);
			}
		}
		
		
		foreach ($panel['items'] as $id => &$item) {
			$item['traits'] = array();
			
			if (issetArrayKey($categoryItemCount, $id)) {
				$item['number_of_content_items'] = $categoryItemCount[$id];
			} else {
				$item['number_of_content_items'] = 0;
			}
			
			if ($item['public']) {
				$item['traits']['public'] = true;
				
				foreach($langs as $lang) {
						$item['lang_'. $lang['id']] =
							getRow('visitor_phrases', 'local_text',
										array('language_id' => $lang['id'], 'code' => '_CATEGORY_'. (int) $id, 'plugin_class' => ''));
				}
				
				if ($item['landing_page_content_id'] && $item['landing_page_content_type']) {
					$item['landing_page'] = $item['landing_page_content_type']. '_'. $item['landing_page_content_id'];
				}
			}
		}
		
		break;
	
	
	case 'tribiq__content/media/images':
		if ($this->get('refiner__content_id') && !isset($this->getVariables['refiner__all_items_images'])) {
			$panel['collection_buttons']['upload']['priv'] = '_PRIV_ADD_IMAGE_TO_ITEM';
			$panel['title'] = getPhrase('Images for the Content Item "[[tag]]"', array('tag' => getTag($this->get('refiner__content_id'), $this->get('refiner__content_type'))));
			$panel['no_items_message'] = getPhrase('This Content Item has no Inline Images.');
		} else {
			$panel['item_buttons']['make_sticky'] = false;
			$panel['item_buttons']['delete']['ajax']['confirm']['message'] = $panel['item_buttons']['delete']['ajax']['confirm']['message_all_images'];
		}
		
		if (!$this->get('refiner__content_id') || isset($this->getVariables['refiner__all_items_images'])) {
			$panel['collection_buttons']['add'] = false;
		}
		
		if (isset($this->getVariables['refiner__all_items_images'])) {
			$panel['collection_buttons']['upload'] = false;
		}
		
		foreach ($panel['items'] as $id => &$item) {
			$img = '?id='. $item['id'];
			$item['image'] = 'cmsincludes/storekeeper_image.php'. $img;
			$item['images'] = array('cmsincludes/storekeeper_closeup_image.php'. $img);
			
			if ($item['usage'] && !$item['content_item_id']) {
				$item['usage'] = 0;
			}
			
			if ($this->get('refiner__content_id') && !isset($this->getVariables['refiner__all_items_images'])) {
				if (!$item['sticky_flag']) {
					$item['traits'] = array('unsticky' => true);
				}
			}
		}
		
		break;
	
	
	case 'tribiq__content/media/movies':
		if ($this->get('refiner__content_id') && !isset($this->getVariables['refiner__all_items_movies'])) {
			$panel['collection_buttons']['upload']['priv'] = '_PRIV_ADD_MOVIE_TO_ITEM';
			$panel['title'] = getPhrase('Animations for the Content Item "[[tag]]"', array('tag' => getTag($this->get('refiner__content_id'), $this->get('refiner__content_type'))));
		} else {
			$panel['item_buttons']['delete']['ajax']['confirm']['message'] = $panel['item_buttons']['delete']['ajax']['confirm']['message_all_images'];
		}
		
		if (!$this->get('refiner__content_id') || isset($this->getVariables['refiner__all_items_movies'])) {
			$panel['collection_buttons']['add'] = false;
		}
		
		if (isset($this->getVariables['refiner__all_items_movies'])) {
			$panel['collection_buttons']['upload'] = false;
		}
		
		foreach ($panel['items'] as $id => &$item) {
			if ($item['usage'] && !$item['content_item_id']) {
				$item['usage'] = 0;
			}
			
			if ($item['mime_type'] == 'application/x-shockwave-flash') {
				$item['traits'] = array('flash' => true);
			} elseif ($item['mime_type'] == 'application/x-shockwave-flash') {
				$item['traits'] = array('quicktime' => true);
			}
		}
		
		break;
	case 'tribiq__templates_and_skins':
	case 'tribiq__templates_and_skins/template_families':
		$dir = CMS_ROOT . "templates/" . SITENAME . "/";
		$dh  = opendir($dir);
	
		while ($file = readdir($dh)) {
			clearstatcache;
			if (filetype($dir . $file)=="dir" && $file!="." && $file!=".."
				&& substr ($file, 0, 1)<>".") {
				$templateFamilies[] = $file;
			}
		}
		
		$templateFamiliesInDB = getTemplateFamilies();
		
		if (is_array($templateFamiliesInDB)) {
			foreach ($templateFamiliesInDB as $templateFamilyInDB) {
				if (is_array($templateFamilies)) {
					if (!in_array($templateFamilyInDB,$templateFamilies)) {
						$templateFamilies[] = $templateFamilyInDB;
					}
				} else {
					$templateFamilies[] = $templateFamilyInDB;
				}
			}
	
			asort($templateFamilies);
		}

		if (is_array($templateFamilies)) {
			foreach ($templateFamilies as $key => $value) {
				$showEditButton = false;
				unset($templateFamily);
				$templateFamily = array();
			
			
				if (!file_exists(CMS_ROOT . "templates/" . SITENAME . "/" . $value)) {
					$folderMissingMsg = " (Folder missing)";
				} elseif ($path=="tribiq__templates_and_skins/template_families") {
					$showEditButton = true;
					$templateFamily['link'] = array();
					$templateFamily['link']['path'] = "tribiq__templates_and_skins/templates";
					$templateFamily['link']['branch'] = "Yes";
					$templateFamily['link']['refiner'] = "template_family";
					$folderMissingMsg = false;
				} else {
					$templateFamily['link'] = array();
					$templateFamily['link']['path'] = "tribiq__templates_and_skins/templates/template_files/templates";
					$templateFamily['link']['branch'] = "Yes";
					$templateFamily['link']['refiner'] = "template_family";
					$folderMissingMsg = false;
				}
	
				if (!checkTemplateFamilyInDB($value)) {
					$notInDBMsg = " (Not registered)";
				} else {
					if (!$folderMissingMsg) {
						$showEditButton = true;
					}
					
					$notInDBMsg = false;
				}				

				if ($showEditButton) {
					$templateFamily['traits'] = array();
					$templateFamily['traits']['can_edit'] = "Yes";
				}
				$templateFamily['name'] = $value . $notInDBMsg . $folderMissingMsg;
				$templateFamiliesForPanel[encodeItemIdForStorekeeper($value)] = $templateFamily;
			}
		}
		
		$panel['items'] = $templateFamiliesForPanel;
		
		break;
	case 'tribiq__templates_and_skins/templates':
		$refinerId = decodeItemIdForStorekeeper($refinerId);
	
		$panel['title'] = "Template Files and Skins in the Template Family \"" . $refinerId . "\"";

		if ($missingTemplates = getAllMissingTemplates(-1,0,$refinerId)) {
			$templatesCount += sizeof($missingTemplates);
		}
		
		if ($existingTemplates = getAllExistingTemplates(0,0,-1,0,true,$refinerId)) {
			$templatesCount += sizeof($existingTemplates);
		}
		
		if ($unregisteredTemplates = getAllNewTemplates($refinerId)) {
			$templatesCount += sizeof($unregisteredTemplates[$refinerId]);
		}
	
		if (!$templatesCount) {
			$templatesCount = 0;
		}
	
		if ($skins = getAllSkins($refinerId)) {
			$skinsCount = sizeof($skins);
		} else {
			$skinsCount = 0;
		}

		foreach ($panel['items'] as $id => &$item) {
			if ($item['name']=="Template Files") {
				$item['name'] .= " (" . $templatesCount . ")";
			} elseif ($item['name']=="Skins") {
				$item['name'] .= " (" . $skinsCount . ")";
			}
		}

		break;
		
	case 'tribiq__templates_and_skins/instances':
		$panel['title'] = getPhrase('Plugin Instances for the "[[template_family]]" Template Family', array('template_family' => decodeItemIdForStorekeeper($refinerId)));
		break;	
		
	case 'tribiq__templates_and_skins/template_families/instances':
		$panel['title'] = getPhrase('Plugin Instances for the "[[template_family]]" Template Family', array('template_family' => decodeItemIdForStorekeeper($refinerId)));
		break;	
		
	case 'tribiq__templates_and_skins/templates/template_files':
		$panel['title'] = "Template Files in the Template Family \"" . decodeItemIdForStorekeeper($this->get("refiner__template_family")) . "\"";

		$sql = "SELECT template_id,
					filename,
					name
				FROM " . DB_NAME_PREFIX . "templates
				WHERE family_name = '" . mysql_real_escape_string(decodeItemIdForStorekeeper($this->get("refiner__template_family"))) . "'";
	
		$result = my_mysql_query($sql);
		
		if (mysql_num_rows($result)>0) {
			while ($row = mysql_fetch_array($result)) {
				$templates[] = $row;
			}
		} else {
			$templates = false;
		}
		
		$sql = "SELECT 
					filename,
					count(*) AS instances
				FROM " . DB_NAME_PREFIX . "templates
				WHERE family_name = '" . mysql_real_escape_string(decodeItemIdForStorekeeper($this->get("refiner__template_family"))) . "'
				GROUP BY family_name,filename";
		
		if (mysql_num_rows($result = my_mysql_query($sql))>0) {
			while ($row = mysql_fetch_array($result)) {
				$templateFileInstances[$row['filename']] = $row['instances'];
			}
		} else {
			$templateFileInstances = array();
		}
		
		if ($newTemplates = getAllNewTemplates(decodeItemIdForStorekeeper($this->get("refiner__template_family")))) {
			foreach ($newTemplates as $newTemplate) {
				foreach ($newTemplate as $newTemplateFilename) {
					$templates[] = array("template_id" => 0,"filename" => $newTemplateFilename);
				}
			}
		}
		
		if ($missingTemplates = getAllMissingTemplates(-1,0,decodeItemIdForStorekeeper($this->get("refiner__template_family")))) {
			foreach ($missingTemplates as $missingTemplate) {
				$templates[] = array("template_id" => -1, "filename" => $missingTemplate['filename']);
			}
		}
	
		if ($templates) {
			foreach ($templates as $key => $row) {
				$template_id[$key]  = $row['template_id'];
				$filename[$key] = $row['filename'];
			}
			
			array_multisort($filename, SORT_ASC, $template_id, SORT_ASC, $templates);
			
			foreach ($templates as $template) {
				$templateForPanel['filename'] = $template['filename'];
				
				if ($template['template_id']==0) {
					$templateForPanel['name'] = $template['filename'] . " (not registered)";
				} elseif ($template['template_id']==-1) {
					$templateForPanel['name'] = $template['filename'] . " (missing)";
				} else {	
					if (issetArrayKey($templateFileInstances,$template['filename'])){
						$templateForPanel['name'] = $template['filename'] . " (" . arrayKey($templateFileInstances,$template['filename']) . ")";
					} else {
						$templateForPanel['name'] = $template['filename'] . " (0)";
					}
				}
			
				$templateForPanel['template_id'] = $template['template_id'];
			
				$templatesForPanel[$templateForPanel['filename']] = $templateForPanel;
			}
			
			$panel['items'] = $templatesForPanel;
		}
		
		break;
		
		
	case 'tribiq__templates_and_skins/templates/template_files/templates':
		if ($refinerName=="filename"){
			$panel['title'] = getPhrase('Templates based on the "[[template]]" Template File', array('template' => decodeItemIdForStorekeeper($refinerId)));
		} else {
			$panel['title'] = getPhrase('Templates based on the "[[template]]" Template Family', array('template' => decodeItemIdForStorekeeper($refinerId)));
		}
		$panel['items'] = array();

		$sql = "SELECT template_id,
					family_name,
					filename,
					image_filename,
					name,
					content_type,
					checksum_inc_name
				FROM " . DB_NAME_PREFIX . "templates 
				WHERE true ";
		if ($refinerName=="filename"){
					$sql .= " AND filename = '" . mysql_real_escape_string($refinerId) . "'";
		}
					$sql .= " AND family_name = '" . mysql_real_escape_string(decodeItemIdForStorekeeper($this->get("refiner__template_family"))) . "'";
	
		$result = my_mysql_query($sql);
		
		if (mysql_num_rows($result)>0) {
			while ($row = mysql_fetch_array($result)) {
				$templates[] = $row;
			}
		} else {
			$templates = false;
		}
		
		if ($templates) {
			foreach ($templates as $key => $row) {
				$template_id[$key]  = $row['template_id'];
				$filename[$key] = $row['filename'];
			}
			
			array_multisort($filename, SORT_ASC, $template_id, SORT_ASC, $templates);

			$templateForPanel['traits'] = array();
			
			foreach ($templates as $template) {
				$templateForPanel['filename'] = $template['image_filename'];
				$templateForPanel['template_filename'] = $template['filename'];
				$templateForPanel['family_name'] = $template['family_name'];
				$templateForPanel['content_type'] = $template['content_type'];
				
				if ($template['template_id']==0) {
					$templateForPanel['name'] = $template['name'] . " (not registered)";
				} elseif ($template['template_id']==-1) {
					$templateForPanel['name'] = $template['name'] . " (missing)";
				} else {	
					$templateForPanel['name'] = $template['name'];
					
					if (checkTemplateUsed($template['template_id'])) {
						$templateForPanel['traits']['live_content'] = true;
					}
					
					if(!checkTemplateLive($template['template_id'])) {
						$templateForPanel['traits']['no_live_content'] = true;
					}
				}
				if (issetArrayKey($template,'checksum_inc_name')){
					$templateForPanel['image'] = 'cmsincludes/show_template_image.php?storekeeper=1&c=' . arrayKey($template,'checksum_inc_name');
					$templateForPanel['traits']['show_image'] = true;
				} else {
					$templateForPanel['filename'] = '-- Not set --';
					if (issetArrayKey($templateForPanel,'image')){
						unset($templateForPanel['image']);
					}
					if (issetArrayKey($templateForPanel,'traits','show_image')){
						unset($templateForPanel['traits']['show_image']);
					}
				}
				$panel['items'][$template['template_id']] = $templateForPanel;
			}
		}

		break;

	case 'tribiq__templates_and_skins/templates/template_files/templates/instances':
		$templateDetails = getTemplateDetails($refinerId);
	
		$panel['title'] = getPhrase('Plugin Instances for the "[[template]]" Template', array('template' => $templateDetails['name']));
		break;		
		
	case 'tribiq__templates_and_skins/templates/skin_files':
		$panel['title'] = "Skins in the Template Family \"" . decodeItemIdForStorekeeper($this->get("refiner__template_family")) . "\"";
		
		$skinDependencies = array();
		if ($registeredSkins = getSkins(decodeItemIdForStorekeeper($this->get("refiner__template_family")))){
			foreach($registeredSkins as $registeredSkin){
				if (validateSkinFromXMLDescriptionByName(decodeItemIdForStorekeeper($registeredSkin['family_name']),$registeredSkin['name'],$desc)){
					if ($desc->extension_of_skin!=''){
						$skinDependencies[(string)$desc->extension_of_skin] = true;
					}
				}
			}
		}
		$skins = getAllSkins(decodeItemIdForStorekeeper($this->get("refiner__template_family")));
		
		if (is_array($skins)) {
			foreach ($skins as $skin) {
				if (issetArrayKey($skin,'id') &&  (!issetArrayKey($skinDependencies,$skin['name'])) ){
					$skinsForPanel['traits']['registered_not_extended'] = true;
				} else {
					unset($skinsForPanel['traits']['registered_not_extended']);
				}
				if (!$skin['id']) {
					$skinDisplayName = $skin['name'] . " (not yet registered)";
					$skinsForPanel['traits']['not_registered'] = true;
				} else {
					if (!checkSkinInFS(decodeItemIdForStorekeeper($this->get("refiner__template_family")),$skin['name'])) {
						$skinNameSuffix = " (not in filesystem)";
					} else {
						$skinNameSuffix = "";
					}
				
					$skinDisplayName = $skin['name'] . $skinNameSuffix;
				}

				$skinsForPanel['name'] = $skinDisplayName;
				$panel['items'][encodeItemIdForStorekeeper($skin['name'])] = $skinsForPanel;

				if (validateSkinFromXMLDescriptionByName(decodeItemIdForStorekeeper($skin['family_name']),$skin['name'],$desc)){
					if (((string)$desc->extension_of_skin)!=''){
						$panel['items'][encodeItemIdForStorekeeper($skin['name'])]['dependencies'] = (string)$desc->extension_of_skin;
					} else  {
						$panel['items'][encodeItemIdForStorekeeper($skin['name'])]['dependencies'] = "None";
					}
					$themes = array();
					if (isset($desc->related_plugin_themes->name)){
						foreach ($desc->related_plugin_themes->name as $theme){
							$themes[] = $theme;
						}
					}
					if (count($themes)){
						$panel['items'][encodeItemIdForStorekeeper($skin['name'])]['related_themes'] = implode(', ',$themes);
					} else {
						$panel['items'][encodeItemIdForStorekeeper($skin['name'])]['related_themes'] = "None";
					}
				} else {
					$panel['items'][encodeItemIdForStorekeeper($skin['name'])]['dependencies'] = "None";
					$panel['items'][encodeItemIdForStorekeeper($skin['name'])]['related_themes'] = "None";
				}
			}
		}
		
		break;

	
	case 'tribiq__plugins':
		addNewPlugins();
		
		//Remove close-up view form select mode, and make it so that double-clicking goes straight into Plugin Instances
		if ($selectMode && $panel['item_buttons']['view_instances']['link']) {
			$panel['item']['link'] = $panel['item_buttons']['view_instances']['link'];
		}
		
		//Don't show the selectmode tooltip in normal mode
		if (!$selectMode) {
			unset($panel['item']['tooltip']);
		}
		
		//Don't show the "all_instances" options for Plugin Nests
		if ($refinerName == 'nestable_only') {
			$panel['collection_buttons']['all_instances'] = false;
			$panel['title'] = getPhrase('Nestable Plugins in the Plugin Library');
		}
		
		//Check which Plugins can upgrade others
		$sql = "
			SELECT d.plugin_class_name,  d.dependency_plugin_class_name
			FROM " . DB_NAME_PREFIX . "plugins AS p
			INNER JOIN " . DB_NAME_PREFIX . "plugin_dependencies AS d
			   ON d.dependency_plugin_class_name = p.class_name
			  AND d.`type` = 'compatibility'";
		
		$upgrades = array();
		$result = my_mysql_query($sql);
		while ($row = mysql_fetch_assoc($result)) {
			$upgrades[$row['plugin_class_name']] = true;
			$upgrades[$row['dependency_plugin_class_name']] = true;
		}
		
		$languagesExist = false;
		$emptyListView = array();
		$inheritedListView = array();
		foreach (getLanguages() as $lang) {
			$panel['columns'][$lang['id']] = array('title' => $lang['id']);
			$emptyListView[$lang['id']] = '-';
			$inheritedListView[$lang['id']] = '*';
			$languagesExist = true;
		}
		
		
		//Look for (installed) Plugin dependencies
		if (!$selectMode) {
			$pluginDependencies = array();
			$result = getRows('plugin_dependencies', array('plugin_class_name', 'dependency_plugin_class_name'), array('type' => 'dependency'), 'dependency_plugin_class_name');
			while($row = mysql_fetch_assoc($result)) {
				if (!isset($pluginDependencies[$row['dependency_plugin_class_name']])) {
					$pluginDependencies[$row['dependency_plugin_class_name']] = array();
				}
				
				$pluginDependencies[$row['dependency_plugin_class_name']][$row['plugin_class_name']] = true;
			}
		}
		
	
		$sql = "
			SELECT
				id,
				display_name,
				name,
				class_name,
				vlp_class,
				uses_instances,
				feature_plugin,
				nestable,
				status
			FROM " . DB_NAME_PREFIX . "plugins";
		$result = my_mysql_query($sql);
		
		$panel['items'] = array();
		while ($plugin = mysql_fetch_assoc($result)) {
			
			if ($refinerName == 'slotable_only' && !($plugin['uses_instances'] && $plugin['status'] == '_ENUM_RUNNING')) {
				continue;
			}
			
			if ($refinerName == 'feature_plugins_only' && !($plugin['uses_instances'] && $plugin['feature_plugin'] && $plugin['status'] == '_ENUM_RUNNING')) {
				continue;
			}
			
			if ($refinerName == 'nestable_only' && !($plugin['uses_instances'] && $plugin['nestable'] && $plugin['status'] == '_ENUM_RUNNING')) {
				continue;
			}
			
			if (file_exists(CMS_ROOT . 'plugins/'. $plugin['name']. '/plugin_code.php')) {
				if ($plugin['status'] == '_ENUM_INSTALLED') {
					$plugin['comment'] = getPhrase('(uninitialized)');
				} elseif ($plugin['status'] == '_ENUM_INITIALISED') {
					$plugin['comment'] = getPhrase('(initialized, not running)');
				} elseif ($plugin['status'] == '_ENUM_SUSPENDED') {
					$plugin['comment'] = getPhrase('(suspended)');
				} else {
					$plugin['comment'] = '';
				}
				
				if (!$selectMode) {
					if (!$plugin['vlp_class']) {
						$plugin = array_merge($plugin, $emptyListView);
					} elseif ($plugin['vlp_class'] != $plugin['class_name']) {
						$plugin = array_merge($plugin, $inheritedListView);
						$lv = $inheritedListView;
					} else {
						$plugin = array_merge($plugin, $emptyListView);
						
						$sql2 = "
							SELECT language_id, COUNT(*) AS c
							FROM ". DB_NAME_PREFIX. "visitor_phrases
							WHERE plugin_class = '". mysql_real_escape_string($plugin['vlp_class']). "'
							GROUP BY language_id";
						
						$result2 = my_mysql_query($sql2);
						while($row2 = mysql_fetch_assoc($result2)) {
							if (isset($plugin[$row2['language_id']])) {
								$plugin[$row2['language_id']] = $row2['c'];
							}
						}
					}
				}
				
				$plugin['traits'] = array();
				if ($plugin['status'] == '_ENUM_INSTALLED') {
					$plugin['traits']['not_initialized'] = true;
				
				} else {
					$plugin['traits']['in_db'] = true;
					
					if ($plugin['uses_instances']) {
						$plugin['traits']['uses_instances'] = true;
					}
					
					if ($plugin['vlp_class'] && $plugin['vlp_class'] == $plugin['class_name']) {
						$plugin['traits']['uses_vlps'] = true;
						
						$phrasePacks = scanPluginPhraseDir($plugin['name']);
						if (!empty($phrasePacks) && $languagesExist) {
							$plugin['traits']['has_phrase_packs'] = true;
						}
					}
					
					if ($plugin['status'] == '_ENUM_RUNNING') {
						$plugin['traits']['running'] = true;
						$plugin['traits']['can_upgrade'] = (bool) $upgrades[$plugin['class_name']];
					} else {
						$plugin['traits']['not_running'] = true;
						
						if ($plugin['status'] == '_ENUM_INITIALISED') {
							$plugin['traits']['initialised'] = true;
						
						} elseif ($plugin['status'] == '_ENUM_SUSPENDED') {
							$plugin['traits']['suspended'] = true;
						}
					}
				}
				
				
				//Load information from the Plugin's description.xml
				if (validatePluginFromXMLDescription('plugins/' . $plugin['name'] . '/db_updates', 'description.xml', $pluginName, $pluginId, $desc)) {
					
					//Read the Plugin's minor revision number from the latest_revision_no.inc.php file
					$minor = 0;
					global $configSettings;
					cms_core::$configSettings = array();
					if (($config = file_get_contents(CMS_ROOT. 'plugins/'. $plugin['name']. '/db_updates/latest_revision_no.inc.php')) !== false) {
						
						foreach(preg_split('/define\s*(\(.*?\)\s*\;)/is', $config, -1, PREG_SPLIT_DELIM_CAPTURE) as $i => $code) {
							if ($i % 2) {
								eval('cms_core::configSetting'. $code);
							}
						}
						
						foreach(cms_core::$configSettings as $name => $value) {
							$minor = $value;
							break;
						}
					}
					
					$plugin['author_name'] = ifNull((string) $desc->author_name, (string) $desc->company_name);
					$plugin['copyright_info'] = (string) $desc->copyright_info;
					$plugin['license_info'] = (string) $desc->license_info;
					$plugin['version'] = (string) $desc->version . "." . $minor;

					getPluginSignalHandlersFromXMLDescription('plugins/' . $plugin['name'] . '/db_updates', 'description.xml', $signals);
					if (count($signals)){
						$plugin['listens_for'] = implode(', ', $signals);
					} else {
						$plugin['listens_for'] = 'n/a';
					}
					
					
					
					
					if ((string) $desc->summary_desc) {
						$plugin['summary'] = (string) $desc->summary_desc;
						$plugin['close_up_view'] = (string) $desc->description;
					} else {
						$plugin['summary'] = (string) $desc->description;
					}
					
					if ($plugin['frontend_link'] = (string) $desc->webpage) {
						$plugin['traits']['has_webpage'] = true;
					}
					
					if (!$selectMode) {
						getPluginDependenciesFromXMLDescription('plugins/' . $plugin['name'] . '/db_updates', 'description.xml', $dependencies, $compatibilities);
						
						
						foreach ($dependencies as $dependency) {
							$dependencyContent .= $dependency . '<br/>';
						}
						
						if (count($compatibilities) || count($dependencies) || !empty($pluginDependencies[$plugin['class_name']])) {
							
							$plugin['close_up_view'] .= '<table>';
							if (count($compatibilities)) {
								$plugin['close_up_view'] .= '<tr><td class="col_label">'. getPhrase('Compatibilities:'). '</td><td width="95%">';
								
								$i = 0;
								foreach ($compatibilities as $compatibility) {
									if ($i++) {
										$plugin['close_up_view'] .= '<br/>';
									}
									$plugin['close_up_view'] .= htmlspecialchars(getPluginDisplayNameByClassName($compatibility));
								}
								$plugin['close_up_view'] .= '</td></tr>';
							}
							
							if (count($dependencies)) {
								$plugin['close_up_view'] .= '<tr><td class="col_label">'. getPhrase('Dependencies:'). '</td><td width="95%">';
								
								$i = 0;
								foreach ($dependencies as $dependency) {
									if ($i++) {
										$plugin['close_up_view'] .= '<br/>';
									}
									$plugin['close_up_view'] .= htmlspecialchars(getPluginDisplayNameByClassName($dependency));
								}
								$plugin['close_up_view'] .= '</td></tr>';
							}
							
							if (!empty($pluginDependencies[$plugin['class_name']])) {
								$plugin['close_up_view'] .= '<tr><td class="col_label">'. getPhrase('Dependents:'). '</td><td width="95%">';
								
								$i = 0;
								foreach ($pluginDependencies[$plugin['class_name']] as $dependent => $dummy) {
									if ($i++) {
										$plugin['close_up_view'] .= '<br/>';
									}
									$plugin['close_up_view'] .= htmlspecialchars(getPluginDisplayNameByClassName($dependent));
								}
								$plugin['close_up_view'] .= '</td></tr>';
							}
							$plugin['close_up_view'] .= '</table>';
						}
						
						
						
			
						if ($desc->preview_images) {
							$i = 0;
							$plugin['images'] = array();
							foreach ($desc->preview_images->preview_image as $previewImage) {
								$plugin['images'][++$i] = 'plugins/'. $plugin['name']. '/'. (string) $previewImage->url;
							}
						}
					}
				}
				
				$plugin['image'] = getPluginIconURL($plugin['name']);
				$plugin['status'] = getPhrase($plugin['status']);
				
				$panel['items'][$plugin['id']] = $plugin;
			}
		}
		
		break;

	
	case 'tribiq__plugins/instances':
		
		if ($this->get('refiner__plugin') && !isset($this->getVariables['refiner__all_instances'])) {
			$panel['title'] =
			$panel['select_mode_title'] =
				getPhrase('Instances of the Plugin "[[name]]"', array('name' => getPluginDisplayName($this->get('refiner__plugin'))));
			$panel['no_items_message'] = getPhrase('No Instances of this Plugin have been created.');
		
		} elseif ($refinerName == 'album') {
			$panel['title'] =
			$panel['select_mode_title'] =
				getPhrase('Plugin Album');
			$panel['no_items_message'] = getPhrase('There are no Plugin Instances in the Album.');
			$panel['item']['css_class'] = 'plugin_album_instance';
		}
		
		foreach ($panel['items'] as $id => &$item) {
			$item['traits'] = array();
			
			if ($item['settings_media'] && substr($item['settings_media'], 0, 6) == 'image_') {
				$item['traits']['has_image'] = true;
				$item['checksum'] = substr($item['settings_media'], 6);
				
				$item['filename'] = 'dummy.gif';
				$item['image'] = 'cmsincludes/storekeeper_image.php?c='. $item['checksum'];
				$item['images'] = array('cmsincludes/storekeeper_closeup_image.php?c='. $item['checksum']);
			} elseif ($item['settings_media'] && substr($item['settings_media'], 0, 6) == 'movie_') {
				$item['traits']['has_movie'] = true;
				$item['checksum'] = substr($item['settings_media'], 6);
				
				$item['filename'] = 'dummy.swf';
				$item['image'] = getPluginIconURL($item['plugin_filename']);
			} else {
				$item['image'] = getPluginIconURL($item['plugin_filename']);
			}
			
			if ($item['use_custom_framework']) {
				$item['framework'] .= ' '. getPhrase('(Customised)');
			}
			
			
			//Get a count of where this instance is used at an item-level
			$item['usage_item'] = 0;
			foreach (getContentTypes() as $contentType) {
				$sql = "
					SELECT COUNT(DISTINCT c.id)
					FROM ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($contentType['content_type_id']). " AS c
					INNER JOIN ". DB_NAME_PREFIX. "plugin_inst_item_link AS piil
					   ON piil.instance_id = ". (int) $id. "
					  AND piil.content_id = c.id
					  AND piil.content_type = '". mysql_real_escape_string($contentType['content_type_id']). "'
					  AND piil.content_version = c.version
					WHERE c.status IN ('published', 'private_draft')
					  AND (c.status = 'private_draft' OR c.version = (
						SELECT MAX(version)
						FROM ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($contentType['content_type_id']). " AS sub
						WHERE sub.id = c.id
					))";
				
				$result = my_mysql_query($sql);
				$row = mysql_fetch_row($result);
				$item['usage_item'] += $row[0];
			}
			
			if ($item['usage_item'] || $item['usage_template'] || $item['usage_family']) {
				$item['traits']['in_use'] = true;
			} else {
				$item['traits']['unused'] = true;
			}

		}
		
		break;

	
	case 'tribiq__languages':
		if (!$isXML) {
			$atLeastOneLanguageEnabled = false;
			foreach ($panel['items'] as $id => &$item) {
				if (file_exists(CMS_ROOT. 'admin/images/store_keeper/main_icons/vlp_'. $id. '.gif')) {
					$item['image'] = 'admin/images/store_keeper/main_icons/vlp_'. $id. '.gif';
				}
				
				if (!$item['enabled']) {
					$item['name'] .= ' '. getPhrase('(not enabled)');
					$item['traits'] = array('not_enabled' => true);
				} else {
					$atLeastOneLanguageEnabled = true;
					$item['traits'] = array('enabled' => true);
					
					foreach(array(
						'homepage_id',
						'search_page_id',
						'extranet_login_page_id',
						'extranet_registration_page_id',
						'extranet_password_reminder_page_id',
						'extranet_change_password_page_id',
						'extranet_logout_page_id'
					) as $col) {
						if ($item[$col]) {
							if ($col == 'homepage_id') {
								$item['frontend_link'] = indexDotPHP(). '?cID='. $item[$col];
								$item['traits']['has_homepage'] = true;
							}
							
							$item[$col] = 'html_'. $item[$col];
						} else {
							$item[$col] = false;
						}
					}
				}
			}
			
			if ($atLeastOneLanguageEnabled) {
				unset($panel['item_buttons']['add_first_language']);
			}
			
			if ($refinerName == 'plugin') {
				$plugin = getPluginDetails($this->get('refiner__plugin'));
				$panel['title'] = getPhrase('Phrases for the "[[plugin]]" Plugin',
					array('plugin' => htmlspecialchars($plugin['display_name'])));
				$panel['no_items_message'] = getPhrase('This Plugin has no Phrases.');
				
				foreach ($panel['columns'] as $name => &$column) {
					if (issetArrayKey($column, 'title') && $name != 'name' && $name != 'code' && $name != 'phrase_count') {
						unset($column['title']);
					}
				}
				
				//If we're showing phrases for a Plugin, don't show any buttons and link there on close-up view
				$panel['collection_buttons'] = array();
				$panel['item_buttons'] = array();
				$panel['item']['tooltip'] = getPhrase('Double-click on a Language to view its Phrases');
				
			} else {
				//Show a close up view, rather than a link to Phrases
				unset($panel['item']['link']);
				
				if (!$atLeastOneLanguageEnabled) {
					$panel['popout_message'] = getPhrase(
<<<_text
<!--Message_Type:Question-->
<p>Tribiq CMS needs at least one Language Pack to be enabled in order to run.</p>

<p>Please select a Language Pack from the panel - click it once and then click the &quot;Enable Language&quot; button.</p>

<p>If the language you require is not shown, you can download it. To do this, click on the button &quot;Go to Tribiq Store&quot;,
select the language you want, then click &quot;Import Language Pack&quot;. You should then return to this Languages panel to Enable it.</p>
_text
					);
				}
			}
		}
		
		break;

	
	case 'tribiq__languages/vlp':
		if (!$isXML) {
			if ($refinerName == 'language') {
				$panel['title'] = getPhrase('Phrases for the Language "[[lang_name]]"',
					array('lang_name' => htmlspecialchars(getLanguageName($refinerId))));
				$panel['key'] = array('language_id' => $refinerId);
			
			} elseif ($refinerName == 'language_and_plugin') {
				$plugin = getPluginDetails($this->get('refiner__plugin'));
				$panel['title'] = getPhrase('"[[lang_name]]" Phrases for the "[[plugin]]" Plugin',
					array('plugin' => htmlspecialchars($plugin['display_name']), 'lang_name' => htmlspecialchars(getLanguageName($refinerId))));
				$panel['key'] = array('language_id' => $refinerId, 'pluginClass' => $plugin['class_name']);
			}
			
			foreach ($panel['items'] as $id => &$item) {
				$item['local_text'] = formatNicely($item['local_text'], 50);
				if (file_exists(CMS_ROOT. 'admin/images/store_keeper/main_icons/vlp_'. $item['language_id']. '.gif')) {
					$item['image'] = 'admin/images/store_keeper/main_icons/vlp_'. $item['language_id']. '.gif';
				}
			}
		}
		
		break;

	
	case 'tribiq__languages/remote_stores':
		
		$this->CURLLanguageFetch($panel, 1);
		
		break;

	
	case 'tribiq__languages/remote_store':
		
		$this->CURLLanguageFetch($panel, 2, $refinerId);
		
		break;

	
	case 'tribiq__users':
		//Add user images to each user, if they have a sticky image
		$ids = '';
		foreach ($panel['items'] as $id => &$item) {
			$ids .= ($ids? ',' : ''). mysql_real_escape_string($id);
			$item['images'] = array('defaut_image' => 'admin/images/store_keeper/main_icons/users_closeup_icon.jpg');
		}
		
		if ($ids) {
			$sql = "
				SELECT user_id, filename, sticky_flag
				FROM ". DB_NAME_PREFIX. "user_images
				WHERE user_id IN (". $ids. ")
				ORDER BY sticky_flag = 1 DESC, filename";
			
			$result = my_mysql_query($sql);
			while ($row = mysql_fetch_assoc($result)) {
				$img = '?id='. (int) $row['user_id']. '&filename='. rawurlencode($row['filename']);
				
				if ($row['sticky_flag']) {
					$panel['items'][$row['user_id']]['image'] = 'cmsincludes/storekeeper_user_image.php'. $img;
				}
				
				unset($panel['items'][$row['user_id']]['images']['defaut_image']);
				$panel['items'][$row['user_id']]['images'][] = 'cmsincludes/storekeeper_user_closeup_image.php'. $img;
			}
		}
		
		//Set a title
		if ($refinerName == 'group_members') {
			$groupDetails = getGroupDetails($refinerId);
			
			$panel['title'] = getPhrase('Members of the Group "[[name]]"', $groupDetails);
			$panel['no_items_message'] = getPhrase('This Group has no members.');
			
			$panel['item_buttons']['remove_users_from_group']['tooltip'] = getPhrase('Remove User from the Group "[[name]]"', $groupDetails);
			$panel['item_buttons']['remove_users_from_group']['multiple_select_tooltip'] = getPhrase('Remove Users from the Group "[[name]]"', $groupDetails);
			$panel['item_buttons']['remove_users_from_group']['ajax']['confirm']['message'] = getPhrase('Are you sure you wish to remove the User "[[username]]" from the Group "[[name]]"?', $groupDetails);
			$panel['item_buttons']['remove_users_from_group']['ajax']['confirm']['multiple_select_message'] = getPhrase('Are you sure you wish to remove the selected Users from the Group "[[name]]"?', $groupDetails);
		}
		
		//Don't show the "Create User" or "Delete User" button on a refiner
		if ($refinerName) {
			unset($panel['collection_buttons']['add']);
			unset($panel['item_buttons']['delete']);
		}
		
		if ($refinerName != 'group_members') {
			unset($panel['collection_buttons']['add_user_to_group']);
		}
		
		break;

	
	case 'tribiq__users/groups':
		
		$langs = getLanguages();
		foreach($langs as $lang) {
			if ($lang['id'] != $langId) {
				$panel['columns']['lang_'. $lang['id']] = array('title' => $lang['id']);
			}
		}
		
		$ids = '';
		foreach ($panel['items'] as $id => &$item) {
			$item['traits'] = array();
			
			if ($item['public']) {
				$item['traits']['public'] = true;
				
				foreach($langs as $lang) {
						$item['lang_'. $lang['id']] =
							getRow('visitor_phrases', 'local_text',
										array('language_id' => $lang['id'], 'code' => '_GROUP_'. (int) $id, 'plugin_class' => ''));
				}
			}
			
			//Add group images to each group, if they have a sticky image
			$ids .= ($ids? ',' : ''). mysql_real_escape_string($id);
			$item['images'] = array('defaut_image' => 'admin/images/store_keeper/main_icons/groups_closeup_icon.jpg');
		}
		
		if ($ids) {
			$sql = "
				SELECT group_id, filename, sticky_flag
				FROM ". DB_NAME_PREFIX. "group_images
				WHERE group_id IN (". $ids. ")
				ORDER BY sticky_flag = 1 DESC, filename";
			
			$result = my_mysql_query($sql);
			while ($row = mysql_fetch_assoc($result)) {
				$img = '?id='. (int) $row['group_id']. '&filename='. rawurlencode($row['filename']);
				
				if ($row['sticky_flag']) {
					$panel['items'][$row['group_id']]['image'] = 'cmsincludes/storekeeper_group_image.php'. $img;
				}
				
				unset($panel['items'][$row['group_id']]['images']['defaut_image']);
				$panel['items'][$row['group_id']]['images'][] = 'cmsincludes/storekeeper_group_closeup_image.php'. $img;
			}
		}
		
		//Set a title
		if ($refinerName == 'users_groups') {
			$userDetails = getUserDetails($refinerId);
			
			$panel['title'] = getPhrase('Group memberships for the User "[[username]]"', $userDetails);
			$panel['no_items_message'] = getPhrase('This User has no Group memberships.');
			
			foreach ($panel['item_buttons'] as $K=>$V) {
				switch ($K){
					case 'view_plans_for_group':
					case 'remove_users_from_group':
						break;
					default:
						unset($panel['item_buttons'][$K]);
						break;
				}
			}
			
			
			$panel['item_buttons']['remove_users_from_group']['tooltip'] = getPhrase('Remove the User "[[username]]" from this Group', $userDetails);
			$panel['item_buttons']['remove_users_from_group']['multiple_select_tooltip'] = getPhrase('Remove the User "[[username]]" from these Groups', $userDetails);
			$panel['item_buttons']['remove_users_from_group']['ajax']['confirm']['message'] = getPhrase('Are you sure you wish to remove the User "[[username]]" from the Group "[[name]]"?', $userDetails);
			$panel['item_buttons']['remove_users_from_group']['ajax']['confirm']['multiple_select_message'] = getPhrase('Are you sure you wish to remove the User "[[username]]" from the selected Groups?', $userDetails);
		}
		
		//Don't show the "Create Group" or "Delete Groups" button on a refiner
		if ($refinerName) {
			unset($panel['collection_buttons']['add']);
			unset($panel['item_buttons']['delete']);
		}
		
		if ($refinerName != 'users_groups') {
			unset($panel['collection_buttons']['add_user_to_group']);
		}
		
		break;

	
	case 'tribiq__administration/admins/local_admins':
		foreach ($panel['items'] as $id => &$item) {
			$item['has_permissions'] = checkRowExists('action_admin_link', array('admin_id' => $id));
		}
		
		if ($refinerName == 'trashed') {
			$panel['trash'] = false;
			$panel['title'] = getPhrase('Trashed Local Administrators');
		
		} else {
			$panel['trash']['empty'] = !checkRowExists('admins', array('status' => 'deleted'));
		}
		
		break;


	case 'tribiq__administration/backups':
		
		if ($errorsAndWarnings = initialiseBackupFunctions(true)) {
			$panel['no_items_message'] = '';
			foreach ($errorsAndWarnings as $errorOrWarning) {
				$panel['no_items_message'] .= $errorOrWarning . '<br />';
			}
			
			$panel['no_items_message'] = str_replace('<br />', "\n", $panel['no_items_message']);
			$panel['collection_buttons'] = false;
			return;
		}
		
		if (file_exists($dirpath = CMS_BACKUP_DIR. '/'. SITENAME)) {
			$panel['items'] = array();
			foreach (scandir($dirpath) as $i => $file) {
				if (is_file($dirpath. '/'. $file)) {
					$panel['items'][encodeItemIdForStorekeeper($file)] = array('filename' => $file, 'size' => filesize($dirpath. '/'. $file));
				}
			}
		}
		
		break;
	
	
	case 'tribiq__administration/favicon':
		
		foreach ($panel['items'] as &$item) {
			unset($panel['popout_message']);
			$item['image'] = 'cmsincludes/favicon.php?usage='. $item['usage']. '&checksum='. $item['checksum'];
			$item['width'] = ifNull($item['width'], getPhrase('n/a'));
			$item['height'] = ifNull($item['height'], getPhrase('n/a'));
		}
		
		break;


	case 'tribiq__content/dropbox':
		
		$panel['items'] = array();
		
		if ($errorsAndWarnings = initialiseDropbox()) {
			$panel['no_items_message'] = '';
			foreach ($errorsAndWarnings as $errorOrWarning) {
				$panel['no_items_message'] .= $errorOrWarning . '<br />';
			}
			
			$panel['no_items_message'] = str_replace('<br />', "\n", $panel['no_items_message']);
			return;
		}
		
		if (is_array($files = scandir($dir = CMS_DROPBOX_DIR . "/" . SITENAME . "/"))) {
			foreach ($files as $file) {
				if (is_file($dir. $file)) {
					$panel['items'][encodeItemIdForStorekeeper($file)] = array(
						'filename' => $file,
						'size' => filesize($dir. $file),
						'filectime' => filectime($dir. $file));
				}
			}
		}
		
		break;


	case 'tribiq__administration/settings':
		foreach ($panel['items'] as $id => &$item) {
			if ($item['type'] == 'tinyint(1)') {
				$item['value'] = $item['value']? getPhrase("Yes") : getPhrase("No");
			}
			
			$item['tooltip'] = getSettingDesc($item['name']);
			unset($item['type']);
		}
		
		break;

	
	case 'tribiq__administration/urls':
		$i = 0;
		$site = getSiteRegistrySite(SITENAME);
		
		foreach ($panel['items'] as $id => &$item) {
			++$i;
			if ($item['url'] == $site['goto_admin_url']) {
				$item['admin_url'] = true;
				$item['css_class'] = 'url_admin_item';
			} else {
				$item['traits'] = array('is_not_admin_url' => true);
			}
		}
		
		//Note that we're limiting site URLs to three or less.
		//Ideally you should only be using one as multiple URLs are bad for SEO, however a couple more are provided for dev-servers/testing
		if ($i >= 3) {
			$panel['collection_buttons']['create'] = false;
		}
		
		break;
}

return false;
?>