<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

if ($this->get('rollback') && checkPriv('_PRIV_MANAGE_PLUGIN_INSTANCE')) {
	//Display a confirmation box, asking the admin if they want to rollback
	$parent = getInstanceParent($this->get('instanceId'));
	echo json_encode(array(
		'html' => getPhrase(
					'Are you sure you wish to abandon the changes made to the Instance &quot;[[name]]&quot;?',
					array('name' => htmlspecialchars($parent['instance_name']))
					),
		'buttonsHTML' =>
					'<input class="submit_selected" value="'. getPhrase('Abandon'). '" onclick="tribiqA.doRollback(\''. htmlspecialchars($this->get('slotName')). '\')" type="button">'.
					'<input value="Cancel" type="button">',
		'warning' => 1
	));

} elseif ($this->post('rollback') && checkPriv('_PRIV_MANAGE_PLUGIN_INSTANCE')) {
	
	//Rollback a trail instance to the old version
	$parent = getInstanceParent($this->post('instanceId'));
	
	replacePluginInstance($this->post('instanceId'), $parent['instance_id'], $this->post('cID'), $this->post('cType'), $this->post('cVersion'), $this->post('slotName'));
	
	sendSignal('eventTryoutAbandoned', array(
		'instanceId' => $this->post('instanceId'),
		'parentId' => $parent['instance_id'],
		'cID' => $this->post('cID'),
		'cType' => $this->post('cType'),
		'cVersion' => $this->post('cVersion'),
		'slotName' => $this->post('slotName')
	));
	
	deletePluginInstance($this->post('instanceId')); 
	
	echo json_encode(array('instanceId' => $parent['instance_id']));
	
} elseif ($this->post('addPluginInstance') && checkPriv('_PRIV_MANAGE_ITEM_SLOT')) {
	updatePluginInstanceInItemSlot($this->post('addPluginInstance'), $this->post('slotName'), $this->post('cID'), $this->post('cType'), $this->post('cVersion'));

} elseif ($this->get('getPluginIdFromInstanceId')) {
	$instance = getPluginInstanceDetails($this->get('getPluginIdFromInstanceId'));
	echo $instance['plugin_id'];

} elseif ($this->get('getPluginIdFromClassName')) {
	echo getPluginIdByClassName($this->get('getPluginIdFromClassName'));
	
//Handle getting the URLs for items
} elseif ($this->post('refiner__content_type')) {
	echo linkToItem($this->post('id'), $this->post('refiner__content_type'), false, '', '', true, false, true);
	exit;
}

return false;
?>