<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

switch ($path) {
	case 'tribiq__content/content':
		
		if ($this->get('refiner__content_type') != 'html') {
			unset($panel['columns']['alias']);
		}
		
		if ($this->get('refiner__content_type') != 'document' && $this->get('refiner__content_type') != 'picture') {
			unset($panel['columns']['filename']);
		}
		
		if (isset($this->getVariables['refiner__trash'])) {
			unset($panel['columns']['status']['title']);
		}
		
		break;
	
	
	case 'tribiq__content/media/images':
		if ($this->get('refiner__content_id') && !isset($this->getVariables['refiner__all_items_images'])) {
			unset($panel['columns']['usage']);
		}
		
		if (!$this->get('refiner__content_id') || isset($this->getVariables['refiner__all_items_images'])) {
			unset($panel['columns']['sticky_flag']);
		}
		
		break;
	
	
	case 'tribiq__content/media/movies':
		if ($this->get('refiner__content_id') && !isset($this->getVariables['refiner__all_items_movies'])) {
			unset($panel['columns']['usage']);
		}
		
		break;

	
	case 'tribiq__languages':
		if ($refinerName == 'plugin') {
			$panel['db_items']['table'] = '
						[[DB_NAME_PREFIX]]languages AS l
					LEFT JOIN 
						[[DB_NAME_PREFIX]]visitor_phrases AS vp
					ON
						l.id = vp.language_id
					LEFT JOIN 
						[[DB_NAME_PREFIX]]plugins pl
					ON 
						vp.plugin_class=pl.class_name';
			
			$panel['db_items']['id_column'] = 'l.id';
			
			
			foreach ($panel['columns'] as &$column) {
				if (trim(arrayKey($column, 'table_join')) == '[[DB_NAME_PREFIX]]languages AS l ON l.id = vp.language_id') {
					unset($column['table_join']);
				}
				if (trim(arrayKey($column, 'db_column')) == 'vp.language_id') {
					$column['db_column'] = 'l.id';
				}
			}
			
			$panel['columns']['phrase_count']['db_column'] = 'COUNT(DISTINCT IF (NOT [[REFINER__PLUGIN]] OR pl.id=[[REFINER__PLUGIN]],vp.code,NULL))';
		}
		
		break;

	
	case 'tribiq__languages/vlp':
		if (!isset($this->getVariables['refiner__category_public_name']) && !isset($this->getVariables['refiner__group_public_name'])) {
			unset($panel['columns']['language_id']);
		}
		
		break;

	
	case 'tribiq__users':
		global $siteConfig;
		if (empty($siteConfig)) {
			$siteConfig = loadSiteConfig();
		}
		
		if (!engToBooleanArray($siteConfig, 'user_show_maiden_name')) {
			unset($panel['columns']['maiden_name']);
		}
		
		if (!engToBooleanArray($siteConfig, 'user_show_middle_name')) {
			unset($panel['columns']['middle_name']);
		}
		
		if (!engToBooleanArray($siteConfig, 'user_show_additional_details')) {
			unset($panel['columns']['alt_email']);
			unset($panel['columns']['birth_date']);
			unset($panel['columns']['website']);
			unset($panel['columns']['job_title']);
			unset($panel['columns']['fax']);
		}
		
		if (!engToBooleanArray($siteConfig, 'user_show_business_details')) {
			unset($panel['columns']['company_name']);
			unset($panel['columns']['bus_address1']);
			unset($panel['columns']['bus_address2']);
			unset($panel['columns']['bus_address3']);
			unset($panel['columns']['bus_town']);
			unset($panel['columns']['bus_state']);
			unset($panel['columns']['bus_postcode']);
			unset($panel['columns']['bus_country_id']);
			unset($panel['columns']['bus_phone']);
			unset($panel['columns']['address_pref']);
		}
		
		if (!engToBooleanArray($siteConfig, 'user_show_residential_details')) {
			unset($panel['columns']['res_address1']);
			unset($panel['columns']['res_address2']);
			unset($panel['columns']['res_address3']);
			unset($panel['columns']['res_town']);
			unset($panel['columns']['res_state']);
			unset($panel['columns']['res_postcode']);
			unset($panel['columns']['res_country_id']);
			unset($panel['columns']['res_phone']);
			unset($panel['columns']['address_pref']);
		}
		
		break;
}
?>