<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

$cID = (int) $primaryKey['sourceCID'];
$cType = $primaryKey['cType'];
$cVersion = $primaryKey['sourceVersion'];

cms_core::duplicateContentLoadDetails($cID, $cType, $cVersion, $currentTitle, $currentLang, $currentAlias, $currentMenu, $languages);


//Add the content type's include file, so we can use the duplicateContent function
includeContentType($cType);

//Dupilcate the content
$newId = duplicateContent($cID, $cVersion, $this->post('alias'), $cType);

//Update the title, as well as the language id if needed
$sql = "
	UPDATE ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($cType). " SET
		title = '". mysql_real_escape_string($this->post('title')). "',
		language_id = '". mysql_real_escape_string($this->post('language')). "'
	WHERE id = ". (int) $newId;
my_mysql_query($sql);

//Check if the user is requesting the menu to be duplicated too
if ($this->post('menu')
 //Only let the user do this if we know the correct parent id in order to place the copy
 && $languages[$this->post('language')]['menu_parent'] !== false) {
	
	//Work out the next free ordinal to give the menu item
	$sql = "
		SELECT max(ordinal)
		FROM ". DB_NAME_PREFIX. "menuitems
		WHERE parent_id = ". (int) $languages[$this->post('language')]['menu_parent']. "
		  AND language_id = '". mysql_real_escape_string($this->post('language')). "'";
	
	$result = my_mysql_query($sql);
	list($newOrdinal) = mysql_fetch_row($result);
	
	if ($newOrdinal) {
		++$newOrdinal;
	} else {
		$newOrdinal = 1;
	}
	
	//Duplicate the menu item
	$sql = "
		INSERT INTO ". DB_NAME_PREFIX. "menuitems
		SET section_id = '". mysql_real_escape_string($currentMenu['section_id']). "',
			name = '". mysql_real_escape_string($this->post('menu_title')). "',
			target_loc = 'int',
			content_id = ". (int) $newId. ",
			content_type = '". mysql_real_escape_string($cType). "',
			mode = '". mysql_real_escape_string($currentMenu['mode']). "',
			parent_id = ". (int) $languages[$this->post('language')]['menu_parent']. ", 
			ordinal = ". (int) $newOrdinal. ", 
			language_id = '". mysql_real_escape_string($this->post('language')). "', 
			active = 0, 
			hide_private_item = ". (int) $currentMenu['hide_private_item']. ", 
			invisible = ". (int) $currentMenu['invisible']. ", 
			rel_tag  = '". mysql_real_escape_string($currentMenu['rel_tag']). "'";
	my_mysql_query($sql);
}

if (issetArrayKey($this->postVariables, 'create_equivalence') && inc('tribiq_avls')) {
	tribiq_avls::recordEquivalenceOfDuplicatedLanguage($cType, $cID, $newId);
}


echo json_encode(array('cID' => $newId));

return false;
?>