<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

if ($floatingBoxName=="Categories") {
	if ($primaryKey['catId']) {
		$title = getPhrase("Viewing/Editing the Category &quot;[[category]]&quot;", array('category' => htmlspecialchars(getCategoryName($primaryKey['catId']))));
	} else {
		$title = getPhrase("Creating a Category");
	}
} elseif ($floatingBoxName == 'Duplicate Content') {
	
	if ($primaryKey['cID'] && !$primaryKey['sourceCID']) {
		$primaryKey['sourceCID'] = $primaryKey['cID'];
		$primaryKey['cID'] = null;
	}
	
	if ($this->request('cVersion') && !$primaryKey['sourceVersion']) {
		$primaryKey['sourceVersion'] = $this->request('cVersion');
	}
	
	if ($this->request('refiner__content_type')) {
		$primaryKey['cType'] = $this->request('refiner__content_type');
	}
	
	if (!$primaryKey['sourceVersion']) {
		$primaryKey['sourceVersion'] = getLatestVersion($primaryKey['sourceCID'], $primaryKey['cType']);
	}
	
	$title = getPhrase('Duplicating Content Item &quot;[[tag]]&quot;', array('tag' => htmlspecialchars(getTag($primaryKey['sourceCID'], $primaryKey['cType']))));
	
	$primaryKey['cVersion'] = 1;

} elseif ($floatingBoxName == 'Spare Domain Name') {
	
	if ($primaryKey['url']) {
		$primaryKey['url'] = decodeItemIdForStorekeeper($primaryKey['url']);
		$title = getPhrase('Viewing/Editing the Spare Domain Name &quot;[[url]]&quot;', array('url' => htmlspecialchars($primaryKey['url'])));
	} else {
		$title = getPhrase('Adding an Spare Domain Name');
	}

} elseif ($floatingBoxName == 'Create Language Pack') {
	$title = getPhrase('Creating a Language Pack');
}

return false;
?>