<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

$requiredFields = array('name');

$categoryFields = array();
$categoryFields['name'] = array(
	'Label' => 'Internal Name:',
	'Type' => 'varchar(50)',
	'Table' => 'categories');
$categoryFields['public'] = array(
	'Label' => 'Category is Public:',
	'Type' => 'tinyint',
	'Note Below' => getPhrase('When a Category is Public, its name will be visible to Visitors where appropriate. Public Categories will automatically be given a name in all Enabled Languages. You can manage its Public Name(s) via the Languages and Phrases system.'));
$categoryFields['landing_page'] = array(
	'Label' => 'Landing Page:',
	'Type' => 'content',
	'Requires' => 'public');

$categoryDBDetails = array();

if ($this->post('catId')) {
	//Load category details fro database if an id has been given
	$categoryDBDetails = $this->getCategories($this->post('catId'));
	$categoryDBDetails = $categoryDBDetails[0];
	
	if ($categoryDBDetails['landing_page_content_id']) {
		$categoryDBDetails['landing_page'] = $categoryDBDetails['landing_page_content_id']. '_'. $categoryDBDetails['landing_page_content_type'];
	} else {
		$categoryDBDetails['landing_page'] = '';
	}
} else {
	//No need to show the show the "Edit"/"Cancel" button for new categories
	$hasEditPermission = false;
}


echo dynamicThickboxFormInner($editMode, $categoryFields, $requiredFields, $this->postVariables, $categoryDBDetails);

return false;
?>