<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

if (!checkPriv('_PRIV_ENABLE_VLP')) {
	exit;
}

$flags = array();
foreach (scandir($path = CMS_ROOT. 'admin/images/flags/') as $file) {
	if (is_file($path. $file) && substr($file, -4) == '.gif') {
		$flags[substr($file, 0, -4)] = $file;
	}
}

$details = array('__LANGUAGE_LOCAL_NAME__' => '', '__LANGUAGE_FLAG_FILENAME__' => 'white');
$fields = array(
	'lang_id' => array(
		'Type' => 'varchar(5)',
		'Label' => getPhrase('Language Code:')),
	'__LANGUAGE_LOCAL_NAME__' => array(
		'Type' => 'varchar(255)',
		'Label' => getPhrase('Language Local Name:')),
	'__LANGUAGE_FLAG_FILENAME__' => array(
		'Type' => 'select',
		'Options' => $flags,
		'Label' => getPhrase('Flag filename:'))
	);
	
$requiredFields = array('lang_id', '__LANGUAGE_LOCAL_NAME__', '__LANGUAGE_FLAG_FILENAME__');
			
echo dynamicThickboxFormInner($editMode, $fields, $requiredFields, $this->postVariables, $details);

return false;
?>