<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

if (!checkPriv('_PRIV_MANAGE_SPARE_DOMAIN_NAME')) {
	exit;
}

$details = array();
if ($primaryKey['url']) {
	connectGlobalDB();
		$details = getRow(
					'spare_urls',
					array('requested_url', 'content_id', 'content_type'),
					array('requested_url' => $primaryKey['url'], 'sitename' => SITENAME),
					false, DB_NAME_PREFIX_GLOBAL);
		$details['content'] = $details['content_id']. '_'. $details['content_type'];
	connectLocalDB();
}


$fields = array();
$fields['description'] = array(
	'Type' => 'description',
	'Label' => getPhrase('You can define a Spare Domain Name, so that Visitors to that Domain Name are redirected to a specified Content Item under the Admin URL. Use this panel to define a Spare Domain Name and the target Content Item. Note that DNS and your web server must be correctly set up to map the Spare Domain to the CMS directory.'));

$fields['requested_url'] = array(
	'Type' => 'varchar(255)',
	'Label' => getPhrase('Spare Domain Name:'),
	'Pre Field HTML' => 'http://',
	'Read Only' => (bool) $primaryKey['url']);

if (!$primaryKey['url']) {
	$fields['add_www'] = array(
		'Type' => 'tinyint(1)',
		'Label' => getPhrase('Add www subdomain:'),
		'Note Below' => getPhrase('For example, if you entered &quot;tribiq.com&quot; in the field above, ticking this checkbox would automatically add &quot;www.tribiq.com&quot; for you as well.'));
	
	$fields['requested_url']['onkeyup'] = "tribiqA.manField = this; if (get('add_www').disabled = this.value.match(/^www\.[^\.]+\.[^\.]+$/i)? true : false) get('add_www').checked = false;";
}

$fields['content'] = array(
	'Type' => 'content',
	'Label' => getPhrase('Content Item:'));
	
$requiredFields = array();
			
echo dynamicThickboxFormInner($editMode, $fields, $requiredFields, $this->postVariables, $details);

return false;
?>