<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

switch ($path) {
	case 'tribiq__content/content':
		if ($this->post('download')) {
			if ($this->post('refiner__content_type') == 'document') {
				$sql = "
					SELECT filename, mime_type, size, version
					FROM ". DB_NAME_PREFIX. "content_document
					WHERE id = ". (int) $ids. "
					ORDER BY version DESC
					LIMIT 1";
				
				if (($result = my_mysql_query($sql))
				 && ($row = mysql_fetch_assoc($result))
				 && (is_file($file = CMS_DOCSTORE_DIR . "/" . SITENAME . "/" . (int) $ids . "/" . $row['version'] . "/" . $row['filename']))) {
					header('Content-Type: ' . $row['mime_type']);
					header('Content-Disposition: attachment; filename="'. $row['filename']. '"');
					header('Content-Length: '. $row['size']); 
					echo file_get_contents($file);
					exit;
				}
			
			} elseif ($this->post('refiner__content_type') == 'picture') {
				$sql = "
					SELECT c.filename, c.mime_type, c.size, rps.data
					FROM ". DB_NAME_PREFIX. "content_picture AS c
					INNER JOIN ". DB_NAME_PREFIX. "raw_picture_store AS rps
					   ON rps.content_id = c.id
					  AND rps.content_version = c.version
					WHERE c.id = ". (int) $ids. "
					ORDER BY c.version DESC
					LIMIT 1";
				
				if (($result = my_mysql_query($sql)) && ($row = mysql_fetch_assoc($result))) {
					header('Content-Type: ' . $row['mime_type']);
					header('Content-Disposition: attachment; filename="'. $row['filename']. '"');
					header('Content-Length: '. $row['size']); 
					echo $row['data'];
					exit;
				}
			}
		}
		
		break;
		
		
	case 'tribiq__languages':
		if ($this->post('export') && checkPriv('_PRIV_EXPORT_VLP')) {
			
			$languageId = $ids;
		
		
			//Functionality for Exporting and Importing Language Packs
			
			//Given a language id, get all of the Language phrases for that language.
			//Calls on the functions defined in the XML section of admin.inc.php
			
			$columnNamesPrinted = false;
			$currentPluginClass = '';
			$currentPluginStatus = '_ENUM_RUNNING';
		
			//Create a file in the temp directory to start writing to.
			$filename = tempnam(sys_get_temp_dir(), 'tmpfiletodownload');
			$f = fopen($filename, 'wb');
			
			//Add the language id in
			fputcsv($f, array(
				'TRIBIQ CMS Language PACK WORKSHEET',
				'',
				'Target Language ID'));
			fputcsv($f, array(
				'(Do not edit this column)',
				'To create a new Language Pack, change the value of the cell to the right to the ID for the language you are creating ->', $languageId));
		
			//Look up all of the codes in the database
			//Order such that we have all of the core VLPs first, then VLPs grouped by Plugins
			$sql = "
				SELECT
					codes.plugin_class,
					codes.code AS `Phrase Code`,";
			
			if ($this->post('reference_text')) {
				$sql .= "
					reference.local_text AS `Reference Text`,";
			}
			
			$sql .= "
					phrases.local_text AS `Translation`
				FROM (
					SELECT DISTINCT code, plugin_class
					FROM ". DB_NAME_PREFIX. "visitor_phrases
				) AS codes
				LEFT JOIN ". DB_NAME_PREFIX. "visitor_phrases AS phrases
				   ON phrases.code = codes.code
				  AND phrases.plugin_class = codes.plugin_class
				  AND phrases.language_id = '". mysql_real_escape_string($languageId). "'";
			
			if ($this->post('reference_text')) {
				$sql .= "
				LEFT JOIN ". DB_NAME_PREFIX. "visitor_phrases AS reference
				   ON reference.code = codes.code
				  AND reference.plugin_class = codes.plugin_class
				  AND reference.language_id = '". mysql_real_escape_string(DEFAULT_LANGUAGE). "'
				  AND reference.code != '__LANGUAGE_LOCAL_NAME__'";
			}
			
			if ($this->post('phrases') == 'missing') {
				$sql .= "
				WHERE phrases.id IS NULL";
			
			} elseif ($this->post('phrases') == 'present') {
				$sql .= "
				WHERE phrases.id IS NOT NULL";
			}
			
			$sql .= "
				ORDER BY codes.plugin_class != '', codes.plugin_class, instr(codes.code, '__') DESC, codes.code;";
			$result = my_mysql_query($sql);
			
			//For each code, write it to the csv file
			while ($row = mysql_fetch_assoc($result)) {
				
				//Check if this is the start of a group of VLPs for a Plugin, and checi if this Plugin is running if so
				if ($currentPluginClass != $row['plugin_class']) {
					$currentPluginStatus = getPluginStatusByClassName($row['plugin_class']);
				}
				
				if (!$currentPluginStatus || $currentPluginStatus == '_ENUM_INSTALLED') {
					$currentPluginClass = $row['plugin_class'];
					continue;
				}
					
				//Check if this is the start of a group of VLPs for a Plugin, and put a header in if so
				if ($currentPluginClass != $row['plugin_class']) {
					$currentPluginClass = $row['plugin_class'];
					fputcsv($f, array());
					fputcsv($f, array('Plugin'));
					fputcsv($f, array($currentPluginClass));
					$columnNamesPrinted = false;
				}
				unset($row['plugin_class']);
				
				//Print the columns names in the first line
				if (!$columnNamesPrinted) {
					$columnNamesPrinted = true;
					fputcsv($f, array());
					fputcsv($f, array_keys($row));
				}
				
				//Print each row
				fputcsv($f, $row);
			}
			
			fclose($f);
		
			//...and finally offer it for download
			header('Content-Type: text/csv; charset=UTF-8');
			header('Content-Disposition: attachment; filename="'. $languageId. '.csv"');
			header('Content-Length: '. filesize($filename)); 
			readfile($filename);
			
			//Remove the file from the temp directory
			@unlink($filename);
			
			exit;
		}
		
		break;
		
		
	case 'tribiq__administration/backups':
		//Functionality for Downloading Backups
		
		//Check permissions for downloading backups
		exitIfNotCheckPriv('_PRIV_BACKUP_SITE');
		
		//Check to see if we can proceed
		if ($errors = initialiseBackupFunctions(false)) {
			foreach($errors as $error) {
				echo $error, '<br />';
			}
			exit;
		}
		
		
		//Offer a backup of the current state of the site for download 
		if (!$ids) {
		
			//Create a gz file in the temp directory...
			$filepath = tempnam(sys_get_temp_dir(), 'tmpfiletodownload');
			
			//...write the backup into it...
			$g = gzopen($filepath, 'wb');
			createDatabaseBackupScript($g);
			gzclose($g);
		
			//...and finally offer it for download
			header('Content-Disposition: attachment; filename="'. generateFilenameForBackups(). '"');
			header('Content-Length: '. filesize($filepath)); 
			readfile($filepath);
			
			//Remove the file from the temp directory
			@unlink($filepath);
		
		
		//Offer one of the previously saved backups for download	
		} else {
			//Add some security to stop the user putting nasty things into their requested filename
			//I'm doing this by stripping out anything not in the usual backup filename format
			if ($ids) {
				$filename = decodeItemIdForStorekeeper($ids);
				if (preg_match('/[^a-zA-Z0-9\._-]/', $_POST['target'])) {
					exit;
				}
			}
			
			$filepath = CMS_BACKUP_DIR. '/'. SITENAME. '/'. $filename;
			
			//Make this page into a download
			header('Content-Disposition: attachment; filename="'. $filename. '"');
			header('Content-Length: '. filesize($filepath)); 
			
			readfile($filepath);
		
		}
		
		break;
}

return false;
?>