<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */
if (!defined('NOT_ACCESSED_DIRECTLY') || !checkPriv()) exit;

$errors = array();

if (!$this->post('language')) {
	$errors[] = getPhrase('Please select a Language');
}

if (!isset($this->postVariables['title']) || $this->postVariables['title'] === '') {
	$errors[] = getPhrase('Please enter a Title');
}

//Validate the alias if it was set
if ($this->post('alias') != '') {
	if ($aliasErrors = validateAlias($this->post('alias'))) {
		foreach($aliasErrors as $error) {
			$errors[] = $error;
		}
	}
}

if ($this->post('menu') && (!isset($this->postVariables['menu_title']) || $this->postVariables['menu_title'] === '')) {
	$errors[] = getPhrase('Please enter a Menu Title');
}

echo json_encode(array('valid' => empty($errors), 'errArray' => $errors));

return false;
?>