<?php 
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

/* Define the content type variable for this include */

global $cType;
$cType = "html";




function getAlias($cID, $cVersion = false) {
	
	$sql = "SELECT alias
			FROM " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . "
			WHERE id = ". (int) $cID;
	
	if ($cVersion) {
		$sql .= "
			  AND version = ". (int) $cVersion;
	}
	
	$sql .= "
			ORDER BY version DESC";
	
	
	$result = my_mysql_query($sql);
	
	if ($row = mysql_fetch_assoc ($result)) {
		return $row["alias"];
	} else {
		return false;
	}		
}

function setAlias ($cID, $cVersion, $alias) {
	
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	
	$sql = "UPDATE " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . "
			SET alias = '" . mysql_real_escape_string($alias) . "'
			WHERE id = " . $cID . "
				AND version = " . $cVersion;
	
	//If there is no published version, update the alias on any Menu Items
	if (!checkRowExists('content_'. $GLOBALS['cType'], array('id' => $cID, 'status' => 'published'))) {
		updateRow('menuitems', array('html_content_alias' => $alias), array('content_id' => $cID, 'content_type' => $GLOBALS['cType']));
	}
	
	$result = my_mysql_query($sql);
}

function getItemMeta ($cID, $cVersion) {
	
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	
	if (($cID > 0) && ($cVersion > 0)) {
		$sql = "SELECT title,
					language_id,
					".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . ".status,
					description,
					keywords,
					enable_rss,
					family_name,
					filename,
					".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . ".template_id,
					alias
				FROM ".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . "
				LEFT JOIN " . DB_NAME_PREFIX . "templates
					ON ".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . ".template_id = " . DB_NAME_PREFIX . "templates.template_id
				WHERE id = '" . mysql_real_escape_string($cID) . "'
					AND version = " . $cVersion;
		$result = my_mysql_query ($sql);
		if ($row = mysql_fetch_array ($result)) {
			return $row;
		} else {
			return false;
		}
	} else {
		return false;
	}
}


function createNewContent($menuid,$page_title,$page_alias="", $template_id,$language_id,$sampletext=false,$private=false,$caller="",$enable_rss=0,$microsite_id=null) {

	if (!$microsite_id) {
		$microsite_id = 'null';
	}
	
	$menuid = (int) $menuid;
	$template_id = (int) $template_id;
	
	if (!$page_title||$page_title=="") {
		$error['page_title'] = getPhrase("_MSG_NO_TITLE");
	}
	
	if (strpos(strtolower($page_alias)," ")>0) {
		$error['page_alias'] = getPhrase("_MSG_SPACES_IN_ALIAS");
	}
	
	if (is_numeric($page_alias)) {
		$error['page_alias'] = getPhrase("_MSG_NUMERIC_ALIAS");
	}
	
	if (aliasExists(tidyAlias($page_alias))) {
		$error['page_alias'] = getPhrase("_MSG_UNIQUE_ALIAS");
	} else {
		$page_alias = tidyAlias($page_alias);
	}

	if (!$template_id||$template_id=="") {
		$error['template_id'] = getPhrase("_MSG_NO_TEMPLATE_SELECTED");
	}
	
	if (!$error) {
	
		if ($sampletext) {
			$content_bodymain = "<h1>Sample Text</h1>\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Curabitur eros augue, suscipit et, tempus nec, consequat sed, erat. Proin est. Proin dapibus. In facilisis sagittis libero. Vivamus nec enim. Cras magna. Donec eu eros. Vestibulum purus dui, viverra nec, sagittis at, laoreet at, augue. Integer mi ante, dictum id, posuere ac, malesuada non, nisi. Sed pulvinar elementum nisi. Nullam lacus erat, cursus sed, rutrum sit amet, interdum vel, quam.</p>";
		}
		
		if ($private) {
			$private = 1;
		} else {
			$private = 0;
		}

		if ($enable_rss) {
			$enable_rss = 1;
		} else {
			$enable_rss = 0;
		}
		
		if ($caller=="" && $parent_mID = getMenuParent($menuid)) {
			$content_array = getContentFromMenu($parent_mID);
			
			$cID = $content_array['content_id'];
			
			$sql = "SELECT template_id 
					FROM " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . " 
					WHERE id = '" . mysql_real_escape_string($cID) . "'";
			$result = my_mysql_query($sql);
			
			if (mysql_num_rows($result)>0) {			
				$row = mysql_fetch_array($result);
				
				if (!$template_id) {
					$template_id = $row['template_id'];
				}
			} else {
				$sql = "SELECT default_template_id
						FROM " . DB_NAME_PREFIX . "contenttypes
						WHERE content_type_id = '" . mysql_real_escape_string($GLOBALS['cType']) . "'";
				
				$result = my_mysql_query($sql);
				
				$row = mysql_fetch_array($result);
				
				if (!$template_id) {
					$template_id = $row['default_template_id'];
				}
			}
		} else {
			$sql = "SELECT default_template_id
					FROM " . DB_NAME_PREFIX . "contenttypes
					WHERE content_type_id = '" . mysql_real_escape_string($GLOBALS['cType']) . "'";
			
			$result = my_mysql_query($sql);
			
			$row = mysql_fetch_array($result);
			
			if (!$template_id) {
				$template_id = $row['default_template_id'];
			}
		}
		
		$sql = "SELECT MAX(id)+1 AS NewID 
				FROM " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'];
		
		$result = my_mysql_query($sql);
		

		$row = mysql_fetch_array($result);
		
		if ($row[0]!="") {
			$newid = $row[0];
		} else {
			$newid = 1;			
		}
		
		$sql = "INSERT INTO " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . " 
				SET id = " . $newid . ",
					title = '" . mysql_real_escape_string($page_title) . "',
					owner_id = " . $_SESSION["admin_userid"] . ",
					owner_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
					creating_author_id = " . $_SESSION["admin_userid"] . ",
					creating_author_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
					created_datetime = NOW(),
					last_author_id = " . $_SESSION["admin_userid"] . ",
					last_author_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
					alias = '" . mysql_real_escape_string(tidyAlias($page_alias)) . "',
					content_head = '" . mysql_real_escape_string($content_head) . "',
					content_bodytop = '" . mysql_real_escape_string($content_bodytop) . "',
					content_bodymain = '" . mysql_real_escape_string($content_bodymain) . "',
					content_bodyfoot = '" . mysql_real_escape_string($content_bodyfoot) . "',
					language_id = '" . mysql_real_escape_string($language_id) . "',
					private = " . $private . ",
					template_id = " . $template_id . ",
					enable_rss = " . $enable_rss;

		if($microsite_id!="null") {
			$sql .= ",
					microsite_id = " . $microsite_id;
		}
		
		$result = my_mysql_query($sql);
		
		if ($caller=="") {
			$sql = "UPDATE " . DB_NAME_PREFIX . "menuitems 
					SET content_id = " . $newid . ", 
						content_type = '" . mysql_real_escape_string($GLOBALS['cType']) . "' , 
						html_content_alias = '" . mysql_real_escape_string($page_alias) . "',
						language_id = '" . mysql_real_escape_string($language_id) . "'
					WHERE id = " . $menuid;
			
			$result = my_mysql_query($sql);
		}
		
		return true;
	
	} else {
		return $error;
	}
}







function displaySetSettingsForm($formInputs, $showEditButton) {
	
	
	if ($formInputs['alias']) {
		$alias = $formInputs['alias'];
		$logUserAccess = $formInputs['log_user_access'];
		
	} elseif ($formInputs['cID']) {
		$alias = getAlias($formInputs['cID'],$formInputs['cVersion']);
	}
	
	$editMode = $formInputs['formMode']=="edit" || !$formInputs['cID'];
	
	if ($editMode) {

		$formhtml = '
			<form name="setsettings" action="?width='. $formInputs['width'] . '&height=' . $formInputs['height'] . '&KeepThis=true&TB_iframe=true&modal=true"
			 id="setsettings" method="post" class="thickbox" onsubmit="formHandler();return false;">
				<input type="hidden" id="formMode" name="formMode" value="edit" />
				<input type="hidden" id="cType" name="cType" value="'. $formInputs['cType']. '" />';
		
		$formhtml .= '
				<table id="content_form" border="0">
					<tr id="errorDisplayRow" style="display:none;">
						<td colspan="2" id="errorDisplay" style="display:none;">'. $errordisplay. '</td>
					</tr>
					<tr>
						<td colspan="2">
							'. getPhrase('_EDIT_ALIAS_FOR_CONTENT_ITEM'). '
						</td>
					</tr>
					<tr>
						<td class="title" style="width:110px"><label for="alias">'. getPhrase('_ALIAS:'). '</label></td>
						<td style="width:490px">
							<input class="form_field" name="alias" id="alias" value="'. htmlspecialchars($alias). '" onKeyUp="tribiqTab.validateAlias();" />
							'. (getSiteConfig('mod_rewrite_enabled')? getSiteConfig('mod_rewrite_suffix') :null). '
						</td>
					</tr>
					<tr>
						<td></td>
						<td id="aliasWarningDisplay"></td>
					</tr>';
				
	} else {

		$formhtml = '
			<form name="setsettings" action="?width='. $formInputs['width']. '&height='. $formInputs['height']. '&KeepThis=true&TB_iframe=true&modal=true"
			 id="setsettings" method="post" class="thickbox" onsubmit="formHandler(this);return false;">
				<input type="hidden" id="formMode" name="formMode" value="view" />
				<table id="content_form" border="0">
					<tr>
						<td colspan="2">
							'. getPhrase('_EDIT_ALIAS_FOR_CONTENT_ITEM'). '
						</td>
					</tr>
					<tr>
						<td class="title" style="width:110px">'. getPhrase('_ALIAS:'). '</td>
						<td style="width:490px">'. htmlspecialchars($alias). '</td>
					</tr>';
	}
	
	$formhtml .= '
					<tr>
						<td>&nbsp;</td>
						<td>&nbsp;</td>
					</tr>';
	
	if ($showEditButton && (($formInputs['cVersion']==getLatestVersion($formInputs['cID'],$formInputs['cType'])) || getLatestVersionStatus($formInputs['cID'],$formInputs['cType'])!="private_draft")) {
		$formhtml .= '	<tr>
							<td>&nbsp;</td>
							<td class="left">
								<input type="submit" id="submit" class="submit" '.
									($editMode?
										'onclick="cancelEdit();" value="'. getPhrase("_CANCEL"). '"'
									:
										'name="submit" value="'. getPhrase('_EDIT'). '"'
									). ' />
							</td>
						</tr>';
	}
					
	$formhtml .= '</table>
			</form>';
	
	
	return array($formhtml,$msg,$type_msg);
}

function validateSettings($formInputs) {

	//Check if the alias is a valid alias, and if it already exists somewhere else
	$error = validateAlias($formInputs['alias'], $formInputs['cID']);
	
	return Array("valid" => !$error,"errArray" => $error);
}

function saveSettings ($formInputs) {
	$alias = tidyAlias($formInputs['alias']);
	setAlias($formInputs['cID'],$formInputs['cVersion'], $alias);
}

function deleteRawVersion($cID, $cVersion, $deleteDirectories=false) {
	
}

?>