<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */  

/* Define the content type variable for this include */

global $cType;
$cType = "news";


 


function getItemMeta ($cID, $cVersion) {
	$cID = (int) $cID;
	$cVersion = (int) $cVersion;
	
	if (($cID > 0) && ($cVersion > 0)) {
		$sql = "SELECT title,
					language_id,
					".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . ".status,
					description,
					keywords,
					family_name,
					filename,
					".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . ".template_id
				FROM ".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . "
				LEFT JOIN " . DB_NAME_PREFIX . "templates
					ON ".DB_NAME_PREFIX."content_" . $GLOBALS['cType'] . ".template_id = " . DB_NAME_PREFIX . "templates.template_id
				WHERE id = '" . mysql_real_escape_string($cID) . "'
					AND version = " . $cVersion;
		$result = my_mysql_query ($sql);
		if ($row = mysql_fetch_array ($result)) {
			return $row;
		} else {
			return false;
		}
	} else {
		return false;
	}
}



function createNewContent($menuid,$page_title, $template_id,$language_id,$sampletext=false,$publication_date,$private=false,$caller="") {
	$menuid = (int) $menuid;
	$template_id = (int) $template_id;
	
	if (!$page_title||$page_title=="") {
		$error['page_title'] = getPhrase("_MSG_NO_TITLE");
	}
	
	// Do Date Format checks if it exists
	if ($publication_date) {

		// _MSG_DATE_FORMAT
		if (preg_match("/\d{4}-\d{2}-\d{2}/",$publication_date)) {
		
			$digit_array_check = explode("-",$publication_date);
		
			$date_year_error = false;
			$date_month_error = false;
			$date_day_error = false;
			$date_error_string = "";
			
			// Digit check
			$digit_year = (int)$digit_array_check[0];
			$digit_month = (int)$digit_array_check[1];
			$digit_day = (int)$digit_array_check[2];				
		
			// Date 0000-00-00 should be a null entry in db
			if ((!$digit_year) && (!$digit_month) && (!$digit_day)) {
				$publication_date = ""; 
			} else {
			
				if (!$digit_year) $date_year_error = true;
				if (($digit_month < 1) || ($digit_month > 12)) $date_month_error = true;
				if (($digit_day < 1) || ($digit_day > 31)) $date_day_error = true;	
				
					
				// If no errors in date then, Format for SQL insert
				if ((!$date_year_error) && (!$date_month_error) && (!$date_day_error))
					$publication_date = "'".$digit_array_check[0]."-".$digit_array_check[1]."-".$digit_array_check[2]."'";
				else {
					if ($date_year_error) $date_error_string .= getPhrase("_MSG_DATE_YEAR")."<br/>";
					if ($date_month_error) $date_error_string .= getPhrase("_MSG_DATE_MONTH")."<br/>";
					if ($date_day_error) $date_error_string .= getPhrase("_MSG_DATE_DAY")."<br/>";
					$error['publication_date'] = getPhrase("_MSG_DATE_FORMAT")."<br/>".$date_error_string;
				}
			}
			

		} else $error['publication_date'] = getPhrase("_MSG_DATE_FORMAT");
	} 
		
	 //$publication_date = checkDateFormat($publication_date,"publication_date");
		
	if (strlen($publication_date) <= 0) $publication_date="null";
	
	if (!$error) {
	
		if ($sampletext) {
			$content_bodymain = "<h1>Sample Text</h1>\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Curabitur eros augue, suscipit et, tempus nec, consequat sed, erat. Proin est. Proin dapibus. In facilisis sagittis libero. Vivamus nec enim. Cras magna. Donec eu eros. Vestibulum purus dui, viverra nec, sagittis at, laoreet at, augue. Integer mi ante, dictum id, posuere ac, malesuada non, nisi. Sed pulvinar elementum nisi. Nullam lacus erat, cursus sed, rutrum sit amet, interdum vel, quam.</p>";
		}
		
		if ($private) {
			$private = 1;
		} else {
			$private = 0;
		}
		
		if ($caller=="" && $parent_mID = getMenuParent($menuid)) {
			$content_array = getContentFromMenu($parent_mID);
			
			$cID = $content_array['content_id'];
			
			$sql = "SELECT template_id 
					FROM " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . " 
					WHERE id = '" . mysql_real_escape_string($cID) . "'";
			$result = my_mysql_query($sql);
			
			if (mysql_num_rows($result)>0) {			
				$row = mysql_fetch_array($result);
				
				if (!$template_id) {
					$template_id = $row['template_id'];
				}
			} else {
				$sql = "SELECT default_template_id
						FROM " . DB_NAME_PREFIX . "contenttypes
						WHERE content_type_id = '" . mysql_real_escape_string($GLOBALS['cType']) . "'";
				
				$result = my_mysql_query($sql);
				
				$row = mysql_fetch_array($result);
				
				if (!$template_id) {
					$template_id = $row['default_template_id'];
				}
			}
		} else {
			$sql = "SELECT default_template_id
					FROM " . DB_NAME_PREFIX . "contenttypes
					WHERE content_type_id = '" . mysql_real_escape_string($GLOBALS['cType']) . "'";
			
			$result = my_mysql_query($sql);
			
			$row = mysql_fetch_array($result);
			
			if (!$template_id) {
				$template_id = $row['default_template_id'];
			}
		}
		
		$sql = "SELECT MAX(id)+1 AS NewID 
				FROM " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'];
		
		$result = my_mysql_query($sql);
		

		$row = mysql_fetch_array($result);
		
		if ($row[0]!="") {
			$newid = $row[0];
		} else {
			$newid = 1;			
		}
		
		$sql = "INSERT INTO " . DB_NAME_PREFIX . "content_" . $GLOBALS['cType'] . " 
					SET id = " . $newid . ",
					title = '" . mysql_real_escape_string($page_title) . "',
					owner_id = " . $_SESSION["admin_userid"] . ",
					owner_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
					creating_author_id = " . $_SESSION["admin_userid"] . ",
					creating_author_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
					created_datetime = NOW(),
					last_author_id = " . $_SESSION["admin_userid"] . ",
					last_author_authtype = '" . mysql_real_escape_string($_SESSION['admin_authtype']) . "',
					content_head = '" . mysql_real_escape_string($content_head) . "',
					content_bodytop = '" . mysql_real_escape_string($content_bodytop) . "',
					content_bodymain = '" . mysql_real_escape_string($content_bodymain) . "',
					content_bodyfoot = '" . mysql_real_escape_string($content_bodyfoot) . "',
					publication_date = " . $publication_date . ",
					language_id = '" . $language_id . "',
					private = '" . $private . "',
					template_id = " . $template_id;
		
		$result = my_mysql_query($sql);
		
		if ($caller=="" AND $menuid<>"") {
			$sql = "UPDATE " . DB_NAME_PREFIX . "menuitems 
						SET content_id = " . $newid . ", 
						content_type = '" . mysql_real_escape_string($GLOBALS['cType']) . "' , 
						language_id = '" . mysql_real_escape_string($language_id) . "'
						WHERE id = " . $menuid;
			
			$result = my_mysql_query($sql);
		}
		
		return true;
	
	} else {
		return $error;
	}
}




function deleteRawVersion($cID, $cVersion, $deleteDirectories=false) {
	
}

?>