showPublishButton = false;

function checkKnownParentIds() {
	return get('known_parent_ids').value.split(',')[get('curr_language').selectedIndex];
}

//Disabled/Enable the radio buttons and text field for the Menu Items as needed
function checkIfWeCanCopyMenus() {
	
	//Check if we should enable the "Yes/No" radio buttons for copying the menu
	//Check the knownParentIds array to see if we can do the copy.
	var canCopyMenus = checkKnownParentIds();
	
	//If not, also set their value to "No"
	if (!canCopyMenus) {
		get('menu_no').checked = true;
	}
	
	//Check whether we should allow the user to enter a new title for the menu
	var canTypeMenuTitle = canCopyMenus && get('menu_yes').checked;
	
	get('menu_yes').disabled = !canCopyMenus;
	get('menu_no').disabled = !canCopyMenus;
	get('menu_title').disabled = !canTypeMenuTitle;
}

//If the language is changed, changed the title between "blah (copy)" and "blah [[TRANSLATE TO blah]"
function langChange() {

	if (get('curr_language').value == get('language').value) {
		get('title').value = get('current_title').value + get('copy_phrase').value;
	} else {
		get('title').value = get('current_title').value + ' [TRANSLATE TO ' + get('curr_language').value + ']';
	}
	
	checkIfWeCanCopyMenus();
}



//The item-key in Storekeeper is not made up from the source item's info
function setStorekeeperItemKey () {
	storekeeperItemKey = primaryKey.cID + "_" + primaryKey.cType + "_" + primaryKey.cVersion;
}


tabInitialiseAfterLoad();

checkIfWeCanCopyMenus();