<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */


//Create the tables needed for basic user commenting functionality
revision( 1

//Create a table to store user comments
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]][[TRIBIQ_COMMENTS_PREFIX]]user_comments`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]][[TRIBIQ_COMMENTS_PREFIX]]user_comments`(
		`id` int(10) unsigned NOT NULL auto_increment,
		`content_id` int(10) unsigned NOT NULL,
		`content_type` varchar(20) NOT NULL,
		`date_posted` datetime NOT NULL,
		`date_updated` datetime NULL,
		`employee_post` tinyint(1) NOT NULL default 0,
		`poster_id` int(10) unsigned NOT NULL,
		`updater_id` int(10) unsigned NULL,
		`message_text` text NOT NULL,
		`rating` int(10) signed NOT NULL default 0,
		PRIMARY KEY  (`id`),
		INDEX (`content_id`, `content_type`),
		INDEX (`poster_id`),
		FULLTEXT KEY (`message_text`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

//Create a table to show extra information on users, such as post counts and signatures
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]][[TRIBIQ_COMMENTS_PREFIX]]users`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]][[TRIBIQ_COMMENTS_PREFIX]]users`(
		`user_id` int(10) unsigned NOT NULL,
		`latest_activity` datetime NULL,
		`previous_visit` datetime NULL,
		`post_count` int(10) unsigned NOT NULL default 0,
		`karma` int(10) signed NOT NULL default 0,
		`signature` varchar(255) NOT NULL default '',
		`email_upon_pm` tinyint(1) NOT NULL default '0',
		PRIMARY KEY  (`user_id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql

//Create a table to store extra information on content items with comments
//This mirrors a content id and a content type (usually html, but this is not a restriction) from the CMS
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]][[TRIBIQ_COMMENTS_PREFIX]]comment_content_items`
_sql

, <<<_sql
	CREATE TABLE `[[DB_NAME_PREFIX]][[TRIBIQ_COMMENTS_PREFIX]]comment_content_items`(
		`content_id` int(10) unsigned NOT NULL,
		`content_type` varchar(20) NOT NULL,
		`date_updated` datetime NULL,
		`updater_id` int(10) unsigned NULL,
		`post_count` int(10) unsigned NOT NULL default 0,
		`locked` tinyint(1) NOT NULL default 0,
		PRIMARY KEY (`content_id`, `content_type`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8
_sql


//Change the logic for tracking read/unread threads
);	revision( 5
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]][[TRIBIQ_COMMENTS_PREFIX]]users`
	DROP COLUMN `previous_visit`
_sql


//Drop a table which was created but not implemented for clarity
);	revision( 23
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]][[TRIBIQ_COMMENTS_PREFIX]]user_messages`
_sql


//Drop another table which was created but not implemented
);	revision( 24
, <<<_sql
	DROP TABLE IF EXISTS `[[DB_NAME_PREFIX]][[TRIBIQ_COMMENTS_PREFIX]]user_comment_ratings`
_sql


//Add a status column to comments
);	revision( 28
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]][[TRIBIQ_COMMENTS_PREFIX]]user_comments`
	ADD COLUMN `status` enum('draft','pending','published') NOT NULL default 'published'
	AFTER `date_updated`
_sql


//Add aan index on date_posted
);	revision( 36
, <<<_sql
	ALTER TABLE `[[DB_NAME_PREFIX]][[TRIBIQ_COMMENTS_PREFIX]]user_comments`
	ADD INDEX (`date_posted`)
_sql

);

?>