<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */





class tribiq_comments extends plugin_base_class {
	
	protected $show = true;
	protected $mode = 'showPosts';
	var $reloadPage = false;
	var $modPrivs = false;
	var $postPrivs = false;
	var $newThreadPrivs = false;
	
	var $showScreennames = false;
	var $forum = array();
	var $thread = array();
	var $posts = false;
	var $post = array();
	var $page = 1;
	
	var $mergeFields = array();
	var $sections = array();
	
	
	function init() {
		
		$this->registerGetRequest('comm_page', 1);
		$this->page = ifNull((int) $this->request('comm_page'), 1);
		
		$this->runCheckPrivs();
		
		$this->loadThreadInfo();
		$this->loadPagination();
		$this->loadPosts();
		
		$this->threadActionHandler();
		
		$this->threadSelectMode();
		
		return true;
	}


	
	function showSlot() {
		if (!$this->show) {
			return;
		}
		
		if (arrayKey($_SESSION, 'extranetUserID')) {
			$this->updateUserLatestActivity(arrayKey($_SESSION, 'extranetUserID'));
		}
		
		$mode = $this->mode;
		$this->$mode();
	}
	
	
	
	
	
	
	//Add a comment onto the thread
	function addReply($userId, &$messageText) {
		
		//Make sure that thid user has an entry in the forum user details table
		$this->checkUserIsInForumsUserTable($userId);
		
		//Add the comment
		$sql = "
			INSERT INTO ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "user_comments SET
				content_id = ". (int) $this->cID. ",
				content_type = '". mysql_real_escape_string($this->cType). "',
				date_posted = NOW(),
				employee_post = ". (int) issetArrayKey($_SESSION, 'extranetUserIsAnEmployee'). ",
				poster_id = ". (int) $userId. ",
				message_text = '". mysql_real_escape_string($messageText). "'";
		
		$result = my_mysql_query($sql);
		
		//Update the user's post count
		$sql = "
			UPDATE ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "users SET
				post_count = post_count + 1
			WHERE user_id = ". (int) $userId;
		
		$result = my_mysql_query($sql);
		
		//Update the post count for the thread
		$sql = "
			UPDATE ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "comment_content_items SET
				date_updated = NOW(),
				updater_id = ". (int) $userId. ",
				post_count = post_count + 1
			WHERE content_id = ". (int) $this->cID. "
			  AND content_type = '". mysql_real_escape_string($this->cType). "'";
		
		$result = my_mysql_query($sql);
		
		//Show the last page
		$this->page = $this->setting('order') == 'MOST_RECENT_FIRST'? 1 : -1;
		
		$this->sendEmailNotification($userId, $messageText);
	}
	
	
	function canDeleteThread() {
		return false;
	}
	
	
	function canDeletePost(&$post) {
		if (issetArrayKey($post, 'first_post')) {
			return false;
		} elseif ($this->modPrivs) {
			return true;
		} else {
			return arrayKey($_SESSION, 'extranetUserID')
				&& $this->setting('allow_user_delete_own_post')
				&& $post['poster_id'] == arrayKey($_SESSION, 'extranetUserID')
				&& !$this->locked();
		}
	}
	
	
	function canEditFirstPost(&$post) {
		return false;
	}
	
	
	function canEditPost(&$post) {
		if (issetArrayKey($post, 'first_post')) {
			return false;
		} elseif ($this->modPrivs) {
			return true;
		} else {
			return arrayKey($_SESSION, 'extranetUserID')
				&& $this->setting('allow_user_edit_own_post')
				&& $post['poster_id'] == arrayKey($_SESSION, 'extranetUserID')
				&& !$this->locked();
		}
	}
	
	
	function canLockThread() {
		return $this->modPrivs && !$this->locked();
	}
	
	
	function canMakeThread() {
		return false;
	}
	
	
	function canMoveThread() {
		return false;
	}
	
	
	function canMakePost() {
		return !$this->locked() && $this->postPrivs;
	}
	
	
	function canQuotePost() {
		return $this->canMakePost() && $this->setting('enable_reply_with_quote');
	}
	
	
	function canReportPost() {
		return $this->setting('enable_report_a_post') && $this->setting('email_subject_for_reports') && 
					($this->setting('enable_anonymous_report_a_post') || arrayKey($_SESSION, 'extranetUserID'));
	}
	
	
	function canUnlockThread() {
		return $this->modPrivs && $this->locked();
	}
	
	
	protected function checkForUnfocusedFieldsBeingSubmitted($field, $phrase) {
		if ($this->postVariables[$field] && $this->postVariables[$field] == $this->phrase($phrase)) {
			unset($this->postVariables[$field]);
		}
	}
	
	
	//Add action buttons to a post, as appropriate
	function checkPostActions(&$post, &$mergeFields, &$sections) {
		$controls = false;
		
		if ($this->canQuotePost()) {
			$controls = true;
			$sections['Quote_Post'] = true;
			$mergeFields['Quote_Post_Link'] = $this->refreshPluginSlotAnchor('&comm_page='. $this->page. '&comm_request=post_reply&comm_enter_text=1&comm_post='. $post['id']. '&forum_thread='. $this->thread['id']);
		}

		if ($this->canEditFirstPost($post)) {
			$controls = true;
			$sections['Edit_Post'] = true;
			$mergeFields['Edit_Post_Link'] = $this->refreshPluginSlotAnchor('&comm_page='. $this->page. '&comm_request=edit_first_post&comm_enter_text=1&comm_post='. $post['id']. '&forum_thread='. $this->thread['id']);
		
		} elseif ($this->canEditPost($post)) {
			$controls = true;
			$sections['Edit_Post'] = true;
			$mergeFields['Edit_Post_Link'] = $this->refreshPluginSlotAnchor('&comm_page='. $this->page. '&comm_request=edit_post&comm_enter_text=1&comm_post='. $post['id']. '&forum_thread='. $this->thread['id']);
		}

		if ($this->canDeletePost($post)) {
			$controls = true;
			$sections['Delete_Post'] = true;
			$mergeFields['Delete_Post_Link'] = $this->refreshPluginSlotAnchor('&comm_page='. $this->page. '&comm_request=delete_post&comm_confirm=1&comm_post='. $post['id']. '&forum_thread='. $this->thread['id']);
		}

		if ($this->canReportPost()) {
			$controls = true;
			$sections['Report_Post'] = true;
			$mergeFields['Report_Post_Link'] = $this->refreshPluginSlotAnchor('&comm_page='. $this->page. '&comm_request=report_post&comm_enter_text=1&comm_post='. $post['id']. '&forum_thread='. $this->thread['id']);
		}
		
		return $controls;
	}
	
	
	function runCheckPrivs() {
		
		if (!issetArrayKey($_SESSION, 'confirm_key')) {
			$_SESSION['confirm_key'] = randomString();
		}
		
		$this->showScreennames = (bool) getSiteConfig('user_use_screen_name');
		
		$this->modPrivs =
			checkPriv('_PRIV_MODERATE_USER_COMMENTS') || (
					$this->setting('enable_extranet_moderators')
				 && $this->setting('moderators')
				 && arrayKey($_SESSION, 'extranetUserID')
				 && checkUserInGroup($this->setting('moderators'))
			);
		
		$this->postPrivs =
			arrayKey($_SESSION, 'extranetUserID') && (
					$this->modPrivs
				 || !$this->setting('enable_posting_restrictions')
				 || !$this->setting('restrict_posting_to_group')
				 || checkUserInGroup($this->setting('restrict_posting_to_group'))
			);
	}
	
	
	//Check the mirror table to the users table for a given user, and add them in if needed
	function checkUserIsInForumsUserTable($userId) {
		
		$sql = "
			SELECT 1
			FROM ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "users
			WHERE user_id = ". (int) $userId. "
			LIMIT 1";
		
		$result = my_mysql_query($sql);
		
		if (!mysql_fetch_row($result)) {
			
			$sql = "
				INSERT INTO ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "users SET
					latest_activity = NOW(),
					user_id = ". (int) $userId;
			
			$result = my_mysql_query($sql);
		}
	}
	
	//Remove a comment from the thread
	function deletePost() {
		
		//Remove the comment
		$sql = "
			DELETE FROM ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "user_comments
			WHERE content_id = ". (int) $this->cID. "
			  AND content_type = '". mysql_real_escape_string($this->cType). "'
			  AND id = ". (int) $this->post['id'];
		
		$result = my_mysql_query($sql);
		
		//Update the user's post count
		$sql = "
			UPDATE ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "users SET
				post_count = post_count - 1
			WHERE post_count > 0
			  AND user_id = ". (int) $this->post['poster_id'];
		
		$result = my_mysql_query($sql);
		
		//Update the post count for the thread
		$sql = "
			UPDATE ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "comment_content_items SET
				post_count = post_count - 1
			WHERE post_count > 0
			  AND content_id = ". (int) $this->cID. "
			  AND content_type = '". mysql_real_escape_string($this->cType). "'";
		
		$result = my_mysql_query($sql);
	}
	
	//Edit a comment
	function editPost($userId, $messageText) {
		
		//Add the comment
		$sql = "
			UPDATE ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "user_comments SET
				message_text = '". mysql_real_escape_string($messageText). "',
				date_updated = NOW(),
				updater_id = ". (int) $userId. "
			WHERE content_id = ". (int) $this->cID. "
			  AND content_type = '". mysql_real_escape_string($this->cType). "'
			  AND id = ". (int) $this->post['id'];
		
		$result = my_mysql_query($sql);
		
		$this->sendEmailNotification($userId, $messageText);
	}
	
	//Get a User's titles
	function getUserTitles($userId) {
		
		$titles = array();
		
		$sql = "
			SELECT g.id
			FROM ". DB_NAME_PREFIX. "group_user_link AS l
			INNER JOIN ". DB_NAME_PREFIX. "groups AS g
			   ON l.group_id = g.id
			WHERE l.user_id = ". (int) $userId. "
			  AND g.public = 1";
		
		$result = my_mysql_query($sql);
		while($row = mysql_fetch_assoc($result)) {
			$titles[] = array('Title' => phrase('_GROUP_'. $row['id']));
		}
		
		if (count($titles)) {
			return $titles;
		} else {
			return false;
		}
	}
	
	//Get a user's screen_name, if we're showing screennames
	function getUserScreenName($userId) {
		if (!$userId) {
			return $this->phrase('_ANONYMOUS');
		} elseif ($this->showScreennames) {
			return getUserScreenName($userId);
		} else {
			return '';
		}
	}
	
	//Get a user's screen name, and add a Storekeeper Link if in Admin mode with the correct Perms
	function getUserScreenNameLink($userId, $screenName = false, $alwaysShowLink = false) {
		if ($screenName === false) {
			$screenName = $this->getUserScreenName($userId);
		}
		
		if (!$screenName) {
			return '';
		} elseif ($userId && ($alwaysShowLink || checkPriv('_PRIV_VIEW_USER'))) {
			return '<a href="'. $basePath. 'admin/storekeeper.php#tribiq__users//'. $userId. '/" target="_blank">'. htmlspecialchars($screenName). '</a>';
		} else {
			return htmlspecialchars($screenName);
		}
	}
	
	
	function loadThreadInfo() {
		
		//Get information on comments for this content item from the mirror table
		$sql = "
			SELECT
				0 AS id,
				date_updated,
				updater_id,
				post_count,
				locked
			FROM ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "comment_content_items
			WHERE content_id = ". (int) $this->cID. "
			  AND content_type = '". mysql_real_escape_string($this->cType). "'";
		
		$result = my_mysql_query($sql);
		
		if ($this->thread = mysql_fetch_assoc($result)) {
			return;
		}
		
		//If we didn't find a row, then add one in
		$sql = "
			INSERT INTO ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "comment_content_items SET
				content_id = ". (int) $this->cID. ",
				content_type = '". mysql_real_escape_string($this->cType). "'";
		my_mysql_query($sql);
		
		$this->thread = array();
		$this->thread['post_count'] = 0;
	}
	
	
	//Setup and generate Pagination
	function loadPagination() {
		
		if ($this->mode == 'showPosts') {
			$this->pageSize = ifNull((int) $this->setting('page_size_posts'), 12);
			
			//Don't show pagination if a specific post id is beind displayed
			if ($this->request('comm_post')) {
				return;
			}
			
			$pageCount = (int) ceil($this->thread['post_count'] / $this->pageSize);
			
			//Show the last page in the thread when adding a new reply
			if ($this->request('comm_enter_text') || $this->page == -1) {
				$this->page = $pageCount;
			}
			
			//Don't show pagination when the enter-reply box is displayed
			if ($this->request('comm_enter_text')) {
				return;
			}
			
			$paginationStyleSettingName = 'pagination_style_posts';
		
		} elseif ($this->mode == 'showThreads') {
			$this->pageSize = ifNull((int) $this->setting('page_size_threads'), 12);
			$pageCount = (int) ceil($this->forum['thread_count'] / $this->pageSize);
			
			$paginationStyleSettingName = 'pagination_style_threads';
		
		} elseif ($this->mode == 'showSearch' && $this->results) {
			$this->pageSize = ifNull((int) $this->setting('page_size_search'), 12);
			$pageCount = (int) ceil($this->results / $this->pageSize);
			
			$paginationStyleSettingName = 'pagination_style_search';
		
		} else {
			return;
		}
		
		
		$pages = array();
		for ($i=1; $i <= $pageCount; ++$i) {
			$pages[$i] = '&comm_page='. $i;
			
			if ($this->mode == 'showPosts' && $this->request('forum_thread')) {
				$pages[$i] .= '&forum_thread='. (int) $this->request('forum_thread');
			}
			
			if ($this->mode == 'showSearch') {
				$pages[$i] .= '&searchString='. rawurlencode($this->request('searchString'));
			}
		}
		
		$this->mergeFields['Pagination'] = '';
		$this->pagination($paginationStyleSettingName, $this->page, $pages, $this->mergeFields['Pagination']);
	}
	
	
	//Load all of the comments/posts within our current view range
	function loadPosts() {
		
		$this->posts = array();
	
		$sql = "
			SELECT
				id,
				date_posted,
				date_updated,
				status,
				employee_post,
				poster_id,
				updater_id,
				message_text,
				rating
			FROM ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "user_comments
			WHERE content_id = ". (int) $this->cID. "
			  AND content_type = '". mysql_real_escape_string($this->cType). "'";
		
		//Have the option to just display a specific post
		if ($this->request('comm_post')) {
			$sql .= "
			  AND id = ". (int) $this->request('comm_post');
		} else {
			$sql .= "
			ORDER BY id";
			
			//Normally, display posts in order, unless the MOST_RECENT_FIRST option is checked and we're not making a reply.
			if ($this->setting('order') == 'MOST_RECENT_FIRST' && !$this->request('comm_enter_text')) {
				$sql .= " DESC";
			}
			
			if ($this->setting('order') == 'MOST_RECENT_FIRST' && $this->request('comm_enter_text')) {
				$sql .= "
				LIMIT ". max(0, ($this->thread['post_count'] - $this->pageSize)). ", ". (int) $this->pageSize;
			} else {
				$sql .= "
				LIMIT ". (max($this->page - 1, 0) * $this->pageSize). ", ". (int) $this->pageSize;
			}
		}
		
		$result = my_mysql_query($sql);

		if ($this->request('comm_post')) {
			$this->posts[] = $this->post = mysql_fetch_assoc($result);
		} else {
			while($row = mysql_fetch_assoc($result)) {
				$this->posts[] = $row;
			}
		}
	}
	
	
	function locked() {
		return $this->thread['locked'];
	}
	
	
	function lockThread($lock) {
		
		$sql = "
			UPDATE ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "comment_content_items SET
				locked = ". (int) $lock. "
			WHERE content_id = ". (int) $this->cID. "
			  AND content_type = '". mysql_real_escape_string($this->cType). "'";
		
		$result = my_mysql_query($sql);
	}
	
	
	//Send an email notification for a reported post
	function reportPost() {
		require_once CMS_ROOT. 'libraries/mit/markitup/bbcode2html.inc.php';
		
		if (issetArrayKey($_SESSION, 'extranetUserID')) {
			$user = getUserDetails($_SESSION['extranetUserID']);
		} else {
			$user = array('email' => '', 'screen_name' => getPhrase('Anonymous'));
		}
		
		$request = '';
		if ($this->post('forum_thread')) {
			$request = '&forum_thread='. (int) $this->post('forum_thread');
		}
		
		$message = '
			<h1>'. htmlspecialchars($this->setting('email_subject_for_reports')). '</h1>
			<p>
				<b>'. getPhrase('URL:'). '</b>
				<a href="'. ($url = htmlspecialchars($this->linkToItem($this->cID, $this->cType, true, $request))). '">'. $url. '</a>
			</p>
			<p>
				<b>'. getPhrase('Poster:'). '</b>
				'. $this->getUserScreenNameLink($this->post['poster_id'], false, true). '
			</p>';
		
		if ($this->post['updater_id'] && $this->post['updater_id'] != $this->post['poster_id']) {
			$message .= '
				<p>
					<b>'. getPhrase('Updated by:'). '</b>
					'. $this->getUserScreenNameLink($this->post['updater_id'], false, true). '
				</p>';
		}
		
		$messageText = $this->post['message_text'];
		BBCode2Html($messageText,
			$this->setting('enable_colours'), $this->setting('enable_images'),
			$this->setting('enable_links'), $this->setting('enable_emoticons'));
		
		$message .= '
			<p>
				<b>'. getPhrase('Reported message:'). '</b>
				<br/>
				'. $messageText. '
			</p>
			<p>
				<b>'. getPhrase('Reported by:'). '</b>
				'. htmlspecialchars($user['screen_name']). '
			</p>';
		
		$messageText = $this->postVariables['comm_message'];
		BBCode2Html($messageText,
			$this->setting('enable_colours'), $this->setting('enable_images'),
			$this->setting('enable_links'), $this->setting('enable_emoticons'));
		
		$message .= '
			<p>
				<b>'. getPhrase("Reporter's comments:"). '</b>
				<br/>
				'. $messageText. '
			</p>';
		
		sendEmail(
			$this->setting('email_subject_for_reports'), $message,
			$this->setting('email_address_for_reports'), false,
			$user['email'], $user['screen_name']);
	}
		
	protected function sendEmailNotification($userId, $messageText) {
		if ($this->setting('send_notification_email')
		 && $this->setting('notification_email_address')
		 && $this->setting('notification_email_template')
		 && inc('tribiq_email_template_manager')) {
			$formFields = array(
				'COMMENT' => $messageText,
				'LINK' => $this->linkToItem($this->cID, $this->cType, true),
				'TITLE' => getItemTitle($this->cID, $this->cType),
				'USERNAME' => userUsername($userId));
			
			tribiq_email_template_manager::sendEmailsUsingTemplate(
				$this->setting('notification_email_address'),
				$this->setting('notification_email_template'),
				$formFields);
		}
	}
	
	
	//Show an "are you sure" box
	function showConfirmBox($message) {

		$this->sections['Confirmation_Box'] = array();
		$this->sections['Confirmation_Box']['Confirmation_Message'] = htmlspecialchars($message);
		$this->sections['Confirmation_Box']['Cancel_Link'] = $this->refreshPluginSlotAnchor('&comm_page='. $this->page. '&forum_thread='. $this->thread['id'], false);
		
		$this->sections['Confirmation_Box']['Open_Form'] = $this->openForm(). 
			$this->remember('comm_request').
			$this->remember('comm_page').
			$this->remember('comm_confirm').
			$this->remember('comm_post').
			$this->remember('forum_thread');
		$this->sections['Confirmation_Box']['Close_Form'] = $this->closeForm();
	}
	
	
	function showPosts() {
		
		$this->mergeFields['Post_Class'] = 'list_of_comments';
		$this->frameworkHead('Posts', 'Post', $this->mergeFields, $this->sections);
		
		if ($this->posts) {
			require_once CMS_ROOT. 'libraries/mit/markitup/bbcode2html.inc.php';
			
			$first = true;
			foreach($this->posts as &$post) {
				
				$sections = array();
				$mergeFields = array();
				
				if ($first && $this->thread['title']) {
					$first = false;
					$sections['Show_Thread_Title'] = true;
					$mergeFields['Thread_Title'] = htmlspecialchars($this->thread['title']);
				}
				
				$mergeFields['Date_Posted'] = formatDateTimeNicely($post['date_posted'], $this->setting('date_format'));
				$mergeFields['Post_Text'] = $post['message_text'];
				$mergeFields['Employee'] = $post['employee_post'] && $this->setting('mark_employee_posts')? 'employee' : '';
				
				BBCode2Html($mergeFields['Post_Text'],
					$this->setting('enable_colours'), $this->setting('enable_images'),
					$this->setting('enable_links'), $this->setting('enable_emoticons'));
				$this->showUserInfo($mergeFields, $sections, $post['poster_id']);
				
				if ($this->request('comm_confirm') || $this->request('comm_enter_text') || !($this->checkPostActions($post, $mergeFields, $sections))) {
					$this->framework('Post', $mergeFields, $sections);
				} else {
					$sections['Post_Controls'] = true;
					$this->framework('Post', $mergeFields, $sections);
				}
			}
		}
		
		$this->frameworkFoot('Posts', 'Post', $this->mergeFields, $this->sections);
	}
	
	
	//Show a post entry screen, with a TinyMCE box for inputting a message
	//Called with different options, it can also be used for quoting a post, editing a post or making a new thread
	function showPostScreen($submitButtonText, $quoteMode, $postIsNewThread = false) {
		
		//IE6 doesn't like AJAX reloads with PunyMCE in them; give it a full page load
		if (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 6') !== false) {
			foreach ($this->getVariables as $var => $value) {
				$this->registerGetRequest($var);
			}
			$this->forcePageReload();
		}
	
		$mergeFields = array();
		
		if ($postIsNewThread || $this->post['first_post']) {
			$this->sections['Show_Post_Title'] = true;
			
			if ($this->postVariables['comm_title']) {
				$mergeFields['Post_Title'] = htmlspecialchars($this->postVariables['comm_title']);
			
			} elseif (!$this->post['id']) {
				$mergeFields['Post_Title'] = '';
			
			} else {
				$mergeFields['Post_Title'] =  htmlspecialchars($this->thread['title']);
			}
			
			$default = '';
			if (!$mergeFields['Post_Title']) {
				$mergeFields['Post_Title'] = $this->phrase('_ENTER_A_TITLE');
				$default = 'class="no_focus" onfocus="tribiq_comments.checkFocus(this);"';
			}
			
			$mergeFields['Post_Title'] = '<input type="text" name="comm_title" name="comm_title" '. $default. ' value="'. $mergeFields['Post_Title']. '"/>';
		}
	

		$mergeFields['Submit_Button_Text'] = $submitButtonText;
		
		if ($postIsNewThread) {
			$mergeFields['Cancel_Link'] = $this->linkToItemAnchor($this->forum['forum_content_id'], $this->forum['forum_content_type'], false);
		} else {
			$mergeFields['Cancel_Link'] = $this->refreshPluginSlotAnchor('&comm_page='. $this->page. '&forum_thread='. $this->thread['id']);
		}

		$this->showUserInfo($mergeFields, $this->sections, arrayKey($_SESSION, 'extranetUserID'));
		
		
		if ($this->postVariables['comm_message']) {
			$mergeFields['Post_Text'] = htmlspecialchars($this->postVariables['comm_message']);
		
		} elseif ($quoteMode == 'edit' && issetArrayKey($this->post, 'id')) {
			$mergeFields['Post_Text'] =  htmlspecialchars($this->post['message_text']);
			
		} elseif ($quoteMode == 'quote' && $this->canQuotePost() && issetArrayKey($this->post, 'id')) {
			$mergeFields['Post_Text'] =
				htmlspecialchars(
					'[quote]'.
						'[b]'. $this->phrase('_SAID', array('user' => $this->getUserScreenName($this->post['poster_id']))). '[/b]'. "\n".
						$this->post['message_text'].
					"[/quote]\n<br/>"
				);
		
		} else {
			$mergeFields['Post_Text'] = '';
		}
		
		$empty = 0;
		$default = 'class="bbcode"';
		if (!$mergeFields['Post_Text']) {
			$empty = 1;
			$mergeFields['Post_Text'] = $this->phrase('_ENTER_A_MESSAGE');
		}
		
		$mergeFields['Post_Text'] = '<textarea id="editor__'. $this->containerId. '" name="comm_message">'. $mergeFields['Post_Text']. '</textarea>';
		
		
		$mergeFields['Open_Form'] = $this->openForm(). 
			$this->remember('comm_request').
			$this->remember('comm_page').
			$this->remember('comm_enter_text').
			$this->remember('comm_post').
			$this->remember('forum_thread');
		$mergeFields['Close_Form'] = $this->closeForm();
		
		$this->sections['Post_Message'] = $mergeFields;
		
		
		if ($this->post('comm_enter_text')) {
			//Hack for a bug in Firefox and reloading TinyMCE via AJAX
			$this->callScript(
				'tribiq_comments', 'loadWithDelay',
				$this->containerId,
				(int) $this->setting('enable_colours'),
				(int) $this->setting('enable_images'),
				(int) $this->setting('enable_emoticons'),
				(int) $this->setting('enable_links'),
				$empty);
		} else {
			$this->callScript(
				'tribiq_comments', 'load',
				$this->containerId,
				(int) $this->setting('enable_colours'),
				(int) $this->setting('enable_images'),
				(int) $this->setting('enable_emoticons'),
				(int) $this->setting('enable_links'),
				$empty);
		}
	}
	
	
	//Show/hide the action buttons for the current thread
	function showThreadActions() {
		
		if ($this->canMakePost()) {
			$this->sections['Add_Reply'] = true;
			$this->mergeFields['Add_Reply_Link'] = $this->refreshPluginSlotAnchor('&comm_page='. $this->page. '&comm_request=post_reply&comm_enter_text=1&forum_thread='. $this->thread['id'], false);
			
		} elseif ($this->locked()) {
			if (!$this->canUnlockThread()) {
				$this->sections['Thread_Locked'] = true;
			}
			
		} elseif (!issetArrayKey($_SESSION, 'extranetUserID') && ($loginCID = getLanguageDefaultExtranetPage($_SESSION['user_lang']))) {
			$this->sections['Login_To_Post'] = true;
			$this->mergeFields['Login_To_Post_Link'] = $this->linkToItemAnchor($loginCID);
		}
		
		if ($this->canLockThread()) {
			$this->sections['Lock_Thread'] = true;
			$this->mergeFields['Lock_Thread_Link'] = $this->refreshPluginSlotAnchor('&comm_page='. $this->page. '&comm_request=lock_thread&comm_confirm=1&forum_thread='. $this->thread['id'], false);
			
		} elseif ($this->canUnlockThread()) {
			$this->sections['Unlock_Thread'] = true;
			$this->mergeFields['Unlock_Thread_Link'] = $this->refreshPluginSlotAnchor('&comm_page='. $this->page. '&comm_request=unlock_thread&comm_confirm=1&forum_thread='. $this->thread['id'], false);
		}
		
		if ($this->canMoveThread()) {
			$this->sections['Move_Thread'] = true;
			$this->mergeFields['Move_Thread_Link'] = 'href="#" onclick="'. $this->pluginClassName. ".moveThread('". $this->slotName. "', '". getPhrase('Move Thread to a different Forum'). "', ". $this->forumId. ", ". $this->thread['id']. ", '". $_SESSION['confirm_key']. "'); return false;". '"';
		}
		
		if ($this->canDeleteThread()) {
			$this->sections['Delete_Thread'] = true;
			$this->mergeFields['Delete_Thread_Link'] = $this->refreshPluginSlotAnchor('&comm_request=delete_thread&comm_confirm=1&forum_thread='. $this->thread['id'], false);
		}
	}
	
	
	//Show detailed information on one user, to appear next to their post
	function showUserInfo(&$mergeFields, &$sections, $userId) {
		
		if (!$userId) {
			$mergeFields['Username'] = $mergeFields['Username_Link'] = htmlspecialchars($this->phrase('_ANONYMOUS'));

			if ($this->setting('show_user_avatars')) {
				$sections['Show_Avatar'] = $sections['Posting_Show_Avatar'] = true;
				$mergeFields['Src'] = htmlspecialchars(getUserImageSrc(0));
			}

			return;
		}

		$sql = "
			SELECT
				latest_activity > NOW() - INTERVAL 10 MINUTE AS `online`,
				post_count
			FROM ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "users
			WHERE user_id = ". (int) $userId;
		$result = my_mysql_query($sql);
		
		$forumDetails = mysql_fetch_assoc($result);
		$coreDetails = getUserDetails($userId);
		
		if ($this->setting('show_user_avatars')) {
			$sections['Show_Avatar'] = $sections['Posting_Show_Avatar'] = true;
			$mergeFields['Src'] = htmlspecialchars(getUserImageSrc($userId));
		}
		
		if ($this->showScreennames) {
			$mergeFields['Username'] = htmlspecialchars($coreDetails['screen_name']);
			$mergeFields['Username_Link'] = $this->getUserScreenNameLink($userId, $coreDetails['screen_name']);
		}
		
		if ($this->setting('show_user_job_titles')) {
			$sections['Show_User_Title'] = $sections['Posting_Show_Title'] = $this->getUserTitles($userId);
		}
		
		if ($this->setting('show_user_online_status')) {
			if ($forumDetails['online']) {
				$sections['Show_Online'] = $sections['Posting_Show_Online'] = true;
			} else {
				$sections['Show_Offline'] = $sections['Posting_Show_Offline'] = true;
			}
		}
		
		if ($this->setting('show_user_post_counts')) {
			$sections['Show_Post_Count'] = $sections['Posting_Show_Post_Count'] = true;
			$mrg = array('post_count' => $forumDetails['post_count']);
			$mergeFields['Post_Count'] = $this->phrase('_POST_COUNT', $mrg);
		}
		
		if ($this->setting('show_user_join_dates')) {
			$sections['Show_Join_Date'] = $sections['Posting_Show_Join_Date'] = true;
			$mrg = array('date' => formatDateNicely($coreDetails['created_date'], $this->setting('date_format')));
			$mergeFields['Join_Date'] = $this->phrase('_JOIN_DATE', $mrg);
		}
	}
	
	//Handle any requests the users ask for
	function threadActionHandler() {
		
		$this->checkForUnfocusedFieldsBeingSubmitted('comm_message', '_ENTER_A_MESSAGE');
		
		if ($this->post('comm_request')) {
			
			$failure = false;
			
			if ($this->post('comm_request') == 'post_reply' && $this->canMakePost()) {
				if ($this->postVariables['comm_message']) {
					$this->addReply(arrayKey($_SESSION, 'extranetUserID'), $this->postVariables['comm_message']);
				} else {
					//complain about required fields
					$failure = true;
				}
			
			} elseif ($this->post('comm_request') == 'delete_post' && $this->canDeletePost($this->post)) {
				$this->deletePost();
				
			} elseif ($this->post('comm_request') == 'edit_first_post' && $this->canEditFirstPost($this->post)) {
				if ($this->postVariables['comm_message'] && $this->postVariables['comm_title']) {
					$this->editFirstPost(arrayKey($_SESSION, 'extranetUserID'), $this->postVariables['comm_message'], $this->postVariables['comm_title']);
				} else {
					//complain about required fields
					$failure = true;
				}
				
			} elseif ($this->post('comm_request') == 'edit_post' && $this->canEditPost($this->post)) {
				if ($this->postVariables['comm_message']) {
					$this->editPost(arrayKey($_SESSION, 'extranetUserID'), $this->postVariables['comm_message']);
				} else {
					//complain about required fields
					$failure = true;
				}
				
			} elseif ($this->post('comm_request') == 'lock_thread' && $this->canLockThread()) {
				$this->lockThread(1);
				
			} elseif ($this->post('comm_request') == 'unlock_thread' && $this->canUnlockThread()) {
				$this->lockThread(0);
				
			} elseif ($this->post('comm_request') == 'delete_thread' && $this->canDeleteThread()) {
				$this->deleteThread();
				return;
				
			} elseif ($this->post('comm_request') == 'report_post' && $this->canReportPost()) {
				if ($this->post('comm_message')) {
					$this->reportPost();
				} else {
					//complain about required fields
					$failure = true;
				}
				
			}
			
			//Clear the requests made and reload the thread info if the action was successful
			if (!$failure) {
				$this->clearRequest('comm_post');
				$this->clearRequest('comm_request');
				$this->clearRequest('comm_confirm');
				$this->clearRequest('comm_enter_text');
				
				$this->loadThreadInfo();
				$this->loadPagination();
				$this->loadPosts();
			}
		}
		
	}
	
	
	function threadSelectMode() {
		
		if ($this->request('comm_confirm')) {
			if ($this->request('comm_request') == 'delete_post' && $this->canDeletePost($this->post)) {
				$this->showConfirmBox($this->phrase('_CONFIRM_DELETE_POST'));
				
			} elseif ($this->request('comm_request') == 'delete_thread' && $this->canDeleteThread()) {
				$this->showConfirmBox($this->phrase('_CONFIRM_DELETE_THREAD'));
				
			} elseif ($this->request('comm_request') == 'lock_thread' && $this->canLockThread()) {
				$this->showConfirmBox($this->phrase('_CONFIRM_LOCK_THREAD'));
				
			} elseif ($this->request('comm_request') == 'unlock_thread' && $this->canUnlockThread()) {
				$this->showConfirmBox($this->phrase('_CONFIRM_UNLOCK_THREAD'));
			}
			
		} elseif ($this->request('comm_enter_text')) {
			if ($this->request('comm_request') == 'edit_first_post' && $this->canEditFirstPost($this->post)) {
				$this->showPostScreen($this->phrase('_EDIT_POST'), 'edit', true);
			
			} elseif ($this->request('comm_request') == 'edit_post' && $this->canEditPost($this->post)) {
				$this->showPostScreen($this->phrase('_SAVE_POST'), 'edit');
			
			} elseif ($this->request('comm_request') == 'post_reply' && $this->canMakePost()) {
				$this->showPostScreen($this->phrase('_ADD_MESSAGE_SUBMIT'), 'quote');
			
			} elseif ($this->request('comm_request') == 'report_post' && $this->canReportPost()) {
				$this->showPostScreen($this->phrase('_REPORT_POST'), 'none');
			}
			
		} else {
			$this->showThreadActions();
		}
	}
	
	
	function updateUserLatestActivity($userId) {
		$sql = "
			UPDATE ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "users SET
				latest_activity = NOW()
			WHERE user_id = ". (int) $userId;
		my_mysql_query($sql);
	}
	
	
	
	
	
	
	
	public static function eventUserDeleted($userId) {
		$sql = "
			DELETE FROM ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "users
			WHERE user_id = ". (int) $userId;
		my_mysql_query($sql);
		
		$sql = "
			UPDATE ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "user_comments SET
				poster_id = 0,
				employee_post = 0
			WHERE poster_id = ". (int) $userId;
		my_mysql_query($sql);
		
		$sql = "
			UPDATE ". DB_NAME_PREFIX. TRIBIQ_COMMENTS_PREFIX. "user_comments SET
				updater_id = 0
			WHERE updater_id = ". (int) $userId;
		my_mysql_query($sql);
	}
	
	
	
	public static function commentsOnPage($cID, $cType = 'html') {
		return (int) getRow(
			TRIBIQ_COMMENTS_PREFIX. 'comment_content_items',
			'post_count',
			array('content_id' => (int) $cID, 'content_type' => $cType));
	}
	
	public static function commentsOnPage_framework(&$mergeFields) {
		$cID = $cType = false;
		
		pullFromArray($cID, $mergeFields, 'cid', 'contentid', 'id');
		pullFromArray($cType, $mergeFields, 'ctype', 'contenttype', 'type');
		
		return tribiq_comments::commentsOnPage($cID, $cType);
	}
	
	public function commentsOnThisPage_framework() {
		return tribiq_comments::commentsOnPage($this->cID, $this->cType);
	}
	
	public static function userLastPost($userId = false) {
		if ($userId === false && session('extranetUserID')) {
			$userId = session('extranetUserID');
		}
		
		if ($userId) {
			$sql = "
				SELECT content_id, content_type, date_posted, message_text
				FROM ". TRIBIQ_COMMENTS_PREFIX. "user_comments
				WHERE poster_id = ". (int) $userId. "
				ORDER BY date_posted DESC
				LIMIT 1";
			
			$result = my_mysql_query($sql);
			if ($row = mysql_fetch_assoc($result)) {
				return $row;
			}
		}
		
		return false;
	}
	
	public static function userLatestActivity($userId = false) {
		if ($userId === false && session('extranetUserID')) {
			$userId = session('extranetUserID');
		}
		
		if ($userId) {
			return getRow(
				TRIBIQ_COMMENTS_PREFIX. 'users',
				'latest_activity',
				array('user_id' => (int) $userId));
		} else {
			return false;
		}
	}
	
	public static function userPostCount($userId = false) {
		if ($userId === false && session('extranetUserID')) {
			$userId = session('extranetUserID');
		}
		
		if ($userId) {
			return (int) getRow(
				TRIBIQ_COMMENTS_PREFIX. 'users',
				'post_count',
				array('user_id' => (int) $userId));
		} else {
			return false;
		}
	}
	
	public static function userPostCount_framework(&$mergeFields) {
		$userId = false;
		
		pullFromArray($userId, $mergeFields, 'userid', 'user', 'id', 'poster');
		
		return tribiq_comments::userPostCount($userId);
	}
}
?>
