/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */


tribiq_content.createPrivateDraft = function(slotName, section) {
	var key = {}
	key.create_draft = true;
	key.section = section;
	key.cID = tribiq_content.cID;
	key.cType = tribiq_content.cType;
	key.cVersion = tribiq_content.cVersion;
	
	tribiq_content.message = tribiq_content.AJAX(key, true);
	
	if (tribiq_content.message) {
		setTimeout("tribiqA.floatingBox(tribiq_content.message, true, 'error');", 30);
	} else {
		tribiq_content.goToItem(tribiq_content.cID, tribiq_content.cType);
	}
}

tribiq_content.edit = function(slotName, section) {
	tribiq_content.refreshPluginSlot(slotName, {content__edit_slot: slotName, content__section: section});
}

tribiq_content.open = function(wide, containerId) {
	
	var theme_advanced_buttons1 = undefined,
		theme_advanced_buttons2 = undefined,
		theme_advanced_buttons3 = undefined,
		theme_advanced_buttons4 = undefined,
		theme_advanced_buttons5 = undefined;
	
	if (wide) {
		theme_advanced_buttons1 = "fullscreen,code,cleanup,|,save,|,pasteword,|,link,unlink,anchor,|,media,image,|,charmap,|,undo,redo,|,search,replace";
		theme_advanced_buttons2 = "visualaid,tablecontrols,|,hr,|,sub,sup,|,numlist,bullist,|,outdent,indent,blockquote";
		theme_advanced_buttons3 = "styleselect,formatselect,fontsizeselect,|,bold,italic,underline,strikethrough,|,removeformat,|,justifyleft,justifycenter,justifyright,justifyfull";
	} else {
		theme_advanced_buttons1 = "fullscreen,code,cleanup,|,save,|,pasteword,|,undo,redo";
		theme_advanced_buttons2 = "link,unlink,anchor,|,media,image,|,charmap,|,hr,|,sub,sup,|,blockquote,|,search,replace";
		theme_advanced_buttons3 = "visualaid,tablecontrols";
		theme_advanced_buttons4 = "bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,numlist,bullist,|,outdent,indent";
		theme_advanced_buttons5 = "styleselect,formatselect,fontsizeselect,|,removeformat";
	}
		//Ones I've missed out:
		//newdocument,ltr,rtl,emotions,print,preview

	
	$('#' + containerId + ' textarea.tinymce_content').tinymce({
		script_url: URLBasePath + 'libraries/lgpl/tinymce/tiny_mce.js',

		theme: "advanced",
		skin: "o2k7",
		skin_variant: "silver",
		
		plugins: "pagebreak,style,layer,table,tribiq_save,advhr,advimage,emotions,inlinepopups,insertdatetime,media,searchreplace" +
					",contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,advlist",
		//Ones I've missed out: preview,print

		content_css: URLBasePath + 'cmsstyles/skin.css.php?v=' + encodeURIComponent(window.tribiqCSSJSVersionNumber) + '&id=' + tribiq.skinId + '&editor=1' + (tribiq.useGZ? '' : '&gz=1'),
		inline_styles: false,
		convert_urls: false,
		
		theme_advanced_buttons1: theme_advanced_buttons1,
		theme_advanced_buttons2: theme_advanced_buttons2,
		theme_advanced_buttons3: theme_advanced_buttons3,
		theme_advanced_buttons4: theme_advanced_buttons4,
		theme_advanced_buttons5: theme_advanced_buttons5,

		theme_advanced_toolbar_location: "top",
		theme_advanced_toolbar_align: "left",
		theme_advanced_statusbar_location: "bottom",
		theme_advanced_resizing: true,
		
		file_browser_callback: "tribiq_content.SK",
		
		init_instance_callback: function(instance) {
			tinymce.dom.Event.add(instance.getWin(), 'resize', function(event) {
				var width = $('#' + containerId + ' .mceEditor iframe').width();
				
				if (tribiq_content.widths[containerId] != width) {
					$('#' + containerId + '__buttons').width(width);
				}
				
				tribiq_content.widths[containerId] = width;
			});
		}
	});
}
tribiq_content.widths = {};

tribiq_content.saveViaAJAX = function(el, close) {

	var slotName = tribiq.getSlotnameFromEl(el);
	var section = get('plgslt_' + slotName + '_section').value;
	var content = $('#plgslt_' + slotName + ' textarea').tinymce().getContent();
	
	var error = tribiq_content.AJAX(
			'cID=' + tribiq_content.cID + 
			'&cType=' + tribiq_content.cType + 
			'&cVersion=' + tribiq_content.cVersion + 
			'&content__section=' + section + 
			'&content__content=' + encodeURIComponent(content), true);
	
	if (error) {
		tribiq_content.floatingMessage(error, true, 'error');
	} else if (close) {
		tribiq_content.refreshPluginSlot(slotName);
	} else {
		tribiqA.notification(tribiqA.phrase.contentSaved);
	}
}

tribiq_content.SK = function(field_name, url, type, win) {
	
	tribiq_content.win = win;
	tribiq_content.field_name = field_name;
	
	if (type == 'file') {
		tribiqA.SK('tribiq_content', 'setLinkURL', false,
						'tribiq__content/item//' + tribiq_content.cType + '//item//' + tribiq_content.languageId + '//',
						'tribiq__content/content',
						'tribiq__content',
						'tribiq__content/content',
						false, undefined, undefined, undefined, true);
	
	} else if (type == 'image') {
		tribiqA.SK('tribiq_content', 'setImageURL', false,
						'tribiq__content/item//' + tribiq_content.cType + '//item//' + tribiq_content.languageId + '//images//' + tribiq_content.cID + '//',
						'tribiq__content/media/images',
						'tribiq__content/media/images',
						'tribiq__content/media/images',
						true, undefined, undefined, undefined, true);
	
	} else if (type == 'media') {
		tribiqA.SK('tribiq_content', 'setFlashURL', false,
						'tribiq__content/item//' + tribiq_content.cType + '//item//' + tribiq_content.languageId + '//movies//' + tribiq_content.cID + '//',
						'tribiq__content/media/movies',
						'tribiq__content/media/movies',
						'tribiq__content/media/movies',
						true, undefined, undefined, undefined, true);
	}
}

tribiq_content.setEditorField = function(value, fieldName) {
	if (!fieldName) {
		fieldName = tribiq_content.field_name;
	}
	
	tribiq_content.win.document.forms[0].elements[fieldName].value = value;
	
	if (tribiq_content.win.document.forms[0].elements[fieldName].onchange) {
		tribiq_content.win.document.forms[0].elements[fieldName].onchange();
	}
}

tribiq_content.setLinkURL = function(path, key, row) {
	//Get the URL via an AJAX program
	var URL = tribiq.pluginClassAJAX('tribiq_cms_core', key, true)
	
	tribiq_content.setEditorField(URL);
}

tribiq_content.setImageURL = function(path, key, row) {
	var imageURL = "cmsincludes/image.php?cID=" + tribiq_content.cID + "&cType=" + tribiq_content.cType + "&cVersion=" + tribiq_content.cVersion + "&filename=" + encodeURIComponent(row.filename);
	
	tribiq_content.setEditorField(imageURL);
}

tribiq_content.setFlashURL = function(path, key, row) {
	var flashURL = "cmsincludes/movie.php?cID=" + tribiq_content.cID + "&cType=" + tribiq_content.cType + "&cVersion=" + tribiq_content.cVersion + "&filename=" + encodeURIComponent(row.filename);
	
	tribiq_content.setEditorField(flashURL);
}

tribiq_content.close = function(el) {

	var slotName = tribiq.getSlotnameFromEl(el);
	
	tribiq_content.floatingMessage(
		tribiqA.phrase.closeEditorWarning,
		'<input type="button" class="submit_selected" value="' + tribiqA.phrase.abandonChanges + '" onclick="tribiq_content.refreshPluginSlot(\'' + slotName + '\');" />' +
		'<input type="button" class="submit" value="' + tribiqA.phrase.cancel + '"/>',
		true);
}