<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

class tribiq_ctype_event extends plugin_base_class {
	
	var $mergeFields = array();
	var $templateSections = array();
	
	function showSlot() {
		if ($this->cType!='event')
			$this->framework('Error_no_event_type_content');
		else{
			$sql = 'SELECT title,
						content_bodytop, 
						location_name,
						location_address1,
						location_address2,
						location_city,
						location_state,
						location_postcode,
						location_country_id,
						phone,
						email,
						website,
						start_time, 
						start_date, 
						end_date, 
						end_time ';
			$sql .= 'FROM '. DB_NAME_PREFIX . 'content_event ';
			$sql .= 'WHERE id =' . (int) $this->cID . ' AND version=' . (int)$this->cVersion;
			
			if (mysql_num_rows($result = my_mysql_query($sql))==1){
				$this->mergeFields = mysql_fetch_assoc($result);
				$this->mergeFields['start_date']=formatDateNicely(htmlspecialchars($this->mergeFields['start_date']),$this->setting('date_format'),false,false);
				$this->mergeFields['start_time']=formatTimeNicely(htmlspecialchars($this->mergeFields['start_time']),'%H:%i','');
				$this->mergeFields['end_date']=formatDateNicely(htmlspecialchars($this->mergeFields['end_date']),$this->setting('date_format'),false,false);
				$this->mergeFields['end_time']=formatTimeNicely(htmlspecialchars($this->mergeFields['end_time']),'%H:%i','');

				$this->mergeFields['content_bodytop'] = nl2br(htmlspecialchars($this->mergeFields['content_bodytop']));
				$this->mergeField['title'] = htmlspecialchars($this->mergeFields['title']);
				$this->mergeField['content_bodytop'] = htmlspecialchars($this->mergeFields['content_bodytop']);
				$this->mergeField['location_name'] = htmlspecialchars($this->mergeFields['location_name']);
				
				for ($i=1;$i<=4;$i++) {
					if ($this->mergeField['location_address1'] = htmlspecialchars($this->mergeFields['location_address1'])) {
						$this->templateSections['Location_Address1_' . $i] = true;
						$this->templateSections['Location_Address_' . $i] = true;
					}
					
					if ($this->mergeField['location_address2'] = htmlspecialchars($this->mergeFields['location_address2'])) {
						$this->templateSections['Location_Address2_' . $i] = true;
						$this->templateSections['Location_Address_' . $i] = true;
					}
					
					if ($this->mergeField['location_city'] = htmlspecialchars($this->mergeFields['location_city'])) {
						$this->templateSections['Location_City_' . $i] = true;
						$this->templateSections['Location_Address_' . $i] = true;
					}
					
					if ($this->mergeField['location_state'] = htmlspecialchars($this->mergeFields['location_state'])) {
						$this->templateSections['Location_State_' . $i] = true;
						$this->templateSections['Location_Address_' . $i] = true;
					}
	
					if ($this->mergeField['location_postcode'] = htmlspecialchars($this->mergeFields['location_postcode'])) {
						$this->templateSections['Location_Postcode_' . $i] = true;
						$this->templateSections['Location_Address_' . $i] = true;
					}
	
					if ($this->mergeField['location_country_id'] = htmlspecialchars($this->mergeFields['location_country_id'])) {
						$this->templateSections['Location_Country_Id_' . $i] = true;
						$this->templateSections['Location_Address_' . $i] = true;
					}
	
					if ($this->mergeField['location_phone'] = htmlspecialchars($this->mergeFields['location_phone'])) {
						$this->templateSections['Location_Phone_' . $i] = true;
						$this->templateSections['Location_Contact_' . $i] = true;
					}
	
					if ($this->mergeField['location_email'] = htmlspecialchars($this->mergeFields['location_email'])) {
						$this->templateSections['Location_Email_' . $i] = true;
						$this->templateSections['Location_Contact_' . $i] = true;
					}
	
					if ($this->mergeField['location_website'] = htmlspecialchars($this->mergeFields['location_website'])) {
						$this->templateSections['Location_Website_' . $i] = true;
						$this->templateSections['Location_Contact_' . $i] = true;
					}
				}
				

				if (($this->mergeFields['start_date']== $this->mergeFields['end_date']) || (!$this->mergeFields['end_date'])) {
					if ($this->mergeFields['start_time']!='')
						$this->framework('Event_details_single_day',$this->mergeFields,$this->templateSections);
					else
						$this->framework('Event_details_single_day_no_time',$this->mergeFields,$this->templateSections);
				}else{
					$this->framework('Event_details_many_days',$this->mergeFields,$this->templateSections);
				}
			}
			else
				$this->framework('Improper_events_count');
		}
	}	
}
?>
