<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */


class tribiq_extranet_change_email extends tribiq_extranet {
	
	
	public function init() {
		if ($this->post('action')=='prepare_email_change'){
			if (issetArrayKey($_SESSION, 'extranetUserID')) {
				if ($this->prepareEmailChange()){
					$this->mode = 'modeLoggedIn';
				} else {
					$this->mode = 'modeChangeEmailForm';
				}
			} else {
				$this->mode = 'modeLogin';
			}
		} elseif ($this->get('action')=='confirm_email'){
			if ($this->changeEmailAndLogUserIn()){
				$this->mode = 'modeLoggedIn';
			} else {
				$this->mode = 'modeLogin';
			}
		} else {
			if (issetArrayKey($_SESSION, 'extranetUserID')) {
				$this->mode = 'modeChangeEmailForm';
			} else {
				$this->mode = 'modeLogin';
			}
		} 
		return true;
	}

	public function modeLogin(){
		echo $this->phrase("_PLEASE_LOGIN");
	}

	public function changeEmailAndLogUserIn(){
		if (issetArrayKey($this->getVariables,'hash')){
			$sql = "SELECT 
						user_id,
						new_email,
						hash
					FROM " 
						. DB_NAME_PREFIX . TRIBIQ_EXTRANET_CHANGE_EMAIL_PREFIX . "new_user_emails 
					WHERE
						hash ='" . mysql_real_escape_string(arrayKey($this->getVariables,'hash')) . "'";
			
			$result = my_mysql_query($sql);
			if ($row = mysql_fetch_assoc($result)){
				$sql = "UPDATE "
							. DB_NAME_PREFIX . "users 
						SET 
							username = IF(email=username,'" . $row['new_email'] . "',username),
							email= '" . $row['new_email'] . "'
						WHERE 
							id = " . (int) $row['user_id'];
				my_mysql_query($sql);
				
				$sql = "DELETE FROM " 
						. DB_NAME_PREFIX . TRIBIQ_EXTRANET_CHANGE_EMAIL_PREFIX . "new_user_emails 
					WHERE
						hash ='" . mysql_real_escape_string(arrayKey($this->getVariables,'hash')) . "'";
				my_mysql_query($sql);
				
				logUserIn($row['user_id'],getUserDetails($row['user_id']));
				$this->message = $this->phrase('_EMAIL_CHANGED');
				return true;
			} else {
				$this->message = $this->phrase('_INVALID_LINK');
				return true;
			}
		}
		return false;
	}

	public function modeChangeEmailForm(){
		$this->addLoggedInLinks();
		
		$this->frameworkHead('Outer', 'Change_Email_Form', $this->objects, $this->subSections);
			echo $this->openForm();
					$this->framework('Change_Email_Form', $this->objects, $this->subSections);
			echo $this->closeForm();
		$this->frameworkFoot('Outer', 'Change_Email_Form', $this->objects, $this->subSections);
	}

	private function prepareEmailChange(){

		$this->validateFormFields('Change_Email_Form');
		if (!$this->errors){
		
			if (($password = $this->getPassword(arrayKey($_SESSION,'extranetUserID'))) === false) {
				$this->errors[] = array('Error'=>$this->phrase('_INCORRECT_PASSWORD'));
			}
	
			if ($password!=arrayKey($this->postVariables,'extranet_password')){
				$this->errors[] = array('Error'=>$this->phrase('_INCORRECT_PASSWORD'));
			}


			if (getUsernameAndPasswordFromEmail(arrayKey($this->postVariables,'extranet_email'))){
				$this->errors[] = array('Error'=>$this->phrase('_EMAIL_ALREADY_IN_USE'));
			}

			if(!$this->errors){
				if ($this->setting('confirmation_email_template') && $this->inc('tribiq_email_template_manager')){
					$hash = md5(arrayKey($this->postVariables,'extranet_email') . SITENAME . time()) . time();
					$sql = "REPLACE INTO " 
								. DB_NAME_PREFIX . TRIBIQ_EXTRANET_CHANGE_EMAIL_PREFIX . "new_user_emails 
							SET 
								user_id = " . (int) arrayKey($_SESSION,'extranetUserID') . ",
								new_email = '" . mysql_real_escape_string(arrayKey($this->postVariables,'extranet_email')) . "',
								hash = '" . $hash . "'";
					my_mysql_query($sql);

					$userDetails = getUserDetails(arrayKey($_SESSION,'extranetUserID'));
					$userDetails['New_Email'] =  arrayKey($this->postVariables,'extranet_email');
					$userDetails['Hash'] =  $hash;
					$userDetails['IP_Address'] = $_SERVER['REMOTE_ADDR'];
					$userDetails['CMS_URL'] = $this->absCMSDirURL();
					$userDetails['Email_Confirmation_Link'] = $this->linkToItem($this->cID, $this->cType, $fullPath = true, $request = '&action=confirm_email&hash='. $hash);
					
					if (!tribiq_email_template_manager::sendEmailsUsingTemplate(arrayKey($this->postVariables,'extranet_email'),$this->setting('confirmation_email_template'),$userDetails,array())){
						$this->errors[] = array('Error'=>$this->phrase('_COULD_NOT_SEND_CONFIRMATION_EMAIL'));
						return false;
					}

					$this->message = $this->phrase('_EMAIL_CHANGE_PREPARED');
					$this->mode = 'modeLoggedIn';
					return true;
				} else {
					$this->errors[] = array('Error'=>$this->phrase('_COULD_NOT_SEND_CONFIRMATION_EMAIL'));
					return false;
				}
			} else {
				return false;
			}
		}
	}
}
?>