<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */


class tribiq_extranet_change_password extends tribiq_extranet {
	
	public function init() {
		
		$this->mode = 'modeChangePassword';
		if (!issetArrayKey($_SESSION, 'extranetUserID')) {
			return false;
		}
		
		$this->lang = getLanguage();
		$this->manageCookies();
		
		if ($this->post('extranet_change_password')) {
			if ($this->changePassword()) {
				$this->message = $this->phrase('_PASSWORD_CHANGED');
				$this->mode = 'modeLoggedIn';
			}
		}
		
		return true;
	}

	//Display a form to let the user change their password
	protected function modeChangePassword() {
		$this->addLoggedInLinks();
		
		if (!issetArrayKey($_SESSION, 'extranetUserID')) {
			return false;
		}
		
		$this->frameworkHead('Outer', 'Change_Password_Form', $this->objects, $this->subSections);
			echo $this->openForm();
					$this->framework('Change_Password_Form', $this->objects, $this->subSections);
			echo $this->closeForm();
		$this->frameworkFoot('Outer', 'Change_Password_Form', $this->objects, $this->subSections);
	}
	
	
	//Attempt to change a user's password
	protected function changePassword() {
		
		//Look up what their current password is
		if (($oldPassword = $this->getPassword($_SESSION['extranetUserID'])) === false) {
			return false;
		}
		
		if (!$this->post('extranet_password')) {
			$this->errors[] = array('Error' => $this->phrase('_ERROR_OLD_PASSWORD'));
		} elseif ($this->post('extranet_password') !== $oldPassword) {
			$this->errors[] = array('Error' => $this->phrase('_ERROR_PASS_NOT_VERIFIED'));
		}

		if (!$this->post('extranet_new_password')) {
			$this->errors[] = array('Error' => $this->phrase('_ERROR_NEW_PASSWORD'));
		
		} elseif ($this->post('extranet_new_password') === $oldPassword) {
			$this->errors[] = array('Error' => $this->phrase('_ERROR_NEW_PASSWORD_SAME_AS_OLD'));
		
		} elseif (strlen($this->post('extranet_new_password')) < $this->setting('min_massword_length')) {
			$this->errors[] = array('Error' => $this->phrase('_ERROR_NEW_PASSWORD_LENGTH', array('min_massword_length' => $this->setting('min_massword_length'))));
		
		} elseif (!$this->post('extranet_new_password_confirm')) {
			$this->errors[] = array('Error' => $this->phrase('_ERROR_REPEAT_NEW_PASSWORD'));
		
		} elseif ($this->post('extranet_new_password') !== $this->post('extranet_new_password_confirm')) {
			$this->errors[] = array('Error' => $this->phrase('_ERROR_NEW_PASSWORD_MATCH'));
		}
		
		
		if (count($this->errors)) {
			return false;
		} else {
			$this->changeUsersPassword($_SESSION['extranetUserID'], $this->post('extranet_new_password'));
			return true;
		}
	}

	//Change an Extranet User's Password
	protected function changeUsersPassword($userId, $newPassword) {
		$sql = "
			UPDATE " . DB_NAME_PREFIX . "users 
			SET password = '" . mysql_real_escape_string( $newPassword ) . "' 
			WHERE id = " . (int) $userId;
		my_mysql_query( $sql );
	}
	
	
	//If a page is created with this Plugin as the Featured Plugin,
	//on a Language without a Change Password Page set, set this as the Change Password Page.
	public static function eventQuickAddContentItem($cID, $instance) {
		if ($instance['class_name'] == 'tribiq_extranet_change_password') {
			$sql = "
				UPDATE ". DB_NAME_PREFIX. "languages SET
					extranet_change_password_page_id = ". (int) $cID. "
				WHERE id = '". mysql_real_escape_string(getContentLang($cID, 'html')). "'
				  AND extranet_change_password_page_id = 0";
			my_mysql_query($sql);
		}
	}
	

}
?>