<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */




//Display a language picker, with hyperlinks to each language that a site is published in

class tribiq_language_picker extends plugin_base_class {
	
	var $links = array();
	var $mergeFields = array();
	var $sections = array();
	
	function init()	{
		$langs = array();
				
		foreach (getLanguages() as $langCfg) {
			$langs[$langCfg['id']] = array(
				'cID' => $langCfg['homepage_id'],
				'cType' => 'html',
				'equiv' => false,
				'flag' => $langCfg['flag'],
				'name' => $langCfg['language_local_name'],
				'current_language' => $langCfg['id'] == $_SESSION['user_lang']);
		}
		
		if ($this->setting('destination') != 'home' && $this->inc('tribiq_avls')) {
			foreach (tribiq_avls::equivalences($this->cID, $this->cType) as $langId => $equiv) {
				if (isset($langs[$langId])) {
					$langs[$langId]['cID'] = $equiv['cID'];
					$langs[$langId]['cType'] = $equiv['cType'];
					$langs[$langId]['equiv'] = true;
				}
			}
		}
		
		foreach ($langs as $langId => &$lang) {
			if ($this->setting('destination') != 'equiv_only' || $lang['equiv']) {
				$this->links[] = array(
					'Flag_Lang' => htmlspecialchars($lang['flag']),
					'Language_Link' => htmlspecialchars($this->linkToItem($lang['cID'], $lang['cType'])),
					'Language_Name' => htmlspecialchars($lang['name']),
					'View_This_Page_In_Lang' => 
						getVLPPhrase('_VIEW_THIS_PAGE_IN_LANG', $replace = array(), $langId, $returnFalseOnFailure = false, $pluginClass = 'tribiq_language_picker'),
					'section' => $langId == $_SESSION['user_lang']?
									'Selection_List_Entry_Current_Language'
								  : 'Selection_List_Entry_Other_Languages');
			}
		}
		
		$this->sections['Prompt_Phrase_Section'] = true;
	
		return !empty($this->links);
	}
	
	
	function showSlot()	{
		if (!empty($this->links)) {
			$this->frameworkHead('Outer', 'Selection_List_Entry_Current_Language', $this->mergeFields, $this->sections);
				foreach ($this->links as &$link) {
					$this->framework($link['section'], $link);
				}
			$this->frameworkFoot('Outer', 'Selection_List_Entry_Current_Language', $this->mergeFields, $this->sections);
		}
	}
	
	
}


?>
