<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */






//This Plugin attempts to load the Publication Date of the current item from the database, and display it
class tribiq_meta_data extends plugin_base_class {
	
	var $mergeFields = array();
	
	//The showSlot method is called by the CMS, and displays the Plugin on the page
	function showSlot() {
		$this->getContentItemMetaData();
		$this->framework('Outer',$this->mergeFields,$this->showSections);
	}
	
	
	//Attempt to look up the publication_date column from the database.
	function getContentItemMetaData() {
		
		//If looking something up about a content item, we need to make sure that we use the correct content-type
		//table by using the statement
		//		DB_NAME_PREFIX. "content_". mysql_real_escape_string($this->cType)
		//to get the name of the table.
		//In order to get the right row, we also need to ensure the content id (cID) and content version (cVersion) match
		$sql .= "
				SELECT IFNULL(IFNULL(publication_date, published_datetime), created_datetime) as _date,title,description,keywords,language_id
				FROM ". DB_NAME_PREFIX. "content_". mysql_real_escape_string($this->cType). "
				WHERE id = ". (int) $this->cID. "
				  AND version = ". (int) $this->cVersion;
		
		$result = my_mysql_query($sql);
		$row = mysql_fetch_assoc($result);
		
		//The formatDateNicely function can be used to convert the date from MySQL's default format into something more
		//readable by humans. It takes three settings: short, medium and long.
		//(What these actually look like are defined as site settings)
		if ($this->setting('show_date') && $this->setting('date_format')){
			$this->mergeFields['Date'] = formatDateNicely($row['_date'], $this->setting('date_format'));
			$this->showSections['show_date']=true;
		}
		if ($this->setting('show_title')){
			$this->mergeFields['Title'] =  htmlspecialchars($row['title']);
			$this->showSections['show_title']=true;
		}
		if ($this->setting('show_description')){
			$this->mergeFields['Description'] =  htmlspecialchars($row['description']);
			$this->showSections['show_description']=true;
		}
		if ($this->setting('show_keywords')){
			$this->mergeFields['Keywords'] =  htmlspecialchars($row['keywords']);
			$this->showSections['show_keywords']=true;
		}	
		if ($this->setting('show_language')){
			$this->mergeFields['Language'] =  htmlspecialchars($row['language_id']);
			$this->showSections['show_language']=true;
		}	
		
		if ($this->inc('tribiq_user_contributed_content_manager')){
			
			$sql =" SELECT user_id
					FROM " . DB_NAME_PREFIX . TRIBIQ_USER_CONTRIBUTED_CONTENT_MANAGER_PREFIX . "contributed_content_user 
					WHERE		content_item_id = " . (int) $this->cID . " 
						AND 	content_item_type = '" . $this->cType . "'";
			if (mysql_num_rows($result = my_mysql_query($sql))==1){
				$row = mysql_fetch_assoc($result);
				if ((($this->setting('show_contributor')=='show_to_contributor_only') && ($row['user_id']==arrayKey($_SESSION,'extranetUserID') || issetArrayKey($_SESSION,'admin_userid'))) || 
					($this->setting('show_contributor')=='show_to_everyone') ) {
					$user = getUserDetails($row['user_id']);
					if ($this->mergeFields['Contributor'] = arrayKey($user,'screen_name')){
						$this->showSections['show_contributor']= true;
					}
				}
					
			}					
		}
		
		if ($this->setting('show_categories') && is_array($itemCats = getContentItemCategories($this->cID, $this->cType, $this->cVersion, true))) {
			$this->showSections['show_categories']=true;
			$this->showSections['categories'] = array();
			
			$c = -1;
			foreach($itemCats as $cat) {
				++$c;
				$section = array('Category' => htmlspecialchars($cat['public_name']));
				
				if ($cat['landing_page_content_id'] && $cat['landing_page_content_type']) {
					$this->langEquivalentItem($cat['landing_page_content_id'], $cat['landing_page_content_type']);
					$section['Category_Link'] = $this->linkToItemAnchor($cat['landing_page_content_id'], $cat['landing_page_content_type']);
				}
				
				$this->showSections['categories'][] = $section;
			}
			
			$comma = $this->phrase('_COMMA');
			foreach ($this->showSections['categories'] as $i => &$section) {
				if ($i != $c) {
					$section['Comma'] = $comma;
				}
			}
		}
	}

	
	

}
?>
