<?php
if (!defined('NOT_ACCESSED_DIRECTLY')) exit;
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

class tribiq_slideshow extends tribiq_plugin_nest {
	
	var $lastTabNum = 0;
	
	public function init() {
		//Revert to normal nest behaviour when showing one specific Egg for the showFloatingBox/showIframe/showRSS methods
		if ($this->specificEgg()) {
			return tribiq_plugin_nest::init();
		}
		
		
		$this->loadTabs();
		
		if (empty($this->tabs)) {
			$this->tabs = array(1 => array('id' => 0, 'tab' => 1, 'tab_title' => ''));
		}
		
		foreach ($this->tabs as &$tab) {
			if ($this->loadTab($tab['tab'])) {
				$this->show = true;
				$this->tabNum =
				$this->lastTabNum = $tab['tab'];
			}
		}
		
		if ($this->checkFrameworkSectionExists('Tab')) {
			$this->sections['Tabs'] = true;
			$this->sections['Tab'] = array();
			
			$i = -1;
			foreach ($this->tabs as &$tab) {
				++$i;
				$link = 'href="#"';
				if ($this->setting('use_tab_clicks')) {
					$link .= ' onclick="return tribiq_slideshow.page(this, '. $i. ');"';
				} else {
					$link .= ' onclick="return false;"';
				}
				
				if ($this->setting('use_tab_hover')) {
					$link .= ' onmouseover="tribiq_slideshow.page(this, '. $i. ', true);" onmouseout="tribiq_slideshow.resume(this);"';
				}
				
				$this->sections['Tab'][$tab['tab']] = array(
					'Class' => 'tab_'. $i. ' tab',
					'Tab_Link' => $link,
					'Tab_Name' => htmlspecialchars($this->phrase($tab['tab_title'])));
			}
			
			$this->sections['Tab'][1]['Class'] .= '_on';
		}
		
		if ($this->checkFrameworkSectionExists('Next')) {
			$this->sections['Next'] = true;
			$this->mergeFields['Next_Link'] = 'href="#" onclick="return tribiq_slideshow.next(this);"';
			$this->mergeFields['Next_Disabled'] = '';
		}
		if ($this->checkFrameworkSectionExists('Prev')) {
			$this->sections['Prev'] = true;
			$this->mergeFields['Prev_Link'] = 'href="#" onclick="return tribiq_slideshow.prev(this);"';
			$this->mergeFields['Prev_Disabled'] = '';
		}
		
		$this->callScript('tribiq_slideshow', 'show',
			$this->containerId,
			$this->setting('fx'),
			(bool) $this->setting('sync'),
			$this->setting('use_timeout')? (int) $this->setting('timeout') : 0,
			(int) $this->setting('speed'),
			$this->setting('use_timeout')? checkPriv() || $this->setting('pause') : 0,
			!$this->setting('next_prev_buttons_loop'));
		
		$this->showInFloatingBox(false);
		return $this->show;
	}

	
	public function showSlot() {
		
		$this->addAdminControls();
		
		$this->frameworkHead(
			'Outer',
			'Plugins',
			$this->mergeFields,
			$this->sections);
		
		$first = true;
		foreach ($this->tabs as &$tab) {
			$this->frameworkHead(
				'Plugins',
				'Plugin',
				$this->mergeFields,
				$this->sections);
					
					foreach ($this->plugins[$tab['tab']] as $id => $slotNameNestId) {
						$this->showPlugin($id, $slotNameNestId);
					}
			
			$this->frameworkFoot(
				'Plugins',
				'Plugin',
				$this->mergeFields,
				$this->sections);
			
			//Hide the slides after slide one, until the jQuery slideshow Plugin kicks in and overrides this.
			if ($first) {
				if ($this->mergeFields['Nest']) {
					$this->mergeFields['Nest'] = substr($this->mergeFields['Nest'], 0, -1). ' ';
				} else {
					$this->mergeFields['Nest'] = 'style="';
				}
				
				$this->mergeFields['Nest'] .= 'display: none;"';
				$first = false;		
			}
		}
		
		$this->frameworkFoot(
			'Outer',
			'Plugins',
			$this->mergeFields,
			$this->sections);
	}
	
}

?>