<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

if ($_REQUEST['edit_profile']) {
	$_REQUEST['adminId'] = $_SESSION['admin_userid'];
	$_REQUEST['adminType'] = $_SESSION['admin_authtype'];
} elseif ($_REQUEST['id'] && !$_REQUEST['adminId']) {
	$_REQUEST['adminId'] = $_REQUEST['id'];
}

$tab_programs = array();
if ($_REQUEST['adminId'] && (checkPriv('_PRIV_VIEW_ADMIN') || ($_REQUEST['adminId'] == $_SESSION['admin_userid'] && $_REQUEST['adminType'] == $_SESSION['admin_authtype']))) {
	$tab_programs['admin_details'] = array('text' => getPhrase('_DETAILS'), 'max_height' => 350);
}
if ($_REQUEST['adminId'] && checkPriv('_PRIV_CHANGE_ADMIN_PASSWORD') && ($_REQUEST['adminType'] == 'local' || $_SESSION["admin_authtype"] == 'super')) {
	$tab_programs['admin_password'] = array('text' => getPhrase('_PASSWORD'), 'max_height' => 350);
}
if (!$_REQUEST['adminId'] && checkPriv('_PRIV_CREATE_ADMIN') && ($_REQUEST['adminType'] == 'local' || $_SESSION["admin_authtype"] == 'super')) {
	$tab_programs['admin_details'] = array('text' => getPhrase('_DETAILS'), 'max_height' => 350);
}

if ($_REQUEST['adminType'] == 'super') {
	if ($_REQUEST['adminId']) {
		$details = getAdminDetails($_REQUEST['adminId'], 'super');
		$title = getPhrase('Manage Super Administrator &quot;[[name]]&quot;', array('name' => htmlspecialchars($details['admin_username'])));
	} else {
		$title = getPhrase('Create a new Super Administrator');
	}
} else {
	$_REQUEST['adminType'] = 'local';
	if ($_REQUEST['adminId']) {
		$details = getAdminDetails($_REQUEST['adminId'], 'local');
		$title = getPhrase('Manage Local Administrator &quot;[[name]]&quot;', array('name' => htmlspecialchars($details['admin_username'])));
	} else {
		$title = getPhrase('Create a new Local Administrator');
	}
}

thickboxHeader($title, $tab_programs, 'Administrator', array('adminId', 'adminType', 'overview'));

echo '
	<script type="text/javascript">
		primaryKey.adminType = "'. ($_REQUEST['adminType'] == 'super'? 'super' : 'local'). '";
		function isPrimaryKeySet() {
			return primaryKey.adminId;
		}
	</script>';

thickboxFooter();
?>