<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

if ($_POST['adminId']) {
	if ($_REQUEST['adminId'] != $_SESSION['admin_userid'] && $_REQUEST['adminType'] != $_SESSION['admin_authtype']) {
		exitIfNotCheckPriv('_PRIV_VIEW_ADMIN');
	}
	$hasEditPermission = checkPriv('_PRIV_EDIT_ADMIN') && ($_POST['adminType'] == 'local' || $_SESSION["admin_authtype"] == 'super');
} else {
	exitIfNotCheckPriv('_PRIV_CREATE_ADMIN');
	$hasEditPermission = checkPriv('_PRIV_CREATE_ADMIN') && ($_POST['adminType'] == 'local' || $_SESSION["admin_authtype"] == 'super');
}

$noSaving = false;
$noValidation = false;
$showEditButton = $hasEditPermission && $_POST['adminId'];
$editMode = $_POST['formMode']=="edit" || !$_POST['adminId'];
require 'includes/common_head.inc.php';


//Saving data
if ($_POST['save']=="true") {
	
	$adminId = $_POST['adminId'];
	$adminType = $_POST['adminType'];
	saveAdmin($_POST, $adminId, $adminType);
	
	//Overwrite the adminId in the primary key if needed
	echo json_encode(array('adminId' => $adminId, 'adminType' => $adminType));
	

//Check if a form is valid
} elseif ($_POST['validate']) {

	$adminId = $_POST['adminId'];
	$adminType = $_POST['adminType'];
	echo json_encode(validateAdmin($_POST, $adminId, $adminType));
	

//Call the display form function.
} else {
	
	$adminDBDetails = array();
	$valuesInCache = $_POST;
	if ($_POST['adminId']) {
		//Load user details from the database if an id has been given
		$adminDBDetails = getAdminDetails($_POST['adminId'], $_POST['adminType'], false, false);
	} else {
		//Default new admins to fckeditor
		$valuesInCache['preferred_editor_id'] = 'fckeditor';
	}
	
	$aboveTableHTML = '';
	
	$requiredFields = array('username', 'password', 'password_reconfirm', 'status');
	
	if ($_POST['adminType'] == 'local') {
		$adminFields = getFields(DB_NAME_PREFIX, 'admins', true);
	} else {
		connectGlobalDB();
			$adminFields = getFields(DB_NAME_PREFIX_GLOBAL, 'superadmins', true);
		connectLocalDB();
	}
		
	$columnsNotToShow = array();
	$columnsNotToShow[] = 'id';
	$columnsNotToShow[] = 'status';
	$columnsNotToShow[] = 'last_login';
	$columnsNotToShow[] = 'use_language_id';
	$columnsNotToShow[] = 'password_salt';
	$columnsNotToShow[] = 'password_needs_changing';
	$columnsNotToShow[] = 'created_date';
	$columnsNotToShow[] = 'modified_date';
	$columnsNotToShow[] = 'note_email_min_priority';
	$columnsNotToShow[] = 'perm_view_users';
	$columnsNotToShow[] = 'perm_view_groups';
	$columnsNotToShow[] = 'perm_editmenu_jnr';
	$columnsNotToShow[] = 'perm_translate';
	$columnsNotToShow[] = 'perm_manageforum';
	
	$columnsNotToShow[] = 'perm_manage';
	$columnsNotToShow[] = 'perm_sysadmin';
	$columnsNotToShow[] = 'perm_publish';
	$columnsNotToShow[] = 'perm_author';
	$columnsNotToShow[] = 'perm_editmenu';
	$columnsNotToShow[] = 'perm_override_author_lock';
	$columnsNotToShow[] = 'perm_edit_users';
	$columnsNotToShow[] = 'perm_edit_groups';
	
	$columnsNotToShow[] = 'preferred_editor_id';
		
	
	if ($_POST['adminId']) {
		//Don't show the password fields on the details page for existing admins
		$columnsNotToShow[] = 'password';
		$columnsNotToShow[] = 'password_reconfirm';
		
		//Don't let admins remove their own manager rights!
		if ($_SESSION['admin_userid'] == $_POST['adminId'] && $_SESSION['admin_authtype'] == $_POST['adminType']) {
			if (isset($adminFields['perm_manage'])) {
				$adminFields['perm_manage']['Read Only'] = true;
			}
		}
	}
	
	
	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $adminFields, $requiredFields, $valuesInCache, $adminDBDetails, $columnsNotToShow);
}
?>