<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_EDIT_CONTENT_TYPE');
$hasEditPermission = checkPriv('_PRIV_EDIT_CONTENT_TYPE');

$noSaving = false;
$noValidation = true;
$showEditButton = $hasEditPermission && $_POST['contentTypeId'];
$editMode = $_POST['formMode']=="edit" || !$_POST['contentTypeId'];
require 'includes/common_head.inc.php';


//Get an array of settings for this content type
getContentTypeSettings($_POST['contentTypeId'], $fields, $dbDetails);

if ($fields['max_filesize']) {
	$fields['max_filesize']['Label'] = getPhrase('Maximum file size:');
}


//Saving data
if ($_POST['save']=="true") {
	
	$contentTypeId = $_POST['contentTypeId'];
	saveContentTypeSettings($_POST, $contentTypeId, $fields);
	
	//Overwrite the contentTypeId in the primary key if needed
	echo json_encode(array('contentTypeId' => $contentTypeId));
	

//Call the display form function.
} else {
	
	$valuesInCache = $_POST;
	
	$aboveTableHTML = '';
	
	$requiredFields = array();
		
	$columnsNotToShow = array();
	$columnsNotToShow[] = 'enable_print';
	$columnsNotToShow[] = 'enable_emailfriend';
	$columnsNotToShow[] = 'special_flag';
	$columnsNotToShow[] = 'bulk_upload';
	
	
	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $fields, $requiredFields, $valuesInCache, $dbDetails, $columnsNotToShow);
}
?>