<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_ENABLE_VLP');
$hasEditPermission = checkPriv('_PRIV_ENABLE_VLP');

$noSaving = false;
$noValidation = false;
$showEditButton = false;
$editMode = true;
require 'includes/common_head.inc.php';


//Get details on this Plugin
$langId = $_POST['lang'];


//Get details on every language on the site
$sql = "
	SELECT class_name, display_name, name
	FROM ". DB_NAME_PREFIX. "plugins
	WHERE vlp_class = class_name
	  AND status != '_ENUM_INSTALLED'
	ORDER BY display_name";

$plugins = array();
$result = my_mysql_query($sql);
while($row = mysql_fetch_assoc($result)) {
	$plugins[$row['class_name']] = $row;
}


//Check which packs have been installed
$sql = "
	SELECT DISTINCT plugin_class
	FROM ". DB_NAME_PREFIX. "visitor_phrases
	WHERE language_id = '". mysql_real_escape_string($langId). "'
	  AND plugin_class != ''";

$installedLanguages = array();
$result = my_mysql_query($sql);
while($row = mysql_fetch_assoc($result)) {
	if ($plugins[$row['plugin_class']]) {
		$plugins[$row['plugin_class']]['installed'] = true;
	}
}

//Check which languages are availible to this Plugin
$unsets = array();
foreach ($plugins as $key => &$plugin) {
	$plugin['importFiles'] = scanPluginPhraseDir($plugin['name']);
	$plugin['langs'] = array(0 => getPhrase(' -- Do not import Phrases -- '));
	
	foreach ($plugin['importFiles'] as $languageId => $file) {
		$plugin['langs'][$languageId] =
			getPhrase('Use [[filename]] ([[language_name]])', array(
				'filename' => htmlspecialchars($file),
				'language_name' => getLanguageName($languageId)));
	}
	
	if (count($plugin['langs']) == 1) {
		$unsets[] = $key;
	}
}

foreach ($unsets as $key) {
	unset($plugins[$key]);
}


//Saving data
if ($_POST['save']=="true") {
	
	foreach($plugins as &$plugin) {
		if ($_POST['plugin_'. $plugin['class_name']] && $plugin['importFiles'][$_POST['plugin_'. $plugin['class_name']]]) {
			$path = CMS_ROOT. 'plugins/'. $plugin['name']. '/phrases/';
			importVisitorLanguagePack($path. $plugin['importFiles'][$_POST['plugin_'. $plugin['class_name']]], $langId, $adding = false, $scanning = false, $forceLanguageIdOverride = true);
		}
	}
	
	echo json_encode(array());
	
//Check if a form is valid
} elseif ($_POST['validate']) {

	$errors = array();
	foreach($plugins as &$plugin) {
		if (!isset($_POST['plugin_'. $plugin['class_name']])) {
			$errors[] = getPhrase('Please confirm which Phrases you wish to Import.');
			break;
		}
	}

	echo json_encode(array('valid' => !count($errors), 'errArray' => $errors));



//Call the display form function.
} else {
	
	
	
	$requiredFields = array();
	$defaults = array();
	$fields = array();
	
	foreach ($plugins as &$plugin) {
		$fields['plugin_'. $plugin['class_name']] = array(
			'Type' => 'select',
			'Null' => 'NO',
			'Label' => htmlspecialchars($plugin['display_name']),
			'Options' => $plugin['langs']
		);
		
		//Don't set the default option to an action if the pack has already been installed
		if ($plugin['installed']) {
			$fields['plugin_'. $plugin['class_name']]['Options'][0] = getPhrase(' -- Phrases have already been imported -- ');
		
		//If a language on the site matches a language availible to the Plugin, default it to that language
		} elseif ($plugin['langs'][$langId]) {
			$defaults['plugin_'. $plugin['class_name']] = $langId;
		
		//Otherwise if there is a close match, use that
		} else {
			foreach ($plugin['langs'] as $pLangId => $pLang) {
				if (substr($langId, 0, 2) == substr($pLangId, 0, 2)) {
					$defaults['plugin_'. $plugin['class_name']] = $pLangId;
					break;
				}
			}
		}
	}
	
	echo dynamicThickboxForm($aboveTableHTML = '<p>'. getPhrase('The following Plugins are running on your site:'). '</p>', 
					$editMode, $showEditButton, $fields, $requiredFields, $_POST, $defaults);
}
?>