<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_INITIALISE_PLUGIN');
$hasEditPermission = checkPriv('_PRIV_INITIALISE_PLUGIN');

$noSaving = false;
$noValidation = true;
$showEditButton = false;
$editMode = true;
require 'includes/common_head.inc.php';


//Get details on this Plugin
$pluginId = $_POST['pluginId'];
if (!($pluginName = getPluginName($pluginId)) || (getPluginStatus($pluginId) == '_ENUM_INSTALLED')) {
	exit;
}


//Get details on every language on the site
$sql = "
	SELECT id, flag_file_name
	FROM ". DB_NAME_PREFIX. "languages
	ORDER BY id";

$languages = array();
$result = my_mysql_query($sql);
while($row = mysql_fetch_assoc($result)) {
	$languages[$row['id']] = array(
		'local_name' => getLanguageName($row['id']),
		'flag' => '../admin/images/flags/'. $row['flag_file_name']. '.gif');
}


//Check which packs have been installed to this Plugin
$sql = "
	SELECT DISTINCT language_id
	FROM ". DB_NAME_PREFIX. "visitor_phrases
	WHERE plugin_class = '". mysql_real_escape_string(getPluginClass($pluginId)). "'";

$installedLanguages = array();
$result = my_mysql_query($sql);
while($row = mysql_fetch_assoc($result)) {
	$installedLanguages[$row['language_id']] = true;
}


//Check which languages are availible to this Plugin
$importFiles = scanPluginPhraseDir($pluginName);
$pluginLanguages = array(0 => getPhrase(' -- Do not import -- '));

foreach ($importFiles as $languageId => $file) {
	$pluginLanguages[$languageId] =
		getPhrase('Use [[filename]] ([[language_name]])', array(
			'filename' => htmlspecialchars($file),
			'language_name' => getLanguageName($languageId)));
}

if (count($pluginLanguages) == 1) {
	$pluginLanguages = array(0 => getPhrase(' -- No Language Packs available -- '));
}



//Saving data
if ($_POST['save']=="true") {
	
	$path = CMS_ROOT. 'plugins/'. $pluginName. '/phrases/';
	foreach($languages as $langId => $lang) {
		if ($_POST['lang_'. $langId] && $importFiles[$_POST['lang_'. $langId]]) {
			importVisitorLanguagePack($path. $importFiles[$_POST['lang_'. $langId]], $langId, $adding = false, $scanning = false, $forceLanguageIdOverride = true);
		}
	}
	
	echo json_encode(array());
	

//Check if a form is valid
} elseif ($_POST['validate']) {

	echo json_encode(array('valid' => true, 'errArray' => array()));
	

//Call the display form function.
} else {
	
	
	
	$requiredFields = array();
	$defaults = array();
	$fields = array();
	
	foreach($languages as $langId => $lang) {
		$fields['lang_'. $langId] = array(
			'Type' => 'select',
			'Null' => 'NO',
			'Label' =>
				'<div style="white-space: nowrap;">'.
					getPhrase('Installed Language [[lang]]', array('lang' => htmlspecialchars($lang['local_name']))).
					' <img width="16" height="11" alt="'. htmlspecialchars($langId). '" src="'. $lang['flag']. '"/>'.
				'</div>',
			'Options' => $pluginLanguages
		);
		
		//Don't set the default option to an action if the pack has already been installed
		if ($installedLanguages[$langId]) {
			$fields['lang_'. $langId]['Options'][0] = getPhrase(' -- Phrases have already been imported -- ');
		
		//If a language on the site matches a language availible to the Plugin, default it to that language
		} elseif ($pluginLanguages[$langId]) {
			$defaults['lang_'. $langId] = $langId;
		
		//Otherwise if there is a close match, use that
		} else {
			foreach ($pluginLanguages as $pLangId => $pLang) {
				if (substr($langId, 0, 2) == substr($pLangId, 0, 2)) {
					$defaults['lang_'. $langId] = $pLangId;
				}
			}
		}
	}
	
	if (count($pluginLanguages) == 1) {
		$aboveTableHTML = getPhrase('This Plugin contains no phrases for site visitors.');
	} else {
		$aboveTableHTML = getPhrase('This Plugin contains phrases which will be read by your site visitors. For each of the installed languages on your site, please select the most appropriate file.');
	}
	
	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $fields, $requiredFields, $_POST, $defaults);
}
?>