<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */


require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_MANAGE_PLUGIN_INSTANCE');
$hasEditPermission = checkPriv('_PRIV_MANAGE_PLUGIN_INSTANCE');

$noSaving = false;
$noValidation = false;
$showEditButton = false;
$editMode = true;
require 'includes/common_head.inc.php';

list ($templateFamily, $dummy, $templateId) = getTemplateFamily($_POST['cID'], $_POST['cType'], $_POST['cVersion']);

//Saving data
if ($_POST['save']=="true") {
	if ($_POST['change_instance'] == 'create_new_instance') {
		//Give the temporary instance a name in its own right, and free it from its parent
		$nest = 0;
		renameInstance($_POST['instanceId'], $nest, $_POST['instance_new_name'], $error, false);
	
	} else {
		//Replace the parent with the temporary instance
		replacePluginInstance($_POST['parent_id'], $_POST['instanceId'], $_POST['cID'], $_POST['cType'], $_POST['cVersion'], $_POST['slotName']);
		
		sendSignal('eventTryoutImplemented', array(
			'instanceId' => $_POST['instanceId'],
			'parentId' => $_POST['parent_id'],
			'cID' => $_POST['cID'],
			'cType' => $_POST['cType'],
			'cVersion' => $_POST['cVersion'],
			'slotName' => $_POST['slotName']
		));
		
		deletePluginInstance($_POST['parent_id']);
		$nest = 0;
		$error = array();
		renameInstance($_POST['instanceId'], $nest, $_POST['instanceName'], $error, false);
	}
	
	echo json_encode(array());


} elseif ($_POST['validate']) {
	
	$errors = array();
	
	//Validate the new instance name, if chosing a new name
	if ($_POST['change_instance'] == 'create_new_instance') {
		$nest = 0;
		if (!renameInstance($_POST['instanceId'], $nest, $_POST['instance_new_name'], $error, false, true)) {
			$errors[] = $error;
		}
	}
	
	echo json_encode(array('valid' => !count($errors), 'errArray' => $errors));


//Call the display form function.
} else {
	
	thickboxForm($formHTMLHead, $formHTMLFoot, $editMode, $showEditButton, getPhrase('Do you want to:'), 2);
	
	$usage = checkInstancesUsage($_POST['instanceId']. ','. $_POST['parent_id'], false);
	$usagePublished = checkInstancesUsage($_POST['instanceId']. ','. $_POST['parent_id'], true);
	$instance = getPluginInstanceDetails($_POST['parent_id']);
	$skLink = getPluginInstanceUsageStorekeeperDeepLink($instance['instance_id'], $instance['plugin_id']);
	
	echo
		$formHTMLHead,
		'<tr><td>
			<input type="radio" name="change_instance" id="change_instance" style="margin: 10px;"',
				$_POST['change_instance'] != 'create_new_instance'? ' checked="checked"' : '',
			'/>
		</td><td colspan="2">
			<label for="change_instance">',
				$instance['keep_in_album']?
					getPhrase(
						'Apply these new settings everywhere this Album Plugin is used. This will affect <span class="tribiq_x_published_items">[[published]] Published Content Item(s)</span> <span class="tribiq_y_items">(<a href="[[link]]" target="_blank">[[pages]] Content Item(s) in total</a>).</span>',
						array('pages' => (int) $usage['count'],
								'published' => (int) $usagePublished['count'],
								'link' => htmlspecialchars($skLink)))
				:	getPhrase(
						'Apply these new settings everywhere this Instance is used. This will affect <span class="tribiq_x_published_items">[[published]] Published Content Item(s)</span> <span class="tribiq_y_items">(<a href="[[link]]" target="_blank">[[pages]] Content Item(s) in total</a>).</span>',
						array('pages' => (int) $usage['count'],
								'published' => (int) $usagePublished['count'],
								'link' => htmlspecialchars($skLink))),
			'</label>
		</td></tr>
		<tr><td>
			<input type="radio" name="change_instance" id="create_new_instance" value="create_new_instance" style="margin: 0 10px;"',
				$_POST['change_instance'] == 'create_new_instance'? ' checked="checked"' : '',
			'/>
		</td><td colspan="2">
			<label for="create_new_instance">'. getPhrase('Create new Plugin Instance with these settings'). '</label>
		</td></tr>
		<tr><td>
			&nbsp;
		</td><td class="title">
			<label for="instance_new_name_input">'. getPhrase('_NEW_INSTANCE_NAME:'). '</label>
		</td><td>
			<input type="text" id="instance_new_name" name="instance_new_name" class="form_field" onFocus="get(\'create_new_instance\').checked = true;" value="',
				htmlspecialchars(ifNull($_POST['instance_new_name'], $_POST['instanceName'])),
			'"/>
		</td></tr>',
		$formHTMLFoot;
}


?>