<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

if ($_POST['cID']) {
	exitIfNotCheckPriv('_PRIV_VIEW_ITEM_META_DATA');
	if ($hasEditPermission = checkPriv('_PRIV_EDIT_ITEM_META_DATA')) {
		if (getContentStatus($_POST['cID'], $_POST['cType']) != 'private_draft') {
			$hasEditPermission = checkPriv('_PRIV_CREATE_REVISION_DRAFT');
		}
	}
} else {
	exitIfNotCheckPriv('_PRIV_CREATE_FIRST_DRAFT');
	$hasEditPermission = checkPriv('_PRIV_CREATE_FIRST_DRAFT');
}

$noSaving = false;
$noValidation = false;
$showEditButton = $hasEditPermission && $_POST['cID'];
$editMode = $_POST['formMode']=="edit" || !$_POST['cID'];
require 'includes/common_head.inc.php';


if ($_POST['save']=="true") {
	if (includeContentType($_POST['cType'])) { {
			
			$content_item = saveMetaData($_POST);
			
			echo json_encode($content_item);
		}
	}
	
} else {
	if (includeContentType($_POST['cType'])) { {
			
			if ($_POST['validate']) {
				/*
				
				Call the validation function passing the $_POST variable.  This function should
				return an associative array with the first element being the boolean "valid"
				and the second being "errArray" which will contain an array of errors if invalid
				or a zero length string if valid. For example:
				
				array("valid" => true, errArray => "");
				
				*/
			
				$validationResult = validateMetaData($_POST);
				echo json_encode($validationResult);
			} else {
				/* Once we know what content type this is, we include the relevant functions */
				/* function displayThickBoxSimpleEditMetaDataForm will be found in each content type include */
				
				list( $formHtml, $msg, $typeMsg, $valid ) = displaySetMetaDataForm($_POST, $showEditButton, $editMode);
				
				echo json_encode(array("formHTML" => $formHtml,"msgHTML" => '',"valid" => ''));
			}
		}
	}
}
?>