<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

if ($_POST['cID']) {
	exitIfNotCheckPriv('_PRIV_VIEW_ITEM_SETTINGS');
	if ($hasEditPermission = checkPriv('_PRIV_EDIT_ITEM_SETTINGS')) {
		if (getContentStatus($_POST['cID'], $_POST['cType']) != 'private_draft') {
			$hasEditPermission = checkPriv('_PRIV_CREATE_REVISION_DRAFT');
		}
	}
} else {
	exitIfNotCheckPriv('_PRIV_CREATE_FIRST_DRAFT');
	$hasEditPermission = checkPriv('_PRIV_CREATE_FIRST_DRAFT');
}

$noSaving = false;
$noValidation = false;
$showEditButton = $hasEditPermission && $_POST['cID'];
$editMode = $_POST['formMode']=="edit" || !$_POST['cID'];
require 'includes/common_head.inc.php';


if ($_POST['save']=="true") {
	if (includeContentType($_POST['cType'])) { {
			
			saveSettings($_POST);
			echo json_encode(array());
		}
	}
} else {
	if (includeContentType($_POST['cType'])) { {
			
			if ($_POST['validate']) {
				$validationResult = validateSettings($_POST);
				echo json_encode($validationResult);
			} else {
				/* Once we know what content type this is, we include the relevant functions */
				/* function displayThickBoxSimpleEditMetaDataForm will be found in each content type include */
				list( $formHtml, $msg, $typeMsg, $valid ) = displaySetSettingsForm($_POST, $showEditButton);
				if( $msg ) {
					$msgHtml = "<div id=\"message_" . $typeMsg . "\" class=\"message\">\n";
					$msgHtml .= "	<table width=\"630\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" id=\"message\">\n";
					$msgHtml .= "		<tr>\n";
					$msgHtml .= "			<td width=\"36\">\n";
					$msgHtml .= "				<div style=\"text-align:center; padding:7px; border-right:1px solid #878986;\"><img src=\"../admin/images/img_" . $typeMsg . ".gif\" width=\"36\" height=\"36\" alt=\"Image showing " . $typeMsg . "\"></div>\n";
					$msgHtml .= "			</td>\n";
					$msgHtml .= "			<td width=\"576\">\n";
					$msgHtml .= "				<div style=\"padding-left:11px;\">" . $msg . "</div>\n";
					$msgHtml .= "			</td>\n";
					$msgHtml .= "		</tr>\n";
					$msgHtml .= "	</table>\n";
					$msgHtml .= "</div>\n";
				} else {
					$msgHtml = "";
				}
				
				echo json_encode(array("formHTML" => $formHtml,"msgHTML" => $msgHtml,"valid" => $valid));
			}
		}
	}
}
?>