<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_VIEW_SLOT');
$slotItemPerms = checkPriv('_PRIV_MANAGE_ITEM_SLOT');
$slotTemplatePerms = checkPriv('_PRIV_MANAGE_TEMPLATE_SLOT');
$hasEditPermission = true;

$noSaving = false;
$noValidation = true;
$showEditButton = false;
$editMode = $slotItemPerms || $slotTemplatePerms;
require 'includes/common_head.inc.php';



//Saving data
if ($_POST['save']=="true") {
	if ($slotItemPerms) {
		updatePluginInstanceInItemSlot($_POST['itemLevelId'], $_POST['slotName'], $_POST['cID'], $_POST['cType'], $_POST['cVersion']);
	}
	
	if ($slotTemplatePerms) {
		updatePluginInstanceInTemplateSlot($_POST['templateLevelId'], $_POST['slotName'], $_POST['templateFamily'], $_POST['templateId']);
		updatePluginInstanceInTemplateSlot($_POST['familyLevelId'], $_POST['slotName'], $_POST['templateFamily']);
	}
	
	if ($_POST['itemLevelId'] !== '') {
		$instanceId = $_POST['itemLevelId'];
		
	} elseif ($_POST['templateLevelId'] !== '') {
		$instanceId = $_POST['templateLevelId'];
		
	} elseif ($_POST['familyLevelId'] !== '') {
		$instanceId = $_POST['familyLevelId'];
		
	} else {
		$instanceId = '0';	
	}
	
	echo json_encode(array('instanceId' => $instanceId));
	

//Call the display form function.
} else {
	
	if ($itemLevelId = getPluginInstanceInItemSlot($_POST['slotName'], $_POST['cID'], $_POST['cType'], $_POST['cVersion'])) {
		$itemLevel		= getPluginInstanceDetails($itemLevelId);
	} else {
		$itemLevel 		= array(
							'instance_id' => $itemLevelId,
							'instance_name' => $itemLevelId === false? getPhrase('_INHERIT_FROM_TEMPLATE') : getPhrase('_SHOW_NOTHING'));
	}
	
	if ($templateLevelId = getPluginInstanceInTemplateSlot($_POST['slotName'], $_POST['templateFamily'], $_POST['templateId'])) {
		$templateLevel	= getPluginInstanceDetails($templateLevelId);
	} else {
		$templateLevel	= array(
							'instance_id' => $templateLevelId,
							'instance_name' => $templateLevelId === false? getPhrase('_INHERIT_FROM_TEMPLATE_FAMILY') : getPhrase('_SHOW_NOTHING'));
	}
	
	if ($familyLevelId = getPluginInstanceInTemplateSlot($_POST['slotName'], $_POST['templateFamily'])) {
		$familyLevel	= getPluginInstanceDetails($familyLevelId);
	} else {
		$familyLevel	= array(
							'instance_id' => $familyLevelId,
							'instance_name' => getPhrase('_SHOW_NOTHING'));
	}
	
	
	echo thickboxFormHead($editMode),
	'
		<tr>
			<td class="title">
				<label>', getPhrase('This Content Item:'), '</label>
			</td><td>
				', getTag($_POST['cID'], $_POST['cType'], $_POST['cVersion']), '
			</td>
		</tr><tr>
			<td class="title">
				<label>', getPhrase('Plugin Instance:'), '</label>
			</td><td>
				<input id="itemLevelId" name="itemLevelId" type="hidden" value="', $itemLevel['instance_id'], '" />
				<input id="itemLevelName" type="text" value="', htmlspecialchars($itemLevel['instance_name']), '" size="50" readonly="readonly" />';
	
	if ($slotItemPerms && $slotTemplatePerms) {
		echo '
				<input id="itemLevelMove" type="button" class="submit" value="', getPhrase('v'), '" onClick="tribiqTab.movePluginLevel(\'item\', \'template\');" />';
	}
	
	echo '
			</td>
		</tr><tr>
			<td>&nbsp;</td>
			<td>';
		
		if ($slotItemPerms) {
			echo '
				<input id="itemLevelChange" type="button" class="launch_keeper" value="', getPhrase('_SELECT_PLUGIN_INSTANCE'), '" onClick="tribiqTab.buttonClick(this);" />
				<input id="itemLevelInherit" type="button" class="submit" value="', getPhrase('_INHERIT_FROM_TEMPLATE'), '" onClick="tribiqTab.buttonClick(this);" />
				<input id="itemLevelRemove" type="button" class="submit" value="', getPhrase('_SHOW_NOTHING'), '" onClick="tribiqTab.buttonClick(this);" />';
		}
	
		echo '
			</td>
		</tr>
		
		<tr><td>&nbsp;</td><td>&nbsp;</td></tr>
		
		<tr>
			<td class="title">
				<label>', getPhrase('This Template Instance:'), '</label>
			</td><td>
				', htmlspecialchars(getRow('templates', 'name', array('template_id' => (int) post('templateId')))), '
				<br/> &nbsp; &nbsp; &nbsp; &nbsp; <i>
				', getPhrase(
					'used by [[pages]] Content Item(s), <b>[[published]] Published</b>',
					array('pages' => checkTemplateUsage($_POST['templateId'], false, false),
							'published' => checkTemplateUsage($_POST['templateId'], false, true))
				), '</i>
			</td>
		</tr><tr>
			<td class="title">
				<label>', getPhrase('Plugin Instance:'), '</label>
			</td><td>
				<input id="templateLevelIdOriginalValue" type="hidden" value="', $templateLevel['instance_id'], '" />
				<input id="templateLevelId" name="templateLevelId" type="hidden" value="', $templateLevel['instance_id'], '" />
				<input id="templateLevelName" type="text" value="', htmlspecialchars($templateLevel['instance_name']), '" size="50" readonly="readonly" />';
	
	if ($slotTemplatePerms) {
		echo '
				<input id="templateLevelMove" type="button" class="submit" value="', getPhrase('v'), '" onClick="tribiqTab.movePluginLevel(\'template\', \'family\');" />';
	}
	
	echo '
			</td>
		</tr><tr>
			<td>&nbsp;</td>
			<td>';
		
		if ($slotTemplatePerms) {
			echo '
				<input id="templateLevelChange" type="button" class="launch_keeper" value="', getPhrase('_SELECT_PLUGIN_INSTANCE'), '" onClick="tribiqTab.buttonClick(this);" />
				<input id="templateLevelInherit" type="button" class="submit" value="', getPhrase('_INHERIT_FROM_TEMPLATE_FAMILY'), '" onClick="tribiqTab.buttonClick(this);" />
				<input id="templateLevelRemove" type="button" class="submit" value="', getPhrase('_SHOW_NOTHING'), '" onClick="tribiqTab.buttonClick(this);" />';
		}
	
		echo '
			</td>
		</tr>
		
		<tr><td>&nbsp;</td><td>&nbsp;</td></tr>
		
		<tr>
			<td class="title">
				<label>', getPhrase('This Template Family:'), '</label>
			</td><td>
				', htmlspecialchars($_POST['templateFamily']), '
				<br/> &nbsp; &nbsp; &nbsp; &nbsp; <i>
				', getPhrase(
					'used by [[pages]] Content Item(s), <b>[[published]] Published</b>',
					array('pages' => checkTemplateUsage($_POST['templateId'], $_POST['templateFamily'], false),
							'published' => checkTemplateUsage($_POST['templateId'], $_POST['templateFamily'], true))
				), '</i>
			</td>
		</tr><tr>
			<td class="title">
				<label>', getPhrase('Plugin Instance:'), '</label>
			</td><td>
				<input id="familyLevelIdOriginalValue" type="hidden" value="', $familyLevel['instance_id'], '" />
				<input id="familyLevelId" name="familyLevelId" type="hidden" value="', $familyLevel['instance_id'], '" />
				<input id="familyLevelName" type="text" value="', htmlspecialchars($familyLevel['instance_name']), '" size="50" readonly="readonly" />';
	
	if ($slotTemplatePerms) {
		echo '
				<input id="familyLevelMove" type="button" class="submit" value="', getPhrase('^'), '" onClick="tribiqTab.movePluginLevel(\'family\', \'template\');" />';
	}
	
	echo '
			</td>
		</tr><tr>
			<td>&nbsp;</td>
			<td>';
		
		if ($slotTemplatePerms) {
			echo '
				<input id="familyLevelChange" type="button" class="launch_keeper" value="', getPhrase('_SELECT_PLUGIN_INSTANCE'), '" onClick="tribiqTab.buttonClick(this);" />
				<input id="familyLevelRemove" type="button" class="submit" value="', getPhrase('_SHOW_NOTHING'), '" onClick="tribiqTab.buttonClick(this);" />';
		}
	
		echo '
			</td>
		</tr>',
	
	thickboxFormFoot($editMode);
}
?>