<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_VIEW_TEMPLATE_FAMILY');
$hasEditPermission = checkPriv('_PRIV_EDIT_TEMPLATE_FAMILY');

$noSaving = false;
$noValidation = true;
$showEditButton = $hasEditPermission && $_POST['family'];
$editMode = $_POST['formMode']=="edit" || !$_POST['family'];
require 'includes/common_head.inc.php';


//Saving data
if ($_POST['save']=="true") {
	
	$familyName = decodeItemIdForStorekeeper($_POST['family']);
	saveTemplateFamily($_POST, $familyName);
	
	//Overwrite the familyName in the primary key if needed
	echo json_encode(array('family' => encodeItemIdForStorekeeper($familyName)));
	

//Check if a form is valid
//} elseif ($_POST['validate']) {

	//$familyName = $_POST['familyName'];
	//echo json_encode(validateTemplateFamily($_POST, $familyName));
	

//Call the display form function.
} else {
	$valuesInCache = $_POST;
	
	$DBDetails = getTemplateFamilyDetails(decodeItemIdForStorekeeper($_POST['family']));
	
	$aboveTableHTML = '';
	
	$requiredFields = array();
	
	$fields = getFields(DB_NAME_PREFIX, 'template_family');
		
	$fields['family_name']['Read Only'] = true;
	$fields['family_name']['Note Below'] = getPhrase('The name of the folder containing the Template Files.');
	$fields['skin_id']['Label'] = getPhrase('Default Skin:');
	$fields['skin_id']['Note Below'] = getPhrase('Content Items will use this Skin unless specified on a per-Template or per-Item basis.');
	
	
	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $fields, $requiredFields, $valuesInCache, $DBDetails);
}
?>