<?php 
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
exitIfNotCheckPriv('_PRIV_UPLOAD_ITEM_FILE');

includeContentType($_POST['cType']);


$siteConfig = loadSiteConfig();

$filename = $_FILES['userfile'];

if ($_POST['cType']) {
	$contentTypeSettings = loadContentTypeSettings($_POST['cType']);
	
	foreach ($filename['tmp_name'] as $key => $tempFilename) {
		if ($tempFilename) {
			if (is_uploaded_file($tempFilename)) {
				if ($filename['size'][$key]>$contentTypeSettings['max_filesize']) {
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_SIZE', array( 'size' => $contentTypeSettings['max_filesize'] ) );
				}
				
				$fileExtension = preg_replace("#^.+\\.([^.]+)$#", "\\1", $filename['name'][$key]);
				if (!documentTypeIsAllowed($fileExtension)) {
					$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_INVALID_TYPE' );
				}
				
			} else {
				switch ($filename['error']) {
					case 1:
						$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_SIZE', array( 'size' => $contentTypeSettings['max_filesize'] ) );
						break;
					case 2:
						$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_SIZE', array( 'size' => $contentTypeSettings['max_filesize'] ) );
						break;
					case 3:
						$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_PARTIAL_UPLOAD', array( 'size' => $contentTypeSettings['max_filesize'] ) );
						break;
					default:
						$error['document'] = getPhrase( '_FILE_UPLOAD_ERROR_EMPTY', array( 'size' => $contentTypeSettings['max_filesize'] ) );
				}
			}
		
			if (!$error) {
				$dest_path = CMS_DROPBOX_DIR . "/" . SITENAME . "/" . tidyFilename($filename['name'][$key]);
				if (move_uploaded_file($filename['tmp_name'][$key], $dest_path)) {
				}
			}
		}
	}
	
	if ($error) {
		foreach ($error as $msg) {
			$error_list .= $msg . "<br />";
		}

		echo "<script type=\"text/javascript\">parent.get('upload_err_list').innerHTML=\"" . $error_list . "\";parent.get('upload_err_list').style.display=\"\";</script>\n";
	} else {
		echo "<script type=\"text/javascript\">
			window.top.tribiqAFB.refreshTab();
		</script>\n";
	}
}
?>