<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

if ($_POST['url']) {
	exitIfNotCheckPriv('_PRIV_URL_SETTINGS');
	$hasEditPermission = checkPriv('_PRIV_URL_SETTINGS');
} else {
	exitIfNotCheckPriv('_PRIV_ADD_URL');
	$hasEditPermission = checkPriv('_PRIV_ADD_URL');
}

$noSaving = false;
$noValidation = false;
$showEditButton = $hasEditPermission && $_POST['url'];
$editMode = $_POST['formMode']=="edit" || !$_POST['url'];
require 'includes/common_head.inc.php';


//Saving data
if ($_POST['save']=="true") {
	
	$url = $_POST['url'];
	savePublicURL($_POST, $url);
	
	//Overwrite the catId in the primary key if needed
	echo json_encode(array('url' => $url));
	

//Check if a form is valid
} elseif ($_POST['validate']) {

	echo json_encode(validatePublicURL($_POST));
	

//Call the display form function.
} else {
	
	$fields = array(
		'public_url' => array(
			'Type' => 'varchar(255)',
			'Label' => getPhrase('URL (web address):'),
			'Null' => 'NO',
			'Table' => 'public_urls',
			'Numeric' => false
		),
		'admin_url' => array(
			'Type' => 'tinyint(1)',
			'Label' => getPhrase('Make this the Admin URL:'),
			'Null' => 'NO',
			'Table' => 'public_urls',
			'Numeric' => true
		)
	);

	if ($_POST['url']) {
		$fields['public_url']['Read Only'] = true;
		$requiredFields = array();
	} else {
		$requiredFields = array('public_url');
	}
	
	if ($_POST['url']) {
		connectGlobalDB();

		$sql = "SELECT goto_admin_url
				FROM " . DB_NAME_PREFIX_GLOBAL . "site_registry
				WHERE goto_admin_url = '" . mysql_real_escape_string($_POST['url']) . "'";
				
		$result = my_mysql_query($sql);

		if ( $dbChanged ) connectLocalDB ();	

		if (mysql_num_rows($result)>0) {
			$adminURL = 1;
		} else {
			$adminURL = 0;
		}
		
		$urlDBDetails = array("public_url" => $_POST['url'],"admin_url" => $adminURL);
	} else {
		//No need to show the show the "Edit"/"Cancel" button for new categories
		$showEditButton = false;
	}
	
	
	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $fields, $requiredFields, $_POST, $urlDBDetails);
}
?>