<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

if ($_POST['userId']) {
	exitIfNotCheckPriv('_PRIV_VIEW_USER');
	$hasEditPermission = checkPriv('_PRIV_EDIT_USER');
} else {
	exitIfNotCheckPriv('_PRIV_CREATE_USER');
	$hasEditPermission = checkPriv('_PRIV_CREATE_USER');
}

$noSaving = false;
$noValidation = false;
$showEditButton = $hasEditPermission && $_POST['userId'];
$editMode = $_POST['formMode']=="edit" || !$_POST['userId'];
require 'includes/common_head.inc.php';



//Saving data
if ($_POST['save']=="true") {
	
	$userId = $_POST['userId'];
	saveUser($_POST, $userId);
	
	//Overwrite the userId in the primary key if needed
	echo json_encode(array('userId' => $userId));
	

//Check if a form is valid
} elseif ($_POST['validate']) {

	echo json_encode(validateUser($_POST));
	

//Call the display form function.
} else {
	
	//Load user details from database if an id has been given
	$userDBDetails = array();

	if ($_POST['userId']) {
		//Load user details fro database if an id has been given
		$userDBDetails = getUserDetails($_POST['userId']);
	}
	
	$userFields = array();
	if ($siteConfig['user_show_additional_details']) {
		$userFields['alt_email'] = array(
			'Field' => 'alt_email',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['birth_date'] = array(
			'Field' => 'birth_date',
			'Type' => 'date',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['website'] = array(
			'Field' => 'website',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['job_title'] = array(
			'Field' => 'job_title',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
	}
	
	if ($siteConfig['user_show_business_details']) {
		$userFields['company_name'] = array(
			'Field' => 'company_name',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['bus_address1'] = array(
			'Field' => 'bus_address1',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['bus_address2'] = array(
			'Field' => 'bus_address2',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['bus_address3'] = array(
			'Field' => 'bus_address3',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['bus_town'] = array(
			'Field' => 'bus_town',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['bus_state'] = array(
			'Field' => 'bus_state',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['bus_postcode'] = array(
			'Field' => 'bus_postcode',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['bus_country_id'] = array(
			'Field' => 'bus_country_id',
			'Type' => 'country',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
	}
	
	if ($siteConfig['user_show_residential_details']) {
		$userFields['res_address1'] = array(
			'Field' => 'res_address1',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['res_address2'] = array(
			'Field' => 'res_address2',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['res_address3'] = array(
			'Field' => 'res_address3',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['res_town'] = array(
			'Field' => 'res_town',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['res_state'] = array(
			'Field' => 'res_state',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['res_postcode'] = array(
			'Field' => 'res_postcode',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		$userFields['res_country_id'] = array(
			'Field' => 'res_country_id',
			'Type' => 'country',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
		if ($siteConfig['user_show_business_details']) {
			$userFields['address_pref'] = array(
				'Field' => 'address_pref',
				'Type' => 'enum',
				'Options' => array(
					'no_pref' => getPhrase('No Preference'),
					'residential' => getPhrase('Residential'),
					'business' => getPhrase('Business')),
				'Null' => 'NO',
				'Key' => '',
				'Default' => '',
				'Extra' => '',
				'Table' => 'users',
				'Numeric' => false
			);
		}
	}
	
	$userFields['mobile'] = array(
		'Field' => 'mobile',
		'Type' => 'varchar',
		'Null' => 'NO',
		'Key' => '',
		'Default' => '',
		'Extra' => '',
		'Table' => 'users',
		'Numeric' => false
	);
	
	if ($siteConfig['user_show_business_details']) {
		$userFields['bus_phone'] = array(
			'Field' => 'bus_phone',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
	}
	
	if ($siteConfig['user_show_residential_details']) {
		$userFields['res_phone'] = array(
			'Field' => 'res_phone',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
	}
	
	if ($siteConfig['user_show_additional_details']) {
		$userFields['fax'] = array(
			'Field' => 'fax',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
	}
	
	$requiredFields = array();

	$columnsNotToShow = array();

	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $userFields, $requiredFields, $_POST, $userDBDetails, $columnsNotToShow);
}
?>