<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

if ($_POST['userId']) {
	exitIfNotCheckPriv('_PRIV_VIEW_USER');
	$hasEditPermission = checkPriv('_PRIV_EDIT_USER');
} else {
	exitIfNotCheckPriv('_PRIV_CREATE_USER');
	$hasEditPermission = checkPriv('_PRIV_CREATE_USER');
}

$noSaving = false;
$noValidation = false;
$showEditButton = $hasEditPermission && $_POST['userId'];
$editMode = $_POST['formMode']=="edit" || !$_POST['userId'];
require 'includes/common_head.inc.php';



//Saving data
if ($_POST['save']=="true") {
	$userId = $_POST['userId'];
	saveUser($_POST, $userId);
	
	//Overwrite the userId in the primary key if needed
	echo json_encode(array('userId' => $userId));
	

//Check if a form is valid
} elseif ($_POST['validate']) {

	echo json_encode(validateUser($_POST));
	

//Call the display form function.
} else {
	
	//Load user details from database if an id has been given
	$userDBDetails = array();

	if ($_POST['userId']) {
		//Load user details fro database if an id has been given
		$userDBDetails = getUserDetails($_POST['userId']);
	}

	if ($editMode) {
		$usernameSuggest = '<input type="button" value="Suggest" style="margin-left: 20px;" onclick="tribiqTab.suggestUsername($(\'#first_name\').val(),$(\'#middle_name\').val(),$(\'#last_name\').val(),$(\'#email\').val())" />';
	}
	
	$userFields = array();
	$userFields['email'] = array(
		'Field' => 'email',
		'Type' => 'email',
		'Null' => 'NO',
		'Key' => '',
		'Default' => '',
		'Extra' => '',
		'Table' => 'users',
		'Numeric' => false
	);
	$userFields['title'] = array(
		'Field' => 'title',
		'Label' => 'Salutation:',
		'Type' => 'varchar(25)',
		'Null' => 'NO',
		'Key' => '',
		'Default' => '',
		'Extra' => '',
		'Table' => 'users',
		'Numeric' => false
	);
	$userFields['first_name'] = array(
		'Field' => 'first_name',
		'Type' => 'varchar',
		'Null' => 'NO',
		'Key' => '',
		'Default' => '',
		'Extra' => '',
		'Table' => 'users',
		'Numeric' => false
	);
	
	if ($siteConfig['user_show_middle_name']) {
		$userFields['middle_name'] = array(
			'Field' => 'middle_name',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
	}
	
	$userFields['last_name'] = array(
		'Field' => 'last_name',
		'Type' => 'varchar',
		'Null' => 'NO',
		'Key' => '',
		'Default' => '',
		'Extra' => '',
		'Table' => 'users',
		'Numeric' => false
	);
	
	if ($siteConfig['user_show_maiden_name']) {
		$userFields['maiden_name'] = array(
			'Field' => 'maiden_name',
			'Label' => 'Maiden Name:',
			'Type' => 'varchar',
			'Null' => 'NO',
			'Key' => '',
			'Default' => '',
			'Extra' => '',
			'Table' => 'users',
			'Numeric' => false
		);
	}
	
	$userFields['username'] = array(
		'Field' => 'username',
		'Type' => 'varchar',
		'Null' => 'NO',
		'Key' => '',
		'Default' => '',
		'Extra' => '',
		'Table' => 'users',
		'Numeric' => false,
		'Post Field HTML' => $usernameSuggest
	);
	$userFields['screen_name'] = array(
		'Field' => 'screen_name',
		'Type' => 'varchar',
		'Label' => 'Screen Name:',
		'Null' => 'NO',
		'Key' => '',
		'Default' => '',
		'Extra' => '',
		'Table' => 'users',
		'Numeric' => false
	);
	$userFields['password'] = array(
		'Field' => 'password',
		'Type' => 'password',
		'Null' => 'NO',
		'Key' => '',
		'Default' => '',
		'Extra' => '',
		'Table' => 'users',
		'Numeric' => false,
		'Post Field HTML' => '<input type="button" value="Suggest" style="margin-left: 20px;" onclick="tribiqTab.suggestPassword()" />'
   );
	$userFields['password_reconfirm'] = array(
		'Field' => 'password_reconfirm',
		'Type' => 'password_reconfirm',
		'Null' => 'NO',
		'Key' => '',
		'Default' => '',
		'Extra' => '',
		'Table' => 'users',
		'Numeric' => false
	);
	$userFields['notes'] = array(
		'Field' => 'notes',
		'Type' => 'text',
		'Label' => 'Notes:',
		'Null' => 'YES',
		'Key' => '',
		'Default' => '',
		'Extra' => '',
		'Table' => 'users',
		'Numeric' => false
	);
	
	$requiredFields = array('username','password','password_reconfirm');

	$columnsNotToShow = array();

	if ($_POST['userId']) {
		//Don't show the status/password fields on the details page for existing users
		$columnsNotToShow[] = 'status';
		$columnsNotToShow[] = 'password';
		$columnsNotToShow[] = 'password_reconfirm';
	} else {
		//Don't give admins to create a user in the suspended state
		//$userFields['status']['Type'] = "enum('pending','active','suspended')";
		$userFields['status']['Type'] = "enum('pending','active')";
		$userDBDetails = array('status' => 'active');
		
		//No need to show the show the "Edit"/"Cancel" button for new users
	}
	
	echo dynamicThickboxForm($aboveTableHTML, 
					$editMode, $showEditButton, $userFields, $requiredFields, $_POST, $userDBDetails, $columnsNotToShow);
}
?>