<?php 
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_EDIT_TEMPLATE');


if (issetArrayKey($_POST, 'templateId') && (!issetArrayKey($_POST, 'sourceId')) && arrayKey($_POST, 'skinChanged')
 && ($details = getTemplateDetails($_POST['templateId']))
 && (arrayKey($_POST, 'selectedSkinId') != $details['skin_id'])) {
	$html = '<p>'. getPhrase(
		'Warning! You are about to change the default Skin for the Template &quot;[[name]]&quot;. When you do this, any Content Items which rely on this Template-wide setting will immediately change their appearance to use the new Skin you specify.',
		array('name' => htmlspecialchars($details['name']))).
		'</p><p>'. getPhrase('Are you sure you wish to proceed?'). '</p>';

} else {
	echo json_encode(array('action' => 'continue'));
	exit;
}

$buttons = '<input type="button" class="submit_selected" value="'. getPhrase('_SAVE'). '" onClick="tribiqAFB.saveTabsSkippingConfirm();"/>'.
					'<input type="button" class="submit" value="'. getPhrase('_CANCEL'). '" onClick="tribiqA.closeFloatingBox();"/>';


echo json_encode(array('action' => 'confirm', 'html' => $html, 'buttons' => $buttons, 'warning' => 1));


?>