var filesArray;

function setStorekeeperItemKey () {
	storekeeperItemKey = primaryKey.cID + "_" + primaryKey.cType + "_" + primaryKey.cVersion;
}

tribiqTab.propagateName = function() {
	var propagate = get("title");
	var count;
	var keywords = "";
	if ( get("description").value == "" ) { 
		get("description").value = propagate.value;
	}
	if ( get("keywords").value == "" ) {
		var words = propagate.value.split(" ");
		words.sort();
		for ( count = 0; count < words.length; count++ ) {
			keywords += words[count] + ", ";
		}
		get( "keywords" ).value = keywords;
	}
}

tribiqTab.checkSelected_GroupsRadio = function() {
	
	for (var i = 0; i < document.setpermissions.perm_type.length; i++) {
		if (document.setpermissions.perm_type[i].value=="selected_groups") {
			document.setpermissions.perm_type[i].checked=true;
		}
	}
}




//Add in a "save and publish" checkbox next to the save button
tribiqTab.setSaveArea = function(html) {
	get('tribiq_fbButtons').innerHTML = 
	'<form>'
	+ '<label for="save_and_publish">' + tribiqA.phrase.publish + ' </label>'
	+ '<input id="save_and_publish" type="checkbox" name="save_and_publish" disabled="disabled" style="margin-right:10px;"/> '
	+ tribiqAFB.getSaveButtonHTML(tribiqA.phrase.save)
	+ '</form>';
}

//Overwrite the logic for setting the save button's state to set the checkbox's state as well,
//and to run a custom script before saving
tribiqTab.setSaveButtonState = function(tab) {
	if (tribiqAFB.determineSaveButtonState({citem_access_log: true, history: true})) {
		get('save_and_publish').disabled = false;
		get('tribiqAFB_save').onclick = tribiqTab.saveContent;
	} else {
		get('save_and_publish').checked = false;
		get('save_and_publish').disabled = true;
	}
}

//Create a new private draft if needed
tribiqTab.preSave = function() {
	try {
		var url = URLBasePath + 'tb/ajax/create_content.php?create_draft=true' + tribiq.urlRequest(tribiqAFB.pk);
		var data = tribiq.nonAsyncAJAX(url, true, true);
		
		if (data.message) {
			tribiqA.floatingBox(data.message, true, 'error');
		}
		
		if (data.error) {
			return false;
		}
		
		if (data.cVersion) {
			tribiqAFB.pk.cVersion = data.cVersion;
		}
		
		return true;
		
	} catch (e) {
		return false;
	}
}

//Special case for multiple file uploads - the save function is run multiple times, one for each upload
tribiqTab.saveContent = function() {
	if (filesArray) {
		saveCount = filesArray.length;
	} else {
		saveCount = 1;
	}
	
	tribiqAFB.dontCloseJustYet = true;
	
	for (var i = 0;i < saveCount;i++) {
		if (filesArray) {
			tribiqAFB.pk.current_file = filesArray[i];
			if (i > 0 && tribiqAFB.pk.cID != undefined && tribiqAFB.pk.cVersion != undefined) {
				tribiqAFB.pk.cID = undefined;
				tribiqAFB.pk.cVersion = undefined;
				tribiqAFB.pk.repeatedSave = 1;
			}
		}
		
		if (i == saveCount-1) {
			tribiqAFB.dontCloseJustYet = false;
		}
		
		tribiqAFB.saveTabs();
	}
}

//Publish if needed
tribiqTab.postSave = function() {
	if (get('save_and_publish').checked) {
		var url = URLBasePath + 'tb/ajax/create_content.php?publish=true' + tribiq.urlRequest(tribiqAFB.pk);
		tribiq.nonAsyncAJAX(url, true);
	}
}

//Set event start/end time hidden fields


function setStartTime () {
	get("start_time").value = tribiqA.makeTimeFromParts(get("start_time_hour").options[get("start_time_hour").selectedIndex].value,get("start_time_minutes").options[get("start_time_minutes").selectedIndex].value);

	if (get("end_time").value == "") {
		get("end_time").value = get("start_time").value;
		get("end_time_hour").value = get("start_time_hour").options[get("start_time_hour").selectedIndex].value;
		get("end_time_minutes").value = get("start_time_minutes").options[get("start_time_minutes").selectedIndex].value;
	}
}

function setEndTime () {
	get("end_time").value = tribiqA.makeTimeFromParts(get("end_time_hour").options[get("end_time_hour").selectedIndex].value,get("end_time_minutes").options[get("end_time_minutes").selectedIndex].value);
}