
//Redirect button clicks to the correct places
tribiqTab.buttonClick = function(el) {
	var ids = el.id.split('Level');
	var scope = ids[0] + 'Level';
	var task = ids[1];

	if (task == 'Change') {
		//tribiqA.launchStoreKeeper('pluginInstances', 'pluginInstances',  'tribiqTab.' + el.id, '&running=false&overrideShowBackButton=true&instance_id=' + get(scope + 'Id').value);
		
		var path, pluginId, instanceId = get(scope + 'Id').value;
		if (instanceId && (pluginId = tribiq.pluginClassAJAX('tribiq_cms_core', {getPluginIdFromInstanceId: instanceId}))) {
			path = 'tribiq__plugins/slotable_only////view_instances//' + pluginId  + '//' + instanceId;
		} else {
			path = 'tribiq__plugins/slotable_only////';
		}
		
		tribiqA.SK('tribiqTab', el.id, false, path, 'tribiq__plugins/instances', 'tribiq__plugins', 'tribiq__plugins/instances', true);
	
	} else if (scope == 'family' || task == 'Inherit') {
		get(scope + 'Id').value = '';
		get(scope + 'Name').value = el.value;
		tribiqTab.setUpFormDisplay();
	
	} else {
		get(scope + 'Id').value = 0;
		get(scope + 'Name').value = el.value;
		tribiqTab.setUpFormDisplay();
	}
	
	
}

//Callback functions for the Keeper to populate the values in this page
tribiqTab.itemLevelChange = function(path, key, row) {
	get('itemLevelId').value = key.id;
	get('itemLevelName').value = row.name;
	
	tribiqTab.setUpFormDisplay();
}

tribiqTab.templateLevelChange = function(path, key, row) {
	get('templateLevelId').value = key.id;
	get('templateLevelName').value = row.name;
	
	tribiqTab.setUpFormDisplay();
}

tribiqTab.familyLevelChange = function(path, key, row) {
	get('familyLevelId').value = key.id;
	get('familyLevelName').value = row.name;
	
	tribiqTab.setUpFormDisplay();
}

tribiqTab.movePluginLevel = function(levelFrom, levelTo) {
	
	if (!get(levelFrom + 'LevelId').value) {
		return;
	}
	
	get(levelTo + 'LevelId').value = get(levelFrom + 'LevelId').value;
	get(levelTo + 'LevelName').value = get(levelFrom + 'LevelName').value;
	
	if (levelFrom == 'item') {
		get('itemLevelId').value = '';
		get('itemLevelName').value = get('itemLevelInherit').value;
	
	} else if (levelFrom == 'template') {
		get('templateLevelId').value = '';
		get('templateLevelName').value = get('templateLevelInherit').value;
	
	} else if (levelFrom == 'family') {
		get('familyLevelId').value = '0';
		get('familyLevelName').value = get('familyLevelRemove').value;
	}
	
	tribiqTab.setUpFormDisplay();
}


//Refresh the display elements of the page
tribiqTab.setUpFormDisplay = function() {
	
	if (get('itemLevelRemove')) {
		
		//There's no point in using the remove button if a field is empty
		get('itemLevelRemove').disabled =		get('itemLevelId').value == '0';
		
		//There's no point in using the inherit button if a field is already inheriting
		get('itemLevelInherit').disabled =		get('itemLevelId').value == '';
		
		//Make fields transparent if they have been overridden with inheritance
		var itemLevelOpacity =
			get('itemLevelId').value !== ''?
				1 : 0.5;
		
		tribiq.opacity(get('itemLevelName'), itemLevelOpacity);
		if (get('itemLevelMove')) {
			tribiq.opacity(get('itemLevelMove'), itemLevelOpacity);
		}
	}
	
	if (get('templateLevelRemove')) {
		
		//There's no point in using the remove button if a field is empty
		get('templateLevelRemove').disabled = 	get('templateLevelId').value == '0';
		get('familyLevelRemove').disabled = 	get('familyLevelId').value == '0';
		
		//There's no point in using the inherit button if a field is already inheriting
		get('templateLevelInherit').disabled = 	get('templateLevelId').value == '';
		
		//Make fields transparent if they have been overridden with inheritance
		var templateLevelOpacity =
			get('templateLevelId').value !== '' && get('itemLevelId').value === ''?
				1 : 0.5;
		
		//Make fields transparent if they have been overridden with inheritance
		var familyLevelOpacity =
			get('familyLevelId').value !== '' && get('itemLevelId').value === '' && get('templateLevelId').value === ''?
				1 : 0.5;

		tribiq.opacity(get('templateLevelName'), templateLevelOpacity);
		tribiq.opacity(get('templateLevelMove'), templateLevelOpacity);
		tribiq.opacity(get('familyLevelName'), familyLevelOpacity);
		tribiq.opacity(get('familyLevelMove'), familyLevelOpacity);
	}
	
	tribiqAFB.pk.templateLevelChanges = get('templateLevelId').value !== get('templateLevelIdOriginalValue').value? 1 : '';
	tribiqAFB.pk.familyLevelChanges = get('familyLevelId').value !== get('familyLevelIdOriginalValue').value? 1 : '';
	
}


tribiqTab.setUpFormDisplay();