<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

exitIfNotCheckPriv('_PRIV_VIEW_SLOT');




$tab_programs = array();
$tab_programs['slot'] = getPhrase('_PLUGINS');


//Attempt to load all the information we can from the $_GET request
$pk = array();
$pk['cID'] = (int) $_REQUEST['cID'];
$pk['cType'] = $_REQUEST['cType'];
$pk['cVersion'] = getLatestVersion($pk['cID'], $pk['cType']);
$pk['slotName'] = $_REQUEST['slotName'];
$pk['instanceId'] = null;
$pk['familyLevelChanges'] = null;
$pk['templateLevelChanges'] = null;

list ($pk['templateFamily'], $dummy, $pk['templateId']) = getTemplateFamily($pk['cID'], $pk['cType'], $pk['cVersion']);

if (getPluginInstanceInTemplateSlot($pk['slotName'], $pk['templateFamily'])
 || getPluginInstanceInTemplateSlot($pk['slotName'], $pk['templateFamily'], $pk['templateId'])
 || getPluginInstanceInItemSlot($pk['slotName'], $pk['cID'], $pk['cType'], $pk['cVersion'])) {
	$title = getPhrase('Changing, Removing or Scaling Out the Plugin Instance in the Slot &quot;[[slot_name]]&quot;', array('slot_name' => str_replace('_', ' ', $pk['slotName'])));
} else {
	$title = getPhrase('Adding a Plugin Instance to the Slot &quot;[[slot_name]]&quot;', array('slot_name' => str_replace('_', ' ', $pk['slotName'])));
}


thickboxHeader($title, $tab_programs, 'Slot', array_keys($pk), 'slot', false, false, false, false, 'core', $pk, 'slot');

?>