<?php
/*
 * This file is part of Tribiq CMS - a web-based Content Management System
 * and Extranet. Copyright (c) 2007-2010 Tribal Limited, registered in England.
 * For more information please visit http://tribiq.com.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation, either version 3 of the
 * Licence, or (at your option) any later version.
 *
 * Please support Free Software. If you use this program please credit
 * the authors by placing a link "Powered by Tribiq CMS" to 
 * http://tribiq.com in the foot of all your templates.
 *
 * Tribiq CMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org.licenses/>.
 */

require '../adminheader.inc.php';
require CMS_ROOT. 'cmsincludes/thickbox.inc.php';

$tab_programs = array();
if (checkPriv('_PRIV_VIEW_TEMPLATE')) {
	$tab_programs['template_details'] = array('text' => getPhrase('_DETAILS'), 'max_height' => 325);
	$tab_programs['template_image'] = array('text' => getPhrase('_IMAGE'), 'max_height' => 325);
}

if ($_GET['duplicate'] && $_GET['id']){
	$template = getTemplateNameAndStatus($_GET['id']);
	$title = getPhrase('Duplicating Template &quot;[[template]]&quot;.', array('template' => htmlspecialchars($template)));
} elseif ($_GET['id']) {
	$template = getTemplateNameAndStatus($_GET['id']);
	$title = getPhrase('Viewing/Editing settings for the Template &quot;[[template]]&quot;.', array('template' => htmlspecialchars($template)));
} else {
	$title = getPhrase('Creating a new Template');
}

if (issetArrayKey($_REQUEST, 'refiner__template_family') && issetArrayKey($_REQUEST, 'refinerId')) {
	$_REQUEST['templateFamily'] = decodeItemIdForStorekeeper($_REQUEST['refiner__template_family']);
}

if (($_GET['duplicate']=="duplicate") && ($_GET['id'])){
	$_REQUEST['sourceId'] = $_GET['id'];
}

if ((arrayKey($_REQUEST, 'refinerName')=='filename') && issetArrayKey($_REQUEST, 'refinerId')) {
	$_REQUEST['fileName'] = decodeItemIdForStorekeeper($_REQUEST['refinerId']);
} elseif (issetArrayKey($_REQUEST,'sourceId')) {
	$template = getTemplateDetails($_REQUEST['sourceId']);
	$_REQUEST['fileName'] = arrayKey($template,'filename');
} elseif (issetArrayKey($_REQUEST,'filename')) {
	$_REQUEST['fileName'] = arrayKey($_REQUEST,'filename');
}


thickboxHeader($title, $tab_programs, 'Template', array('templateId', 'sourceId','templateFamily', 'fileName', 'skinChanged', 'selectedSkinId'), false, false, false, false, false, 'core', false, 'template');
thickboxFooter();

?>